package com.despark.tuning3d.controller {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.auth.LoginScreen;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class AuthUserCommand extends SimpleCommand {
    override public function execute(note:INotification):void {
        var type:int = LoginScreen.TYPE_NORMAL;
        var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;

        if (note.getBody() && note.getBody().hasOwnProperty('login') && note.getBody().login) {

            if (note.getBody() && note.getBody().hasOwnProperty('type')) {
                type = note.getBody().type;
            }

            sendNotification(Notifications.DISPLAY_LOGIN_SCREEN, {type: type});
        }


        if (usersProxy.currentUser) {
            sendNotification(Notifications.USER_AUTHENTICATED, {wasAlreadyAuthenticated: true});
        }
        else {


            if (note.getBody()) {
                type = note.getBody().type;
            }
            sendNotification(Notifications.DISPLAY_LOGIN_SCREEN, {type: type});
        }
    }
}
}