package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.modals.ChallengeTuningViewPopup;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;
    import org.puremvc.as3.patterns.command.SimpleCommand;

    public class DisplayChallengeTuningViewPopupCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var blocker : BlockerView = BlockerView.show();
            var complete:Function = function ():void {
                if(blocker){
                    blocker.hide();
                }
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var popUp : ChallengeTuningViewPopup = new ChallengeTuningViewPopup(note.getBody());
                windowMediator.addPopUp(popUp);
            };
            var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadChallengeTuningViewPopupAssets(complete);
        }
    }
}
