package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesLeaderboardScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;
    import org.puremvc.as3.patterns.command.SimpleCommand;

    public class DisplayChallengesLeaderboardScreenCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var preloaderOpenHandler:Function = function():void{
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadBrandScreenAssets(false);
                assetsProxy.loadFeedAssets(false);
                assetsProxy.loadFriendsAssets(null, false);
                assetsProxy.loadChallengeListAssets(function ():void {
                    var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var leaderBoardScreen : ChallengesLeaderboardScreen = new ChallengesLeaderboardScreen();
                    leaderBoardScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide();
                        }
                    }
                    windowMediator.pushScreen(leaderBoardScreen, true, true);
                    blocker.onHidingComplete = function():void{
                        leaderBoardScreen.transitionComplete();
                    }
                });
            }
            var isBlackScreen:Boolean = (note.getBody() && note.getBody()["tabMenu"]);
            var blocker : BlockerView;
            BannerStackedScreen.hideAdBanner(true);
            if(isBlackScreen){
                blocker = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
            }else{
                blocker = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
            }
        }
    }
}
