package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesNotificationsScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesTuningsListScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesUserTuningsScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesVotingScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    public class DisplayChallengesNotificationsScreenCommand extends  DisplayScreenCommand{
    public function DisplayChallengesNotificationsScreenCommand() {
    }

    override public function execute(notification:INotification):void {
        executeHandler = function ():void {
            var preloaderOpenHandler:Function = function():void{
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadChallengeTuningsListAssets(function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var challengesScreen:ChallengesNotificationsScreen = new ChallengesNotificationsScreen();
                    challengesScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide();
                        }
                    }
                    blocker.onHidingComplete = function():void{
                        challengesScreen.transitionComplete();
                    }
                    Starling.juggler.delayCall(function ():void {
                        windowMediator.pushScreen(challengesScreen);
                    },.1);
                });
            }
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
        };
        super.execute(notification);
    }
}
}
