package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesTuningsListScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesUserTuningsScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    public class DisplayChallengesUserTuningsScreenCommand extends  DisplayScreenCommand{
    public function DisplayChallengesUserTuningsScreenCommand() {
    }

    override public function execute(note:INotification):void {
        executeHandler = function ():void {
            var preloaderOpenHandler:Function = function():void {
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadChallengeTuningsListAssets(null, false);
                assetsProxy.loadChallengeListAssets(function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    if (note.getBody().userData) {
                        var leaderBoardTuningScreen:ChallengesUserTuningsScreen = new ChallengesUserTuningsScreen(note.getBody().userData, note.getBody().userGarage);
                        leaderBoardTuningScreen.onComplete = function():void{
                            if(blocker){
                                blocker.hide(0.25);
                            }
                        };
                        blocker.onHidingComplete = function():void{
                            leaderBoardTuningScreen.transitionComplete();
                        }
                        Starling.juggler.delayCall(function ():void {
                            windowMediator.pushScreen(leaderBoardTuningScreen);
                        }, .05);
                    } else {
                        var userProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                        userProxy.loadCurrentUser(function (result:String):void {
                            if (result) {
                                var userData:Object = JSON.parse(result);
                                var leaderBoardTuningScreen:ChallengesUserTuningsScreen = new ChallengesUserTuningsScreen(userData, note.getBody().userGarage);
                                leaderBoardTuningScreen.onComplete = function():void{
                                    if(blocker){
                                        blocker.hide(0.25);
                                    }
                                };
                                blocker.onHidingComplete = function():void{
                                    leaderBoardTuningScreen.transitionComplete();
                                }
                                Starling.juggler.delayCall(function ():void {
                                    windowMediator.pushScreen(leaderBoardTuningScreen);
                                }, .05);
                            }
                        });
                    }
                });
            }
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView;
            var isBlackScreen:Boolean = (note.getBody() && note.getBody()["tabMenu"]);
            if (isBlackScreen || note.getBody().userData) {
                blocker = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
            }else{
                blocker = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
            }

        };
        super.execute(note);
    }
}
}
