package com.despark.tuning3d.controller
{
	import com.despark.tuning3d.model.assets.AssetsProxy;
	import com.despark.tuning3d.view.WindowMediator;
	import com.despark.tuning3d.view.components.challenges.modals.EnterChallengePopup;
	import com.despark.tuning3d.view.components.core.BlockerView;

	import feathers.layout.HorizontalAlign;

	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;

	public class DisplayEnterChallengePopupCommand extends SimpleCommand {
		public override function execute(note : INotification) : void {
			var blocker : BlockerView = BlockerView.show();
			var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
			var complete:Function = function ():void {
				blocker.hide();
				if(note.getBody().car && note.getBody().user) {
					var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
					var enterChallengePopup:EnterChallengePopup = new EnterChallengePopup(note.getBody());
					if(note.getBody().hasOwnProperty('animate') && !note.getBody().animate){
						windowMediator.animate = false;
					}
					windowMediator.addPopUp(enterChallengePopup/*, HorizontalAlign.RIGHT, true*/);
				}
			};
			assetsProxy.loadLeaderBoardTuning(complete);
		}
	}
}