package com.despark.tuning3d.controller
{
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.gallery.GalleryScreen;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;


import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayGalleryScreenCommand extends DisplayScreenCommand
{
    override public function execute(note : INotification) : void
    {
        executeHandler = function ():void {
            var countryLoadCompleteHandler:Function = function(obj:Object):void {
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadFlagTexture(obj.country, false, null);
                assetsProxy.loadGalleryScreenAssets(function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var galleryScreen:GalleryScreen = new GalleryScreen();
                    galleryScreen.countryData = obj;
                    galleryScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide();
                        }
                    }
                    blocker.onHidingComplete = function():void{
                        galleryScreen.transitionComplete();
                    }
                    windowMediator.pushScreen(galleryScreen, true, true);
                });
            };
            var preloaderOpenHandler:Function = function():void {
                var timelineProxy:TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
                timelineProxy.getCountryApi(countryLoadCompleteHandler);
                BannerStackedScreen.hideAdBanner(true);
            }
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
        };
        super.execute(note);

    }
}
}