package com.despark.tuning3d.controller {
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.challenges.modals.InAppNotificationsPopup;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayInAppNotificationsPopupCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var preloaderOpenHandler:Function = function():void{
                var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadBrandScreenAssets(false);
                assetsProxy.loadFeedAssets(false);
                assetsProxy.loadInAppNotificationsPopupAssets(null, false);
                assetsProxy.loadFriendsAssets(complete);
            };
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
            var complete:Function = function ():void {
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var screenPopUp : InAppNotificationsPopup = InAppNotificationsPopup.getInstance(note.getBody());
                windowMediator.animate = false;
                screenPopUp.onComplete = function():void{
                    if(blocker){
                        blocker.hide();
                        blocker.onHidingComplete = function():void{
                            if(screenPopUp && screenPopUp.parent){
                                screenPopUp.parent.setChildIndex(screenPopUp, screenPopUp.parent.numChildren - 1);
                                screenPopUp.transitionComplete();
                            }
                        }
                    }
                };
                windowMediator.addPopUp(screenPopUp);
                blocker.parent.swapChildren(blocker, screenPopUp);
            };
        }
    }
}
