/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.controller {
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.timeline.TimelineProxy;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
import com.despark.tuning3d.view.components.timeline.TimelineScreen;

import org.puremvc.as3.interfaces.INotification;

public class DisplayTimelineScreenCommand extends  DisplayScreenCommand{
    public function DisplayTimelineScreenCommand() {

    }

    override public function execute(notification:INotification):void {
        executeHandler = function ():void {


            var countryLoadCompleteHandler:Function = function(obj:Object):void{
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadFlagTexture(obj.country, false, null);
                assetsProxy.loadBrandScreenAssets(false);
                assetsProxy.loadFeedAssets(true, function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var user:User;
                    var ownTimeline:Boolean = true;
                    if(notification.getBody() && notification.getBody().hasOwnProperty("user")){
                        user = notification.getBody().user;
                        ownTimeline = false;
                    }else{
                        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                        user = usersProxy.currentUser;
                    }
                    var timelineScreen:TimelineScreen = new TimelineScreen(user);
                    timelineScreen.ownTimeline = ownTimeline;
                    timelineScreen.countryData = obj;
                    if(!ownTimeline){
                        timelineScreen.activateCloseButton(notification.getBody().closeHandler);
                    }
                    if(notification && notification.getBody() && notification.getBody().firstPost){
                        timelineScreen.firstPost = notification.getBody().firstPost;
                    }
                    var deleteOthers:Boolean = true
                    if(notification && notification.getBody() && notification.getBody().hasOwnProperty("deleteOtherScreens")) {
                        deleteOthers = notification.getBody().deleteOtherScreens
                    }
                    if(windowMediator.window.screenNavigator.screenTypeExists(TimelineScreen)){
                        deleteOthers = true;
                        timelineScreen.activateCloseButton(function():void{
                            sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
                        });
                    }
                    timelineScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide();
                        }
                    }
                    blocker.onHidingComplete = function():void{
                        timelineScreen.transitionComplete();
                    }
                    windowMediator.pushScreen(timelineScreen, true, deleteOthers);
                });
            };
            var preloaderOpenHandler:Function = function():void {
                var timelineProxy:TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
                timelineProxy.getCountryApi(countryLoadCompleteHandler);
            }
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
        };
        super.execute(notification);
    }
}
}
