package com.despark.tuning3d.controller
{
	import com.despark.tuning3d.model.assets.AssetsProxy;
	import com.despark.tuning3d.view.WindowMediator;
	import com.despark.tuning3d.view.components.tunings.editing.TuningSharingPopUp;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	public class DisplayTuningSharingPopUpCommand extends SimpleCommand
	{
		override public function execute(note : INotification) : void 
		{
			var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
			assetsProxy.loadSharingPopupAssets(function():void {
				var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;

				var title:String = note.getBody().title;
				if (!title) {
					title = "SHARE ON FACEBOOK";
				}

				var challenge:Boolean = false;
				var hashTags:String = "";
				var siteLink:String = "";

				if (note.getBody().hasOwnProperty("challenge")) {

					challenge = note.getBody().challenge;
					hashTags = note.getBody().hashTags;


				}

				if (note.getBody().siteLink)
					siteLink = note.getBody().siteLink;

				var sharingPopUp:TuningSharingPopUp = new TuningSharingPopUp(title, challenge, hashTags, siteLink);

				windowMediator.addPopUp(sharingPopUp);
			}, true);
		}
	}
}

