package com.despark.tuning3d.controller
{
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
    import com.utils.ObjectUtils;


    import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayTuningsListScreenCommand extends DisplayScreenCommand {
    override public function execute(note : INotification) : void {
        executeHandler = function ():void {

            var preloaderOpenHandler:Function = function():void {
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadBrandScreenAssets(false);
                assetsProxy.loadFeedAssets(true, function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var garageScreen:TuningsListScreen = new TuningsListScreen();
                    garageScreen.postToTimeline = (note.getBody() ? note.getBody().postToTimeline : false);
                    var displayData:Object = note.getBody();
                    var deleteOthers:Boolean = true;
                    garageScreen.carType = ObjectUtils.getValue(displayData, "carType", null);
                    garageScreen.carId = ObjectUtils.getValue(displayData, "car.id", null);
                    garageScreen.enterChallenge = ObjectUtils.getValue(displayData, "activeForChallenge", false);
                    if (garageScreen.enterChallenge) {
                        garageScreen.challengeData = displayData;
                    }
                    garageScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide(1);
                        }
                    };
                    blocker.onHidingComplete = function():void{
                        garageScreen.transitionComplete();
                    }

                    if (note.getBody() && note.getBody().hasOwnProperty("deleteOtherScreens")) {
                        deleteOthers = note.getBody().deleteOtherScreens;
                        garageScreen.enableBackward = !deleteOthers;
                        if (windowMediator.window.screenNavigator.screenTypeExists(TuningsListScreen)) {
                            deleteOthers = true;
                        }
                        windowMediator.pushScreen(garageScreen, true, deleteOthers);
                        if (deleteOthers) {
                            garageScreen.activateCloseButton(function ():void {
                                sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
                            });
                        } else if (garageScreen.enableBackward) {
                            if (note.getBody()) {
                                garageScreen.activateCloseButton(note.getBody().closeHandler);
                            } else {
                                garageScreen.activateCloseButton();
                            }
                        }
                    } else {
                        windowMediator.pushScreen(garageScreen);
                        if (note.getBody() && note.getBody().hasOwnProperty("enableCloseButton")) {
                            garageScreen.enableBackward = note.getBody().enableCloseButton;
                            if (garageScreen.enableBackward) {
                                garageScreen.activateCloseButton(note.getBody().closeHandler);
                            }
                        }
                    }
                });
            }
            BannerStackedScreen.hideAdBanner(true);
            var blocker : BlockerView = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
        };
        super.execute(note);

    }
}
}