package com.despark.tuning3d.controller {
import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.tunings.Tuning;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.auth.ProfilePopup;
    import com.despark.tuning3d.view.components.auth.UserDetailsPopup;
    import com.despark.tuning3d.view.components.core.BlockerView;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayUserDetailsPopupCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var blocker : BlockerView = BlockerView.show();
            var complete:Function = function ():void {
                blocker.hide();
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var options:Array;
                var sharingUserReg:RegExp = /^3DT-Share-[0-9]{1,3}$/;
                var username:String = note.getBody().user.username;
                if(sharingUserReg.test(username) && !note.getBody().user.name){
                    options = [UserDetailsPopup.NO_FRIEND];
                }else if(note.getBody().hasOwnProperty("options")){
                    options = note.getBody().options;
                }else{
                    if(UsersProxy.loggedInUser()){
                        options = [UserDetailsPopup.TIMELINE, UserDetailsPopup.GARAGE, UserDetailsPopup.EMAILS, UserDetailsPopup.CHALLENGE];
                    }else{
                        options = [UserDetailsPopup.TIMELINE, UserDetailsPopup.GARAGE, UserDetailsPopup.CHALLENGE];
                    }
                }
                var referrer:String = note.getBody().hasOwnProperty("referrer")?note.getBody().referrer:null;
                var screenPopUp : UserDetailsPopup = new UserDetailsPopup(note.getBody().user, options, referrer);
                windowMediator.addPopUp(screenPopUp);
            };
            var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadMailBoxAssets(complete);
        }
    }
}
