package com.despark.tuning3d.model.brands
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	import com.despark.tuning3d.model.parts.Material3dtProvider;

	public class Brand implements PersistentImageProvider
	{
		public var id : String;
		public var imageURL : String; 
		public var name : String;
		public var lastAdded:Boolean=false;
		public var limitedOption:Boolean=false;
		public var cars : Array;
		
		public var index:int=0;
		
		
		
		private var carsMap : Object;
		
		private var _isDefault : Boolean;
		
		
		
		public function get frameIndeX() : int 
		{
			return -1;
		}
		
		public function get isDefault() : Boolean 
		{
			return _isDefault;
		}
		
		public function set isDefault(value : Boolean) : void
		{
			_isDefault = value;
		}
		
		public function Brand()
		{
			super();
			carsMap = {};
		}
		
		public function addCar(car : Car) : void
		{
			if(cars.indexOf(car) == -1){
				cars.push(car);
			}
			carsMap[car.id] = car;
			limitedOption ||= car.limitedOptions;
		}

		public function removeCar(car : Car) : void
		{
			var index:int = cars.indexOf(car);
			if(index != -1){
				cars.removeAt(index);
			}
			if(carsMap.hasOwnProperty(car.id)){
				delete carsMap[car.id];
			}
		}

		public function getCar(id : String) : Car
		{
			return carsMap[id];
		}
		
		public function get localFile() : String
		{
			if(!imageURL){
				return "";
			}
			var brandParts : Array = imageURL.split("/");
			var localImagePath : String = "Cars/Brands/" + brandParts[brandParts.length - 1];
			/*var file1: File = File.cacheDirectory.resolvePath(localImagePath); 
			file1.preventBackup = true;*/
			return localImagePath;
		}
		
		public function get remoteUrl() : String
		{
			return imageURL;
		}
		
		public function get isEncrypted() : Boolean 
		{
			return false;
		}
		
		public function get ignoresTransparentPixelsOnTouch() : Boolean 
		{
			return false;
		}
		
		public function get touchable() : Boolean 
		{
			return true;
		}
		
		public function get important() : Boolean
		{
			return false;
		}
		
		public function get brightness() : Number 
		{
			return 1.0;
		}
		
		public function set brightness(value : Number) : void
		{
			
		}
		
		public function get material3dtProvider() : Material3dtProvider
		{
			return null;
		}
	}
}

