package com.despark.tuning3d.model.core
{
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.model.core.http.HttpClient;
	import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;
	import com.despark.tuning3d.model.users.UsersProxy;
	import com.utils.ObjectUtils;
	
	import flash.desktop.NativeApplication;
	import flash.events.Event;
	import flash.events.StatusEvent;
	import flash.globalization.LocaleID;
	import flash.globalization.StringTools;
	import flash.net.SharedObject;
	import flash.net.URLRequest;
	
	import air.net.URLMonitor;
	
	import org.puremvc.as3.patterns.proxy.Proxy;
	
	import starling.utils.AssetManager;

	public class ConnectionProxy extends Proxy  
	{
		public static const NAME : String = "ConnectionProxy";
		
		public var httpClient :HttpClient;
		public var assetManager : AssetManager;
		
		private var _monitor:URLMonitor=null;
		
		private var _connected:Boolean=false;
		private var _checked:Boolean=false;
		
		public function ConnectionProxy()
		{
			super(NAME);
			
		
			NativeApplication.nativeApplication.addEventListener(Event.NETWORK_CHANGE, onNetworkChange);
			

			start();   
			
		}
		
		protected function onNetworkChange(event:Event):void{
			
			//check();
			
		}
		
		private function start():void{  
			
			if(_monitor){
				if(_monitor.running){
					_monitor.stop();
				}
				_monitor.removeEventListener(StatusEvent.STATUS, announceStatus); 
			}
			
			_monitor ||= new URLMonitor(new URLRequest('http://assets2.3dtuning.com/api/v1/'));
			_monitor.addEventListener(StatusEvent.STATUS, announceStatus);
			_monitor.pollInterval = 10000;
			_monitor.start(); 
		}
		
		
		public function check():void{
			
			if(!_checked){
				return;    
			}
			
			if(!_connected){
				
				sendNotification(Notifications.INTERNET_DISCONNECTED);
			}else{   
				
				//sendNotification(Notifications.INTERNET_CONNECTED);   
			}
		}
		
		
		private function announceStatus(event:StatusEvent):void { 
			
			
			var monitor:URLMonitor = event.target as URLMonitor;
			

			
			     
			if(monitor.available){
				
				_connected=true;
				sendNotification(Notifications.INTERNET_CONNECTED);   
			}else{  
				
				_connected=false;
				sendNotification(Notifications.INTERNET_DISCONNECTED);
			}
			
			_checked=true;
		} 
		
		
	}
}