package com.despark.tuning3d.model.core {
    import com.despark.tuning3d.view.TuningScreenMediator;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.despark.tuning3d.view.core.StackedScreenMediator;
    import com.distriqt.extension.firebase.crashlytics.FirebaseCrashlytics;

    public class ErrorTracker {
        private static var _stackedScreenMediator:StackedScreenMediator;
        private static var _lineLabel:String;
        private static var _reference:String;
        public static function getMoreInfo(stackTrace:String = null):String{
            var result:String = '\n';
            switch (true) {
                case _stackedScreenMediator is TuningScreenMediator:
                    var tuningScreen:TuningScreen;
                    if(_stackedScreenMediator.stackedScreen){
                        tuningScreen = _stackedScreenMediator.stackedScreen as TuningScreen;
                    }
                    if(tuningScreen){
                        result += "TuningScreen:" + '\n';
                        if(tuningScreen.car){
                            if(tuningScreen.car.id){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.car.id, "carId");
                            }
                            if(tuningScreen.car.displayName){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.car.displayName, "carName");
                            }
                            result += "car: " + tuningScreen.car.id + '\n';
                        }
                        if(tuningScreen.selectedPartSlot){
                            if(tuningScreen.selectedPartSlot.name){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.name, "selectedPartSlot");
                            }
                            result += "selectedPartSlot: " + tuningScreen.selectedPartSlot.name + '\n';
                            if(tuningScreen.selectedPartSlot.selectedPart){
                                if(tuningScreen.selectedPartSlot.selectedPart.name){
                                    FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.selectedPart.name, "carSelectedPart");
                                }
                                result += "carSelectedPart: " + tuningScreen.selectedPartSlot.selectedPart.name + '\n';
                                if(tuningScreen.selectedPartSlot.selectedPart.selectedMaterial && tuningScreen.selectedPartSlot.selectedPart.selectedMaterial.name){
                                    FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.selectedPart.selectedMaterial.name, "selectedMaterial");
                                }
                            }
                        }
                        if(tuningScreen.selectedPart){
                            if(tuningScreen.selectedPart.name){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPart.name, "selectedPart");
                            }
                            if(tuningScreen.selectedPart.id){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPart.id, "selectedPartId");
                            }
                            result += "selectedPart: " + tuningScreen.selectedPart.name + '\n';
                        }
                    }
                    break;
            }
            if(stackTrace && lineLabel && reference){
                FirebaseCrashlytics.service.setStringValue(reference + " -> " + lineLabel, "reference");
                setLineLabel(null);
                setReference(null);
                _reference = null;
            }
            return result;
        }

        public static function recordError(error:Error):void{
            FirebaseCrashlytics.service.log(error.message + '\n stack:'+error.getStackTrace());
            FirebaseCrashlytics.service.recordError(error);
        }

        public static function setMediator(stackedScreenMediator:StackedScreenMediator):void{
            _stackedScreenMediator = stackedScreenMediator;
        }

        public static function setReference(label:String):void{
            _reference = label;
        }

        public static function setLineLabel(label:String):void{
            _lineLabel = label;
        }

        public static function get lineLabel():String {
            return _lineLabel;
        }

        public static function get reference():String {
            return _reference;
        }
    }
}
