package com.despark.tuning3d.model.core.images
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.geom.Matrix;

	public class ImageWatermarker
	{
		public var padding : int = 10;
		
		public function ImageWatermarker()
		{
			super();
		}
		
		public function addWatermark(bitmapData : BitmapData, watermarkBitmap : Bitmap, watermarkScale : Number = 1.0, __paddingX: int = -1, __paddingY: int = -1) : void
		{
			var matrix : Matrix = new Matrix();
			
			var paddingX : int = padding;
			var paddingY : int = padding;
			
			if(__paddingX > 0){
				paddingX = __paddingX;
			}
			
			if(__paddingY > 0){
				paddingY = __paddingY;
			}
			
			matrix.scale(watermarkScale, watermarkScale);
				
			matrix.translate(bitmapData.width - watermarkBitmap.bitmapData.width * watermarkScale - paddingX, 
							 bitmapData.height - watermarkBitmap.bitmapData.height * watermarkScale - paddingY);
			
			bitmapData.draw(watermarkBitmap, matrix, null, BlendMode.MULTIPLY);
		}
	}
}