package com.despark.tuning3d.model.parts
{
	import com.utils.Console;

	public class PartColor
	{
		public var name : String;
		private var _value : uint;
		public var isCustom : Boolean;
		public var isNoColor : Boolean;
		
		public function PartColor()
		{
			super();
		}
		
		public static function noColor() : PartColor
		{
			var partColor : PartColor = new PartColor();
			
			partColor.name = "color";
			partColor._value = 0xEEEEEE;
			partColor.isNoColor = true;
			
			return partColor;
		}

		public static function defaultColor() : PartColor {
			var partColor : PartColor = new PartColor();
			partColor.name = "red";
			partColor._value = 0xFF0000;
			partColor.isNoColor = false;
			return partColor;
		}
		
		public static function customColor() : PartColor
		{
			var partColor : PartColor = new PartColor();
			
			partColor.name = "customColor";
			partColor._value = 0xFEFFFF;
			partColor.isCustom = true;
			
			return partColor;
		}
		
		public function copy():PartColor
		{
			
			var copyOfObject : PartColor = new PartColor();
			
			copyOfObject.name = name;
			copyOfObject._value = _value;
			copyOfObject.isCustom = isCustom;
			copyOfObject.isNoColor = isNoColor;
			
			return copyOfObject;
		}


		public function get value():uint {
			return _value;
		}

		public function set value(value:uint):void {
			_value = value;
		}
	}
}