package com.despark.tuning3d.model.parts
{
	import com.despark.tuning3d.model.cars.Car;
	import com.utils.Console;

	import flash.utils.Dictionary;
	
	public class PartSlot {
		public static var PART_SHADOWS : Array = ["shadow_front_left", "shadow_front_right", "shadow_rear_left", "shadow_rear_right"];
		public static var PART_SLOTS_NOT_AFFECTED_BY_SUSPENSION : Array = ["shadow", "neon", "chassi"].concat(Car.DISKS_SLOTS, Car.TIRES_SLOTS, Car.BRAKES_SLOTS, Car.TIRE_VINYL_PARTS, PART_SHADOWS);
		public static const VINYL:String = "Vinyls";
		public static const BACKGROUNDS:String = "Backgrounds";
		public static const BODY_PACK:String = "packs";
		public static const BODY:String = "body";
		public static const FACTORY_TRIM:String = "factory_trims";
		public static const VINYL_PACK:String = "aerography_packs";
		public static const TWO_TONE_VINYL_PACK:String = "two_tone_vinyls_packs";
		public static const VINYL_GROUP:String = "vinyl_groups";
		public static const TWO_TONE_VINYL_GROUP:String = "two_tone_vinyl_groups";
		public static var VINYLS:Array = [];
		public static var VINYL_PACK_LINKED:Array = [];
		public static var TWO_TONE_VINYLS_LIST:Array = [];
		public var grouping:Array;
		public static const AEROGRAPHY:String = 'aerography';
		public static const TWO_TONE_VINYLS:String = 'two_tone_vinyls';
		public static const TWO_TONE_VINYL_TYPE:String = 'two_tone_vinyl_';
		//


		private var _name : String;

		public var isAffectedBySuspension : Boolean;
		public var displayName : String;
		public var layerIndex : int;
		public var sortKey : int = 999;
		public var isMandatory : Boolean;
		public var isEditable : Boolean;
		public var isColorable : Boolean;
		private var _selectedColor : PartColor;
		public var isDependence:Boolean=false;
		private var _isWide:Boolean=false;

		public var lockSuspension: Boolean = false;
		public var unselectableComponent: Boolean = false;
		public var hideFromMenu: Boolean = false;
		public var strictShowInMenu: Boolean = false;
		public var turnFiveDesign: Boolean = false;
		public var priceString: String;
		private var _defaultPart:Part;



		public var previousColor : PartColor;
		public var previousColorOfState : PartColor;
		public var previousColorOfNoState : PartColor;
		public var currentPartWithState : Part;
		public var previousNameOfMaterialOfNoState : String;
		public var prevSelectedPartMaterial : PartMaterial;

		private var _savePartLinked:Part=null;

		public var oldBeforeExludeSelectedPart:Part=null;

		private var _selectedPart : Part;
		private var _prevSelectedPart : Part;
		public var mem_selectedPart : Part;

		public var selectedParts:Array;
		//
		public var bestViewFrameIndex : int;
		protected var _possibleParts : Array;
		public var sizeInMegabytes : Number;
		public var percentLoaded : Number;
		public var dummy : Boolean;
		public var nameSuffix : String;
		private var _isExcluded : Boolean;
		public var isMask:Boolean=false;

		private var _addedMaskLayerNames:Array=[];
		public var setterMaskPartSlotName:String;

		public var layerIndexForFrames:Array=[];

		public var parentCar:Car=null;

		public var possiblePartsMap:Dictionary=null



		public function PartSlot(car:Car) {
			super();
			parentCar=car;
			possibleParts = [];
		}

		public function get isWide():Boolean{
			return _isWide;
		}
		
		public function set isWide(value:Boolean):void{
			_isWide = value;
		}
		
		public function set selectedColor(value:PartColor):void{
			if(name == "front_bumper"){
				Console.log();
			}
			_selectedColor=value;
		}
		
		public function get selectedColor():PartColor{
			
			return _selectedColor;
		}

		public function set isExcluded(excluded: Boolean):void {
			if (name == "tonneau_cover" && !excluded) {
				trace("tonneau_cover", excluded);
			}
			_isExcluded = excluded;
		}

		public function isBackground():Boolean{
			return name && name.indexOf("background_") == 0;
		}

		public function get isExcluded(): Boolean {
			return  _isExcluded;
		}

        public function dispose():void
        {
            var i:int;
            var temp:Part;
            if(_possibleParts){
                for(i=0; i < _possibleParts.length; i++){
                    Part(_possibleParts[i]).dispose();
                    temp = _possibleParts[i];
                    temp.dispose();
                    _possibleParts[i] = null;
					temp=null;
                }
            }

            if (selectedParts){
                for(i=0; i < selectedParts.length; i++){
                    Part(selectedParts[i]).dispose();
                    temp = selectedParts[i];
                    temp.dispose();
                    selectedParts[i] = null;
					temp=null;
                }
            }
			
			if(_possibleParts){
				_possibleParts.length=0;
			}
			
			if(selectedParts){
				selectedParts.length=0;
			}
			
            temp = null;
			
			displayName = null;
			_name = null;

			_selectedColor = null;
            previousColorOfState = null;
            previousColorOfNoState = null;
            _savePartLinked = null;
            oldBeforeExludeSelectedPart = null;
            previousColor = null;

            _possibleParts=null;
            selectedParts = null;
            currentPartWithState=null;
            _selectedPart=null;
            _prevSelectedPart=null;
            mem_selectedPart=null;
            possiblePartsMap=null;
            setterMaskPartSlotName = null;
            _addedMaskLayerNames=null;
            parentCar=null;
			layerIndexForFrames = null;
			setterMaskPartSlotName = null;
			nameSuffix=null;
			previousNameOfMaterialOfNoState = null;
            prevSelectedPartMaterial = null;
        }

		public function set selectedPart(part: Part):void {
			prevSelectedPartMaterial = ((_selectedPart && _selectedPart.selectedMaterial)? _selectedPart.selectedMaterial: null);
			if(_selectedPart && part != _selectedPart && !_selectedPart.isState && !_selectedPart.isSubpart && (!part || _selectedPart.folder != part.folder)){
				_selectedPart.unloadPart();
			}
			_prevSelectedPart = _selectedPart;
			_selectedPart = part;
			if(isMandatory && _selectedPart){
				_defaultPart ||= _selectedPart;
			}
			if(name == "tire_front_left" && !part){
				trace();
			}
		}

		public function get selectedPart(): Part {
			return _selectedPart;
		}

		public function get addedMaskLayerNames():Array{
			return _addedMaskLayerNames;
		}
		
		public function addMaskLayerName(layerName:String, setterPartSlotName:String):void{
			
			var addFlag:Boolean=false;
			for(var i:int=0; i<_addedMaskLayerNames.length; i++){
				
				if(_addedMaskLayerNames[i].layerName==layerName){
					
					addFlag=true;
				}
			}
			
			if(!addFlag)
				_addedMaskLayerNames.push({layerName:layerName, setterPartSlotName:setterPartSlotName});
		}
		
		
		public function removeMaskLayerName(layerName:String):void{
			
			var newList:Array=[];
			for(var i:int=0; i<_addedMaskLayerNames.length; i++){
				
				if(_addedMaskLayerNames[i].layerName!=layerName){
					
					
					
					newList.push(_addedMaskLayerNames[i])
				}
			}
			
			_addedMaskLayerNames=newList;
		}

		public function removePartByRadius(radius:int):void{
			for(var i:int = possibleParts.length - 1; i >= 0; i--){
				var part:Part = possibleParts[i] as Part;
				if(part && part.properties && part.properties.size == radius){
					if(possiblePartsMap[part.id]){
						possiblePartsMap[part.id] = null;
					}
				}
			}
		}
		
		public function applyMaterial(name:String, car:Car):void{
			
			var partMaterial : PartMaterial = this._selectedPart.getPossibleMaterial(name);
			
			if(partMaterial)
			{
				this._selectedPart.selectedMaterial = partMaterial;
				
				var part:Part=this._selectedPart;
				
				if(part.selectedMaterial.name!="metal" && part.selectedMaterial.name!="white"){
					
					if( part.color){
						
						if(part.color && part.color.value==0xffffff){
							
							part.color=car.bodyPartColor.copy();
							part.parentSlot.selectedColor.value=car.bodyPartColor.value;
						}else{
							
							part.color=car.bodyPartColor.copy();
							part.parentSlot.selectedColor.value=car.bodyPartColor.value;  
						}
						
					}else{
						
						part.color=car.bodyPartColor.copy();
						part.parentSlot.selectedColor=car.bodyPartColor.copy();
						//trace("partSlot.selectedColor:", null);
					}
					//}   
					
				}else{
					
					part.color=PartColor.noColor();
					part.parentSlot.selectedColor=PartColor.noColor();
					
				}
			}
		}
		
		public function getPartByName(name:String):Part{
			
			for(var i:int=0; i<_possibleParts.length; i++){
				
				var part:Part=_possibleParts[i];
				
				if(part.name==name){
					
					return part;
				}
			}
			
			return null;
		}
        public function getPartById(id:String):Part{
			if(possiblePartsMap && possiblePartsMap[id]){
				return possiblePartsMap[id];
			}
			for(var i:int = 0; i < _possibleParts.length; i++){
				var part:Part = _possibleParts[i];
				if(part.id == id){
					return part;
				}
			}
			return null;
        }
		
		public function getDefaultPart():Part{
			
			for(var i:int=0; i<_possibleParts.length; i++){
				var part:Part=_possibleParts[i];
				if(part.isDefault){
					return part;
				}
			}
			return null;
		}
		
		
		public function set possibleParts(value:Array):void{
			
			_possibleParts=value;
		}
		
		public function get possibleParts():Array{
			
			return _possibleParts;
		}
		
		public function get isPrimal() : Boolean 
		{
			return (name == "shadow" || name == "black" || name == "body");
		}
		
		public function addPossiblePart(part : Part) : void
		{
			/*if(parentCar.isChopper)*/
            if(!possiblePartsMap) possiblePartsMap = new Dictionary();
            possiblePartsMap[part.id]=part;
			
			part.parentSlot = this;
			
			possibleParts.push(part);

			parentCar.addPossiblePart(part);
		}
		
		public function set name(value : String) : void 
		{
			_name = value;
			
			isAffectedBySuspension = !defaultSuspensionLock;
			if(_name == "two_tone_vinyl_trunk"){
				Console.log();
			}
		}

		public function get defaultSuspensionLock():Boolean{
			return (PART_SLOTS_NOT_AFFECTED_BY_SUSPENSION.indexOf(_name) != -1);
		}
		
		public function get name() : String
		{
			return _name;
		}

        public function getFirstPossiblePartForAGivenRadius(radius : int) : Part {
            if (possibleParts && possibleParts.length && possibleParts[0].properties && possibleParts[0].properties.size)
            {
                for each (var part: Part in possibleParts)
                {
                    if(part.properties.size == radius)
                    {
                        return part;
                    }
                }
            }

            return null;
        }
        public function getPossiblePartForAGivenNameAndRadius(partName : String, radius : int, dependence: Array = null) : Part {
            if (possibleParts && possibleParts.length && possibleParts[0].properties && possibleParts[0].properties.size) {
                for (var i:int = 0; i < possibleParts.length; i++) {
					var part: Part = possibleParts[i] as Part;
                    if(part && part.properties.size == radius && part.name == partName) {
						if (!dependence || dependence.length == 0) {
							return part;
						}
						if (part.properties.dependence && arrayInArray(dependence, part.properties.dependence)) {
							return part;
						}
                    }
                }
			}

            return null;

        }
		private function arrayInArray(in1:Array, subject:Array):Boolean {
			var index:int = 0;
			while(subject.indexOf(in1[index])>-1 && index<in1.length){
				index++;
			}
			return index>=in1.length;
		}

		public function getDependantPart(partId:String):Part{
			var result:Part = null;
			if(isDependence){
				for(var i:int=0; i < _possibleParts.length; i++){
					if(Part(_possibleParts[i]).dependence && Part(_possibleParts[i]).dependence.indexOf(partId) != -1){
                        result = Part(_possibleParts[i]);
						break;
					}
				}
			}
			return result;
		}

		public function afterParseAllSlot():void{
			
			//Выполняется после парсинга всех слотов
			//Может быть полезно для задач групировкаи
			//Например таких как радиус у дисков
		}

		public function get savePartLinked():Part {
			return _savePartLinked;
		}

		public function set savePartLinked(value:Part):void {
			_savePartLinked = value;
		}

		public function get defaultPart():Part {
			return _defaultPart;
		}

		public function get prevSelectedPart():Part {
			return _prevSelectedPart;
		}
	}
}



