package com.despark.tuning3d.model.parts
{
	import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
	import com.utils.ArrayUtil;
	import com.utils.Console;
	import com.utils.ObjectUtils;
import com.utils.ObjectUtils;

import flash.utils.Dictionary;
	
	import api.com.adobe.crypto.MD5;
	
	
	
	public class PartSlotDisk extends PartSlot {
		public var diskRadiusMap:Dictionary=null;
		public var factoryDiskPart:PartDisk=null;
		public var selectedMaterialName:String;
		public var selectedStateName:String;
		private var _possiblePartList:Object;
		public static const PROFILE_LIST:Array = [{
			id:"FLAT",
			title:"FLAT"
		},{
			id:"MID",
			title:"MID"
		},{
			id:"DEEP",
			title:"DEEP"
		},{
			id:"S.DEEP",
			title:"S.DEEP"
		}];
		public function PartSlotDisk(car:Car) {
			super(car);
		}

		override public function dispose():void{
			diskRadiusMap=null;
			factoryDiskPart=null;
			selectedMaterialName=null;
			selectedStateName=null;
			super.dispose();
		}

		public function findPartDiskForRadius(partName:String, r:int, profile:String = null):Object{
			var selectedProfile:String = profile||(selectedPart?PartDisk(selectedPart).profile:'default');
			if(diskRadiusMap==null)
				return null;
			for(var diskSize:String in diskRadiusMap[partName]) {
                for each(var item:Object in diskRadiusMap[partName][diskSize] as Array) {
                    if ((this.name == 'tires_rear' || this.name == 'tires_front') && item.size == r) {
                        return item;
                    } else {
                        if (item.size == r && item.profile == selectedProfile) {
                            return item;
                        }
                    }
                }
            }
            var result:Object = null;
            if(r > 0 && diskRadiusMap[partName] && diskRadiusMap[partName][r]) {
                result = diskRadiusMap[partName][r][ObjectUtils.getFirstKey(diskRadiusMap[partName][r])];
            }
			return result;
		}

		public function findPartDisk(partName:String = null, partRadius:String = null, partProfile:String = null, folderName:String = null):PartDisk{
            partName ||= selectedPart?selectedPart.name:"";
            partRadius ||= selectedPart?PartDisk(selectedPart).radius.toString():"";
            partProfile ||= selectedPart?PartDisk(selectedPart).profile:"";
			if(_possiblePartList){
                if(!_possiblePartList[partName]){
					// TODO: F-250 71" bug fix (apply changes)
					for each(var part:PartDisk in possibleParts){
						if(part.name == partName && part.radius.toString() == partRadius && part.profile == partProfile && part.folder == folderName){
							return part;
						}
					}/**///TODO: END
					partName = ObjectUtils.getFirstKey(_possiblePartList);
				}
				if(!_possiblePartList[partName][partRadius]){
                    partRadius = ObjectUtils.getFirstKey(_possiblePartList[partName]);
				}
				if(!_possiblePartList[partName][partRadius][partProfile]){
                    partProfile = ObjectUtils.getFirstKey(_possiblePartList[partName][partRadius]);
				}
				return _possiblePartList[partName][partRadius][partProfile];
			}
			return null;
		}

		public function get radiusList():Array{
			var result:Array = [];
			if(_possiblePartList[selectedPart.name]){
				for(var key:String in _possiblePartList[selectedPart.name]){
					result.push(parseInt(key));
				}
				return result;
			}
			result.push(PartDisk(selectedPart).radius);
			return result;
		}
		
		public static function getPrefixDep(part:Part):String{
			var prefix:String = "";
			var i:int = 0;
			if(part && part.properties && part.properties.dependence && part.properties.dependence.length>0){
				for(i=0; i<part.properties.dependence.length; i++){
					prefix+=part.properties.dependence[i];
				}
			}
			
			if(prefix == ""){
				return prefix;
			}
			return "_"+MD5.hash(prefix)
		}
		
		override public function afterParseAllSlot():void{
			
			super.afterParseAllSlot();
			
			var selDiskPartObj:Object;
			var diskPartObj:Object;
			var minRadius:int;
			var maxRadius:int;
			var firsrtPart:Boolean;
			var withOutRadiusPartDisk:Array;
			
			var partDisk:PartDisk;
			
			if(!diskRadiusMap)
				diskRadiusMap=new Dictionary(true);

			withOutRadiusPartDisk=[];
			for each(partDisk in this.possibleParts){

				if(partDisk.radius>0){
					var prefix:String=getPrefixDep(partDisk);

					var diskName:String = partDisk.name+prefix;
					var diskRadius:String = partDisk.radius.toString();
					var diskProfile:String = partDisk.profile;
                    _possiblePartList ||= {};
                    _possiblePartList[diskName] ||= {};
                    _possiblePartList[diskName][diskRadius] ||= {};
                    _possiblePartList[diskName][diskRadius][diskProfile] ||= partDisk;

                    this.diskRadiusMap[diskName] ||= [];
					this.diskRadiusMap[diskName][partDisk.properties.size] ||= [];
					this.diskRadiusMap[diskName][partDisk.properties.size][diskProfile]={size:partDisk.radius, profile:diskProfile,part:partDisk};
				}else{
					if(this.factoryDiskPart==null){
						this.factoryDiskPart=partDisk;
					}else{
						withOutRadiusPartDisk.push(partDisk);
					}
				}
			}
			
			var newPossibleParts:Array=[];
			for (var namePart:String in diskRadiusMap){

				/*diskRadiusMap[namePart]=(diskRadiusMap[namePart] as Array).sortOn("size", Array.NUMERIC);
				if(parentCar.isChopper) {
					diskRadiusMap[namePart]=(diskRadiusMap[namePart] as Array).reverse();
				}*/
				selDiskPartObj=null;
				diskPartObj=null;
				minRadius=0;
				maxRadius=0;
				firsrtPart=true;

                var size:String;
				for(size in diskRadiusMap[namePart]) {
                    for each(diskPartObj in diskRadiusMap[namePart][size]) {
                        if (firsrtPart) {
                            selDiskPartObj = diskPartObj;
                            if (parentCar.isChopper) {
                                maxRadius = selDiskPartObj.size;
                            } else {
                                minRadius = selDiskPartObj.size;
                            }
                            firsrtPart = false;
                            continue;
                        } else {
                            if (parentCar.isChopper) {
                                minRadius = diskPartObj.size;
                            } else {
                                maxRadius = diskPartObj.size;
                            }
                        }
                    }
                }
				
				if(maxRadius<minRadius){
					maxRadius=minRadius;
				}
				
				selDiskPartObj.part.properties.min_size=minRadius;
				selDiskPartObj.part.properties.max_size=maxRadius;
				selDiskPartObj.part.selectedDiskSize=selDiskPartObj.part.properties.size;
                for(size in diskRadiusMap[namePart]) {
                    for each(diskPartObj in diskRadiusMap[namePart][size]) {
                        diskPartObj.part.properties.min_size = minRadius;
                        diskPartObj.part.properties.max_size = maxRadius;
                        diskPartObj.part.selectedDiskSize = diskPartObj.part.properties.size;
                    }
                }
				
				(selDiskPartObj.part as PartDisk).selectedDiskSize=maxRadius;
				(selDiskPartObj.part as PartDisk).main=true;
				newPossibleParts.push(selDiskPartObj.part);
			}
			if(factoryDiskPart){
				factoryDiskPart.main=true;
				newPossibleParts.push(factoryDiskPart);
			}

			for(var i:int=0; i<withOutRadiusPartDisk.length; i++){
				withOutRadiusPartDisk[i].main=true;
				newPossibleParts.push(withOutRadiusPartDisk[i]);
			}
			
			possibleParts=newPossibleParts;
		}
		
		
		public function findMainPartDiskByName(name:String):PartDisk{
			// ****** Disk profile functionality added ******
			var partDisk:PartDisk;
			/*for(var diskRadius:String in _possiblePartList[name]){
				for(var diskProfile:String in _possiblePartList[name][diskRadius]){
					partDisk = _possiblePartList[name][diskRadius][diskProfile];
					if(partDisk.main){
						return partDisk;
					}
				}
			}*/
			//
			
			for(var diskSize:String in diskRadiusMap[name]) {
                for each(var partDiskObj:Object in this.diskRadiusMap[name][diskSize]) {
                    if (partDiskObj) {
                        partDisk = partDiskObj.part;
                        if (partDisk.main) {

                            return partDisk;
                        }
                    }
                }
            }
			
			return null;
		}
		private function arrayInArray(in1:Array, subject:Array):Boolean {
			var index:int = 0;
			while(subject.indexOf(in1[index])>-1 && index<in1.length){
				index++;
			}
			return index>=in1.length;
		}

        public override function getPossiblePartForAGivenNameAndRadius(name : String, radius : int, dependence: Array = null): Part {
			for each (var partDisk: PartDisk in possibleParts) {
				if(partDisk.selectedDiskSize == radius && name == partDisk.name) {
					if (!dependence) {
						/*var profileValue:String = selectedPart?PartDisk(selectedPart).profile:null;
						return findPartDisk(name, radius.toString(), profileValue);*/
						return partDisk;
					} else {
						if (arrayInArray(partDisk.properties.dependence, dependence)) {
							return partDisk;
						}
					}
				}
			}
			var obj : Object = findPartDiskForRadius(name, radius);
			if (!obj) {
				var prefix:String=getPrefixDep(partDisk);
				obj  = findPartDiskForRadius(name+prefix, radius);
			}
			if(obj && obj.part){

                return obj.part;
			}
			return null;
        }
		
		public function findMainPartDisk():PartDisk{

			var partDisk:PartDisk;
			for each(partDisk in this.possibleParts){
				if(partDisk.main){
					return partDisk
				}
			}
			return null;
		}

		override public function removePartByRadius(radius:int):void{
			var brandName:String;
			var items:Object;
			var i:int;
			var newRadiusList:Array = radiusList;
			var radiusIndex:int = newRadiusList.indexOf(radius);

			var minSize:int;
			var maxSize:int;

			if(radiusIndex != -1){
				newRadiusList.removeAt(radiusIndex);
			}

			for(var partId:String in possiblePartsMap){
				var partDisk:PartDisk = possiblePartsMap[partId] as PartDisk;
				if(partDisk && partDisk.properties){
					if(partDisk.properties.size == radius){
						if(possiblePartsMap[partDisk.id]){
							possiblePartsMap[partDisk.id] = null;
							delete possiblePartsMap[partDisk.id];
						}
						var partIndex:int = _possibleParts.indexOf(partDisk);
						if(partIndex != -1){
							_possibleParts.removeAt(partIndex);
						}
					}
				}
			}

			for(brandName in _possiblePartList){
				items = _possiblePartList[brandName];
				if(items && items.hasOwnProperty(radius.toString())){
					delete items[radius.toString()];
				}
				if(ObjectUtils.isEmpty(items)){
					delete _possiblePartList[brandName];
				}else{
					var keyArr:Array = ObjectUtils.getKeys(items, true);
					minSize = keyArr[0];
					maxSize = keyArr[keyArr.length - 1];
					for each(var parts:Object in items){
						for each(var itemPart:PartDisk in parts){
							if(itemPart && itemPart.properties){
								if(itemPart.selectedDiskSize == radius){
									if(radius < minSize){
										itemPart.selectedDiskSize = minSize;
									}else{
										itemPart.selectedDiskSize = maxSize;
									}
								}
								if(itemPart.properties.hasOwnProperty("min_size")){
									itemPart.properties.min_size = minSize;
								}
								if(itemPart.properties.hasOwnProperty("max_size")){
									itemPart.properties.max_size = maxSize;
								}

								if(itemPart.minRadius){
									itemPart.minRadius = minSize;
								}
								if(itemPart.maxRadius){
									itemPart.maxRadius = maxSize;
								}
							}
						}
					}
				}
			}

			for(brandName in diskRadiusMap){
				items = diskRadiusMap[brandName];
				if(items && items.hasOwnProperty(radius.toString())){
					delete items[radius.toString()];
				}
				if(ObjectUtils.isEmpty(items)){
					delete diskRadiusMap[brandName];
					Console.log("brand empty", brandName);
				}
			}


			// removing tires, brakes and vinyls
			var dir:String;
			if(name.indexOf("front") != -1){
				dir = "front";
			}else if(name.indexOf("rear") != -1){
				dir = "rear";
			}
			var tireSlot:PartSlot;
			var brakeSlot:PartSlot;
			var vinylSlot:PartSlot;
			for(i = 0; i < Car.BRAKES_SLOTS.length; i++){
				if(dir && Car.BRAKES_SLOTS[i].indexOf(dir) != -1){
					brakeSlot = parentCar.getPossiblePartSlot(Car.BRAKES_SLOTS[i]);
					if(brakeSlot){
						brakeSlot.removePartByRadius(radius);
						break;
					}
				}else if(!dir && Car.BRAKES_SLOTS[i].indexOf("front") == -1 && Car.BRAKES_SLOTS[i].indexOf("rear") == -1){
					brakeSlot = parentCar.getPossiblePartSlot(Car.BRAKES_SLOTS[i]);
					if(brakeSlot){
						brakeSlot.removePartByRadius(radius);
						break;
					}
				}
			}
			for(i = 0; i < Car.TIRES_SLOTS.length; i++){
				if(dir && Car.TIRES_SLOTS[i].indexOf(dir) != -1){
					tireSlot = parentCar.getPossiblePartSlot(Car.TIRES_SLOTS[i]);
					if(tireSlot){
						tireSlot.removePartByRadius(radius);
						break;
					}
				}else if(!dir && Car.TIRES_SLOTS[i].indexOf("front") == -1 && Car.TIRES_SLOTS[i].indexOf("rear") == -1){
					tireSlot = parentCar.getPossiblePartSlot(Car.TIRES_SLOTS[i]);
					if(tireSlot){
						tireSlot.removePartByRadius(radius);
						break;
					}
				}
			}
			for(i = 0; i < Car.TIRE_VINYL_PARTS.length; i++){
				if(dir && Car.TIRE_VINYL_PARTS[i].indexOf(dir) != -1){
					vinylSlot = parentCar.getPossiblePartSlot(Car.TIRE_VINYL_PARTS[i]);
					if(vinylSlot){
						vinylSlot.removePartByRadius(radius);
						break;
					}
				}else if(!dir && Car.TIRE_VINYL_PARTS[i].indexOf("front") == -1 && Car.TIRE_VINYL_PARTS[i].indexOf("rear") == -1){
					vinylSlot = parentCar.getPossiblePartSlot(Car.TIRE_VINYL_PARTS[i]);
					if(vinylSlot){
						vinylSlot.removePartByRadius(radius);
						break;
					}
				}
			}

			var pairDisk:PartSlotDisk;

			if(name.indexOf("left") != -1){
				pairDisk = parentCar.getPossiblePartSlot(name.replace("left")) as PartSlotDisk;
			}else if(name.indexOf("right") != -1){
				pairDisk = parentCar.getPossiblePartSlot(name.replace("right")) as PartSlotDisk;
			}
			if(pairDisk){
				pairDisk.removePartByRadius(radius);
			}
		}

		public function get possiblePartList():Object {
			return _possiblePartList;
		}
	}
}


