package com.despark.tuning3d.model.sharing
{
import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.distriqt.extension.core.Core;
	import com.distriqt.extension.share.Share;
	import com.distriqt.extension.share.ShareOptions;
	import com.distriqt.extension.share.events.ShareEvent;
	import com.utils.Tracker;

	import flash.display.Bitmap;
import flash.display.BitmapData;

import org.puremvc.as3.patterns.proxy.Proxy;

//import ru.inspirit.net.MultipartURLLoader;

	public class SharingInstagramProxy extends Proxy
	{
		public static const NAME : String = "SharingInstagramProxy";
		public var logoBitmap : Bitmap;
		public var screenScale : int;
		private var alertViewOfFB : AlertView = null;
		public var cb: Function;
		public function SharingInstagramProxy()
		{
			super(NAME);
			Core.init();
		}
		
		public function prepare() : void
		{
			sendNotification(Notifications.SHARING_READY,"SHARE");
		}


		
		public function sharePhoto(message : String, bitmapData : BitmapData, complete:Function=null, url:String = '') : void {
			if (Share.isSupported) {
				Share.service.addEventListener( ShareEvent.COMPLETE,	onInstagramComplete );
				Share.service.addEventListener( ShareEvent.CANCELLED,	onInstagramComplete );
				Share.service.addEventListener( ShareEvent.FAILED,  	onInstagramComplete );
				Share.service.addEventListener( ShareEvent.CLOSED,  	onInstagramComplete );
                Share.service.share(message, bitmapData, url);
				/*
				if(Constants.isIOS){
                    Share.service.share( message, bitmapData);
				}else{
                    var options:ShareOptions = new ShareOptions();
                    options.packageName = "com.instagram.android";
                    options.UTI = "com.instagram.photo";
					if(Share.service.isApplicationInstalled(options.packageName, "instagram://app")){
                        Share.service.share( message, bitmapData, "", options);
					}else{
                        Share.service.share( message, bitmapData);
                    }
				}
				*/
				this.cb = complete;
			}

		}
		
		private function onInstagramComplete(event:ShareEvent):void{

			if(cb){
				cb();
				cb=null;
			}

			if(alertViewOfFB) alertViewOfFB.hide();
			alertViewOfFB = null;

			sendNotification(Notifications.SHARING_PHOTO_UPLOADED);

			Tracker.trackEvent("Tuning", "share");
		}
	}
}