package com.despark.tuning3d.model.users {
    import com.utils.ArrayUtil;

    public class ChallengeUser extends User {
        public var rating:Number = 0;
        public var keys:int = 0;
        public var diamonds:int = 0;
        public var submittedChallenges:Array = [];
        private var _onUpdate:Function;
        public function ChallengeUser(data:Object = null) {
            super(data);
            updateData(data);
        }

        override public function updateData(data:Object = null):void{
            super .updateData(data);
            if(!data){
                if(rating != 0){
                    rating = 0;
                    updated = true;
                }
                if(keys != 0){
                    keys = 0;
                    updated = true;
                }
                if(diamonds != 0){
                    diamonds = 0;
                    updated = true;
                }
                if(updated && _onUpdate != null){
                    _onUpdate();
                }
                return;
            }
            var updated:Boolean = false;
            var nv:Number = 0;
            if(data.hasOwnProperty("challengeNewSystemRatings")){
                if(data["challengeNewSystemRatings"] is Array){
                    nv = countAvg(data["challengeNewSystemRatings"]);
                }else if(data["challengeNewSystemRatings"] is Number){
                    nv = data["challengeNewSystemRatings"];
                }
                if(rating != nv){
                    rating = nv;
                    updated = true;
                }
            }else if(data.hasOwnProperty("averageRating")){
                nv = data["averageRating"];
                if(rating != nv){
                    rating = nv;
                    updated = true;
                }
            }
            if(data.hasOwnProperty("challengeNewSystemKeys")){
                nv = data["challengeNewSystemKeys"];
                if(keys != nv){
                    keys = nv;
                    updated = true;
                }
            }
            if(data.hasOwnProperty("challengeNewSystemDiamonds")){
                nv = data["challengeNewSystemDiamonds"];
                if(diamonds != nv){
                    diamonds = nv;
                    updated = true;
                }
            }
            if(data.hasOwnProperty("challengeNewList")){
                var arr:Array = data["challengeNewList"];
                if(arr && !ArrayUtil.equals(submittedChallenges, arr)){
                    submittedChallenges = arr;
                    updated = true;
                }
            }
            if(updated && _onUpdate != null){
                _onUpdate();
            }
        }

        private static function countAvg(arr:Array):Number{
            var result:Number = 0;
            for (var i:int = 0; i < arr.length; i++){
                result += arr[i];
            }
            return result / (arr.length + 1);
        }

        public function set onUpdate(value:Function):void {
            _onUpdate = value;
        }

        public function get onUpdate():Function {
            return _onUpdate;
        }
    }
}
