package com.despark.tuning3d.view
{
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.model.users.UsersProxy;
	import com.despark.tuning3d.view.components.brands.BuyCarPopUp;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.core.PopUpMediator;
	import com.utils.ArrayUtil;

	import org.puremvc.as3.interfaces.INotification;

	import starling.events.Event;

	public class BuyCarPopUpMediator extends PopUpMediator
	{
		//private var sizesSum : Number = 0;
		//private var selectedPartSlots : Array;
		//private var partSlotsProxy : PartSlotsProxy;
		//private var carsProxy : CarsProxy;
		//private var downloadsProgressView : DownloadsProgressView;
		//private var expandedPartSlots : Array;
		//private var SaveDefCar: Boolean;
		
		public function BuyCarPopUpMediator(popUp : PopUp)
		{
			super(popUp);
			
			//selectedPartSlots = [];
			
			//partSlotsProxy = facade.retrieveProxy(PartSlotsProxy.NAME) as PartSlotsProxy;
			//carsProxy = facade.retrieveProxy(CarsProxy.NAME) as CarsProxy;
		}
		
		override public function listNotificationInterests():Array {
            return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
				/*Notifications.CAR_PARTS_DOWNLOADED,
				Notifications.CAR_PARTS_DOWNLOAD_FAILED,
				Notifications.CAR_PARTS_DOWNLOAD_CACHING_FAILED*/
			])
		}
		
		override public function handleNotification(note : INotification) : void
		{
			/*switch(note.getName())
			{
				case Notifications.CAR_PARTS_DOWNLOADED:
					handlePartsDownloaded();
					break;
				
				case Notifications.CAR_PARTS_DOWNLOAD_FAILED:
					handlePartsFailedDownload();
					break;
				
				case Notifications.CAR_PARTS_DOWNLOAD_CACHING_FAILED:
					handlePartsDownloadCachingFailed();
					break;
			}*/
			
			super.handleNotification(note);
		}
		
		public function get buyCarPopUp() :BuyCarPopUp
		{
			
			
			return BuyCarPopUp(popUp);
		}
		
		override public function onRegister() : void
		{
			super.onRegister();
			
			buyCarPopUp.addEventListener(Event.ADDED_TO_STAGE, downloadsPopUpAddedToStageHandler);
			
			buyCarPopUp.addEventListener(BuyCarPopUp.BUY_NOW_CAR, buyNowCar);
			/*downloadsPopUp.addEventListener(DownloadsPopUp.DELETE_SELECTED, downloadsPopUpDeleteSelectedHandler);
			downloadsPopUp.addEventListener(DownloadsPopUp.DOWNLOAD_SELECTED, downloadsPopUpDownloadSelectedHandler);
			downloadsPopUp.addEventListener(DownloadsPartSlotView.SELECTION_STATE_CHANAGED, downloadsPartSlotViewSelectionStateChangedHandler);
			downloadsPopUp.addEventListener(DownloadsDefCarSlotView.SELECTION_DEF_CAR_STATE_CHANAGED, downloadsDefCarSlotViewSelectionStateChangedHandler);
			
			downloadsPopUp.addEventListener(DownloadsPopUp.CLEAN_CACHE_SELECTED, downloadsPopUpDownloadCleanCacheHandler);*/
			//
		}
		
		override public function onRemove() : void
		{
			super.onRemove();
			
			buyCarPopUp.removeEventListener(Event.ADDED_TO_STAGE, downloadsPopUpAddedToStageHandler);
			
			buyCarPopUp.removeEventListener(BuyCarPopUp.BUY_NOW_CAR, buyNowCar);
			/*downloadsPopUp.removeEventListener(DownloadsPopUp.DELETE_SELECTED, downloadsPopUpDeleteSelectedHandler);
			downloadsPopUp.removeEventListener(DownloadsPopUp.DOWNLOAD_SELECTED, downloadsPopUpDownloadSelectedHandler);
			downloadsPopUp.removeEventListener(DownloadsPartSlotView.SELECTION_STATE_CHANAGED, downloadsPartSlotViewSelectionStateChangedHandler);
			downloadsPopUp.removeEventListener(DownloadsDefCarSlotView.SELECTION_DEF_CAR_STATE_CHANAGED, downloadsDefCarSlotViewSelectionStateChangedHandler);
			
			downloadsPopUp.removeEventListener(DownloadsPopUp.CLEAN_CACHE_SELECTED, downloadsPopUpDownloadCleanCacheHandler);*/
		}
		
		private function downloadsPopUpAddedToStageHandler(event : Event) : void
		{
			//moreCarsPopUp.setDownloadButtonEnabled(false);
			/*downloadsPopUp.setDeleteButtonEnabled(false);
			downloadsPopUp.totalValueLabel.text = "0 MB";
			
			var car : Car = downloadsPopUp.car;
			
			downloadsPopUp.enterIntializationState();
			
			Starling.juggler.delayCall(function() : void
			{
				expandedPartSlots = getExpandedPartSlots("disks", 3);
				
				carsProxy.updatePartSlotsSizes(car, expandedPartSlots);
				downloadsPopUp.partSlotsForDownload = expandedPartSlots;
				
				downloadsPopUp.enterSelectionState();
			}, 0.5);*/
		}
		
		
		
		
	
		private function buyNowCar(event:Event):void{
			
			
		//	trace("buyNowCar:",event.data.car );
			sendNotification(Notifications.REMOVE_POP_UP, popUp);
			sendNotification(Notifications.BUY_NOW_CAR, {car:event.data.car});
		}
		
		
		
		
	
		//
		private function downloadsPopUpDownloadCleanCacheHandler(event : Event) : void
		{
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.deleteAllCache();
		
		}
		
		
	
		
	}
}