package com.despark.tuning3d.view {
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.view.components.challenges.ChallengesNotificationsScreen;
    import com.despark.tuning3d.view.components.core.StackedScreen;

    import org.puremvc.as3.interfaces.INotification;

    import starling.events.Event;

    public class ChallengesNotificationsScreenMediator extends ChallengesScreenMediator {
        private var challengeProxy : ChallengesProxy;
        public function ChallengesNotificationsScreenMediator(stackedScreen:StackedScreen) {
            super(stackedScreen);
        }

        override public function onRegister():void {
            super.onRegister();
            challengeProxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            Constants.selectedUser = null;
            challengesVotingScreen.showLoadBar();
            challengesVotingScreen.addEventListener(ChallengeEvent.GET_NOTIFICATIONS, getNotificationsHandler);
            challengesVotingScreen.addEventListener(ChallengeEvent.TUNING_SELECTED, tuningSelectedHandler);
            challengesVotingScreen.addEventListener(ChallengeEvent.CHALLENGE_CLAIM_REWARD, claimRewardHandler);
            markUnreadNotifications();
        }

        private function tuningSelectedHandler(event:Event):void {
            sendNotification(Notifications.DISPLAY_CHALLENGE_TUNING_POPUP, event.data);
        }

        private function claimRewardHandler(event:Event):void {
            var data:Object = event.data;
            challengeProxy.claimRewards(data._id, data.diamond);
        }

        override public function onRemove():void {
            super.onRemove();
            challengesVotingScreen.removeEventListener(ChallengeEvent.GET_NOTIFICATIONS, getNotificationsHandler);
            challengesVotingScreen.removeEventListener(ChallengeEvent.CHALLENGE_CLAIM_REWARD, claimRewardHandler);
            challengesVotingScreen.removeEventListener(ChallengeEvent.TUNING_SELECTED, tuningSelectedHandler);
            challengesVotingScreen.dispose();
            challengeProxy = null;
        }

        override protected function challengeScreenHomeSelectedSelectedHandler(event:Event):void{
            sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
        }


        private function getNotificationsHandler(event:Event):void {
            challengeProxy.getNewNotifications(event.data.skip, event.data.limit, challengesVotingScreen.loadNotifications);
        }

        private function markUnreadNotifications():void {
            challengeProxy.markUnreadNotifications();
            Constants.UNREAD_CHALLENGE_NOTIFICATIONS = 0;
        }

        public function get challengesVotingScreen():ChallengesNotificationsScreen {
            return viewComponent as ChallengesNotificationsScreen;
        }

        override public function handleNotification(note:INotification):void {
            switch (note.getName()) {

            }
            super.handleNotification(note);
        }
    }
}
