/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.view {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.cars.CarsProxy;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.friend.FriendProxy;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.LanguagesProxy;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.settings.Settings;
    import com.despark.tuning3d.model.settings.SettingsProxy;
    import com.despark.tuning3d.model.timeline.TimelineProxy;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.brands.BrandsScreen;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.MainMenuItem;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
    import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
    import com.despark.tuning3d.view.components.gallery.GalleryScreen;
    import com.despark.tuning3d.view.components.gallery.GalleryTuningPopup;
    import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
    import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
    import com.despark.tuning3d.view.core.StackedScreenMediator;
    import com.distriqt.AdsManager;
    import com.utils.ArrayUtil;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;
    import starling.events.Event;

    public class GalleryScreenMediator extends StackedScreenMediator{
    private var _screen_delay:Number = 0.1;
    private var showAlertConnectionLost:Boolean;
    private var _tuningData:Object;
    public function GalleryScreenMediator(stackedScreen:StackedScreen) {
        super(stackedScreen);
    }


    override public function onRegister() : void {
        super.onRegister();

        galleryScreen.addEventListener(TuningsListScreen.TUNING_SELECTED, tuningPopupSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.HOME_SELECTED, homeSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.BRANDS_SELECTED, brandsSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.VOTE_SELECTED, votesSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.GARAGE_SELECTED, garageSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.USER_GARAGE_SELECTED, userGarageSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.TIMELINE_SELECTED, timelineSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.FRIENDS_SELECTED, friendsSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.NOTIFICATION_SELECTED, notificationsSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
        galleryScreen.addEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);
        galleryScreen.addEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);

        galleryScreen.addEventListener(BrandsScreen.LANGUAGE_CHANGED,languageChangedHandler);
        galleryScreen.addEventListener(BrandsScreen.LOGIN_SELECTED, loginSelectedHandler);
        galleryScreen.addEventListener(BrandsScreen.LOGOUT_SELECTED, logoutSelectedHandler);

        galleryScreen.addEventListener(StackedScreen.CHALLENGES_SELECTED, challengeSelectHandler);
        galleryScreen.addEventListener(StackedScreen.IN_APP_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
        galleryScreen.addEventListener(StackedScreen.LEADER_BOARD_SELECTED, leaderBoardSelectHandler);
        Starling.juggler.delayCall(initialize, 1);
    }



    private function initialize():void{
        var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
        friendProxy.loadPendings();
    }

    private function leaderBoardSelectHandler(event : Event) : void {
        BannerStackedScreen.hideAdBanner(false);
    }

    private function challengeSelectHandler(event : Event) : void {
        sendNotification(Notifications.DISPLAY_CHALLENGE_SCREEN);
    }

    override public function onRemove() : void
    {
        super.onRemove();
        galleryScreen.removeEventListener(TuningsListScreen.TUNING_SELECTED, tuningPopupSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.HOME_SELECTED, homeSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.BRANDS_SELECTED, brandsSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.VOTE_SELECTED, votesSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.GARAGE_SELECTED, garageSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.USER_GARAGE_SELECTED, userGarageSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.TIMELINE_SELECTED, timelineSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.FRIENDS_SELECTED, friendsSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.NOTIFICATION_SELECTED, notificationsSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
        galleryScreen.removeEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);
        galleryScreen.removeEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);

        galleryScreen.removeEventListener(BrandsScreen.LANGUAGE_CHANGED,languageChangedHandler);
        galleryScreen.removeEventListener(BrandsScreen.LOGIN_SELECTED, loginSelectedHandler);
        galleryScreen.removeEventListener(BrandsScreen.LOGOUT_SELECTED, logoutSelectedHandler);

        galleryScreen.removeEventListener(StackedScreen.CHALLENGES_SELECTED, challengeSelectHandler);
        galleryScreen.removeEventListener(StackedScreen.IN_APP_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
        galleryScreen.removeEventListener(StackedScreen.LEADER_BOARD_SELECTED, leaderBoardSelectHandler);
        galleryScreen.dispose();
    }

    private function gallerySelectHandler(event : Event) : void {
        sendNotification(Notifications.DISPLAY_GALLERY_SCREEN);
    }

    private function tuningPopupSelectedHandler(event:Event):void {
        var data:Object = event.data;
        data.deleteOtherScreens = false;
        data.enableCloseButton = true;
        data.eventDispatcher = galleryScreen;
        _tuningData = data;
        var selectedUser:User = data.user as User;
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        var currentUser:User = usersProxy.currentUser;
        if((currentUser && selectedUser && selectedUser.id != currentUser.id) || !currentUser){
            Constants.selectedUser = selectedUser;
        }else{
            Constants.selectedUser = null;
        }
        AdsManager.$.bannerHide(false);
        sendNotification(Notifications.DISPLAY_GALLERY_TUNING_POPUP, data);
    }

    private function challengeNotesSelectHandler(event : Event) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(!usersProxy.currentUser) {
            _screen_delay = 1.5;
        } else {
            _screen_delay = 0.2;
        }

        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_IN_APP_NOTIFICATIONS;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function userDetailsSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_USER_DETAILS_POPUP, event.data);
    }

    private function loginSelectedHandler(event : Event) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(!usersProxy.currentUser) {
            _screen_delay = 1.5;
        } else {
            _screen_delay=0.2;
        }
        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_LOGIN;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function handleUserAuthenticated() : void {
        if(!galleryScreen.userSignedIn){
            var userProxy:UsersProxy =  facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if(userProxy.currentUser && userProxy.currentUser.isSuperAdmin){

                var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                packagesProxy.packages = [];
                //galleryScreen.packages = [];
                CarsProxy.IS_FULL = true;
                Constants.IN_APP_PURCHASE_ENABLED = false;
                Constants.update_API_URLS(true);
                //loadData();
            }else{
                Constants.update_API_URLS(false);
                CarsProxy.IS_FULL = false;
                Constants.IN_APP_PURCHASE_ENABLED = true;
                //loadData();
            }
        }

        if (pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_LOGIN){
            galleryScreen.invalidateTunings();
        }

        var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
        friendProxy.loadPendings();

        if (galleryScreen){
            galleryScreen.userSignedIn = true;
        }

        if(stackedScreen && !stackedScreen.stage) {
            return;
        }

        if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_FRIENDS) {
            Starling.juggler.delayCall(function():void{
                BannerStackedScreen.hideAdBanner(false);
                sendNotification(Notifications.DISPLAY_FRIENDS_LIST_SCREEN, {showBannerAfterExit: true});
            }, _screen_delay);
        }

        if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_GARAGE){
            Starling.juggler.delayCall(function():void{
                sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
            }, _screen_delay);
        }else if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_MAILS){
            Starling.juggler.delayCall(function():void{
                sendNotification(Notifications.DISPLAY_MAIL_SCREEN);
            }, _screen_delay);
        }else if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_TIMELINE) {
            Starling.juggler.delayCall(function():void{
                sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN);
            }, _screen_delay);
        }else if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_IN_APP_NOTIFICATIONS){
            Starling.juggler.delayCall(function():void{
                BannerStackedScreen.hideAdBanner(false);
                sendNotification(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP, {showBannerAfterExit: true});
            }, _screen_delay);
        }
    }

    private function mailSelectedHandler(event:Event):void {
        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_MAILS;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function logoutSelectedHandler(e:Event):void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        usersProxy.logoutCurrentUser();
        AlertView.show(AlertView.language.translate("mob_saving", "loggedOut"), -1, false);
        galleryScreen.ShowDone();
    }

    private function languageChangedHandler(event:Event):void {
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguage(galleryScreen.selectedLanguage);
    }

    private function votesSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_VOTES_LIST_SCREEN, null);
    }

    private function notificationsSelectedHandler(event : Event) : void{
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(!usersProxy.currentUser) {
            _screen_delay = 1.5;
        } else {
            _screen_delay = 0.2;
        }
        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_NOTIFICATIONS;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function garageSelectedHandler(event : Event): void {
        Constants.selectedUser = null;
        _screen_delay = 0.2;
        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_GARAGE;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function userGarageSelectedHandler(event : Event): void {
        if(Constants.selectedUser) {
            _screen_delay = 1.5;
            pendingForAuthAction = null;
            sendNotification(Notifications.DISPLAY_USER_DETAILS_POPUP, {deleteOtherScreens : false, user: Constants.selectedUser});
            //sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
        } else {
            _screen_delay = 0.2;
            pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_GARAGE;
            sendNotification(Notifications.AUTHENTICATE_USER);
        }
    }

    private function timelineSelectedHandler( e : Event) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(!usersProxy.currentUser) {
            _screen_delay = 1.5;
        } else {
            _screen_delay = 0.2;
        }
        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_TIMELINE;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function friendsSelectedHandler(event : Event) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(!usersProxy.currentUser) {
            _screen_delay=1.5;
        } else {
            _screen_delay=0.2;
        }

        pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_FRIENDS;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }

    private function homeSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
    }

    private function brandsSelectedHandler(event:Event):void {
        if(HomeScreenPopUpMediator.isBrandScreenFirstOpen) {
            sendNotification(Notifications.DISPLAY_BRANDS_SCREEN);
        } else {
            sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
        }
        HomeScreenPopUpMediator.isBrandScreenFirstOpen = false;
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
            Notifications.PENDING_FRIENDS_LOADED,
            Notifications.CLOSE_USER_DETAILS_POPUP,

            Notifications.LANGUAGES_LOADED,
            Notifications.LANGUAGES_LOADING_FAILED,
            Notifications.LANGUAGE_LOADED,
            Notifications.LANGUAGE_LOADING_FAILED,
            Notifications.USER_LOGGED_OUT,

            Notifications.SHARING_READY,
            Notifications.TUNING_SHARING_MESSAGE_ENTERED,
            Notifications.SHARING_PREPARING_ERROR,
            Notifications.SHARING_PHOTO_UPLOADED,
            Notifications.SHARING_PHOTO_UPLOADING_ERROR,

            Notifications.SHARING_PHOTO_UPLOADING_ERROR,
            Notifications.AUTHENTICATE_USER,
            Notifications.CAR_BACKGROUNDS_LOADED,
            Notifications.USER_AUTHENTICATED,
            Notifications.DISPLAY_PREVIOUS_SCREEN,
            Notifications.TIMELINE_SCREEN_FEED_PREVIEW,
            Notifications.REMOVE_POP_UP
        ]);
    }

    override public function handleNotification(note : INotification) : void {
        switch(note.getName()) {
            case Notifications.INTERNET_CONNECTED:
                handleInternetConnected();
                break;

            case Notifications.INTERNET_DISCONNECTED:
                handleInternetDisconnected();
                break;

            case Notifications.USER_LOGGED_OUT:
                handleUserLoggedOut();
                break;

            case Notifications.USER_AUTHENTICATED:
                handleUserAuthenticated();
                break;

            case Notifications.LANGUAGES_LOADED:
                handleLanguagesLoaded();
                break;

            case Notifications.LANGUAGES_LOADING_FAILED:
                handleLanguagesLoadingFailed();
                break;

            case Notifications.LANGUAGE_LOADED:
                handleLanguageLoaded(note.getBody().language);
                break;

            case Notifications.LANGUAGE_LOADING_FAILED:
                handleLanguageLoadingFailed();
                break;
            case Notifications.PENDING_FRIENDS_LOADED:
                handlePendingFriendsLoaded(note.getBody());
                break;
            case Notifications.DISPLAY_PREVIOUS_SCREEN:
                handlePrevScreenSelected();
                break;
            case Notifications.REMOVE_POP_UP:
                handlePopupRemoved(note.getBody() as GalleryTuningPopup);
                break;

            case Notifications.TIMELINE_SCREEN_FEED_PREVIEW:
                handleDisplayTimelineScreenFeed(note.getBody());

            case Notifications.CLOSE_USER_DETAILS_POPUP:
                handleCloseUserDetailsPopup();
        }

        super.handleNotification(note);
    }

    private function handlePrevScreenSelected():void{
        if(_tuningData){
            AdsManager.$.bannerHide(false);
            _tuningData.animate = false;
            sendNotification(Notifications.DISPLAY_GALLERY_TUNING_POPUP, _tuningData);
        }
    }

    private function handleDisplayTimelineScreenFeed(data:Object):void {
        sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
    }

    private function handleCloseUserDetailsPopup():void {
        galleryScreen.refresh();
    }

    private function handlePopupRemoved(popup:GalleryTuningPopup):void{
        if(popup && !(!popup.visible && popup.name == 'restore')){
            _tuningData = null;
        }
    }

    private function handleInternetConnected():void{
        trace("handleInternetConnected");
        showAlertConnectionLost=false;
        if(!(galleryScreen.owner as  StackedScreenNavigator))
            return;
        if((galleryScreen.owner as  StackedScreenNavigator).activeScreen.name!=galleryScreen.name){

        }
    }

    private function handleInternetDisconnected():void{
        if(!BrandsScreenMediator.FIRST_LOAD_COMPLETE){
            if(!showAlertConnectionLost){
                AlertView.show("Lost internet connection",-1, false);
                showAlertConnectionLost=true;
            }
        }

        if(!(galleryScreen.owner as  StackedScreenNavigator))
            return;

        if((galleryScreen.owner as  StackedScreenNavigator).activeScreen.name!=galleryScreen.name)
            return;

        if(!showAlertConnectionLost){
            AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "lostinternetconnection"),-1, false);
            showAlertConnectionLost=true;
        }
    }

    private function handlePendingFriendsLoaded(friends: Object): void {
        galleryScreen.dispatchEventWith(FriendsListPopUp.PENDING_FRIENDS_READ, false, friends);
    }

    private function handleLanguageLoadingFailed():void {

    }

    private function handleUserLoggedOut() : void {
        sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
        galleryScreen.invalidateTunings();
    }

    private function handleLanguagesLoaded():void{
        Starling.juggler.delayCall(refreshSettings, 1.5);
    }

    private function handleLanguagesLoadingFailed() : void {
        galleryScreen.selectedLanguage = null;
    }

    private function handleLanguageLoaded(loadedLanguage : Language) : void {
        if(galleryScreen) {
            galleryScreen.updateWithLanguage(loadedLanguage);
            updateSettings();
            sendNotification(Notifications.LANGUAGE_CHANGED);
        }
    }

    private function updateSettings() : void {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var settings : Settings = settingsProxy.currentSettings;
        if(galleryScreen.selectedLanguage) {
            settings.selectedLanguageCode = galleryScreen.selectedLanguage.code;
        }
        settingsProxy.update(settings);
        if(alertView) {
            alertView.hide();
        }
    }

    private function refreshSettings() : void {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        var settings : Settings = settingsProxy.currentSettings;

        if(!settings.selectedLanguageCode) {
            settings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
        }

        galleryScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
        if(!galleryScreen.selectedLanguage){
            settings.selectedLanguageCode = "en-US";
            galleryScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
        }

        galleryScreen.languages = languagesProxy.languages;
        if(galleryScreen.languages!=null && galleryScreen.languages.length<=0){
            languagesProxy.loadLanguages();
        }else if (galleryScreen.languages == null){
            languagesProxy.loadLanguages();
        }
    }

    public function get galleryScreen() : GalleryScreen {
        return viewComponent as GalleryScreen;
    }
}
}
