package com.despark.tuning3d.view {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.brands.BrandsProxy;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.cars.CarsProxy;
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.core.AppMode;
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.brands.BrandsProxy;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.cars.CarsProxy;
import com.despark.tuning3d.model.core.AppMode;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.friend.FriendProxy;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.LanguagesProxy;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.model.packages.Purchase;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.parts.PartMaterial;
    import com.despark.tuning3d.model.parts.PartMaterialImageTest;
    import com.despark.tuning3d.model.parts.PartSlot;
    import com.despark.tuning3d.model.settings.Settings;
    import com.despark.tuning3d.model.settings.SettingsProxy;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.timeline.TimelineProxy;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.brands.BrandsScreen;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
    import com.despark.tuning3d.view.core.*;
    import com.distriqt.AdsManager;
    import com.utils.ArrayUtil;
    import com.utils.Console;
    import com.utils.DateParser;
    import com.utils.RandomSplashManager;
    import com.utils.Tracker;

    import feathers.core.PopUpManager;

    import flash.system.System;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;
    import starling.events.Event;
    import starling.utils.ScaleMode;

    public class HomeScreenPopUpMediator extends StackedBannerScreenMediator {

    public static var isBrandScreenFirstOpen : Boolean = true;
    public static var isInitialOpen : Boolean = true;
    private var _screen_delay:Number;
    public function HomeScreenPopUpMediator(screen:StackedScreen) {
        super(screen);
    }

    public function get homeScreenPopUp() : HomeScreenPopUp {
        return HomeScreenPopUp(stackedScreen);
    }


    override public function onRegister():void {
        super.onRegister();

        homeScreenPopUp.addEventListener(HomeScreenPopUp.MODE_SELECTED, onModeSelectedHandler);
        AppMode.self.addEventListener("featuredCompleteLoad", onFeaturedCompletedLoad);
        loadData();
        //
        homeScreenPopUp.addEventListener(StackedScreen.TUNING_SELECTED, carSelectedHandler);
        homeScreenPopUp.addEventListener(BrandsScreen.LANGUAGE_CHANGED, languageChangedHandler);
        homeScreenPopUp.addEventListener(StackedScreen.NEWS_SELECTED, newsSelectedHandler);

        if(isInitialOpen){
            var brandsProxy : BrandsProxy = facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy;
            brandsProxy.loadBrands();

            var userProxy:UsersProxy =  facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if(userProxy.currentUser){
                userProxy.extendSession();
                //dailyRewardsHandler(false);
            }else{
                var challengeProxy:ChallengesProxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
                challengeProxy.getGuestDeviceData(Settings.getUniqueId(), function (result:Object):void {
                    if(result){
                        var alertView:ChallengeAlertView;
                        if(result.hasOwnProperty("firstVisit")){
                            alertView = ChallengeAlertView.show(ChallengeAlertView.WELCOME_GUEST_POPUP, null, homeScreenPopUp.stage);
                            challengeProxy.updateGuestDeviceData(Settings.getUniqueId());
                        }else{
                            var lastVisitDate:Date = DateParser.parseDate(result.date);
                            if(DateParser.getDateTime(lastVisitDate) != DateParser.getDateTime(new Date())){
                                alertView = ChallengeAlertView.show(ChallengeAlertView.DAILY_GUEST_WELCOME, null, homeScreenPopUp.stage);
                                challengeProxy.updateGuestDeviceData(Settings.getUniqueId());
                            }
                        }

                        if(alertView){
                            alertView.open();
                            alertView.addEventListener(ChallengeAlertEvent.LOGIN_TRIGGERED, loginSelectHandler);
                        }
                    }
                });
            }

            if(!HomeScreenPopUp.UPDATE_OBJECT){
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadUpdateText(newsLoadedCallback);
            }
            isInitialOpen = false;
            SoundManager.playSound(SoundManager.THEME, 1000, true, 0.5);
        }
        Starling.juggler.delayCall(updateNotifications, .5);

        AdsManager.$.initializedCallback = function():void{
            Starling.juggler.delayCall(BannerStackedScreen.showAdBanner, 0.1);
        }
        Tracker.trackEvent("Home Screen", "open");
        System.pauseForGCIfCollectionImminent(1);
    }

    override public function onRemove():void {
        super.onRemove();
        homeScreenPopUp.removeEventListener(HomeScreenPopUp.MODE_SELECTED, onModeSelectedHandler);
        AdsManager.$.initializedCallback = null;
        AdsManager.$.bannerHide(true);

        homeScreenPopUp.removeEventListener(StackedScreen.TUNING_SELECTED, carSelectedHandler);
        homeScreenPopUp.removeEventListener(BrandsScreen.LANGUAGE_CHANGED, languageChangedHandler);
        homeScreenPopUp.removeEventListener(StackedScreen.NEWS_SELECTED, newsSelectedHandler);
        homeScreenPopUp.dispose();
    }

    private function newsLoadedCallback():void{
        sendNotification(Notifications.NEWS_LOADED);
    }

    private function newsSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_NEWS_POPUP, {
            data: HomeScreenPopUp.UPDATE_OBJECT,
            showBannerAfterExit: true,
            homeScreenPopUp: homeScreenPopUp
        });
        Starling.juggler.delayCall(homeScreenPopUp.updateNotificationCount, 2);
    }

    private function loginSelectHandler(event:Event):void {
        userAuthenticate(null);
    }

    private function languageChangedHandler(event:Event):void {
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguage(homeScreenPopUp.selectedLanguage);
    }

    private function carSelectedHandler(event : Event) : void {
        /*var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(usersProxy.httpClient.isUserSigned){
            continueCarSelect(event);
            return;
        }*/

        var textOfMessage:String = AlertView.language.translate("carchooserTop", "agreement_text");
        var title:String = AlertView.language.translate("carchooserTop", "agreement_title");
        var agree:String = AlertView.language.translate("carchooserTop", "agree");
        var disagree:String = AlertView.language.translate("carchooserTop", "disagree");
        if(!textOfMessage){
            textOfMessage = "Вы согласны с <u><a href=\"http://google.com\">лицензионным соглашением</a></u>?";
        }
        SoundManager.playSound(SoundManager.SELECT_PART);
        AlertViewHL.show(title,textOfMessage, agree,disagree, -1, false, function(yesSelected : Boolean) : void {
            if(yesSelected){
                continueCarSelect(event);
            }
        },  0x49cc46);
    }


    private function continueCarSelect(event : Event) : void {
        AppMode.self.setModeTuning();
        /*if(event.data.screenMode == AppMode.MODE_TUNING){
            AppMode.self.setModeTuning();
        }else if(event.data.screenMode == AppMode.MODE_TRUCK_CONFIGURATOR){
            AppMode.self.setModeTruckConfigurator();
        }else if(event.data.screenMode == AppMode.MODE_AMERICAN_MUSCLE){
            AppMode.self.setModeAmericanMuscle();
        }
*/
        var car:Car = new Car();
        car.id = event.data.carId;
        car.carType = AppMode.getCarTypeForMode();
        var info : Object = {
            car : car
        };
        var partSlot:PartSlot = new PartSlot(car);
        var partCarSplash:Part = new Part(partSlot);
        var partMaterial:PartMaterial = new PartMaterial(partCarSplash);
        var randomSplashUrl:String = RandomSplashManager.getRandomUrl();

        var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
        carSplashImageProvider.frameIndex = 0;
        carSplashImageProvider.angleIndex = 0;
        carSplashImageProvider.isEncrypted = false;


        var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
        carSplashImage.overrideDispose = true;
        carSplashImage.snapToPixels = false;
        if(Constants.TOTAL_MEMORY<1024 && Constants.SCALE_FACTOR<2){
            carSplashImage.bitmapScale = 0.5;
        }
        carSplashImage.visible = false;
        BlockerView.show();
        if(Starling.current.stage) {
            Starling.current.stage.addChild(carSplashImage);
            carSplashImage.completeHandler = function (image:ImageLoaderWithStates):void {
                info.carSplashImage = carSplashImage;
                showInterstitial(function():void{
                    BlockerView.hide();
                    PopUpManager.removeAllPopUps(true);
                    sendNotification(Notifications.DISPLAY_TUNING_SCREEN, info);
                });
            };
            carSplashImage.scaleMode = ScaleMode.NONE;
            carSplashImage.persistentImageProvider = carSplashImageProvider;
        }
    }

    private function showInterstitial(callback:Function):void{
        if(AdsManager.ENABLED){
            AdsManager.$.requestInterstitial(function(success:Boolean):void{
                callback();
            });
        }else{
            callback();
        }
    }

    private function onFeaturedCompletedLoad(event:Event):void {
        if(homeScreenPopUp.brandsLoaded()) {
            AppMode.self.removeEventListener("featuredCompleteLoad", onFeaturedCompletedLoad);
        }
    }

    private function onModeSelectedHandler(event:Event):void {
        if(isBrandScreenFirstOpen) {
            sendNotification(Notifications.DISPLAY_BRANDS_SCREEN);
        } else {
            sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
        }
        isBrandScreenFirstOpen = false;
    }

    private function loadData() : void {
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguages();

        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languageToLoad : Language = Language.createInstance(settingsProxy.currentSettings.selectedLanguageCode);

        if(languagesProxy.defaultLanguageCode.indexOf("ru")<0 && settingsProxy.currentSettings.selectedLanguageCode && settingsProxy.currentSettings.selectedLanguageCode.indexOf("en")<0){
            settingsProxy.currentSettings.selectedLanguageCode = "en-US";
        }

        languageToLoad.code = settingsProxy.currentSettings.selectedLanguageCode;
        languagesProxy.loadLanguage(languageToLoad);
    }

    private function handleUserLoggedIn():void{
        var brandsProxy : BrandsProxy = facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy;
        brandsProxy.loadBrands();
        homeScreenPopUp.updateUserData(UsersProxy.loggedInUserJSON());
    }

    private function handleUserAuthenticated() : void {
        if(!homeScreenPopUp.userSignedIn){
            var userProxy:UsersProxy =  facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if(userProxy.currentUser && userProxy.currentUser.isSuperAdmin){
                var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                packagesProxy.packages = [];
                CarsProxy.IS_FULL = true;
                Constants.IN_APP_PURCHASE_ENABLED = false;
                Constants.update_API_URLS(true);
            }else{
                Constants.update_API_URLS(false);
                CarsProxy.IS_FULL = false;
                Constants.IN_APP_PURCHASE_ENABLED = true;
            }
        }

        if (homeScreenPopUp){
            homeScreenPopUp.userSignedIn = true;
        }
    }


    private function handleLanguageLoaded(loadedLanguage : Language) : void {
        if(homeScreenPopUp) {
            homeScreenPopUp.updateWithLanguage(loadedLanguage);
            if(alertView) {
                alertView.hide();
            }
            sendNotification(Notifications.LANGUAGE_CHANGED);
        }
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [

            Notifications.LANGUAGES_LOADED,
            Notifications.LANGUAGES_LOADING_FAILED,
            Notifications.LANGUAGE_LOADED,
            Notifications.LANGUAGE_LOADING_FAILED,
            Notifications.USER_LOGGED_OUT,

            Notifications.SHARING_READY,
            Notifications.TUNING_SHARING_MESSAGE_ENTERED,
            Notifications.SHARING_PREPARING_ERROR,
            Notifications.SHARING_PHOTO_UPLOADED,
            Notifications.SHARING_PHOTO_UPLOADING_ERROR,

            Notifications.CHALLENGE_NOTIFICATIONS_VIEWED,
            Notifications.SHARING_PHOTO_UPLOADING_ERROR,
            Notifications.AUTHENTICATE_USER,
            Notifications.CAR_BACKGROUNDS_LOADED,
            Notifications.USER_AUTHENTICATED,
            Notifications.USER_LOGGED_IN,
            Notifications.DISPLAY_PREVIOUS_SCREEN,
            Notifications.REMOVE_POP_UP,

            Notifications.BRANDS_LOADED,
            Notifications.PACKAGES_LOADED,
            Notifications.PURCHASES_LOADED,
            Notifications.PENDING_FRIENDS_LOADED,
            Notifications.TIMELINE_SCREEN_FEED_PREVIEW,
            Notifications.UPDATE_NOTIFICATION_COUNTS,
            Notifications.USER_DATA_UPDATED,

            Notifications.NEWS_LOADED
        ]);
    }

    override public function handleNotification(note:INotification):void {
        switch(note.getName()) {
            case Notifications.BRANDS_LOADED:
                handleBrandsLoaded(note.getBody().brands);
                break;
            case Notifications.LANGUAGE_LOADED:
                handleLanguageLoaded(note.getBody().language);
                break;
            case Notifications.INTERNET_CONNECTED:
                handleInternetConnected();
                break;

            case Notifications.INTERNET_DISCONNECTED:
                handleInternetDisconnected();
                break;

            case Notifications.USER_LOGGED_OUT:
                handleUserLoggedOut();
                break;

            case Notifications.USER_AUTHENTICATED:
                // handleUserAuthenticated();
                break;

            case Notifications.USER_LOGGED_IN:
                handleUserLoggedIn();
                break;

            case Notifications.LANGUAGES_LOADED:
                handleLanguagesLoaded();
                break;

            case Notifications.LANGUAGES_LOADING_FAILED:
                handleLanguagesLoadingFailed();
                break;

            case Notifications.LANGUAGE_LOADING_FAILED:
                handleLanguageLoadingFailed();
                break;

            case Notifications.PENDING_FRIENDS_LOADED:
                handlePendingFriendsLoaded(note.getBody());
                homeScreenPopUp.updateNotificationCount();
                break;

            case Notifications.UPDATE_NOTIFICATION_COUNTS:
                homeScreenPopUp.updateNotificationCount();
                break;

            case Notifications.NEWS_LOADED:
                homeScreenPopUp.updateNotificationCount();
                break;

            case Notifications.TIMELINE_SCREEN_FEED_PREVIEW:
                handleDisplayTimelineScreenFeed(note.getBody());
                break;

            case Notifications.PACKAGES_LOADED:
                handleCarPackagesLoaded(note.getBody().packages);
                break;

            case Notifications.PURCHASES_LOADED:
                handlePurchasesLoaded(note.getBody().purchases);
                break;

            case Notifications.AUTHENTICATE_USER:
                handleAuthenticateUser();
                break;

            case Notifications.DISPLAY_PREVIOUS_SCREEN:
                if(homeScreenPopUp.stage){
                    handlePopupRemoved();
                }
                break;
            case Notifications.REMOVE_POP_UP:
                 Console.log(PopUpManager.popUpCount);
                break;

        }

        super.handleNotification(note);
    }

    override protected function userDataUpdatedHandler(event:Event):void {
        //dailyRewardsHandler(false);
    }

    private function handleAuthenticateUser():void {

    }

    private function handlePopupRemoved():void {
        Starling.juggler.delayCall(BannerStackedScreen.showAdBanner, 0.2);
    }

    private function handlePurchasesLoaded(products:Array):void{
        var i:int;
        var packet:Packet;
        var packagePacketMap:Object={};
        var existAllPacket:Boolean=false;
        var existCurrentAllPacket:Boolean=false;
        var packetCurrentAllPacket:Packet=null;
        var purchases:Array=[];
        var packet_id:String;
        var j:int;
        if(!products)
            return;
        var packagesProxy : PackagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
        if(!packagesProxy.packages)
            return;
        for(i=0; i<packagesProxy.packages.length; i++){
            packet=packagesProxy.packages[i];
            for(j=0; j<products.length; j++ ){
                packet_id=products[j].product;
                if(packet.id==packet_id || packet.productId === products[j].productId){
                    products[j].product = packet.id;
                    packagePacketMap[packet_id]=packet;
                }
            }
        }

        for each( packet in packagePacketMap){
            purchases.push(new Purchase(packet.id, packet.title, true, packet.type, packet.productId));
            packet.lock=false;
            if(packet.type==Packet.TYPE_ALLPACKET){
                existAllPacket=true;
            }

            if(packet.type==Packet.TYPE_CURRENTALLPACKET){
                existCurrentAllPacket=true;
                packetCurrentAllPacket=packet;
            }
        }

        if(existAllPacket){
            for(i=0; i<packagesProxy.packages.length; i++){
                packet=packagesProxy.packages[i];
                packet.lock=false;
            }
        }else if(existCurrentAllPacket){
            for(i=0; i<packagesProxy.packages.length; i++){
                packet=packagesProxy.packages[i];
                if(packetCurrentAllPacket.packets.indexOf(packet.id)>=0){
                    packet.lock=false;
                }
            }
        }

        if(purchases.length>0){
            AdsManager.turnOffAds();
        }
    }


    private function handleBrandsLoaded(brands:Array):void{
        var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(usersProxy.currentUser && usersProxy.currentUser.isSuperAdmin){
            packagesProxy.packages = [];
            CarsProxy.IS_FULL = true;
            Constants.IN_APP_PURCHASE_ENABLED = false;
            Constants.update_API_URLS(true);
        }else{
            Constants.update_API_URLS(false);
            CarsProxy.IS_FULL = false;
            Constants.IN_APP_PURCHASE_ENABLED = true;
            packagesProxy.loadPackages(BrandsProxy.makeAllCarsList(brands));
        }
    }

    private function handleCarPackagesLoaded(packages : Array) : void {
        var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(Constants.IN_APP_PURCHASE_ENABLED && !usersProxy.purchasesLoaded) {
            usersProxy.getPurchases();
        }
        // packagesLoaded = true;
    }

    private function handleDisplayTimelineScreenFeed(data:Object):void {
        sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
    }

    private function handlePendingFriendsLoaded(friends: Object): void {
        homeScreenPopUp.dispatchEventWith(FriendsListPopUp.PENDING_FRIENDS_READ, false, friends);
    }

    private function updateNotifications():void{
        var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
        friendProxy.loadPendings();
        (facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy).loadFullUnreadNotificationCount(function (obj:Object) : void {
            homeScreenPopUp.updateNotificationCount();
        });
    }

    private function handleInternetConnected():void{
        trace("handleInternetConnected");
    }


    private function handleInternetDisconnected():void{
        AlertView.show("Lost internet connection",-1, false);
    }


    private function handleUserLoggedOut() : void {
        sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
        homeScreenPopUp.updateNotificationCount();
        handleUserLoggedIn();
    }


    private function handleLanguagesLoaded():void{
        Starling.juggler.delayCall(refreshSettings, 1.5);
    }

    private function handleLanguagesLoadingFailed() : void {
        homeScreenPopUp.selectedLanguage = null;
    }

    private function handleLanguageLoadingFailed():void {

    }

    private function refreshSettings() : void {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        var settings : Settings = settingsProxy.currentSettings;

        if(!settings.selectedLanguageCode) {
            settings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
        }

        homeScreenPopUp.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
        if(!homeScreenPopUp.selectedLanguage){
            settings.selectedLanguageCode = "en-US";
            homeScreenPopUp.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
        }

        homeScreenPopUp.languages = languagesProxy.languages;
        if(homeScreenPopUp.languages != null && homeScreenPopUp.languages.length<=0){
            languagesProxy.loadLanguages();
        }else if (homeScreenPopUp.languages == null){
            languagesProxy.loadLanguages();
        }
    }
}
}
