/**
 * Created by Vardan on 17/05/2021.
 */
package com.despark.tuning3d.view {
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.mailbox.MailsScreen;
    import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
    import com.utils.ArrayUtil;

    import flash.events.StageOrientationEvent;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    import starling.events.Event;

    public class MailsScreenMediator extends StackedScreenExtendedMediator{
        private var _mailsScreen:MailsScreen;
    public function MailsScreenMediator(stackedScreen:StackedScreen) {
        super(stackedScreen);
        _mailsScreen = stackedScreen as MailsScreen;
    }

        override public function onRegister():void{
            super .onRegister();
            _mailsScreen.addEventListener(MailsScreen.MAIL_ITEM_SELECTED, mailItemSelectHandler);
            Starling.juggler.delayCall(initialize, 1);
        }

        override public function onRemove():void{
            super .onRemove();
            _mailsScreen.removeEventListener(MailsScreen.MAIL_ITEM_SELECTED, mailItemSelectHandler);
            _mailsScreen.dispose();
        }

        private function mailItemSelectHandler(event:Event):void {
            sendNotification(Notifications.DISPLAY_MAIL_BOX_POPUP, event.data);
        }

        override public function listNotificationInterests():Array {
            return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
                Notifications.MAILS_LOADED,
                Notifications.MAILS_LOADING_FAILED,
                Notifications.MAIL_BOX_POPUP_CLOSES,
                Notifications.MAIL_READ_SUCCESS
            ])
        }

        private function initialize():void {

        }

        private function handleMailReadSuccess() : void {

        }


        override public function handleNotification(note:INotification):void {
            super.handleNotification(note);
            switch (note.getName()){
                case Notifications.MAILS_LOADED:
                    _mailsScreen.addMails(note.getBody().mails);
                    break;
                case Notifications.MAILS_LOADING_FAILED:
                    _mailsScreen.addMails(null);
                    break;
                case Notifications.MAIL_BOX_POPUP_CLOSES:
                    _mailsScreen.refreshMails(true);
                    break;
                case Notifications.MAIL_READ_SUCCESS:
                    handleMailReadSuccess();
                    break;
            }
        }
}
}
