package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.packages.Packet;
import com.despark.tuning3d.view.components.brands.RewardConfirmPopUp;
import com.despark.tuning3d.view.components.core.PacketView;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.distriqt.GameService;

import starling.events.Event;

public class RewardConfirmPopUpMediator   extends PopUpMediator{
    public function RewardConfirmPopUpMediator(popUp : PopUp) {
        super(popUp);
    }
    public function get rewardConfirmPopUp() : RewardConfirmPopUp
    {
        return RewardConfirmPopUp(popUp);
    }

    override public function onRegister() : void
    {
        rewardConfirmPopUp.addEventListener(RewardConfirmPopUp.REWARD_BUY_PACKET, rewardBuyPacketHandler);
        super.onRegister();
    }

    override public function onRemove() : void
    {
        rewardConfirmPopUp.removeEventListener(RewardConfirmPopUp.REWARD_BUY_PACKET, rewardBuyPacketHandler);
        super.onRemove();
    }

    private function rewardBuyPacketHandler(event: Event): void {
        var eventData:Object = event.data;
        var packet: Packet = eventData.packet;
        var coin3dFee:int;
        var oneTimeUnlocked:Boolean = eventData["oneTimeUnlocked"]||false;
        if(eventData.hasOwnProperty("coin3dFee")){
            coin3dFee = eventData.coin3dFee;
        }else{
            coin3dFee = packet.coin3dFee;
        }
        GameService.$.addRewardPacket(packet.id, coin3dFee, function(status: Boolean): void {
            if (status) {
                packet.tempOpened = true;
                packet.lock = false;
                packet.oneTimeUnlocked = oneTimeUnlocked;
                sendNotification(Notifications.BUY_NOW_PACKET, {packet : packet, popUp : null});
            }
        }, oneTimeUnlocked);
    }
}
}
