package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.view.components.brands.RewardNoAdsPopUp;
    import com.despark.tuning3d.view.components.brands.RewardNoCoinPopUp;
import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedBannerScreen;
    import com.despark.tuning3d.view.core.PopUpMediator;
    import com.utils.ArrayUtil;

    import org.puremvc.as3.interfaces.INotification;

    import starling.events.Event;


public class RewardNoCoinPopUpMediator   extends PopUpMediator{
    public static const OPEN_WATCH_REWARD_POP_UP : String = 'OPEN_WATCH_REWARD_POP_UP';
    public function RewardNoCoinPopUpMediator(popUp : PopUp) {
        super(popUp);
    }
    public function get rewardNoCoinPopUp() : RewardNoCoinPopUp
    {
        return RewardNoCoinPopUp(popUp);
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
            Notifications.REWARD_ARS_LOAD
        ]);
    }

    override public function handleNotification(note : INotification) : void {
        switch(note.getName()) {
            case Notifications.REWARD_ARS_LOAD:
                RewardNoCoinPopUp(popUp).enableWatching(true);
                break;
        }
    }

    override public function onRegister() : void
    {
        super.onRegister();
        rewardNoCoinPopUp.addEventListener(OPEN_WATCH_REWARD_POP_UP, openWatchRewardPopUpHandler);
        rewardNoCoinPopUp.addEventListener(StackedBannerScreen.CHALLENGES_HOME_SELECTED, openChallengesRewardPopUpHandler);
    }

    override public function onRemove() : void
    {
        super.onRemove();
        rewardNoCoinPopUp.removeEventListener(OPEN_WATCH_REWARD_POP_UP, openWatchRewardPopUpHandler);
        rewardNoCoinPopUp.removeEventListener(StackedBannerScreen.CHALLENGES_HOME_SELECTED, openChallengesRewardPopUpHandler);
    }

    private function openWatchRewardPopUpHandler(e: Event): void {
        sendNotification(Notifications.DISPLAY_REWARD_INFO_POPUP);
    }

    private function openChallengesRewardPopUpHandler(e: Event): void {
        sendNotification(Notifications.DISPLAY_CHALLENGE_SCREEN);
    }
}
}
