package com.despark.tuning3d.view {
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.events.NativeWBEvent;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.partinfo.webview.IWebView;
import com.despark.tuning3d.view.components.partinfo.webview.NativeWB;
import com.despark.tuning3d.view.components.partinfo.webview.StageWB;
    import com.distriqt.extension.nativewebview.Header;


    import flash.geom.Rectangle;

import starling.core.Starling;
import starling.events.Event;

public class TuningEditorPopUp extends PopUp{

    public static const CLOSED_TRIGGERED : String = 'closedTriggered';

    private var _url : String ;
    private var _webView : IWebView;
    private var _headers:Vector.<Header>;
    private var _tuning:Tuning;
    private var _isChallenge:Boolean;
    public function TuningEditorPopUp(obj : Object) {
        super();
        _url = obj.url;
        _tuning = obj.tuning;
        _isChallenge = obj.isChallenge;
    }


    override protected function initialize():void {
        super.initialize();

        setSizeInternal(this.stage.stageWidth, this.stage.stageHeight,false);

        contentBackgroundImage.visible = false;
        background.width = actualWidth;
        background.height = actualHeight;
        background.color = 0x242424;
        background.alpha = 1;

        if(_isChallenge){
            if(closeButton){
                closeButton.removeFromParent(true);
                closeButton = null;
            }
        }else{
            closeButtonLayout();
        }

        _webView = new NativeWB();
        var gap : Number = 0;
        if(closeButton){
            gap = closeButton.height + closeButton.y * 2;
        }else{
            _webView.addEventListener(NativeWBEvent.TUNING_FILTER_SAVED, filterChangesSavedHandler);
        }
        var ratio : Number = Starling.current.nativeStage.stageWidth / Constants.STAGE_WIDTH;
        var leftOffset: int = 0;
        if (Device.isIphoneXVariant()) {
            leftOffset = Device.IPHONE_X_VARIANT_MARGIN_LEFT * Starling.current.contentScaleFactor;
        }
        var viewPort:Rectangle = new Rectangle(leftOffset, ratio * gap, actualWidth * ratio - 2 * leftOffset, (actualHeight - gap) * ratio);
        _webView.setViewPort(viewPort);

        Starling.juggler.delayCall(function () : void {
            _webView.loadURL(_url, _headers);
        }, 2);
    }

    private function filterChangesSavedHandler(event:NativeWBEvent):void {
        _webView.removeEventListener(NativeWBEvent.TUNING_FILTER_SAVED, filterChangesSavedHandler);
        closeButtonTriggeredHandler(null);
    }

    override protected function closeButtonTriggeredHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        _webView.dispose();
        this.dispatchEventWith(CLOSED_TRIGGERED, false, _tuning);
        super.closeButtonTriggeredHandler(event);
    }

    override protected function draw():void {
        super.draw();
        closeButtonLayout();
    }

    private function closeButtonLayout():void{
        if(closeButton){
            closeButton.x = actualWidth - closeButton.width - 15;
            closeButton.y = 10;
        }
    }

    public function setHeader(headers:Vector.<Header>):void {
        _headers = headers;
    }

}
}
