package com.despark.tuning3d.view
{
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
    import com.despark.tuning3d.view.components.tunings.editing.TuningVideoPopup;
    import com.despark.tuning3d.view.core.PopUpMediator;
    import com.utils.ArrayUtil;
    import com.utils.Tracker;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    import starling.events.Event;

    public class TuningVideoPopupMediator extends PopUpMediator {

    public function TuningVideoPopupMediator(stackedScreen : PopUp) {
        super(stackedScreen);
    }

    override public function onRegister() : void {
        super.onRegister();
        tuningVideoPopup.addEventListener(TuningVideoPopup.SAVE_VIDEO, saveVideoHandler);
    }

    private function saveVideoHandler(event:Event):void {
        Starling.juggler.delayCall(function ():void {
            sendNotification(Notifications.TUNING_VIDEO_SAVE, event.data);
        }, 0.5);

        if(tuningVideoPopup.mode == TuningVideoPopup.START){
            Tracker.trackEvent("Tuning Video Popup", "prepare and download");
        }
    }

    override public function onRemove() : void {
        super.onRemove();
        tuningVideoPopup.removeEventListener(TuningVideoPopup.SAVE_VIDEO, saveVideoHandler);
    }


    public function get tuningVideoPopup() : TuningVideoPopup {
        return viewComponent as  TuningVideoPopup;
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [

        ]);
    }

    override public function handleNotification(note : INotification) : void {
        switch(note.getName()) {

        }
        super.handleNotification(note);
    }
}
}