package com.despark.tuning3d.view
{
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.tunings.editing.TunningNameInputPopUp;
	import com.despark.tuning3d.view.core.PopUpMediator;
		
	import starling.events.Event;

	public class TunningNameInputPopUpMediator extends PopUpMediator
	{
		public function TunningNameInputPopUpMediator(popUp : PopUp)
		{
			super(popUp);
		}
		
		public function get tunningNameInputPopUp() : TunningNameInputPopUp
		{
			return TunningNameInputPopUp(popUp);
		}
		
		override public function onRegister() : void
		{
			super.onRegister();
			
			tunningNameInputPopUp.addEventListener(Event.ADDED_TO_STAGE, tunningNameInputPopUpAddedToStageHandler);
			tunningNameInputPopUp.addEventListener(TunningNameInputPopUp.OK_BUTTON_SELECTED, tunningNameInputPopUpOkButtonSelectedHandler);
			tunningNameInputPopUp.addEventListener(TunningNameInputPopUp.NAME_CHANGED, tunningNameInputPopUpNameChangedHandler);
		}
		
		override public function onRemove() : void
		{
			super.onRemove();
			
			tunningNameInputPopUp.removeEventListener(Event.ADDED_TO_STAGE, tunningNameInputPopUpAddedToStageHandler);
			tunningNameInputPopUp.removeEventListener(TunningNameInputPopUp.OK_BUTTON_SELECTED, tunningNameInputPopUpOkButtonSelectedHandler);	
			tunningNameInputPopUp.removeEventListener(TunningNameInputPopUp.NAME_CHANGED, tunningNameInputPopUpNameChangedHandler);

		}
		
		private function tunningNameInputPopUpAddedToStageHandler(event : Event) : void
		{
			tunningNameInputPopUp.okButtonEnabled = true;
		}
		
		private function tunningNameInputPopUpOkButtonSelectedHandler(event : Event) : void
		{
			tunningNameInputPopUp.setOKButtonEnabled(false);
			
			sendNotification(Notifications.REMOVE_POP_UP, popUp);
			sendNotification(Notifications.TUNING_BEGIN_ADDING, tunningNameInputPopUp.tuningName);
		}
		
		private function tunningNameInputPopUpNameChangedHandler(event : Event) : void
		{
//			tunningNameInputPopUp.okButtonEnabled = tunningNameInputPopUp.tuningName.length > 0;
		}
	}
}