package com.despark.tuning3d.view.components.auth
{
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.LanguagesProxy;
    import com.despark.tuning3d.model.settings.Settings;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.MainMenuView;
    import com.despark.tuning3d.view.components.core.MultilingualButton;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.core.HomeScreenPopUp;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;
    import com.utils.ObjectUtils;
    import com.utils.ObjectUtils;

    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.controls.Radio;
    import feathers.controls.ToggleButton;
    import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.ITextRenderer;
    import feathers.core.ToggleGroup;
    import feathers.layout.FlowLayout;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.VerticalLayout;

    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;

    import starling.core.Starling;

    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Image;
    import starling.events.Event;
    import starling.filters.ColorMatrixFilter;

    public class ProfilePopup extends PopUp {
        public static const SAVE_CHANGES:String = 'saveChanges';
        public static const RESEND_EMAIL:String = 'resendVerificationEmail';
        public static const DELETE_ACCOUNT:String = 'delete3DTuningAccount';

        private var backgroundImage:Image;
		private var fullNameField:ProfilePageLabel;
		private var emailField:ProfilePageLabel;
		private var currentPasswordField:ProfilePageLabel;
		private var newPasswordField:ProfilePageLabel;
		private var repeatPasswordField:ProfilePageLabel;
        private var saveButton:MultilingualButton;
        private var cancelButton:MultilingualButton;

        private var resendEmailButton:Button;
        private var messageField:Label;

		private var formGroup:LayoutGroup;
        private var _isEmailVerified:Boolean;
        private var _isVerifiedIcon:Image;
        private var _exclamationIcon:Image;

        private var userData:Object = {};
        private var messageCode:uint;
        private var showAdsOnClose:Boolean;

        private var soundSwitch:ToggleButton;

        private var _hdFrames12:Radio;
        private var _hdFrames8:Radio;
        private var _hdGroup:LayoutGroup;
        private var _hdToggleGroup:ToggleGroup;

        private var restoreButton:Button;
        private var deleteAccountButton:Button;

        private var _stackScreen:StackedScreen;
        private var _mainMenuHolder:IMainMenuHolder;

		public function ProfilePopup() {

		}

		public function updateWithLanguage(language : Language) : void {

		}
		
		override protected function initialize() : void {
			super.initialize();
            setSizeInternal(stage.stageWidth, stage.stageHeight, false);
            _isVerifiedIcon = new Image(ButtonFactory.assetManager.getTexture("profile_yes"));
            _exclamationIcon = new Image(ButtonFactory.assetManager.getTexture("profile_not"));
            _isVerifiedIcon.scale = _exclamationIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
			if(contentBackgroundImage){
				contentBackgroundImage.visible = false;
            }
			if(background){
				background.visible = false;
			}

			backgroundImage = new Image(ButtonFactory.assetManager.getTexture('profile_screen_background'));
			addChildAt(backgroundImage, 0);
			//
            fullNameField = new ProfilePageLabel("Full Name");
			fullNameField.width = 265;
			fullNameField.height = 30;

            emailField = new ProfilePageLabel("Email address");
            emailField.width = 265;
            emailField.height = 30;
            emailField.addEventListener(Event.CHANGE, emailFieldChangeHandler);
            emailField.focusOutCallback = function():void{
                if((!emailField.text || !emailField.text.length) && userData.email && String(userData.email).length){
                    emailField.text = userData.email;
                }
            };

            currentPasswordField = new ProfilePageLabel('<font color="#b50606">Change Password</font> &#47; Enter Current');
            currentPasswordField.displayAsPassword = true;
            currentPasswordField.width = 265;
            currentPasswordField.height = 30;

            newPasswordField = new ProfilePageLabel("New");
            newPasswordField.displayAsPassword = true;
            newPasswordField.width = 125;
            newPasswordField.height = 30;

            repeatPasswordField = new ProfilePageLabel("Retype new");
            repeatPasswordField.displayAsPassword = true;
            repeatPasswordField.width = 125;
            repeatPasswordField.height = 30;

            resendEmailButton = new Button();
            resendEmailButton.labelFactory = function ():ITextRenderer {
                var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 9, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.LEFT;
                textRenderer.textFormat.bold = false;
                textRenderer.textFormat.italic = false;
                textRenderer.embedFonts = FontSelector.embedFonts();
                return textRenderer;
            };
            resendEmailButton.label = "resend";
            var resendIcon:Image = new Image(ButtonFactory.assetManager.getTexture("restore"));
            resendIcon.width = 15;
            resendIcon.scale = resendIcon.scaleX;
            resendEmailButton.defaultIcon = resendIcon;
            var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
            colorFilter.tint(0xC90809, 1);
            resendEmailButton.filter = colorFilter;
            resendEmailButton.addEventListener(Event.TRIGGERED, resendEventHandler);

            formGroup = new LayoutGroup();
            formGroup.width = 266;
            formGroup.height = actualHeight;
            formGroup.x = (actualWidth - formGroup.width) /2;
            formGroup.y = 35;

            saveButton = ButtonFactory.defaultButton("SAVE", 0xC90809);
            saveButton.labelFactory = LabelFactory.profileButtonLabel;
            saveButton.width = 96;
            saveButton.height = 30;
            saveButton.addEventListener(Event.TRIGGERED, saveHandler);


            cancelButton = ButtonFactory.defaultButton("CANCEL", 0xC90809);
            cancelButton.labelFactory = LabelFactory.profileButtonLabel;
            cancelButton.defaultSkin.alpha = cancelButton.downSkin.alpha = 0;
            cancelButton.width = 96;
            cancelButton.height = 30;
            cancelButton.addEventListener(Event.TRIGGERED, cancelHandler);

            messageField = new Label();
            messageField.wordWrap = true;
            messageField.width = 266;
            messageField.height = 30;
            messageField.textRendererFactory = function ():ITextRenderer {
                var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 9, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.CENTER;
                textRenderer.textFormat.bold = true;
                textRenderer.embedFonts = true;
                textRenderer.isHTML = true;
                return textRenderer;
            };

			var groupLayout:FlowLayout = new FlowLayout();
            groupLayout.verticalGap = 15;
            groupLayout.horizontalGap = 15;
            groupLayout.horizontalAlign = HorizontalAlign.CENTER;
			formGroup.layout = groupLayout;

            formGroup.addChild(fullNameField);
            formGroup.addChild(emailField);
            formGroup.addChild(currentPasswordField);
            formGroup.addChild(newPasswordField);
            formGroup.addChild(repeatPasswordField);
            formGroup.addChild(messageField);
            formGroup.addChild(saveButton);
            formGroup.addChild(cancelButton);
			addChild(formGroup);
            addChild(_isVerifiedIcon);
            addChild(_exclamationIcon);
            addChild(resendEmailButton);
            resendEmailButton.visible = false;
            _exclamationIcon.visible = _isVerifiedIcon.visible = false;
            //
            deleteAccountButton = new Button();
            deleteAccountButton.labelFactory = LabelFactory.profileRestoreLabel;
            deleteAccountButton.label = "Delete\nAccount";
            formGroup.addChild(deleteAccountButton);
            var deleteAccountIcon:Image = new Image(ButtonFactory.assetManager.getTexture("delete_account_icon"));
            deleteAccountIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
            deleteAccountIcon.color = 0xCC0000;
            deleteAccountButton.defaultIcon = deleteAccountIcon;

            var deleteAccountDownIcon:Image = new Image(ButtonFactory.assetManager.getTexture("delete_account_icon"));
            deleteAccountDownIcon.scale = 0.95 * ButtonFactory.assetManager.scaleFactor / 2;
            deleteAccountDownIcon.color = 0x660000;
            deleteAccountButton.downIcon = deleteAccountDownIcon;


            deleteAccountButton.validate();
            deleteAccountButton.includeInLayout = false;
            deleteAccountButton.addEventListener(Event.TRIGGERED, deleteAccountTriggeredHandler);
            deleteAccountButton.isEnabled = UsersProxy.loggedInUser();
            deleteAccountButton.alpha = (deleteAccountButton.isEnabled? 1: 0.75);

            restoreButton = new Button();
            restoreButton.labelFactory = LabelFactory.profileRestoreLabel;
            restoreButton.label = "Restore\nPurchases";
            formGroup.addChild(restoreButton);
            var restoreIcon:Image = new Image(ButtonFactory.assetManager.getTexture("restoreButton"));
            restoreIcon.scale = 0.75;
            restoreIcon.color = 0x3438ff;
            restoreButton.defaultIcon = restoreIcon;
            restoreButton.validate();
            restoreButton.includeInLayout = false;
            restoreButton.addEventListener(Event.TRIGGERED, restoreTriggeredHandler);

            soundSwitch = new ToggleButton();
            soundSwitch.labelFactory = LabelFactory.profileSoundLabel;
            soundSwitch.label = "Sound ON";
            soundSwitch.labelOffsetX = 2;
            soundSwitch.defaultIcon = new Image(ButtonFactory.assetManager.getTexture("sound_on_icon"));
            soundSwitch.defaultSelectedIcon = new Image(ButtonFactory.assetManager.getTexture("sound_off_icon"));
            soundSwitch.defaultIcon.width = soundSwitch.defaultIcon.height = 35/2;
            soundSwitch.defaultSelectedIcon.width = soundSwitch.defaultSelectedIcon.height = 35/2;
            soundSwitch.includeInLayout = false;
            soundSwitch.addEventListener(Event.CHANGE, soundChangeHandler);
            soundSwitch.isSelected = SoundManager.isMute;
            formGroup.addChild(soundSwitch);


            _hdGroup = new LayoutGroup();
            var hdLayout:VerticalLayout = new VerticalLayout();
            hdLayout.horizontalAlign = HorizontalAlign.LEFT;
            hdLayout.gap = 4;
            hdLayout.paddingLeft = 2;
            _hdGroup.layout = hdLayout;
            _hdGroup.includeInLayout = false;
            var textFormat:TextFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 10, UIColors.WHITE);
            textFormat.letterSpacing = 1;

            var _hdTitle:Label = new Label();
            _hdTitle.textRendererFactory = LabelFactory.createTextRenderer(new TextFormat(FontSelector.getMontserratSemiBold(), 10, UIColors.WHITE));
            _hdTitle.text = "HD Car Frames";
            _hdGroup.addChild(_hdTitle);

            _hdToggleGroup = new ToggleGroup();
            _hdToggleGroup.isSelectionRequired = true;

            _hdFrames12 = ButtonFactory.simpleRadioButton("12/12", UIColors.WHITE);
            _hdFrames12.labelFactory = LabelFactory.createTextRenderer(textFormat);
            _hdFrames12.labelOffsetX = 8;
            _hdGroup.addChild(_hdFrames12);
            _hdToggleGroup.addItem(_hdFrames12);

            _hdFrames8 = ButtonFactory.simpleRadioButton("8/8", UIColors.WHITE);
            _hdFrames8.labelFactory = LabelFactory.createTextRenderer(textFormat);
            _hdFrames8.labelOffsetX = 8;
            _hdGroup.addChild(_hdFrames8);
            _hdToggleGroup.addItem(_hdFrames8);

            _hdFrames8.isSelected = Settings.isEightFrame;
            _hdToggleGroup.addEventListener(Event.CHANGE, eightFramesChangeHandler);
            formGroup.addChild(_hdGroup);
            _hdGroup.validate();


            var langProxy:LanguagesProxy = ApplicationFacade.getInstance().retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
            if(_mainMenuHolder && _mainMenuHolder.mainMenuView && _mainMenuHolder.mainMenuView.languagePickerList && langProxy.defaultLanguageCode != "en-US"){
                _mainMenuHolder.mainMenuView.languagePickerList.includeInLayout = false;
                formGroup.addChild(_mainMenuHolder.mainMenuView.languagePickerList);
                if(_mainMenuHolder.mainMenuView.languagePickerList.hasEventListener(Event.CHANGE, _mainMenuHolder.mainMenuView.languagePickerListChangeHandler)){
                    _mainMenuHolder.mainMenuView.languagePickerList.removeEventListener(Event.CHANGE, _mainMenuHolder.mainMenuView.languagePickerListChangeHandler);
                }
                _mainMenuHolder.mainMenuView.languagePickerList.addEventListener(Event.CHANGE, languagePickerListChangeHandler);
            }
            //
            showAdsOnClose = AdsManager.$.bannerHide();
            //
            fullNameField.isEnabled = false;
            emailField.isEnabled = false;
            currentPasswordField.isEnabled = false;
            newPasswordField.isEnabled = false;
            messageField.isEnabled = false;
            repeatPasswordField.isEnabled = false;
            saveButton.isEnabled = false;
		}

        private function emailFieldChangeHandler(event:Event):void {
            resendEmailButton.visible = (userData.email == emailField.text);
        }

        private function languagePickerListChangeHandler(event:Event):void {
            _mainMenuHolder.mainMenuView.languagePickerListChangeHandler(event);
            _mainMenuHolder.updateWithLanguage(MainMenuView.language);
        }

        private function deleteAccountTriggeredHandler(event:Event):void {
            AlertView.show("Are you sure you want to \npermanently delete your account", 0, false, function(confirmed:Boolean):void{
                if(confirmed){
                    dispatchEventWith(DELETE_ACCOUNT);
                }
            }, false);
        }

        private function restoreTriggeredHandler(event:Event):void {
            if(_mainMenuHolder){
                _mainMenuHolder.dispatchExternalEvent(HomeScreenPopUp.RESTORE_SELECTED);
            }
        }

        private function soundChangeHandler(event:Event):void {
            SoundManager.soundMute(soundSwitch.isSelected);
            if(!soundSwitch.isSelected){
                soundSwitch.label = "Sound ON";
                SoundManager.playSound(SoundManager.THEME, 1000, true, 0.5);
            }else{
                soundSwitch.label = "Sound OFF";
            }
        }


        private function eightFramesChangeHandler(event:Event):void {
            Settings.isEightFrame = _hdFrames8.isSelected;
        }


        override protected function closeButtonTriggeredHandler(event:Event):void {
            super.closeButtonTriggeredHandler(event);
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            if(showAdsOnClose){
                AdsManager.$.bannerShow(AdsManager.$.currentBannerScreen);
            }
        }

        private function cancelHandler(event:Event):void {
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            closeButtonTriggeredHandler(null);
        }

        private function resendEventHandler(event:Event):void {
            if(userData && userData.email != emailField.text){
                saveHandler(null);
            }else{
                dispatchEvent(new Event(RESEND_EMAIL));
            }
            AlertView.show("Verification mail sent", 3, false);
        }

        private function saveHandler(event:Event):void {
            if(newPasswordField.text.length && repeatPasswordField.text.length && newPasswordField.text !== repeatPasswordField.text){
                messageField.text = '<font color="#b00000">"New" and "Retype new" fields don\'t  match.<br/></font>';
                newPasswordField.setText('');
                repeatPasswordField.setText('');
                return;
            }
            SoundManager.playSound(SoundManager.SELECT_PART);
            var data:Object = {};
            if(userData.name != fullNameField.text){
                data.name = fullNameField.text;
                messageCode = 3;
            }
            if(userData.email != emailField.text){
                data.email = emailField.text;
            }
            if(newPasswordField.text.length && repeatPasswordField.text.length && currentPasswordField.text.length && currentPasswordField.text !== newPasswordField.text){
                data.password = {"passwordOld": currentPasswordField.text, "passwordNew": newPasswordField.text};
                messageCode = 4;
            }
            if(!ObjectUtils.isEmpty(data)){
                if(data.hasOwnProperty('email')){
                    messageCode = 1;
                }else if(ObjectUtils.getLength(data) > 1){
                    messageCode = 2;
                }
                dispatchEvent(new Event(SAVE_CHANGES, false, data));
            }
        }

		override protected function draw() : void {
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE)){
				if(stage.stageWidth/stage.stageHeight > backgroundImage.width/backgroundImage.height){
                    backgroundImage.width = stage.stageWidth;
                    backgroundImage.scale = backgroundImage.scaleX;
				}else{
                    backgroundImage.height = stage.stageHeight;
                    backgroundImage.scale = backgroundImage.scaleY;
				}
                backgroundImage.x = (stage.stageWidth - backgroundImage.width) / 2;
                backgroundImage.y = (stage.stageHeight - backgroundImage.height) / 2;
                //
			}
            Starling.juggler.delayCall(layoutButtons, 0.25);
		}


        private function layoutButtons():void{
            if(soundSwitch && restoreButton && deleteAccountButton && saveButton && _hdGroup){
                soundSwitch.x = actualWidth - (soundSwitch.width + 30 + formGroup.x);
                soundSwitch.y = saveButton.y + (saveButton.height - soundSwitch.height) / 2;

                restoreButton.x = soundSwitch.x - 5;
                restoreButton.y = soundSwitch.y - (restoreButton.height + 10);

                deleteAccountButton.x = soundSwitch.x - 3;
                deleteAccountButton.y = restoreButton.y - (deleteAccountButton.height + 10);

                _hdGroup.x = soundSwitch.x - 3;
                _hdGroup.y = deleteAccountButton.y - (_hdGroup.height + 15);

                if(_mainMenuHolder && _mainMenuHolder.mainMenuView && _mainMenuHolder.mainMenuView.languagePickerList){
                    _mainMenuHolder.mainMenuView.languagePickerList.validate();
                    _mainMenuHolder.mainMenuView.languagePickerList.x = restoreButton.x;
                    _mainMenuHolder.mainMenuView.languagePickerList.y = _hdGroup.y - _mainMenuHolder.mainMenuView.languagePickerList.height - 10;
                }
            }else if(restoreButton && deleteAccountButton && saveButton && _hdGroup){
                restoreButton.x = actualWidth - (restoreButton.width + 35 + formGroup.x);
                restoreButton.y = saveButton.y + (saveButton.height - restoreButton.height) / 2;

                deleteAccountButton.x = restoreButton.x + 3;
                deleteAccountButton.y = restoreButton.y - (deleteAccountButton.height + 10);

                _hdGroup.x = restoreButton.x + 3;
                _hdGroup.y = deleteAccountButton.y - (_hdGroup.height + 15);

                if(_mainMenuHolder && _mainMenuHolder.mainMenuView && _mainMenuHolder.mainMenuView.languagePickerList){
                    _mainMenuHolder.mainMenuView.languagePickerList.validate();
                    _mainMenuHolder.mainMenuView.languagePickerList.x = restoreButton.x + 3;
                    _mainMenuHolder.mainMenuView.languagePickerList.y = _hdGroup.y - _mainMenuHolder.mainMenuView.languagePickerList.height - 10;
                }
            }
        }

    override public function dispose():void {
        if(_mainMenuHolder && _mainMenuHolder.mainMenuView){
            _mainMenuHolder.mainMenuView.languagePickerList.removeEventListener(Event.CHANGE, languagePickerListChangeHandler);
            _mainMenuHolder.mainMenuView.languagePickerList.removeFromParent();
        }

        super.dispose();

		if(backgroundImage){
            backgroundImage.removeFromParent(true);
            backgroundImage = null;
		}

        if(fullNameField){
            fullNameField.removeFromParent(true);
            fullNameField = null;
        }

        if(emailField){
            emailField.removeFromParent(true);
            emailField = null;
        }

        if(currentPasswordField){
            currentPasswordField.removeFromParent(true);
            currentPasswordField = null;
        }

        if(newPasswordField){
            newPasswordField.removeFromParent(true);
            newPasswordField = null;
        }

        if(repeatPasswordField){
            repeatPasswordField.removeFromParent(true);
            repeatPasswordField = null;
        }

        if(saveButton){
            saveButton.removeFromParent(true);
            saveButton = null;
        }

        if(cancelButton){
            cancelButton.removeFromParent(true);
            cancelButton = null;
        }

        if(formGroup){
            formGroup.removeFromParent(true);
            formGroup = null;
        }
    }

    private function set isEmailVerified(value:Boolean):void{
        _isEmailVerified = value;
        resendEmailButton.x = formGroup.x + emailField.x + emailField.width - (resendEmailButton.width + 8);
        resendEmailButton.y = formGroup.y + emailField.y + (emailField.height - resendEmailButton.height) / 2;

        _isVerifiedIcon.x = formGroup.x + emailField.x + emailField.width - (_isVerifiedIcon.width + 8);
        _isVerifiedIcon.y = formGroup.y + emailField.y + (emailField.height - _isVerifiedIcon.height) / 2;

        _exclamationIcon.x = formGroup.x + messageField.x - _exclamationIcon.width;
        _exclamationIcon.y = formGroup.y + messageField.y;

        _exclamationIcon.visible = false;
        /*_exclamationIcon.visible = */resendEmailButton.visible = !value;
        _isVerifiedIcon.visible = value;
        if(!value && messageCode == 0){
            messageField.text = '<font color="#b00000">Unverified email:  Please log in to your email account' + '<br>' + 'and find the email we have just sent you.</font>';
        }
    }

    public function setChangeResult(object:Object):void{
        resendEmailButton.visible = false;
        if(object.success){
            _exclamationIcon.color =  0x0db500;
            if(messageCode == 1){
                messageField.text = '<font color="#0db500">We’ve sent you a link to confirm your email address.' + '<br/>' + 'Please check you inbox.</font>';
            }else if(messageCode == 4){
                messageField.text = '<font color="#0db500">Your password has been successfully changed.</font>';
            }else if(messageCode == 3){
                messageField.text = '<font color="#0db500">Your Profile changes has been saved successfully.</font>';
            }else if(messageCode == 2){
                messageField.text = '<font color="#0db500">Your Profile changes has been saved successfully.</font>';
            }
        }else{
            _exclamationIcon.color = 0xb00000;
            if(object.result.hasOwnProperty("param")){
                if(object.result.param == 'email'){
                    if(object.result.msg == "Invalid email"){
                        messageField.text = '<font color="#b00000">The email address you entered is invalid.' + '<br>' + 'Type a valid email address.</font>';
                    }
                }
            }else if(String(object.result).toLowerCase() == "invalid username password" || ObjectUtils.getProperty(object, "result.error") == 103){
                if(messageCode == 1){
                    messageField.text = '';
                    Starling.juggler.delayCall(function():void{
                        messageField.text = '<font color="#b00000">An account with this email already exists.' + '<br>' + 'Type another email address please.</font>';
                    }, 0.5);
                }else if(messageCode == 4){
                    messageField.text = '<font color="#b00000">The current password you entered is incorrect.' + '<br>' + 'Type your current password, please.</font>';
                }
            }
        }
        currentPasswordField.setText('');
        newPasswordField.setText('');
        repeatPasswordField.setText('');
        _exclamationIcon.x = formGroup.x + messageField.x - _exclamationIcon.width;
        _exclamationIcon.y = formGroup.y + messageField.y;
    }

    public function setProfileData(result:Object):void {
        userData = result;
        if(result.name) {
            fullNameField.setText(result["name"]);
        }

        if(result.email) {
            emailField.setText(result["email"]);
        }

        isEmailVerified = result.emailVerified;
        //
        if(userData){
            fullNameField.isEnabled = true;
            emailField.isEnabled = true;
            currentPasswordField.isEnabled = true;
            newPasswordField.isEnabled = true;
            messageField.isEnabled = true;
            repeatPasswordField.isEnabled = true;
            saveButton.isEnabled = true;
        }
    }

        public function set stackScreen(value:StackedScreen):void {
            _stackScreen = value;
            _mainMenuHolder = value as IMainMenuHolder;
        }
    }
}