package com.despark.tuning3d.view.components.brands
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PacketView;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.downloads.DownloadsDefCarSlotView;
	import com.despark.tuning3d.view.components.downloads.DownloadsPartSlotView;
	import com.utils.FontSelector;
	
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.List;
	import feathers.controls.ScrollContainer;
	import feathers.controls.renderers.IListItemRenderer;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.FeathersControl;
	import feathers.data.ListCollection;
	import feathers.layout.VerticalLayout;
	
	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.filters.ColorMatrixFilter;

	public class BuyCarPopUp extends PopUp implements Multilingual
	{
		//cleanCacheButton
		public static const BUY_NOW_CAR : String = "buyNowCar";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 480;
		
		
		private var carImage:ImageLoaderWithStates;
		private var currentLanguage : Language;
		//private var container : ScrollContainer;
		
	
		private var okButton : MultilingualButton;
		
		private var textLabel:TextFieldTextRenderer;
			
		private var _text:String="";
		
		private var _car:Car;
		
		
		public function BuyCarPopUp()
		{
			super()
						
			setSizeInternal(350, Starling.current.stage.height - 60, false);
			
			/*if(Starling.current.stage.width  <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 50, Starling.current.stage.height - 50, false);
			}*/
		}
		
		public function set car(value:Car):void{
			
			_car=value;
			this.invalidate("car");
			
		}
		
		public function get car():Car{
			
			return _car;
		}
		
		
	
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
			//title = //language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
			
			//intializingLabel.updateWithLanguage(language);
			
			//totalLabel.text = language.translate("mob_downloads", "total");
			//totalLabel.updateWithLanguage(language);
			
			//cleanCacheButton.updateWithLanguage(language);
			//cleanCacheButton.label = "   CLEAN CACHE"//language.translate("mob_downloads", "cleanCache").toUpperCase();
			
			
			
			
			okButton.updateWithLanguage(language);
			okButton.label = language.translate("mob_info", "ok").toUpperCase();
			
			
		}
		override public function set  title(value:String):void{
			
			super.title=value;
			this.invalidate("title");
		}
		
		public function set text(value:String):void{
			
			_text=value;
			
			this.invalidate("text");
		}
		
		public function get text():String{
			
			return _text;
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
		
			
			carImage=new ImageLoaderWithStates();
			carImage.overrideDispose = true;  
			carImage.snapToPixels=false;   
			//carImage.carItem=true;
			addChild(carImage);
			
			
			textLabel=new TextFieldTextRenderer();
			textLabel.height=60;
			textLabel.textFormat = new TextFormat(FontSelector.getFont(), 10, 0x434343);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			textLabel.wordWrap=true;
			textLabel.isHTML=true;
			
			textLabel.embedFonts=FontSelector.embedFonts();
			
			addChild(textLabel);
			
		
			
			okButton = ButtonFactory.defaultButton(null, 0x49cc46);
			//leaveACommentButton.visible = false;
			
			okButton.textFormat.size=11;
			okButton.addEventListener(Event.TRIGGERED, okButtonnTriggeredHandler);
			addChild(okButton);
				
			//textLabel.text
			//contentBackgroundImage.visible = false;
		}
	
		
		override protected function draw() : void
		{
			super.draw();
			
			
			if(isInvalid("car")){
				
				if(_car){
					
					var carName:String=_car.name+" "+_car.model+" "+_car.year;
					textLabel.text="Вам было открыто "+carName+". Спасибо, что пользуетесь нашим приложением.";
						
						
					/*if(AlertView.language)   
					{	
						var url:String=AlertView.language.translate(car.id, "purchase_car_image").replace("data", "cdn");
						
						var newCar:Car;
						
						if(carImage.persistentImageProvider && carImage.persistentImageProvider.remoteUrl!=url){
							newCar=new Car();
							newCar.imageURL=url;  
							carImage.persistentImageProvider = newCar;  
						}else if(!carImage.persistentImageProvider){
							
							newCar=new Car();
							newCar.imageURL=url;   
							carImage.persistentImageProvider = newCar;  
						}
						
						//car.remoteUrl=imageURL;     
					}	
					else{*/
						
						carImage.persistentImageProvider=car;    
						
					/*}  */  
				}
					
				okButton.label = currentLanguage.translate("mob_info", "ok").toUpperCase();
			
				
				
				
				
			}
			
			/*if(isInvalid("text")){
				
				
				if(textLabel){
					
					textLabel.text=text;
				}
			}
			
			if(isInvalid("title")){
				
				
				if(titleLabel){
					
					titleLabel.text=title;
				}
			}*/
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.width-=10;
				contentBackgroundImage.height-=15;
				
				contentBackgroundImage.x+=5;
				contentBackgroundImage.y+=5;
				
			
			
				okButton.width=100;
				okButton.height=28;
				okButton.x =  ((actualWidth-okButton.width)/2);  
				okButton.y = contentBackgroundImage.y + contentBackgroundImage.height + 15;
				
		
				
				carImage.width=(contentBackgroundImage.width/2)-5;
				carImage.x=contentBackgroundImage.x+13;
				carImage.y=contentBackgroundImage.y+16;
				carImage.height=actualHeight/2;
				
				
			
				textLabel.width=(contentBackgroundImage.width/2)-20;
				textLabel.height=carImage.height;
							
				textLabel.x = carImage.x+carImage.width+10;
				textLabel.y = carImage.y;
				
			
				/*intializingLabel.width = actualWidth;
				intializingLabel.y = int((actualHeight - intializingLabel.height) / 2);*/
			}
			
			
		}
		
	
	
		private function buyNowButtonnTriggeredHandler(event : Event) : void
		{
		
		
			dispatchEventWith(BUY_NOW_CAR, false, {car:car});
		}
			
				
		
		private function okButtonnTriggeredHandler(event : Event) : void
		{
					
			
			
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		
	}
}