package com.despark.tuning3d.view.components.brands
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.downloads.DownloadsDefCarSlotView;
	import com.despark.tuning3d.view.components.downloads.DownloadsPartSlotView;
	import com.utils.FontSelector;
	
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.ScrollContainer;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.FeathersControl;
	
	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.filters.ColorMatrixFilter;

	public class InfoPopUp extends PopUp implements Multilingual
	{
		//cleanCacheButton
		//public static const CLEAN_CACHE_SELECTED : String = "cleanCacheSelected";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 480;
		
		
		
		private var currentLanguage : Language;
		private var container : ScrollContainer;
		
		private var okButton : MultilingualButton;
		private var textLabel:TextFieldTextRenderer;
			
		private var _text:String="";
		
		private var _packet:Packet;
		
		
		
		public function InfoPopUp()
		{
			super()
						
			setSizeInternal(350, Starling.current.stage.height - 60, false);
			
			/*if(Starling.current.stage.width  <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 50, Starling.current.stage.height - 50, false);
			}*/
		}
		
		public function set packet(value:Packet):void{
			
			_packet=value;
		}
		
		public function get packet():Packet{
			
			return _packet;
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
			//title = //language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
			
			//intializingLabel.updateWithLanguage(language);
			
			//totalLabel.text = language.translate("mob_downloads", "total");
			//totalLabel.updateWithLanguage(language);
			
			//cleanCacheButton.updateWithLanguage(language);
			//cleanCacheButton.label = "   CLEAN CACHE"//language.translate("mob_downloads", "cleanCache").toUpperCase();
			
			
			okButton.updateWithLanguage(language);
			okButton.label = language.translate("mob_info", "ok").toUpperCase();
			
			
		}
		override public function set  title(value:String):void{
			
			super.title=value;
			this.invalidate("title");
		}
		
		public function set text(value:String):void{
			
			_text=value;
			
			this.invalidate("text");
		}
		
		public function get text():String{
			
			return _text;
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			container = new ScrollContainer();
			//container.visible = false;
			container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 10;
			addChild( container );
			
			/*intializingLabel = new MultilingualLabel();
			intializingLabel.height = 20;
			intializingLabel.textFormat = new TextFormat("OpenSansSemiBold", 12, 0xFFFFFF);
			intializingLabel.textFormat.horizontalAlign = TextFormatAlign.CENTER;
			addChild(intializingLabel);*/
			
			
		
			
			okButton = ButtonFactory.defaultButton(null, 0x49cc46);
			//leaveACommentButton.visible = false;
			
			okButton.textFormat.size=11;
			okButton.addEventListener(Event.TRIGGERED, okButtonnTriggeredHandler);
			addChild(okButton);
			
		
			
			
			textLabel=new TextFieldTextRenderer();
			textLabel.height=60;
			textLabel.textFormat = new TextFormat(FontSelector.getFont(), 10, 0x434343);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			textLabel.wordWrap=true;
			textLabel.isHTML=true;
			
			textLabel.embedFonts=FontSelector.embedFonts();
		/*	textLabel.x=13;
			textLabel.y=16;*/
			
		
			/*textLabel.paddingRight=13;
			textLabel.paddingLeft=13;
			textLabel.paddingTop=16;*/
			
			
			
			  
		
			addChild(textLabel);
			
			//textLabel.text
			//contentBackgroundImage.visible = false;
		}
	
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid("text")){
				
				
				if(textLabel){
					
					textLabel.isHTML=true;
					textLabel.text=text;
				}
			}
			
			if(isInvalid("title")){
				
				
				if(titleLabel){
					
					titleLabel.text=title;
				}
			}
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.width-=10;
				contentBackgroundImage.height-=15;
				
				contentBackgroundImage.x+=5;
				contentBackgroundImage.y+=5;
				
				
				container.x = contentBackgroundImage.x;
				container.y = contentBackgroundImage.y;
				container.width = contentBackgroundImage.width;
				container.height = contentBackgroundImage.height;
				
				
			
			
				okButton.width=100;
				okButton.height=28;
				okButton.x =  (contentBackgroundImage.width/2)-(okButton.width/2)+contentBackgroundImage.x;  
				okButton.y = contentBackgroundImage.y + contentBackgroundImage.height + 15;
				
			
				textLabel.width=contentBackgroundImage.width-26;
				textLabel.height=contentBackgroundImage.height-32;
							
				textLabel.x = contentBackgroundImage.x+13;
				textLabel.y =contentBackgroundImage.y+16;
				
				
				
				
				/*intializingLabel.width = actualWidth;
				intializingLabel.y = int((actualHeight - intializingLabel.height) / 2);*/
			}
			
			
		}
		
	
	
			
				
		
		private function okButtonnTriggeredHandler(event : Event) : void
		{
					
			
			
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		
	}
}