package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.distriqt.AdsManager;
    import com.utils.DateParser;

    import starling.core.Starling;
    import starling.events.Event;

    public class RewardInfoPopUp  extends PopUp {
    public static const OPEN_NO_ADS_POP_UP : String = 'OPEN_NO_ADS_POP_UP';
    public static const REQUEST_REWARDS_DATA : String = 'requestRewardsData';


    public function RewardInfoPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }

    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.alpha = 0;
        contentBackgroundImage.visible = false;
        contentBackgroundImage.removeFromParent();
        this.closeButton.visible = false;

        if(background){
            background.removeFromParent();
        }

        var rewardsAlert:ChallengeAlertView = ChallengeAlertView.show(ChallengeAlertView.REWARDED_ADS_POPUP, null, this);
        rewardsAlert.addEventListener(ChallengeAlertEvent.WATCH_TRIGGERED, watchButtonTriggerHandler);
        rewardsAlert.addEventListener(ChallengeAlertEvent.CLOSE_TRIGGERED, noOrLaterButtonTriggeredHandler);
        rewardsAlert.open();
    }

    override protected function draw() : void {
        super.draw();

        contentBackgroundImage.alpha = 0;
        contentBackgroundImage.visible = false;
    }

    private function noOrLaterButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        closeButtonTriggeredHandler(null);
        Starling.juggler.delayCall(function():void{
            AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
        }, 0.5);
    }

    private function watchButtonTriggerHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        if (AdsManager.$.haveRewardAds) {
            if(!AdsManager.$.showReward()){
                dispatchEventWith(REQUEST_REWARDS_DATA);
            }
        } else {
            dispatchEventWith(OPEN_NO_ADS_POP_UP);
        }
        closeButtonTriggeredHandler(null);
    }

    public function setUserRewardsData(rewardsData:Object):void{
        var result:Object = {};
        if(rewardsData.hasOwnProperty("date")){
            result.date = DateParser.getDateTime(DateParser.parseDate(rewardsData.date));
        }else{
            result.date = DateParser.getDateTime(new Date());
        }
        if(rewardsData.hasOwnProperty("rewardCount")){
            result.rewardCount = rewardsData.rewardCount;
        }else{
            result.rewardCount = 0;
        }
        if(rewardsData.hasOwnProperty("userId")){
            result.userId = rewardsData.userId;
        }
        AdsManager.$.updateRewardsStats(result);
        AdsManager.$.showReward();
    }

    override public function dispose(): void {
        super.dispose();
    }

}
}
