package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedBannerScreen;

    import starling.core.Starling;
    import starling.events.Event;

    public class RewardNoAdsPopUp   extends PopUp{
    public function RewardNoAdsPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }


    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.visible = false;
        background.visible = false;
        this.closeButton.visible = false;

        var alertView:ChallengeAlertView = ChallengeAlertView.show(ChallengeAlertView.REWARDED_ADS_NOT_AVAILABLE_POPUP, null, this);
        alertView.addEventListener(ChallengeAlertEvent.CLOSE_TRIGGERED, okButtonTriggeredHandler);
        alertView.addEventListener(ChallengeAlertEvent.CHALLENGES_TRIGGERED, challengeButtonTriggeredHandler);
        alertView.open();
    }
    override protected function draw() : void {
        super.draw();
    }

    private function okButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }

    private function challengeButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        dispatchEventWith(StackedBannerScreen.CHALLENGES_HOME_SELECTED)
    }

    override public function dispose(): void {
        super.dispose();
    }

}
}
