package com.despark.tuning3d.view.components.cars {
    import com.despark.tuning3d.model.cars.CarBackground;
    import com.despark.tuning3d.view.components.core.BackgroundContainer;

    import feathers.core.FeathersControl;

    import flash.display.BitmapData;

    import flash.geom.Rectangle;

    import starling.display.Quad;
    import starling.textures.Texture;

    public class Background3D extends FeathersControl {
        private var _frames:Vector.<CarFrameView>;
        private var _currentAngle:int;
        private var _carView:CarView;
        public function Background3D() {
            super();
            _frames = new Vector.<CarFrameView>(2, true);
            for(var i:int = 0; i < _frames.length; i++){
                _frames[i] = new CarFrameView(0, 0, i);
                _frames[i].FRAME_WIDTH = CarBackground.DEFAULT_WIDTH;
                _frames[i].FRAME_HEIGHT = CarBackground.DEFAULT_HEIGHT;
                addChild(_frames[i]);
            }
            _currentAngle = -1;
        }

        public function get frames():Vector.<CarFrameView> {
            return _frames;
        }

        public function showAngle(index:int):void{
            if(_currentAngle == index && frames[_currentAngle]){
                return;
            }
            if(_currentAngle != -1 && frames[_currentAngle]){
                frames[_currentAngle].beforChangeFrame(_currentAngle, 0, 0, 0, 0, 0);
                frames[_currentAngle].visible = false;
            }
            _currentAngle = index;
            if(frames[index]){
                if(_currentAngle != -1 && frames[_currentAngle]){
                    frames[_currentAngle].beforChangeFrame(_currentAngle, 0, 0, 0, 0, 0);
                    frames[_currentAngle].visible = true;
                    frames[_currentAngle].showMainLayers();
                    updateBackgroundPosition();
                }
            }
        }

        public function updateBackgroundPosition():void{
            if(parent && frames && _currentAngle >= 0){
                x = (parent.width - frames[_currentAngle].bounds.width) / 2 - frames[_currentAngle].bounds.x;
                y = (parent.height - frames[_currentAngle].bounds.height) / 2 - frames[_currentAngle].bounds.y;
            }
        }

        public function get carView():CarView {
            return _carView;
        }

        public function set carView(value:CarView):void {
            _carView = value;
        }

        override public function dispose():void{
            super .dispose();
            for(var i:int = 0; i < _frames.length; i++){
                if(_frames[i]){
                    _frames[i].removeFromParent(true);
                    _frames[i] = null;
                }
            }
            _frames = null;
            _carView = null;
        }
    }
}
