package com.despark.tuning3d.view.components.cars
{
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.parts.PartMaterialImage;
import com.despark.tuning3d.model.parts.PartSlot;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.PixelMaskDisplayObject;
import com.utils.DisplayObjectUtil;
import com.utils.ImageUtils;

import feathers.core.FeathersControl;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.BitmapDataChannel;
import flash.geom.Matrix;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.utils.getTimer;
import flash.utils.setTimeout;

	import starling.core.Starling;

	import starling.display.Canvas;
import starling.display.DisplayObject;
import starling.display.DisplayObjectContainer;
import starling.display.Image;
import starling.display.Sprite;
import starling.events.Event;
import starling.extensions.TextureMaskStyle;
import starling.textures.SubTexture;
import starling.textures.Texture;
import starling.utils.Color;

public class CarFrameView extends FeathersControl
	{
		
		public static var isChopper:Boolean = false;
		public var layers : Array;
		public var layersPartSlotIndexMap:Object={};
		public var  layersPartSlotMap:Object={};
		private var _maskLayer:PixelMaskDisplayObject;
		private var _scaleFactor:Number;   
		private var disposeFlag:Boolean=false;
		private var _mapMaskForSlot:Object={};
		private var _firstRender:Boolean=false;
		private var _frameIndex:int=-1;
		private var _angelIndex:int=-1;
		public var framesType:String="";
		public  var FRAME_WIDTH:Number=1004;
		public var FRAME_HEIGHT:Number=373;
		private var isAntimask:Boolean=false;
		public var maxLayerIndex:int=0;
		public static var MAX_TEXTURE_WIDTH:int;
		public static var MAX_TEXTURE_HEIGHT:int;
		public static var ANDROID_NORMAL_SCALE:Boolean=true;
		private static var renderedFrameIndex:int = -1;
		private static var renderedAngelIndex:int = -1;
		private var _offset:Point = new Point();
		private var _offsetScale:Number = 1;
		public var complete:Boolean = false;
		
		
		private var mainLayers:Sprite;
		private var maskLayers:Sprite;
		
		public var skipForFastMode:Boolean = false;
		
		//private var _quadMask:Quad;
		
		public function CarFrameView(layersCount : int, frameIndex:int=-1, angelIndex:int=-1)
		{
			super();
			_scaleFactor = -1;
			_frameIndex=frameIndex;
			_angelIndex=angelIndex;
			layers = [];  
			
			addEventListener("complete_load", oneImageCompleteLoad);
		}
		
		public function showMainLayers():void{
			
			//if(mainLayers.visible && mainLayers.alpha==1) return;
			
			
			/*mainLayers.alpha = 0;
			mainLayers.visible = true;
			var tween:Tween = new Tween(mainLayers, 0.2);
			tween.animate("alpha", 1);
			tween.onComplete = function() : void
			{
				mainLayers.alpha = 1;
			}
			
			Starling.juggler.add(tween);*/
			
			this.mainLayers.visible = true;
		}
		
		public function hideMainLayers():void{
			
			this.mainLayers.visible = false;
		}
		
		private function oneImageCompleteLoad(event:*):void{
			
			if(visible)
			this.invalidate("children");
		}
		
		public function taskLoadFromCacheFull():void{
			
			var i:int;
			var j:int;
			for(i=0; i<mainLayers.numChildren; i++){
				layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
				if(layer.numChildren>0){
					for(j=0; j<layer.numChildren; j++){
						image=layer.getChildAt(j) as ImageLoaderWithStates;
						if(image && !image.loadingFlag){
							image.loadFromCache(); 
						}
					}
				}
			}
		}
		
		public function taskLoadFromCacheToMem():void{
			
			var i:int;
			var j:int;
			for(i=0; i<mainLayers.numChildren; i++){
				
				layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
				
				
				if(layer.numChildren>0){
					
					for(j=0; j<layer.numChildren; j++){
						image=layer.getChildAt(j) as ImageLoaderWithStates;
						
						if(image && !image.loadingFlag ){
							
							image.loadFromCache(true); 
							countImageForUpdate++;
							//image=null;
						}
					}
				}
			}
			
		}
		
		
		
		private var oldCameraIndex:int=0;
		private var oldCurrentFrame:int = 0;
		private var countImageForUpdate:int = 0;
		
		public function beforChangeFrame(angelIndex:int, prev2Frame:int, prev1frame:int, currentFrame:int, next1Frame:int, next2Frame):void{
			
			var i:int, j:int;
			var image:ImageLoaderWithStates;
			var layer:PixelMaskDisplayObject;
			
			var changeCamera:Boolean=oldCameraIndex!=angelIndex;
			
			countImageForUpdate = 0;
			
			if(this.angelIndex==angelIndex && this.frameIndex==currentFrame) {
				var startToGPU:int = getTimer();	
				
				for(i=0; i<mainLayers.numChildren; i++){
					
					layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
					
					
					if(layer.numChildren>0){
						
						for(j=0; j<layer.numChildren; j++){
							image=layer.getChildAt(j) as ImageLoaderWithStates;
							
							if(image && !image.loadingFlag ){
								
								image.loadFromCache(); 
								
								countImageForUpdate++;
								//image=null;
							}
						}
					}
					
					
				}	
			}else {	
				
				for(i=0; i<mainLayers.numChildren; i++){
					
					layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
					
					
					if(layer.numChildren>0){
						
						for(j=0; j<layer.numChildren; j++){
							image=layer.getChildAt(j) as ImageLoaderWithStates;
							
							
							var force:Boolean = !image.cleanupFlag;
							
							if(changeCamera) force = false;
							
							if(image && !image.loadingFlag &&  !image.errorFlag){
								
								image.cleanupMemory(); 
								image=null;
								
								countImageForUpdate++;
							}
						}
					}
					
					
				}
			}
			
			oldCameraIndex = angelIndex;
			oldCurrentFrame = currentFrame;
		}
		
		
		override protected function initialize():void{
			
			
			
			mainLayers = new Sprite();
			addChild(mainLayers);
			
			maskLayers = new Sprite();
			addChild(maskLayers);
			
			
			//_quadMask = new Quad(1,1);
		}
		
		protected function onGlobalEventMemLeakTest(event:*):void{
			
		}
		
		
		public function get frameIndex():int{
			
			return _frameIndex;
		}
		
		
		public function get angelIndex():int{
			
			return _angelIndex;
		}
		
		private function onImageChange(event:Event):void{
			complete = false;	
			if(visible && !_firstRender){
				dispatchEventWith('stop_render_frame', true);
			}
		}
		
		
		override public function dispose():void{
			
			for(i=0; i<mainLayers.numChildren; i++){
				layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
				if(layer.numChildren>0){
					for(j=0; j<layer.numChildren; j++){
						image=layer.getChildAt(j) as ImageLoaderWithStates;
						image.dispose();
						image.sepcialDispose();
					}
				}
			}
			
			
			disposeFlag=true;
			layers=null;
			layersPartSlotIndexMap=null;
			layersPartSlotMap=null;
			_maskLayer=null;
			_mapMaskForSlot=null;
			if(_drawToBitmapCanvas){
				_drawToBitmapCanvas.dispose();
				_drawToBitmapCanvas=null
			}
			_excludePartSlotsNames=null;
			_masks=null;
			_antimasks=null;
			if(bufferBitmapData){
				bufferBitmapData=null;
			}
			
			super.dispose();
            DisplayObjectUtil.dispose(this, true, true);
		}
		
		public function get layersCount() : int
		{
			
			return layers ? layers.length: 0;
		}
		
		private var _visible:Boolean;
		
		public override  function set visible(value:Boolean):void{
			
			if(value!=_visible && value) this.invalidate("invalid_mask");
			_visible=value;
			super.visible=value;
			
			
		}
		
		public function addChildAtLayer(child :DisplayObject, layerIndex : int, partSlot:PartSlot=null) : void
		{
			
			//trace("layerIndex", layerIndex)
			if(layerIndex>maxLayerIndex){
				
				maxLayerIndex=layerIndex;
			}
			var IsAddAntimask:Boolean=false;
			if(partSlot && partSlot.name=="antimask"){
				isAntimask=true;
				IsAddAntimask=true;
			}
			
			var layer : PixelMaskDisplayObject = layers[layerIndex];
			if(IsAddAntimask && layer){
				
				
			}else if(IsAddAntimask){
				
			}


			
			var flagUpdateConfig:Boolean=false;
			if(!layer)
			{
				
				layer = new PixelMaskDisplayObject();
				
				//layer.mask
				layers[layerIndex] = layer;
				if(partSlot){
					var partSlotName:String=partSlot.name;
					//if(this.angelIndex==1)
					//trace("addPartSlot to layer:", partSlotName, layerIndex, this.frameIndex, this.angelIndex)
					
					
					
					if(layersPartSlotMap[partSlotName]){
						if(partSlot.name!="masks"){
							partSlotName+="addState";
						}
					}
					
					
					layersPartSlotIndexMap[layerIndex]=partSlot;
					layersPartSlotMap[partSlotName]=layerIndex;
					
					
					
					layer.partSlotName=partSlotName;  
					layer.partSlotNameWithoutState=partSlot.name;
					layer.layerIndex=layerIndex;
					
					layer.maskForSlots=[];//partSlot.selectedPart.maskForSlots;
					
					
					if(partSlot.name=="masks"){  
						
						layer.isMask=true;
						layer.maskSet=partSlot.selectedPart.maskSet;
						//layer.visible=false;
						//layer.blendMode=MASK_MODE_INVERTED; 
						if(partSlot.selectedPart){
							layer.maskForSlots=partSlot.selectedPart.maskForSlots;
							//_mapMaskForSlot=[];
							
							
							if(Car.CAR_DISKS_SLOTS.indexOf(partSlot.setterMaskPartSlotName)>=0 ){
								
								if(!layer.maskForSlots) layer.maskForSlots = ["sides", "rear_bumper"];
								 
								if(layer.maskForSlots.indexOf("sides")<0) layer.maskForSlots.push("sides")
								if(layer.maskForSlots.indexOf("rear_bumper")<0) layer.maskForSlots.push("rear_bumper")
									
//									/rear_bumper
							}
							
							//trace("layer.maskForSlots:", layer.maskForSlots)
							for(var k:int=0; k<layer.maskForSlots.length; k++){
								if(!_mapMaskForSlot[layer.maskForSlots[k]]){
									
									_mapMaskForSlot[layer.maskForSlots[k]]=[];
								}
								
								var msaksLayers:Array=_mapMaskForSlot[layer.maskForSlots[k]];
								
								_mapMaskForSlot[layer.maskForSlots[k]]=[];
								
								for(var i:int=0; i<msaksLayers.length; i++){
									
									var tmp_l:PixelMaskDisplayObject=msaksLayers[i];
									
									if(tmp_l && tmp_l.parent){
										
										_mapMaskForSlot[layer.maskForSlots[k]].push(tmp_l);
									}
									
								}
								
								_mapMaskForSlot[layer.maskForSlots[k]].push(layer);
							}
							
						}else{
							
							layer.maskForSlots=[];
						}
						
						
						partSlot.addMaskLayerName("masks_"+partSlot.selectedPart.maskSet,partSlot.setterMaskPartSlotName);
					}
					
				}
				
				if(IsAddAntimask){
					layer.visible = false;
				}
			}
			
			if(partSlot.name=="masks"){
				
				
			}
			
			(child as ImageLoaderWithStates).layerIndex=layerIndex;   
			
			layer.addChild(child);
			invalidate("children");
		}
		
		private static var _resultRect:Rectangle;
		
		override public function getBounds(targetSpace:DisplayObject, resultRect:Rectangle=null):Rectangle{
			
			var child:DisplayObject;
			var layer:PixelMaskDisplayObject;
			
			if (resultRect == null) {
				
				if(_resultRect==null){
					_resultRect=new Rectangle();
				}
				resultRect = _resultRect;
				
			}
			
			if (mainLayers.numChildren == 0)
			{
				resultRect.setTo(0, 0, 0, 0);
			}
			else if (mainLayers.numChildren == 1)
			{
				//this.mainLayers
				child=mainLayers.getChildAt(0);
				
				layer=child as PixelMaskDisplayObject;
				
				/*if(layer.partSlotNameWithoutState=="shadow"){
				resultRect.setTo(0, 0, 0, 0);
				}else{*/
				
				child.getBounds(targetSpace, resultRect);
				//}
				
				
			}
			else
			{
				var minX:Number = Number.MAX_VALUE, maxX:Number = -Number.MAX_VALUE;
				var minY:Number = Number.MAX_VALUE, maxY:Number = -Number.MAX_VALUE;
				
				
				for (var i:int=0; i<mainLayers.numChildren; ++i)
				{
					child=mainLayers.getChildAt(i);
					
					layer=child as PixelMaskDisplayObject;
					
					/*if(layer.partSlotNameWithoutState=="shadow"){
					continue;
					}*/
					
					child.getBounds(targetSpace, resultRect);
					
					if (minX > resultRect.x)      minX = resultRect.x;
					if (maxX < resultRect.right)  maxX = resultRect.right;
					if (minY > resultRect.y)      minY = resultRect.y;
					if (maxY < resultRect.bottom) maxY = resultRect.bottom;
				}
				
				resultRect.setTo(minX, minY, maxX - minX, maxY - minY);
			}                
			
			return resultRect;
		}
		
		public  function getChildrensBounds(targetSpace:DisplayObject, resultRect:Rectangle=null):Rectangle
		{
			var child:DisplayObject;
			var layer:PixelMaskDisplayObject;
			
			if (resultRect == null) {
				
				if(_resultRect==null){
					_resultRect=new Rectangle();
				}
				resultRect = _resultRect;
				
			}
			
			if (mainLayers.numChildren == 0)
			{
				resultRect.setTo(0, 0, 0, 0);
			}
			else if (mainLayers.numChildren == 1)
			{
				//this.mainLayers
				child=mainLayers.getChildAt(0);
				
				layer=child as PixelMaskDisplayObject;
				
				if(layer.partSlotNameWithoutState=="shadow"){
					resultRect.setTo(0, 0, 0, 0);
				}else{
					
					child.getBounds(targetSpace, resultRect);
				}
				
				
			}
			else
			{
				var minX:Number = Number.MAX_VALUE, maxX:Number = -Number.MAX_VALUE;
				var minY:Number = Number.MAX_VALUE, maxY:Number = -Number.MAX_VALUE;
				
				
				for (var i:int=0; i<mainLayers.numChildren; ++i)
				{
					child=mainLayers.getChildAt(i);
					
					layer=child as PixelMaskDisplayObject;
					
					if(layer.partSlotNameWithoutState=="shadow"){
						continue;
					}
					
					child.getBounds(targetSpace, resultRect);
					
					if (minX > resultRect.x)      minX = resultRect.x;
					if (maxX < resultRect.right)  maxX = resultRect.right;
					if (minY > resultRect.y)      minY = resultRect.y;
					if (maxY < resultRect.bottom) maxY = resultRect.bottom;
				}
				
				resultRect.setTo(minX, minY, maxX - minX, maxY - minY);
			}                
			
			return resultRect;
		}
		
		
		private function findMaskLayerForSlot(partSlotName:String):Array{
			if(_mapMaskForSlot[partSlotName])
				return _mapMaskForSlot[partSlotName];
			return null;
		}
		
		private function compareArray(a:Array, b:Array):Boolean{
			
			if(a.length!=b.length){
				
				return false;
			}
			
			if(a.length==0){
				return true;  
			}
			
			for(var i:int=0; i<a.length; i++){
				
				if(b.indexOf(a[i])<0){
					
					return false;
				}
			}
			
			
			return true;
		}
		
		private var _skipImagesFlag:Boolean=false;
		private var i:int;
		private var l:int;
		private var j:int;
		private var k:int;
		private var maskLayerTmp:PixelMaskDisplayObject;
		private var imageMask:ImageLoaderWithStates;
		private var imageAntimask:ImageLoaderWithStates;
		private var createFlagMaskFilter:Boolean=false;
		//private var maskFilter:MaskFilter;
		private var layerRect:Rectangle = null;
		private var maskRect:Rectangle = null;
		private var antimaskRect:Rectangle = null;
		private var allAntimaskLayers:Array = [];
		private var image:ImageLoaderWithStates;
		private var layer:PixelMaskDisplayObject;
		
		
		
		/*public override function render(painter):void
		{
		try{
		if(disposeFlag)
		return;
		
		if(!visible) 
		return;
		
		
		allAntimaskLayers=[];
		
		for(i=0; i<numChildren; i++){        
		layer=getChildAt(i) as PixelMaskDisplayObject;
		if(layer.partSlotNameWithoutState=="antimsk"){
		for(j=0; j<layer.numChildren; j++){
		image = layer.getChildAt(j) as ImageLoaderWithStates;
		allAntimaskLayers.push(image);
		}
		}
		}
		
		for(k=0; k<numChildren; k++){
		layer=getChildAt(k) as PixelMaskDisplayObject;
		
		if(layer.isMask || layer.partSlotNameWithoutState=="masks") { layer.visible = false; continue; }
		
		if(layer.partSlotNameWithoutState=="antimsk") {  }
		
		var masksLayers:Array = this.findMaskLayerForSlot(layer.partSlotNameWithoutState);
		
		layerRect = layer.getBounds(layer.stage);
		
		if(masksLayers && masksLayers.length>0){
		
		var imagesMasks:Array = [];
		var imagesAtimask:Array =[];
		
		for(i=0; i<masksLayers.length; i++){
		
		maskLayerTmp = masksLayers[i];
		
		if(!maskLayerTmp) continue;
		
		for(l=0; l<maskLayerTmp.numChildren; l++){
		
		imageMask = maskLayerTmp.getChildAt(l) as ImageLoaderWithStates;
		
		
		if(!imageMask) continue;
		if(imageMask.errorFlag) continue;
		
		if(!imageMask.parent) continue;
		
		
		maskRect = imageMask.getBounds(imageMask.stage);
		
		
		if(imageMask.image && imageMask.image.texture && layerRect.intersects(maskRect)){
		
		imagesMasks.push(imageMask);
		
		
		for(j=0; j<allAntimaskLayers.length; j++){
		
		imageAntimask = allAntimaskLayers[j];
		
		if(!imageAntimask) continue;
		
		if(imageAntimask.errorFlag) continue;
		
		if(!imageAntimask.parent) continue;
		
		antimaskRect = imageAntimask.getBounds(imageAntimask.stage);
		
		if(maskRect.intersects(antimaskRect)){
		
		imageMask.addAntimask(imageAntimask);
		//imagesAtimask.push(imageAntimask);
		}
		}
		
		imageMask.applayAntimask();
		
		}
		}
		}
		
		
		if(imagesMasks.length<=0) {
		
		for(i=0; i<layer.numChildren; i++){
		
		image = layer.getChildAt(i) as ImageLoaderWithStates;
		
		if(image.filter){
		
		image.filter.dispose();
		image.filter=null;
		}
		
		}
		continue;   
		}
		
		createFlagMaskFilter = false;
		
		
		for(i=0; i<layer.numChildren; i++){
		
		image = layer.getChildAt(i) as ImageLoaderWithStates;
		
		
		
		
		if(!image) continue;
		
		
		
		
		
		if(!image.image) continue;
		
		if(!image.image.texture) continue;
		
		
		
		if(!image.filter) createFlagMaskFilter = true;
		else {
		
		maskFilter = image.filter as MaskFilter;
		
		if(!maskFilter.validate(image,imagesMasks,[])){
		
		createFlagMaskFilter = true;
		}
		}
		
		
		if(createFlagMaskFilter){
		
		if(image.filter) {image.filter.dispose(); image.filter=null;}
		maskFilter = new MaskFilter(image, imagesMasks, []);
		image.filter = maskFilter;
		
		}
		}
		}else{
		for(i=0; i<layer.numChildren; i++){
		
		image = layer.getChildAt(i) as ImageLoaderWithStates;
		if(!image) continue;
		
		if(image.filter){
		image.filter.dispose();
		image.filter = null;
		}
		
		if(!image.image) continue;
		
		if(!image.image.texture) continue;	
		}
		}
		
		}
		
		for(i=0; i<numChildren; i++){              
		
		layer=getChildAt(i) as PixelMaskDisplayObject;
		
		if(layer.partSlotNameWithoutState=="masks") continue; 
		
		if(layer.partSlotNameWithoutState=="antimsk") continue;
		
		if(layer.isMask) continue;
		
		support.pushMatrix();
		support.transformMatrix(layer);
		
		//support.blendMode = BlendMode.SCREEN;
		try{
		
		//support.applyBlendMode(true);
		layer.render(support, parentAlpha);
		}catch(e:Error){
		
		
		trace("Error:", e.getStackTrace());
		
		}
		support.popMatrix();
		
		}
		
		
		if(!CarView.touchDown){
		//trace("render", CarView.JOBS_AFTER_RENDER_CLEAN.length, CarView.JOBS_AFTER_RENDER_LOAD.length);
		if(CarView.JOBS_AFTER_RENDER_CLEAN.length>0 && getTimer()-lastClenJobTime>200){
		var jobObject:Object = CarView.JOBS_AFTER_RENDER_CLEAN.pop();
		if(jobObject)
		jobObject.func(jobObject.frameView);
		lastClenJobTime = getTimer();
		//trace("background clean job");
		}
		
		if(CarView.JOBS_AFTER_RENDER_LOAD.length>0 && getTimer()-lastLoadJobTime>250){
		jobObject = CarView.JOBS_AFTER_RENDER_LOAD.pop();
		if(jobObject)
		jobObject.func(jobObject.frameView);
		lastLoadJobTime = getTimer();
		
		//trace("background job");
		}
		}		
		complete = true;
		
		}catch(e:Error){
		trace("Error:", e.getStackTrace());
		}
		}*/
		
		private var lastClenJobTime:int=0;
		private var lastLoadJobTime:int=0;
		
		private var layer_index:int;
		private var index:int;
		private var data_layer:Object;
		private var new_layers:Array;
		
		override protected function draw() : void
		{
			//super.draw();
			//trace("DRAW");
			
			var isInvalidChildren:Boolean = isInvalid("children");
			var isInvalidMask:Boolean = isInvalid("invalid_mask");
			
			
			if(isInvalidChildren)  
			{				
				//trace("CarFrameView darw isInvalidChildren:", isInvalidMask)
				k=0;
				layer_index = 0;
				new_layers = [];
				var maskLayer:Object=null;  
				
				for (layer_index in layers)
				{
					if(layers[layer_index]){
						new_layers.push({layer_index:layer_index, layer:layers[layer_index]});  
						
						layer=layers[layer_index];
						
						
					}
				}
				
				new_layers=new_layers.sortOn("layer_index", Array.NUMERIC ); 
				
				//Выстраиваем обычное отображение слоев последовательно
				for (index in new_layers)
				{
					data_layer=new_layers[index];   
					layer=data_layer.layer;
					
					/*if(layer.isMask) {
					
					trace("SKIP ADD MASK")
					continue;
					}*/
					var partSlot:PartSlot=layersPartSlotIndexMap[data_layer.layer_index];
					
					if(layer && !layer.stage)  
					{	
						//layer.
						mainLayers.addChildAt(layer, k);  
					}
					
					if(layer) layer.sortIfNeeded();
					k++;
				}
				
				
				
				_mapMaskForSlot=new Object();
				
				for(k=0; k<mainLayers.numChildren; k++){
					layer=mainLayers.getChildAt(k) as PixelMaskDisplayObject;

					
					if(layer && layer.isMask){
						for(i=0; i<layer.maskForSlots.length; i++){
							if(!_mapMaskForSlot[layer.maskForSlots[i]]){
								_mapMaskForSlot[layer.maskForSlots[i]]=[];
							}
							if(_mapMaskForSlot[layer.maskForSlots[i]].indexOf(layer)<0){
								_mapMaskForSlot[layer.maskForSlots[i]].push(layer);
							}
						}
					}
				}	
				
				
				allAntimaskLayers=[];
				
				for(i=0; i<mainLayers.numChildren; i++){        
					layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
					if(layer.partSlotNameWithoutState=="antimask"){
						for(j=0; j<layer.numChildren; j++){
							image = layer.getChildAt(j) as ImageLoaderWithStates;
							allAntimaskLayers.push(image);
						}
					}
				}
				
			}
			
			
			
			if(isInvalidChildren || isInvalidMask){
				
				
				updateMasks();
			}
		}
		
		
		
		public function redrawAntimask():void{
			
			/*if(!maskLayers) return;
			for(k=0; k<maskLayers.numChildren; k++){
				maskLayerTmp = maskLayers.getChildAt(k) as PixelMaskDisplayObject;
				
				if(!maskLayerTmp) continue;
				
				for(l=0; l<maskLayerTmp.numChildren; l++){
					
					imageMask = maskLayerTmp.getChildAt(l) as ImageLoaderWithStates;
					
					if(!imageMask) continue;
					imageMask.antimaskBitmapDataActuale = false;
				}
			}*/
		}
		
		
		
		
		private function updateMasks():void{
			

			for(k=0; k<mainLayers.numChildren; k++){
				layer=mainLayers.getChildAt(k) as PixelMaskDisplayObject;
				if(!layer) continue;

				if(layer.isMask || layer.partSlotNameWithoutState=="masks") { layer.visible = false; continue; }



				for(i=0; i<layer.numChildren; i++){
					image = layer.getChildAt(i) as ImageLoaderWithStates;
					if(image && image.loadingFlag){
						
						setTimeout(invalidate, 400, "invalid_mask");
						continue;
					}
				}
				
				var masksLayers:Array = this.findMaskLayerForSlot(layer.partSlotNameWithoutState);
				layerRect = layer.getBounds(layer.stage);
				
				if(masksLayers && masksLayers.length>0){
					
					var imagesMasks:Array = [];

					for(i=0; i<masksLayers.length; i++){
						maskLayerTmp = masksLayers[i];
						if(!maskLayerTmp) continue;
						
						for(l=0; l<maskLayerTmp.numChildren; l++){
							
							imageMask = maskLayerTmp.getChildAt(l) as ImageLoaderWithStates;
							if(!imageMask) continue;
							if(imageMask.errorFlag) continue;
							if(!imageMask.parent) continue;
							if(imageMask.loadingFlag){
								setTimeout(invalidate, 400, "invalid_mask");
								continue;
							}
							
							maskRect = imageMask.getBounds(imageMask.stage);
							
							if(imageMask.image && imageMask.image.texture && layerRect.intersects(maskRect)){
								
								if(imagesMasks.indexOf(maskLayerTmp)<0)
									imagesMasks.push(maskLayerTmp);

								for(j=0; j<allAntimaskLayers.length; j++){
									
									imageAntimask = allAntimaskLayers[j];
									if(!imageAntimask) continue;
									if(imageAntimask.errorFlag) continue;
									if(!imageAntimask.parent) continue;
									if(imageAntimask.loadingFlag) {
										
										setTimeout(invalidate, 400, "invalid_mask");
										continue;
									}
									antimaskRect = imageAntimask.getBounds(imageAntimask.stage);
									if(maskRect.intersects(antimaskRect)){
										imageMask.addAntimask(imageAntimask);
									}
								}
								imageMask.applayAntimask();
							}
						}
					}
					
					
					if(imagesMasks.length<=0) {
						if(layer.mask ) layer.mask.removeFromParent(true);
						layer.mask = null;
						continue;
					}
					
					
					//Тут имеем уже массив масок с примененными антимасками 
					/*if(!layer.mask) */createFlagMaskFilter = true;
					if(createFlagMaskFilter){
						var canvasMask:Canvas = this.createMaskCanvas(imagesMasks);
						this.maskLayers.addChild(canvasMask);
						layer.mask = canvasMask;
						layer.maskInverted = true;
					}
					
					
				}else{
					
					if(layer.mask ) layer.mask.removeFromParent(true); 
					layer.mask=null;
				}
				
			}
		}
		
		private function createMaskCanvas(imagesMasks:Array):Canvas{
			
			var maskLayer:PixelMaskDisplayObject;
			var maskCanvas:Canvas = new Canvas();
			var img:Image;
			
			for(i=0; i<imagesMasks.length; i++){
				
				maskLayer = imagesMasks[i];
				for(j=0; j<maskLayer.numChildren; j++){
					image = maskLayer.getChildAt(j) as ImageLoaderWithStates;
					img = createMaskImage(image);
					if (img) {
						maskCanvas.addChild(img);
					}
				}
			}
			
			return maskCanvas;
		}
		
		private function createMaskImage(srcImage:ImageLoaderWithStates):Image{
			if (!srcImage.currentTexture) {
				return null;
			}
			var subTexture:SubTexture = new SubTexture(srcImage.currentTexture);
			//subTexture.scale = 0.5;
			var image:Image = new Image(subTexture);
			image.scale = 0.5;
			
			image.x=srcImage.x;
			image.y=srcImage.y;
			
			image.style = getTextureMaskStyle();
			
			return image;
		}
		
		private function getTextureMaskStyle():TextureMaskStyle{
			var maskStyle:TextureMaskStyle = new TextureMaskStyle();
			maskStyle.threshold = 0.01;
			return maskStyle;
		}
		
		
		
		
		public function removeChildFromLayer(child : DisplayObject, layerIndex : int, dispose : Boolean = false) : void
		{
			try{
				
				var layer :PixelMaskDisplayObject = layers[layerIndex];
				
				if(layer)
				{			
					var partSlotName:String=layer.partSlotName;
					//trace("removeChildFromLayer partSlotName:", partSlotName)
					if(layer.partSlotNameWithoutState=="antimask"){
						
						for each(var masksLayers:Array in _mapMaskForSlot){
							
							for(i=0; i<masksLayers.length; i++){
								
								maskLayerTmp = masksLayers[i];
								
								if(!maskLayerTmp) continue;
								
								
								for(k=0; k<maskLayerTmp.numChildren; k++){
									
									imageMask = maskLayerTmp.getChildAt(k) as ImageLoaderWithStates;
									
									if(!imageMask) continue;
									
									
										
									//var antimaskImage:ImageLoaderWithStates = layer.getChildAt(l) as ImageLoaderWithStates;
										
									if(child){
										imageMask.removeAntimask(child as ImageLoaderWithStates);
									}
									
								}
								
							}
						}
						
					}
					
					
					layer.removeChild(child, dispose);
					if(layer.numChildren == 0)
					{
						
						if(layer.isMask){
							
							var partSlot:PartSlot=layersPartSlotIndexMap[layer.layerIndex];
							
							partSlot.removeMaskLayerName("masks_"+layer.maskSet);
							
							for(var k:int=0; k<layer.maskForSlots.length; k++){
								
								if(_mapMaskForSlot[layer.maskForSlots[k]]){
									
									var maskLayers:Array=_mapMaskForSlot[layer.maskForSlots[k]];
									
									if(maskLayers.indexOf(layer)>=0){
										
										maskLayers=maskLayers.splice(maskLayers.indexOf(layer), 1);
										
										
										_mapMaskForSlot[layer.maskForSlots[k]]=maskLayers;
									}
								}
							}
							
							
							mainLayers.removeChild(layer);
							layer.dispose();
							layers[layerIndex] = null;	
							
							var flagExistsMask:Boolean=false;
							
							for(var i:int=0; i<mainLayers.numChildren; i++){
								layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
								
								if(layer.isMask){
									flagExistsMask=true;
									break;
								}
							}
							
						}else{
							
							
							if(mainLayers.getChildIndex(layer)>=0)
							mainLayers.removeChild(layer);
							
							if(layer)
							layer.dispose();
							layers[layerIndex] = null;	
							
							var flagExistsAntiMask:Boolean=false;
							
							
							for(i=0; i<mainLayers.numChildren; i++){
								layer=mainLayers.getChildAt(i) as PixelMaskDisplayObject;
								
								if(layer.partSlotNameWithoutState=="antimask"){
									flagExistsAntiMask=true;
									break;
								}
							}
							
							
							/*setTimeout(function():void{
								invalidate("children");
								invalidate("invalid_mask");
							}, 500)*/
							isAntimask=flagExistsAntiMask;
						}
					}
				} 
			}catch(e:Error){
				
				trace("Error:"+e.getStackTrace());
				
			}
			
			invalidate("children");    
		}
		
		public function getLayer(layer : int):DisplayObjectContainer
		{
			return layers[layer];
		}
		
		
		private var _drawToBitmapIndexLayer:int=0;
		private var _drawToBitmapCanvas:BitmapData=null;
		private var _imageIndex:int=0;
		private var _excludePartSlotsNames:Array=[];   
		private var _masks:Object={};
		private var _antimasks:Object={};
		public static var bufferBitmapData:BitmapData=null;
		
		public static var COMPLETE_DRAW_TO_BITMAP:String="COMPLETE_DRAW_TO_BITMAP";
		private static const IMG_DX:int = 52;
		private static const IMG_DY:int = 10; // -20

		public  function copyToBitmapData(displayObject:DisplayObject, outBmp:BitmapData=null, scale:Number = 1.0):BitmapData {
			var scaleFactor:Number = AlertView.assetManager.scaleFactor;
			displayObject.width = displayObject.width / scaleFactor;
			displayObject.height = displayObject.height / scaleFactor;
			var rect:Rectangle = displayObject.getBounds(this);
			var bitmapDataOut:BitmapData = new BitmapData(Math.round(rect.width*scaleFactor), Math.round(rect.height*scaleFactor), true, 0x00808080);
			displayObject.drawToBitmapData(bitmapDataOut);

			if(!outBmp){
				return bitmapDataOut;
			}else{
				
				var cropArea:Rectangle = new Rectangle(0, 0, rect.width*scaleFactor, rect.height*scaleFactor);
				var bmp:Bitmap=new Bitmap(bitmapDataOut);
				
				outBmp.fillRect(outBmp.rect, 0x00808080);
				outBmp.draw(bmp, null, null,null,cropArea);  
				return outBmp;
			}
		}
		
		
		private function colorFilter(bitmapData:BitmapData, color):BitmapData{
			
			
			/*
			Попробуем оптимизировать по скорости в некоторых случаях заюзаем GPU
			*/

			var bd:BitmapData
			
			if(color!=0xffffff){   
				bd=bitmapData.clone();
				if(bd.width >= 1 && bd.height >=1 && bd.width<Constants.STAGE.fullScreenWidth && bd.height<Constants.STAGE.fullScreenHeight){
					
					var texture:Texture=Texture.fromBitmapData(bd,false, false,1);  
					
					var image:Image=new Image(texture);
					
					image.color=color;
					
					this.parent.addChild(image);
					
					bd=copyToBitmapData(image, bd);
					
					image.removeFromParent(true);
					image=null;
					
					texture.dispose();
					texture=null;
					
					var endTime:int = new Date().valueOf();
					return bd;
					
				}
				
			}
			
			var setRed:Number=Color.getRed(color)/255;
			var setGreen:Number=Color.getGreen(color)/255;
			var setBlue:Number=Color.getBlue(color)/255;
			
			var alpha:Number, red:Number, green:Number, blue:Number;
			
			var pixelColor:uint;
			var ft2:Number=0;
			var ft3_x:Number=0;
			var ft3_y:Number=0;
			var ft3_z:Number=0;
			
			//var pixelVector:Vector<>
			
			if(color!=0xffffff){
				
				bitmapData=bd;
				
				for(var v:int=0; v<bitmapData.height; v++){
					
					
					for(var h:int=0; h<bitmapData.width; h++){
						
						pixelColor=bitmapData.getPixel32(h,v);
						
						
						alpha=Color.getAlpha(pixelColor)/255;
						red=Color.getRed(pixelColor)/255;
						green=Color.getGreen(pixelColor)/255;
						blue=Color.getBlue(pixelColor)/255;
						
						if(alpha>0){
							
							ft2=red-green;
							
							ft3_x=setRed-1;
							
							ft3_x=ft3_x*ft2;
							
							ft3_x=ft3_x+red;
							
							
							ft3_y=setGreen*ft2;
							
							ft3_y=ft3_y+green;
							
							
							ft3_z=setBlue*ft2;
							
							ft3_z=ft3_z+blue;
							
							bitmapData.setPixel32(h,v, Color.argb(alpha*255, ft3_x*255, ft3_y*255, ft3_z*255));
							
						}
					}
				}
			}
			return bitmapData;
		}
		
		
		private function antiMaskDraw(image:ImageLoaderWithStates, bitmapData:BitmapData):void{
			
			var layer:PixelMaskDisplayObject=null;
			layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
			
			
			if(bitmapData){
				
				
				var dx:Number=0;
				var dy:Number=0;
				var partMaterialImage:PartMaterialImage=image.persistentImageProvider as PartMaterialImage;
				dx+=partMaterialImage.x + IMG_DX;
				dy+=image.y/0.5 - offset.y;
				
				_antimasks[layer.layerIndex]={layer:layer, x:dx, y:dy, bitmapData:bitmapData};
				
				_imageIndex++;
				continueLoadAntiMask();
				
			}else{
				
				_imageIndex++;
				continueLoadAntiMask();  
			}
		}
		
		private function maskDraw(image:ImageLoaderWithStates, bitmapData:BitmapData):void{
			
			var layer:PixelMaskDisplayObject=null;
			layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
			if(bitmapData){
				var dx:Number=0;
				var dy:Number=0;
				var partMaterialImage:PartMaterialImage=image.persistentImageProvider as PartMaterialImage;
				dx+=partMaterialImage.x + IMG_DX;
				dy+=image.y/0.5 - offset.y;
				
				_masks[layer.layerIndex]={layer:layer, x:dx, y:dy, bitmapData:bitmapData};
				_imageIndex++;
				continueLoadMask();
			}else{
				_imageIndex++;
				continueLoadMask();  
			}
		}
		
		private var _isFirstMask:Boolean=false;
		
		private function canvasDraw(image:ImageLoaderWithStates, bitmapData:BitmapData):void{
			
			
			var layer:PixelMaskDisplayObject=null;
			layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
			
			var disposeFlag:Boolean=false;
			
			if(image.visible && bitmapData){
				
				var masksLayer:Array=this.findMaskLayerForSlot(layer.partSlotNameWithoutState);
				
				var masksLayerData:Array=[];
				
				if(!masksLayer){
					masksLayer=[];
				}
				
				for(var i:int=0; i<masksLayer.length; i++){
					
					var maskLayer:PixelMaskDisplayObject=masksLayer[i];
					
					if(_masks && _masks[maskLayer.layerIndex]){
						
						masksLayerData.push(_masks[maskLayer.layerIndex]);
					}
					
				}
				
				var color:uint;
				
				if(image.image){
					color=image.image.color
				}else{
					
					color=image.color;
				}
				
				
				var bd:BitmapData=colorFilter(bitmapData, color);
				
				if(bd!=bitmapData){
					
					disposeFlag=true;
					
					bitmapData=bd;
				}
				
				var bmp:Bitmap=new Bitmap(bitmapData,"auto", false);
				var matrix:Matrix=new Matrix();
				
				var dx:Number=0;
				var dy:Number=0;
				
				var partMaterialImage:PartMaterialImage=image.persistentImageProvider as PartMaterialImage;
				
				
				dx+=partMaterialImage.x + IMG_DX;
				dy+=image.y/0.5 - offset.y;

				//
				if(partMaterialImage.angleIndex != angelIndex || partMaterialImage.frameIndex != frameIndex){ // TODO: fix needed
					_imageIndex++;
					continueDrawToBitmap();
					return;
				}
				//


				var maskMixerBitmapData:BitmapData=null;
				var imageBitmapData:BitmapData=null;
				var antimaskMixerBitmapData:BitmapData=null;
				
				var bufferBitmapData:BitmapData=null;
				
				var imageBitmap:Bitmap=null;
				var maskMixerBitmap:Bitmap=null;
				var antimaskMixerBitmap:Bitmap=null;
				var bufferBitmap:Bitmap=null;
				var maskDx:int;
				var maskDy:int;
				
				if(masksLayerData.length>0){
					
					
					_isFirstMask=true;
					
					imageBitmapData=new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);
					
					maskMixerBitmapData=new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0xffffffff);  
					
					if(isAntimask){
						antimaskMixerBitmapData=new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);  
						
						bufferBitmapData=new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080); 
						
						
					}

					
					matrix.translate(dx, dy);
					imageBitmapData.draw(bmp,matrix);
					imageBitmap=new Bitmap(imageBitmapData);
					imageBitmap.cacheAsBitmap=true;
					
					
					
					for(i=0; i<masksLayerData.length; i++){
						
						bd=masksLayerData[i].bitmapData;
						maskDx=masksLayerData[i].x;
						maskDy=masksLayerData[i].y;
						
						matrix=new Matrix(); 
						matrix.translate(maskDx, maskDy);  
						
						maskMixerBitmapData.draw(bd, matrix );
					}
					
					if(isAntimask){
						
						for each (var antimask:Object in _antimasks){
							bd=antimask.bitmapData;
							maskDx=antimask.x;
							maskDy=antimask.y;
							
							matrix=new Matrix();
							matrix.translate(maskDx, maskDy);  
							
							antimaskMixerBitmapData.draw(bd, matrix );
							
						}
					}
					
					if(isAntimask){
						//antimaskMixerBitmapData.copyChannel(antimaskMixerBitmapData, antimaskMixerBitmapData.rect, new Point(), BitmapDataChannel.BLUE, BitmapDataChannel.ALPHA);
					}    
					
					maskMixerBitmapData.copyChannel(maskMixerBitmapData, maskMixerBitmapData.rect, new Point(), BitmapDataChannel.BLUE, BitmapDataChannel.ALPHA);
					
					if(isAntimask){
						antimaskMixerBitmap=new Bitmap(antimaskMixerBitmapData);
						antimaskMixerBitmap.cacheAsBitmap=true;
					}
					
					maskMixerBitmap=new Bitmap(maskMixerBitmapData);
					maskMixerBitmap.cacheAsBitmap=true;
					if(isAntimask){
						
						bufferBitmap=new Bitmap(bufferBitmapData);
						bufferBitmap.cacheAsBitmap=true;
						
						//maskMixerBitmap.mask=antimaskMixerBitmap;
						
						Constants.STAGE.addChild(antimaskMixerBitmap);
						Constants.STAGE.addChild(maskMixerBitmap);  
						
						
						//Constants.STAGE.addChild(imageBitmap);
						
						matrix=new Matrix();
						matrix.translate(0, 0);
						bufferBitmapData.draw(maskMixerBitmap, matrix);
						
						bufferBitmapData.draw(antimaskMixerBitmap, matrix);
						
						if(maskMixerBitmapData){
							maskMixerBitmapData.dispose();
							maskMixerBitmapData=null;
						}
						
						Constants.STAGE.removeChild(maskMixerBitmap);
						Constants.STAGE.removeChild(antimaskMixerBitmap);    
						
						
						maskMixerBitmap=null;
						
						maskMixerBitmapData=bufferBitmapData;
						maskMixerBitmap=bufferBitmap;
					}
					
					imageBitmap.mask=maskMixerBitmap;
					
					//if(!isAntimask){
					Constants.STAGE.addChild(maskMixerBitmap);
					//}
					
					Constants.STAGE.addChild(imageBitmap);
					
					
					matrix=new Matrix();
					matrix.translate(0, 0);

					_drawToBitmapCanvas.draw(imageBitmap,matrix);
					
					maskMixerBitmapData.dispose();
					maskMixerBitmapData=null;
					
					imageBitmapData.dispose();
					imageBitmapData=null;
					
					if(this.isAntimask){
						
						antimaskMixerBitmapData.dispose();
						antimaskMixerBitmapData=null;
					}
					
					
					Constants.STAGE.removeChild(maskMixerBitmap);
					
					Constants.STAGE.removeChild(imageBitmap);
					
					
					
				}else{
					
					
					matrix.translate(dx, dy);
					_drawToBitmapCanvas.draw(bmp,matrix);
				}
				
				
				if(disposeFlag && bitmapData){
					bitmapData.dispose();
				}
				
				//image.unloadBitmapDataForDraw();
				
				
				_imageIndex++;
				continueDrawToBitmap();
				
				
			}else{
				
				_imageIndex++;
				continueDrawToBitmap();
			}
		}

		public function getBitmapData():BitmapData{
			var imageBitmapData:BitmapData = new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);
			var i:int;
			var layer:PixelMaskDisplayObject;
			var image:ImageLoaderWithStates;
			for(i = 0; i < mainLayers.numChildren; i++){
				layer = mainLayers.getChildAt(i) as PixelMaskDisplayObject;
				if(layer){
					image = layer.getChildAt(layer.numChildren - 1) as ImageLoaderWithStates;
					if(image && image.textureBitmapData){
						var dx:Number = 0;
						var dy:Number = 0;
						var partMaterialImage:PartMaterialImage = image.persistentImageProvider as PartMaterialImage;
						dx += partMaterialImage.x + IMG_DX;
						dy += image.y / 0.5;
						_masks[layer.layerIndex] = {layer:layer, x:dx, y:dy, bitmapData: image.textureBitmapData};
					}
				}
			}

			for(i = 0; i < mainLayers.numChildren; i++){
				layer = mainLayers.getChildAt(i) as PixelMaskDisplayObject;
				if(!layer.isMask && layer.partSlotNameWithoutState != "antimask"){
					for(var j:int = 0; j < layer.numChildren; j++){
						image = layer.getChildAt(j) as ImageLoaderWithStates;
						if(image){
							getLayerBitmapData(layer, imageBitmapData, image);
						}

					}
				}
			}
			_masks = {};
			return imageBitmapData;
		}

		private function getLayerBitmapData(layer:PixelMaskDisplayObject, mainBitmapData:BitmapData, image:ImageLoaderWithStates):void{
			var bitmapData:BitmapData = image.textureBitmapData;
			var disposeFlag:Boolean = false;
			var i:int;
			if(layer.partSlotName && layer.partSlotName.indexOf("black") != -1){
				trace();
			}
			if(image && image.textureBitmapData){
				var masksLayer:Array = findMaskLayerForSlot(layer.partSlotNameWithoutState);
				var masksLayerData:Array = [];
				if(!masksLayer){
					masksLayer = [];
				}
				for(i = 0; i < masksLayer.length; i++){
					var maskLayer:PixelMaskDisplayObject = masksLayer[i];
					if(_masks && _masks[maskLayer.layerIndex]){
						masksLayerData.push(_masks[maskLayer.layerIndex]);
					}
				}
				var color:uint;
				if(image.image){
					color = image.image.color
				}else{
					color = image.color;
				}
				var bd:BitmapData = colorFilter(bitmapData, color);
				if(bd != bitmapData){
					disposeFlag = true;
					bitmapData = bd;
				}
				var bmp:Bitmap = new Bitmap(bitmapData,"auto", false);
				var matrix:Matrix = new Matrix();
				var dx:Number = 0;
				var dy:Number = 0;
				var partMaterialImage:PartMaterialImage = image.persistentImageProvider as PartMaterialImage;
				dx += partMaterialImage.x + IMG_DX;
				dy += image.y / 0.5;


				var maskMixerBitmapData:BitmapData = null;
				var imageBitmapData:BitmapData = null;
				var antimaskMixerBitmapData:BitmapData = null;
				var bufferBitmapData:BitmapData = null;
				var imageBitmap:Bitmap = null;
				var maskMixerBitmap:Bitmap = null;
				var antimaskMixerBitmap:Bitmap = null;
				var bufferBitmap:Bitmap = null;
				var maskDx:int;
				var maskDy:int;

				if(masksLayerData.length > 0){
					imageBitmapData = new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);
					maskMixerBitmapData = new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0xffffffff);
					if(isAntimask){
						antimaskMixerBitmapData = new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);
						bufferBitmapData = new BitmapData(FRAME_WIDTH,FRAME_HEIGHT, true, 0x00808080);
					}
					if(!layer.isMask){
						matrix.translate(dx, dy);
						imageBitmapData.draw(bmp, matrix);
					}else{
						trace();
					}
					imageBitmap = new Bitmap(imageBitmapData);
					imageBitmap.cacheAsBitmap = true;
					for(i=0; i < masksLayerData.length; i++){
						bd = masksLayerData[i].bitmapData;
						maskDx = masksLayerData[i].x;
						maskDy = masksLayerData[i].y;
						matrix = new Matrix();
						matrix.translate(maskDx, maskDy);
						maskMixerBitmapData.draw(bd, matrix );
					}
					if(isAntimask){
						for each (var antimask:Object in _antimasks){
							bd = antimask.bitmapData;
							maskDx = antimask.x;
							maskDy = antimask.y;
							matrix = new Matrix();
							matrix.translate(maskDx, maskDy);
							antimaskMixerBitmapData.draw(bd, matrix );
						}
					}
					maskMixerBitmapData.copyChannel(maskMixerBitmapData, maskMixerBitmapData.rect, new Point(), BitmapDataChannel.BLUE, BitmapDataChannel.ALPHA);
					if(isAntimask){
						antimaskMixerBitmap = new Bitmap(antimaskMixerBitmapData);
						antimaskMixerBitmap.cacheAsBitmap=true;
					}
					maskMixerBitmap = new Bitmap(maskMixerBitmapData);
					maskMixerBitmap.cacheAsBitmap=true;
					if(isAntimask){
						bufferBitmap = new Bitmap(bufferBitmapData);
						bufferBitmap.cacheAsBitmap=true;
						Constants.STAGE.addChild(antimaskMixerBitmap);
						Constants.STAGE.addChild(maskMixerBitmap);

						matrix = new Matrix();
						matrix.translate(0, 0);
						bufferBitmapData.draw(maskMixerBitmap, matrix);
						bufferBitmapData.draw(antimaskMixerBitmap, matrix);
						if(maskMixerBitmapData){
							maskMixerBitmapData.dispose();
							maskMixerBitmapData = null;
						}

						Constants.STAGE.removeChild(maskMixerBitmap);
						Constants.STAGE.removeChild(antimaskMixerBitmap);
						maskMixerBitmap = null;
						maskMixerBitmapData = bufferBitmapData;
						maskMixerBitmap = bufferBitmap;
					}

					imageBitmap.mask = maskMixerBitmap;
					Constants.STAGE.addChild(maskMixerBitmap);
					Constants.STAGE.addChild(imageBitmap);
					matrix = new Matrix();
					matrix.translate(0, 0);
					mainBitmapData.draw(imageBitmap, matrix);
					maskMixerBitmapData.dispose();
					maskMixerBitmapData = null;

					imageBitmapData.dispose();
					imageBitmapData = null;
					if(this.isAntimask){
						antimaskMixerBitmapData.dispose();
						antimaskMixerBitmapData = null;
					}
					Constants.STAGE.removeChild(maskMixerBitmap);
					Constants.STAGE.removeChild(imageBitmap);
				}else{
					matrix.translate(dx, dy);
					mainBitmapData.draw(bmp, matrix);
				}
				if(disposeFlag && bitmapData){
					bitmapData.dispose();
				}
			}
		}

		private function continueDrawToBitmap():void{
			
			var layer:PixelMaskDisplayObject=null;
			
			
			if(_drawToBitmapIndexLayer<mainLayers.numChildren){
				
				layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
				
				if(!layer){
					
					_drawToBitmapIndexLayer++;
					continueDrawToBitmap();
					return;
				}
				
				if( layer.isMask){
					
					_drawToBitmapIndexLayer++;
					continueDrawToBitmap();
					return;
				}
				
				if(layer.partSlotNameWithoutState=="antimask"){
					
					_drawToBitmapIndexLayer++;
					continueDrawToBitmap();
					return;
				}
				
				if(this._excludePartSlotsNames.indexOf(layer.partSlotNameWithoutState)>=0){
					
					_drawToBitmapIndexLayer++;
					continueDrawToBitmap();
					return;
				}
				
				//Даем команду на загрузку картинок из кеша последовательно
				
				if(_imageIndex<layer.numChildren){
					
					var image:ImageLoaderWithStates=layer.getChildAt(_imageIndex) as ImageLoaderWithStates;
					
					if(image){
						
						image.loadBitmapDataForDraw(canvasDraw);
						
					}else{
						
						_imageIndex++;
						continueDrawToBitmap();
					}
					
					
					
				}else{
					
					_imageIndex=0;
					_drawToBitmapIndexLayer++;
					continueDrawToBitmap();
				}
				
				
			}else{
				
				finishDrawToBitmap();
			}
			
			
		}
		
		private function finishDrawToBitmap():void{
			
			//диспатчим событие об окончании отрисвоки фрейма
			
			var bmp:BitmapData=_drawToBitmapCanvas;
			var layer:PixelMaskDisplayObject;
			var image:ImageLoaderWithStates;
			var i:int=0;
			
			_imageIndex=0;
			_drawToBitmapIndexLayer=0;
			_drawToBitmapCanvas=null;  
			/*if(bufferBitmapData){
			bufferBitmapData.dispose();
			bufferBitmapData=null;
			}*/
			
			
			for each(var mask:Object in _masks ){
				
				
				//_masks[layer.layerIndex]={layer:layer, x:dx, y:dy, bitmapData:bitmapData};
				
				if(mask && mask.layer){
					
					layer= mask.layer;
					
					if(layer){
						
						for(i=0; i<layer.numChildren; i++){
							
							image=layer.getChildAt(i) as ImageLoaderWithStates;
							
							if(image){
								
								//image.unloadBitmapDataForDraw();   
								
								if(mask.bitmapData){
									
									mask.bitmapData=null;
								}
							}
						}
						
						
						mask.layer=null;
						
					}
					
				}
				
			}
			
			_masks=[];
			
			
			for each(var antimask:Object in _antimasks ){
				
				
				//_masks[layer.layerIndex]={layer:layer, x:dx, y:dy, bitmapData:bitmapData};
				
				if(antimask && antimask.layer){
					
					layer= antimask.layer;
					
					if(layer){
						
						for(i=0; i<layer.numChildren; i++){
							
							image=layer.getChildAt(i) as ImageLoaderWithStates;
							
							if(image){
								
								//image.unloadBitmapDataForDraw();   
								
								if(antimask.bitmapData){
									
									antimask.bitmapData=null;
								}
							}
						}
						
						
						antimask.layer=null;
						
					}
					
				}
				
			}
			
			_antimasks=[];
			
			this.dispatchEventWith(COMPLETE_DRAW_TO_BITMAP, false, {bitmapData:bmp});
			
			
			
		}
		
		private function continueLoadMask():void{
			
			
			var layer:PixelMaskDisplayObject=null;
			
			
			if(_drawToBitmapIndexLayer<mainLayers.numChildren){
				
				layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
				
				
				if(!layer){
					
					_drawToBitmapIndexLayer++;
					continueLoadMask();
					return;
				}
				
				
				if( !layer.isMask){
					
					_drawToBitmapIndexLayer++;
					continueLoadMask();
					return;
				}
				
				if(_imageIndex<layer.numChildren){
					
					var image:ImageLoaderWithStates=layer.getChildAt(_imageIndex) as ImageLoaderWithStates;
					
					if(image){
						image.loadBitmapDataForDraw(maskDraw);
					}else{
						
						_imageIndex++;
						continueLoadMask();
					}
				}else{
					
					_imageIndex=0;
					_drawToBitmapIndexLayer++;
					continueLoadMask();
				}
				
				
			}else{
				
				
				_imageIndex=0;
				_drawToBitmapIndexLayer=0;
				continueDrawToBitmap();
			}
		}
		
		
		private function continueLoadAntiMask():void{
			
			
			var layer:PixelMaskDisplayObject=null;
			
			
			if(_drawToBitmapIndexLayer<mainLayers.numChildren){
				
				layer=mainLayers.getChildAt(_drawToBitmapIndexLayer) as PixelMaskDisplayObject;
				
				
				if(!layer){
					
					_drawToBitmapIndexLayer++;
					continueLoadAntiMask();
					return;
				}
				
				
				if(layer.partSlotNameWithoutState!="antimask"){
					
					_drawToBitmapIndexLayer++;
					continueLoadAntiMask();
					return;
				}
				
				if(_imageIndex<layer.numChildren){
					
					var image:ImageLoaderWithStates=layer.getChildAt(_imageIndex) as ImageLoaderWithStates;
					
					if(image){
						
						image.loadBitmapDataForDraw(antiMaskDraw);
						
					}else{
						
						_imageIndex++;
						continueLoadAntiMask();
					}
					
					
					
				}else{
					
					_imageIndex=0;
					_drawToBitmapIndexLayer++;
					continueLoadAntiMask();
				}
				
				
			}else{
				
				
				_imageIndex=0;
				_drawToBitmapIndexLayer=0;
				continueLoadMask();
			}
		}
		
		
		private var _startTimeDrawToBitmap:int;
		
		public function startDrawToBitmap(excludePartSlotsNames:Array, bgBitmapData : BitmapData):void{
			
			
			_startTimeDrawToBitmap=getTimer();
			_excludePartSlotsNames=excludePartSlotsNames;
			

			_imageIndex=0;
			_drawToBitmapIndexLayer=0;
			
			
			if(_drawToBitmapCanvas){
				
				_drawToBitmapCanvas.dispose();
				_drawToBitmapCanvas=null;
			}

			if(bgBitmapData)
			{
                if(bgBitmapData.width >= FRAME_WIDTH && bgBitmapData.height >= FRAME_HEIGHT)
                {
					var xDiff : Number = (bgBitmapData.width - FRAME_WIDTH)/2;
					var yDiff : Number = (bgBitmapData.height - FRAME_HEIGHT)/2;

                    _drawToBitmapCanvas = ImageUtils.cropBMP(
							new Bitmap(bgBitmapData),
							xDiff,
							yDiff,
							bgBitmapData.width - 2*xDiff,
							bgBitmapData.height-2*yDiff).bitmapData;
                }else {
                    _drawToBitmapCanvas = bgBitmapData;
                }
			}
			else {
				_drawToBitmapCanvas=new BitmapData(FRAME_WIDTH, FRAME_HEIGHT, true, 0x00808080);
			}

			
			if(_drawToBitmapIndexLayer<mainLayers.numChildren){
				
				continueLoadAntiMask();
				//continueLoadMask();
				//continueDrawToBitmap();
				return;
				
			}
			
			finishDrawToBitmap();
		}

		public function get offset():Point{
			return _offset;
		}
		
		public function copyToBitmap(__width : int, __height : int, __scaleFactor : Number):BitmapData//используется для фоток
		{
			/*var stage:Stage= Starling.current.stage;
			var rs:RenderSupport = new RenderSupport();
			
			rs.clear();
			rs.scaleMatrix(1.0/__scaleFactor, 1.0/__scaleFactor);
			rs.setProjectionMatrix(0, 0, __width  , __height  );
			rs.translateMatrix(0, 0); 
			
			var prevVisible:Boolean=visible; 
			this.visible=true;
			
			this.render(rs, 1.0);   
			rs.finishQuadBatch();
			
			var outBmp:BitmapData = new BitmapData(__width , __height , true);//result
			Starling.context.drawToBitmapData(outBmp);
			
			this.visible=prevVisible;  
			
			return outBmp;  */
			return null;
		}
	}
}



