package com.despark.tuning3d.view.components.cars {
import com.despark.tuning3d.model.cars.Car;

public class CarYCalculator {

    private var _carView:CarView;
    private var _scaleYCoefficient:Number = 120;
    private var _carYMargin:Number = 20;

    private var _calculusFunction:Function;

    public function CarYCalculator(carView:CarView) {
        this._carView = carView;

        if (car && car.size && car.size.hasOwnProperty("width") && car.size.hasOwnProperty("height") && (car.size.width > 1004 || car.size.height > 373)) {
            _carYMargin = -30;

        } else {
            _carYMargin = 20;
            _scaleYCoefficient = 40;
        }

        if (car && car.isBigSize) {

            if (car.size.width >= 1920 && car.size.height >= 1080) {
                _carYMargin = -70;

            } else {
                _carYMargin = -10;
                _scaleYCoefficient = 80;
            }
        }

        if (car.size && car.size.height == 900) {
            _carYMargin -= 20;
        } else if (car.hdsize) {
            _carYMargin -= 60;
        }
        _calculusFunction = normalYCalculus;
    }

    private function get car():Car {
        return _carView.car;
    }

    private function normalYCalculus():Number {
        var ratio:Number = 1 / _carView.scale;
        return ratio * (_carView.frameHeight / 2 + (1 - _carView.initialScale * _carView.scaleComponent) * _scaleYCoefficient + _carYMargin);
    }

    private function custom1YCalculus():Number {
        var k:Number;

        if (_carView.currentAngelIndex == 1 && _carView.height > 0) {
            var t:Number = (_carView.height - _carView.frameHeight) / 50; // 50 is the maximum gap  or the height of the bottom menu in the tuning screen;
            t = (1 - t) * 15; // 15 is the Y that we want to reduce for second camera, when the bottom menu is opened
            k = (_carView.frameHeight / 2 + (1 - _carView.initialScale * _carView.scaleComponent) * _scaleYCoefficient + _carYMargin - t);
        } else {
            k = (_carView.frameHeight / 2 + (1 - _carView.initialScale * _carView.scaleComponent) * _scaleYCoefficient + _carYMargin);
        }

        return k;


    }

    public function get carY():Number {
        return _calculusFunction();
    }
}
}
