package com.despark.tuning3d.view.components.challenges.controls {
    import feathers.controls.List;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.core.FeathersControl;

    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;

    public class ChallengeScreenItemRenderer extends FeathersControl implements IListItemRenderer {
    protected var _owner:List;
    protected var _data:Object;
    protected var _factoryID:String;
    protected var _isSelected:Boolean;
    //
    public static const ITEM_SELECTED:String = 'ChallengeItemRenderer:itemSelected';
    public function ChallengeScreenItemRenderer() {
        addEventListener(TouchEvent.TOUCH, touchHandler);
    }

        /**
         * Return true if the current renderer is the first visible item of the owner list
         * false otherwise
         */
    public function isFirstVisibleItem():Boolean{
        if(data && owner && owner.dataProvider){
            var numPerPage:int = Math.ceil(owner.dataProvider.length/owner.horizontalPageCount);
            if(owner.horizontalPageIndex < owner.horizontalPageCount - 1 || owner.dataProvider.length % numPerPage == 0) {
                var firstIndex:int = owner.horizontalPageIndex * numPerPage;
                if (index == firstIndex) {
                    return true
                }
            }else if(index == owner.dataProvider.length - numPerPage){
                return true;
            }
        }
        return false;
    }

    public function get index():int {
        if(data && owner && owner.dataProvider){
            return owner.dataProvider.getItemIndex(data);
        }
        return -1;
    }

    public function set index(value:int):void {
        if(value == index) {
            return;
        }
        if(data && owner && owner.dataProvider && value >= 0 && value < owner.dataProvider.length){
            owner.dataProvider.setItemAt(data, value);
        }
        invalidate(INVALIDATION_FLAG_DATA);
    }

    public function get owner():List {
        return _owner;
    }

    public function set owner(value:List):void {
        if(_owner == value) {
            return;
        }
        _owner = value;
        invalidate(INVALIDATION_FLAG_DATA);
    }

    public function get data():Object {
        return _data;
    }

    public function set data(value:Object):void {
        if(_data == value) {
            return;
        }
        _data = value;
        invalidate(INVALIDATION_FLAG_DATA);
    }

    public function get factoryID():String {
        return _factoryID;
    }

    public function set factoryID(value:String):void {
        _factoryID = value;
    }

    public function get isSelected():Boolean {
        return _isSelected;
    }

    public function set isSelected(value:Boolean):void {
        if(_isSelected == value) {
            return;
        }
        _isSelected = value;
        invalidate(INVALIDATION_FLAG_SELECTED);
        dispatchEventWith(Event.CHANGE);
    }

    override public function dispose():void{
        super .dispose();
        _owner = null;
        _data = null;
    }

    private function touchHandler(event : TouchEvent):void {
        try {
            const touches : Vector.<Touch> = event.getTouches(this);
            for each(var touch : Touch in touches) {
                if (touch.phase == TouchPhase.ENDED && !owner.isScrolling) {
                    owner.dispatchEvent(new Event(ITEM_SELECTED, false, _data));
                    return;
                }
            }
        } catch(e:Error) {

        }
    }
}
}