package com.despark.tuning3d.view.components.challenges.controls {
    import com.despark.tuning3d.model.users.ChallengeUser;
    import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.LabelFactory;
import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;

import feathers.core.FeathersControl;

import flash.geom.Rectangle;

import starling.display.Image;
import starling.display.Sprite;
import starling.textures.Texture;

public class ChallengeUserLabel extends Sprite {
    private var _avatar:ChallengeUserAvatar;
    private var _background:Image;
    private var _user:ChallengeUser;
    private var _label:FeathersControl;
    private static const SIZE:int = 35;
    public var num:String = "";
    public function ChallengeUserLabel(userObject:Object = null) {
        super();
        var bgTxt:Texture = ButtonFactory.assetManager.getTexture("profile_background");
        Image.bindScale9GridToTexture(bgTxt, new Rectangle(bgTxt.width/3, 0, bgTxt.width/3, bgTxt.height));
        _background = new Image(bgTxt);
        _background.scale = ButtonFactory.assetManager.scaleFactor/2;
        _background.height = SIZE + 3;
        _label = LabelFactory.createLabelPopup();
        _label.height = 18;
        _label.minWidth = 70;
        _label.maxWidth = 180;
        _label.x = 40;
        _label.y = (_background.height - _label.height)/2;
        addChild(_background);
        addChild(_label);
        if(userObject) {
            _user = new ChallengeUser(userObject);
            _avatar = new ChallengeUserAvatar(_user, SIZE);
            _avatar.x = _avatar.y = 2.5;
            addChild(_avatar);
            updateLabel();
        }
    }

    public function set user(value:ChallengeUser):void{
        _user = value;
        if(_user) {
            if(_avatar && _avatar.user) {
                if (_avatar.user.id != _user.id) {
                    _avatar.user = _user;
                    updateLabel();
                }
            }else{
                _avatar ||= new ChallengeUserAvatar(_user, SIZE);
                if(_avatar.user != _user){
                    _avatar.user = _user;
                }
                avatar = _avatar;
            }
        }
    }

    public function get user():ChallengeUser{
        return _user;
    }

    override public function dispose():void {
        super.dispose();
        if(_background){
            _background.removeFromParent(true);
            _background = null;
        }
        if(_avatar){
            _avatar.removeFromParent(true);
            _avatar = null;
        }
    }

    public function get avatar():ChallengeUserAvatar {
        return _avatar;
    }

    private function updateLabel():void{
        if(_user) {
            _label["text"] = num + _user.nameToShow;
            _label.validate();
            _background.width = _label.width + 65;
        }
    }

    public function set avatar(value:ChallengeUserAvatar):void {
        _avatar = value;
        if(_avatar) {
            _avatar.validate();
            _user = _avatar.challengeUser;
            _avatar.x = _avatar.y = (_background.height - SIZE) / 2;
            addChild(_avatar);
            updateLabel();
        }
    }
}
}
