package com.despark.tuning3d.view.components.challenges.modals {
    public class ChallengeErrorCode {
        public static const MAX_COUNT_STATUS_CODE:int = 427;
        public static const NOT_ENOUGH_COIN_CODE:int = 426;
        public static const MINE_IN_CHALLENGE_STATUS_CODE:int = 402;
        public static const OPPONENT_IN_CHALLENGE_STATUS_CODE:int = 403;

        public static const MINE_IN_CHALLENGE_ERROR_TYPE:String = "own";
        public static const OPPONENT_IN_CHALLENGE_ERROR_TYPE:String = "opponent";
        public static const MAX_COUNT_ERROR_TYPE:String = "noLimit";
        public static const NO_COIN_ERROR_TYPE:String = "noCoin";

        public static function getStatusCode(errorType:String):int{
            switch (errorType) {
                case MINE_IN_CHALLENGE_ERROR_TYPE:
                    return MINE_IN_CHALLENGE_STATUS_CODE;
                case OPPONENT_IN_CHALLENGE_ERROR_TYPE:
                    return OPPONENT_IN_CHALLENGE_STATUS_CODE;
                case MAX_COUNT_ERROR_TYPE:
                    return MAX_COUNT_STATUS_CODE;
                case NO_COIN_ERROR_TYPE:
                    return NOT_ENOUGH_COIN_CODE;
            }
            return 0;
        }
    }
}
