package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.cars.CarBackground;
import com.despark.tuning3d.model.core.images.PersistentImageProvider;

import starling.display.Image;
import starling.textures.Texture;

public class BackgroundItemRenderer extends ListItemRenderer
	{
		
		//public static const EVENT_OPEN_INFO_POP_UP:String="EVENT_OPEN_INFO_POP_UP";
		
		
		protected var _selectedIcon:Image;
		
		
		public function BackgroundItemRenderer()
		{
			super();
			//fontSize = 9;
			//_textColor = 0xffffff;
			
			//_bold=false;
		}
		
		
		
		public function get carBackground() :CarBackground
		{
			return data as CarBackground;
		}
		
		override public function dispose():void{
			trace("dispose BackgroundItemRenderer");
			//data=null;
			if(_selectedIcon){
                _selectedIcon.dispose();
                _selectedIcon = null;
			}
			super.dispose();
		}
		
		protected override function initialize():void
		{
			//return ;
			super.initialize();
			
			imageLoader.overrideDispose = false;
			
			
			imageLoader.maintainAspectRatio = false;
			//imageLoader.clipRect = new Rectangle(0, 0, 51.25, 41); //tt Убрал но не уверен нужно мегрировать
			//imageLoader.
			imageLoader.setSize(51.25, 41);
			
			
			var texture:Texture=AlertView.assetManager.getTexture("a_selected_bg_icon");
			_selectedIcon=new Image(texture);
			_selectedIcon.width=14;
			_selectedIcon.height=14;
			_selectedIcon.visible=false;
			addChild(_selectedIcon);
			
			
		}
		
		
		
		protected override function commitData() : void
		{
			super.commitData();
			
			
			if(carBackground){
				
				var newPersistentImageProvider:PersistentImageProvider=carBackground;
				
				if(imageLoader.persistentImageProvider && imageLoader.persistentImageProvider.remoteUrl!=newPersistentImageProvider.remoteUrl){
					
					imageLoader.persistentImageProvider = carBackground;
				}else if(!imageLoader.persistentImageProvider){
					
					imageLoader.persistentImageProvider = carBackground;
					//imageLoader.
				}
			}
			
		}
		
		protected override function commitSelection() :void
		{
			super.commitSelection();
			
			_selectedIcon.visible=isSelected;
			
			
		}
		
		protected override function layout():void
		{
			imageLoader.width = actualWidth;
			imageLoader.height = actualHeight;
			
			imageLoader.x=0
			imageLoader.y=0;
			
			_selectedIcon.x=actualWidth-_selectedIcon.width-2;
			_selectedIcon.y=actualHeight-_selectedIcon.height-2;
			
		}
		
		
		protected override function  draw():void{
			
			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			
			if(sizeInvalid)
			{
				
				layout();
				
			}
			
		}
		
	}
}


