package com.despark.tuning3d.view.components.core {
import feathers.controls.List;
import feathers.data.IListCollection;

public class DisposableList extends List {
    private var _reservedDataProvider:IListCollection;
    private var _hScroll:Number;
    private var _vScroll:Number;
    public function DisposableList() {
        super();
        _hScroll = _vScroll = 0;
    }

    override public function set visible(value:Boolean):void {
        super.visible = value;
        if(value && _reservedDataProvider){
            dataProvider = _reservedDataProvider;
            horizontalScrollPosition = _hScroll;
            verticalScrollPosition = _vScroll;
        }else if(!value && dataProvider){
            _vScroll = verticalScrollPosition;
            _hScroll = horizontalScrollPosition;
            _reservedDataProvider = dataProvider;
            dataProvider = null;
        }
    }
}
}
