package com.despark.tuning3d.view.components.core {
import feathers.controls.List;

public class ExtendedList extends List{

    private var _data : Object;
    private var _orientation : String;
    private var _orientationUpdate : Boolean = false;
    private var _activeItemRendererList:Vector.<ListItemRenderer>;

    public function ExtendedList() {
        super();
        _activeItemRendererList = new <ListItemRenderer>[];
    }

    public function get data():Object {
        return _data;
    }

    public function set data(value:Object):void {
        _data = value;
    }

    public function set orientation(value:String):void{
        _orientation = value;
        if(dataProvider){
            dataProvider.updateAll();
        }
    }

    public function get orientation():String {
        return _orientation;
    }

    public function get orientationUpdate():Boolean {
        return _orientationUpdate;
    }

    public function set orientationUpdate(value:Boolean):void {
        _orientationUpdate = value;
    }

    public function orientationUpdateCallback():void {
        for(var i:int = 0; i < _activeItemRendererList.length; i++){
            if(_activeItemRendererList[i] && _activeItemRendererList[i].stage){
                _activeItemRendererList[i].updateOrientationDependantView();
            }
        }
    }

    public function addItemRenderer(item:ListItemRenderer):void {
        if(_activeItemRendererList.indexOf(item) == -1){
            _activeItemRendererList.push(item);
        }
    }

    public function removeItemRenderer(item:ListItemRenderer):void {
        var ind:int = _activeItemRendererList.indexOf(item);
        if(ind != -1){
            _activeItemRendererList.removeAt(ind);
        }
    }
}
}
