package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.core.Tracer;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
	import com.utils.DevHelper;
	import com.utils.FontSelector;
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.core.FeathersControl;
	
	import starling.animation.Transitions;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
	
	public class FramedMenuScreen extends StackedScreen
	{
		public var handleTouchable : Boolean;
		public var menuAlwaysOpen : Boolean;
		
		public var frameImage:Image;
		public var handleBarImage:Image;
		protected var tween : Tween;
		protected var tweening : Boolean;
		protected var menuBackground:Image;
		protected var arrowImage : Quad;
		protected var handleTitleLabel : MultilingualLabel;
		
		private var startY : int;
		private var startHeight : int;
		private var beganOutside : Boolean;
		private var touchBegan : Boolean;
		private var handleHitArea : Rectangle;
		private var touchPoint : Point;
		private var _handleTitle : String;
		protected var menuVisible : Boolean = false;
		private var touchMoved : Boolean;
		
		protected var handleOpenBarImage:Image;
		
		public var locked : Boolean = false;
		
		protected var showOpenHandleFlag:Boolean=false;
		
		public function FramedMenuScreen(name : String)
		{
			super(name);
			handleHitArea = new Rectangle();
			touchPoint = new Point();
			handleTouchable = true;
			showOpenHandleFlag=false;
		}
		
		public function onUpdateMenu() : void
		{
			layoutMenuViews();
			//moveObjectTo(((frameImage.width - handleBarImage.width) / 2),handleBarImage);
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			addEventListener(TouchEvent.TOUCH, touchHandler);
			
			var scale:Number=assetManager.scaleFactor/2;
			
			var texture:Texture = Texture.fromColor(100,100, 0xff0000);
			
			frameImage = new Image( texture );
			addChild( frameImage );
			
			
			var p1:Number=20;
			var p2:Number=21;
			if(assetManager.getTexture("a_close_menu")==handleTexture || assetManager.getTexture("a_open_menu")==handleTexture){
				p1=p1/scale;
				p2=p2/scale;
			}
			
			if(handleTexture){
				
				//var handleS3Textures : Scale3Textures = new Scale3Textures(handleTexture, p1, p2, Scale3Textures.DIRECTION_HORIZONTAL);
				handleBarImage = new Image( handleTexture );
				
				handleBarImage.scale9Grid = new Rectangle(p1,0,p2,handleTexture.frameHeight);
				handleBarImage.visible = false;
				addChild( handleBarImage );
			}
			
			if(handleBarImage){
				if(assetManager.getTexture("a_close_menu")==handleTexture || assetManager.getTexture("a_open_menu")==handleTexture){
					
					handleBarImage.width=72;
					handleBarImage.height=13;
				}else{
					
					
					handleBarImage.width = handleWidth;
					
				}
			}
			
			texture = assetManager.getTexture("a_open_menu");
			
			//var handleOpenS3Textures : Scale3Textures = new Scale3Textures(assetManager.getTexture("a_open_menu"), 20/scale, 21/scale, Scale3Textures.DIRECTION_HORIZONTAL);
			handleOpenBarImage = new Image( texture );
			
			handleOpenBarImage.scale9Grid = new Rectangle( 20/scale, 0, 21/scale, texture.frameHeight);
			addChild( handleOpenBarImage );
			handleOpenBarImage.width = handleWidth;
			handleOpenBarImage.visible=true;
			
			handleOpenBarImage.width=72;
			handleOpenBarImage.height=13;
			
			
//			if(Device.isIphoneX()){
//				handleOpenBarImage.height = 30;
//			}
			
			try{

				menuBackground = new Image( menuBackgroundTexture );
				menuBackground.height=50;

				addChild( menuBackground );
			}catch(e:Error){
				
				Tracer.print("error:" +  e.message, e.getStackTrace());
			} // comment by maxb
			
			handleTitleLabel = new MultilingualLabel();
			handleTitleLabel.height = 13;
			handleTitleLabel.textFormat = new TextFormat(FontSelector.getFont(), 7, 0x6A7275);
			handleTitleLabel.textFormat.align = TextFormatAlign.CENTER;
			addChild(handleTitleLabel);
			
			arrowImage = new Image(assetManager.getTexture("brandsMenuArrow"));
			arrowImage.pivotX = arrowImage.width / 2;
			arrowImage.visible = false;
			addChild(arrowImage);
		}
		
		override public function dispose():void{
			removeEventListener(TouchEvent.TOUCH, touchHandler);
			
			super.dispose();
		}
		
		public function set handleTitle(value : String) : void
		{
			_handleTitle = value;
			invalidate(FeathersControl.INVALIDATION_FLAG_DATA);
		}
		
		public function get handleTitle() : String
		{
			return _handleTitle;
		}
		
		protected function get handleTexture() : Texture
		{
			return null;
		}
		
		protected function get handleWidth() : int
		{
			return handleTexture.width;
		}
		
		protected function get menuBackgroundTexture() : Texture
		{
			return null;
		}
		
		protected function get menuHeight() : int
		{
			return 0;
		}
		
		protected var _wantedWidth : Number = 0;
		protected override function draw() : void
		{
			var sizeInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);
			
			if(sizeInvalid)
			{
				
				frameImage.width = _wantedWidth>0 ? _wantedWidth : actualWidth;
				frameImage.height = actualHeight;
				
				_newFrameImageHeight= frameImage.height;
				
				if(menuBackground) menuBackground.width = actualWidth+1;
			}
			
			
			if(isInvalid("layout_menu_views")){
				
				layoutMenuViews();
			}
			
			var dataInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_DATA);
			
			if(dataInvalid)
			{
				handleTitleLabel.text = handleTitle;
			}
		}
		
		public function moveObjectTo(delta:Number,target:*) : void
		{
			var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
			tween.moveTo(delta,0);
			tween.onComplete = completeMove;
			Starling.juggler.add(tween);
		}
		
		private function completeMove():void
		{
		}
		
		public var deltaIsUsed  : Boolean = false;
		protected function layoutMenuViews() : void
		{
			frameImage.height = _newFrameImageHeight;
			
			if(handleBarImage){
				handleBarImage.y = frameImage.height - handleBarImage.height;
				handleBarImage.x = int((frameImage.width - handleBarImage.width) / 2) ;
			}
			
//			if(Device.isIphoneX()){
//				handleOpenBarImage.height = 30;
//			}
			
			handleOpenBarImage.y = frameImage.height - handleOpenBarImage.height;
			handleOpenBarImage.x = int((frameImage.width - handleOpenBarImage.width) / 2);
			
			if(handleBarImage){
				handleTitleLabel.width = handleBarImage.width;
				handleTitleLabel.x = handleBarImage.x;
				handleTitleLabel.y = handleBarImage.y + 2;
			}
			
			if(menuBackground){
				menuBackground.width = actualWidth+1;
				menuBackground.y = Math.round(frameImage.height);
				menuBackground.height = menuHeight;
			}
			
			checkAndInformForMenuStatus();
		}
		
		private var originalFrameImageHeight : int;
		
		protected var _newFrameImageHeight:Number=0;
		
		public var hitAreaDX   : Number = 0;
		public var windowIsOpened : Boolean = false;
		
		private var extendXarea : Number = 30;
		private var extendYarea : Number = 15;
		protected function touchHandler(event : TouchEvent) : void
		{
			const touch : Touch = event.getTouch(this);
			
			if (menuAlwaysOpen){
				return;
			}
			
			if (!touch){
				return;
			}
			
			if(touch.phase == TouchPhase.BEGAN) {
				touchBegan = true;
				originalFrameImageHeight = _newFrameImageHeight;//frameImage.height;
				touchMoved = false;
				
				if(handleBarImage){
					handleHitArea.setTo(handleBarImage.x - extendXarea, handleBarImage.y - extendYarea, handleBarImage.width + 2 * extendXarea, handleBarImage.height + extendYarea);
				}
				
				touchPoint.setTo(touch.globalX -this.x, touch.globalY);

				if (!handleTouchable || !handleHitArea.containsPoint(touchPoint)){
					beganOutside = true;
					return;
				}
				if(menuVisible){
					SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
				}else{
					SoundManager.playSound(SoundManager.PART_MENU);
				}
				startY = touch.globalY;
				startHeight = _newFrameImageHeight;//frameImage.height;
			}else if(touch.phase == TouchPhase.MOVED) {
				if(beganOutside)
				{
					return;
				}
				
				_newFrameImageHeight=int(Math.min(actualHeight, Math.max(actualHeight - menuHeight, startHeight + touch.globalY - startY)));
				
				
				checkAndInformForMenuStatus();
				
				this.invalidate("layout_menu_views");
				//layoutMenuViews()
			}else if(touch.phase == TouchPhase.ENDED) {
				if(beganOutside) {
					beganOutside = false;
					touchBegan = false;
					return;
				}
				
				if(!tweening && touchBegan) {
					var dY : int = touch.globalY - (actualHeight - menuHeight / 2);
					
					touchMoved = originalFrameImageHeight - frameImage.height != 0;
					
					if(!touchMoved && frameImage.height == actualHeight) {
						dY = -1;
					}else if(!touchMoved && frameImage.height == actualHeight - menuHeight) {
						dY = 1;
					}
					animate(dY);
				}
				touchBegan = false;
			}
		}
		
		protected function completeAnimation():void{
			
			if(_dY < 0){
				
				
				_targetObject.height= actualHeight - menuHeight;
				//tween.animate("height", actualHeight - menuHeight);
				
			}else{
				_targetObject.height= actualHeight;
			}
		}
		
		private var _targetObject:Object={height:0};
		private var _dY:Number;
		
		private function animate(dY : int, resultHandler : Function = null, animated:Boolean=true) : void
		{		
			if(tweening){			
				return;
			}
			
			tweening = true;
			//_animationStart = true;
			
			_dY = dY;
			if(dY < 0)
			{
				var time:Number=0.3;
				
				if(!animated)  time=0.01;
				tween = new Tween(_targetObject, time, Transitions.LINEAR);
			}else{
				tween = new Tween(_targetObject, 0.3, Transitions.LINEAR);
			}
			
			
			tween.onComplete = function() : void
			{           
				checkAndInformForMenuStatus();
				
				if (resultHandler) {
					resultHandler();
					completeAnimation();
				}
				
				tweening = false;
				menuShownComplete();
			}
			
			tween.onUpdate = function() : void
			{
				//checkAndInformForMenuStatus();
				_newFrameImageHeight=_targetObject.height;//(actualHeight - menuHeight)*tween.progress;
				invalidate("layout_menu_views");
				//layoutMenuViews();
			}
			
			if (dY < 0) {
				_targetObject.height=_newFrameImageHeight;
				tween.animate("height", actualHeight - menuHeight);
			}
			else
			{
				_targetObject.height=_newFrameImageHeight;
				tween.animate("height", actualHeight);
			}
			
			Starling.juggler.add(tween);
		}
		
		public function checkAndInformForMenuStatus() : void
		{
			if(frameImage.height == actualHeight)
			{
				if (menuVisible) {
					menuVisible = false;
					menuHidden();
				}
				
				if(this.showOpenHandleFlag){
					if(handleBarImage){
						this.handleBarImage.visible=false;
					}
					this.handleOpenBarImage.visible=true;
				}
			}
			else
			{
				if (!menuVisible) {
					menuVisible = true;
					menuShown();
				}
				
				if(this.showOpenHandleFlag){
					if(handleBarImage){
						this.handleBarImage.visible=true;
					}
					this.handleOpenBarImage.visible=false;
				}
			}
			
			
			if (this as TuningScreen)
			{
				var tuningScreen:TuningScreen = this as TuningScreen;
				if(tuningScreen.carView && !tuningScreen.carView.visible)
				{
					if(handleBarImage){				
						handleBarImage.visible=false;
					}
					
					if(handleOpenBarImage){					
						handleOpenBarImage.visible=false;
					}				
				}			
			}		
		}

		public function checkMenuStatus() : void {
			if(frameImage.height == actualHeight) {
				if (menuVisible) {
					menuVisible = false;
				}
			} else {
				if (!menuVisible) {
					menuVisible = true;
				}
			}
		}
		
		protected function menuHidden() : void {
			if (menuBackground) menuBackground.visible = false;
		}
		
		protected function menuShown() : void {
			if (menuBackground) menuBackground.visible = true;
		}

		protected function menuShownComplete() : void {

		}
		
		public function closeMenu(animated : Boolean = false, resultHandler : Function = null) : void {
			if(animated) {
				animate(1, resultHandler);
			} else {
				_newFrameImageHeight = actualHeight;
				invalidate("layout_menu_views");
			}
		}
		
		public function openMenu(animated : Boolean = true) : void
		{
			
			animate(-1, null, animated);
			
		}
	}
}