package com.despark.tuning3d.view.components.core {
    import feathers.controls.Label;
    import feathers.controls.text.TextFieldTextRenderer;

    import flash.geom.Rectangle;
    import flash.text.TextLineMetrics;

    public class LabelTextFieldTextRenderer extends TextFieldTextRenderer {
        private var _autoTruncate:Boolean = false;
        public function LabelTextFieldTextRenderer() {
            super();
        }

        public function getCharBoundaries(charIndex:int):Rectangle{
            if(textField){
                return textField.getCharBoundaries(charIndex);
            }
            return null;
        }

        public function getCharIndexAtPoint(x:Number, y:Number):int{
            if(textField){
                return textField.getCharIndexAtPoint(x, y);
            }
            return -1;
        }

        override protected function commit():void{
            super.commit();
            if(!wordWrap && _autoTruncate && !isHTML){
                var shortenedText:String = "";
                var parentLabel:Label = parent as Label;
                if(parentLabel){
                    for(var i:int = 0; i < textField.numLines; i++){
                        var metrics:TextLineMetrics = textField.getLineMetrics(i);
                        var acWidth:Number = actualWidth - (parentLabel.paddingLeft + parentLabel.paddingRight);
                        if(actualWidth && metrics.width > acWidth){
                            var charIndex:int = textField.getCharIndexAtPoint(acWidth, metrics.height);
                            if(charIndex > 3){
                                shortenedText += textField.getLineText(i).substr(0, charIndex - 3) + "..." + (textField.numLines - 1>i?'\n':'');
                            }
                        }else{
                            shortenedText += textField.getLineText(i) + (textField.numLines - 1>i?'\n':'');
                        }
                    }
                    if(shortenedText.length){
                        text = shortenedText;
                    }
                }

            }
        }

        public function set autoTruncate(value:Boolean):void {
            _autoTruncate = value;
        }
    }
}
