package com.despark.tuning3d.view.components.core
{


	import com.utils.FontSelector;

	import feathers.controls.Button;
	import feathers.core.FeathersControl;

	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import starling.display.Quad;
	import starling.events.Event;

	public class NotificationView extends FeathersControl
	{
		
		
		
		private var quad:Quad;
		
		private var blueQuad:Quad;
		
		
		private var closeButton:Button;
		
		private var titleLabel:MultilingualLabel;
		
		private var textLabel:MultilingualLabel;
		
		private var _title:String="";
		private var _text:String="";
		
	
		
		public function NotificationView()
		{
			super();
		}
		
		override protected function initialize():void{
			
			super.initialize();
			
			quad=new Quad(1,1,0x000000);
			
			quad.alpha=0.75;
			addChild(quad);
			
			blueQuad=new Quad(1,1,0x0f86ff);
			addChild(blueQuad);
			
			
			
		
			closeButton=ButtonFactory.circleButton("a_close_effect_menu");
			closeButton.width=19/2;
			closeButton.height=20/2;
			closeButton.addEventListener(Event.TRIGGERED, onCloseHandler);
			addChild(closeButton);
			
			
			
			titleLabel = new MultilingualLabel();
			titleLabel.textFormat = new TextFormat(FontSelector.getFont(true), 10, 0xffffff);
			titleLabel.textFormat.align = TextFormatAlign.LEFT;
			titleLabel.textFormat.bold=true;   
			titleLabel.text=_title;
			titleLabel.updateWithLanguage(AlertView.language);
			addChild(titleLabel);
			
			
			textLabel = new MultilingualLabel();
			textLabel.textFormat = new TextFormat(FontSelector.getFont(false), 10, 0xffffff);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			textLabel.textFormat.bold=false;   
			textLabel.text=_text;
			textLabel.updateWithLanguage(AlertView.language);
			addChild(textLabel);
			
		
			
			
		}
		
	
	
		public function set title(value:String):void{
			
			_title=value;
			
			if(titleLabel){
				
				invalidate("title");
			}
		}
		
		
		public function set text(value:String):void{
			
			_text=value;
			
			if(textLabel){
				
				invalidate("text");
			}
		}
		
		
	
		
		protected function onCloseHandler(event:Event):void{
			
			this.visible=false;
		}
		
		override protected function draw():void{
			
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE)){
				
				
				quad.width=actualWidth;
				quad.height=actualHeight;
				
				
				blueQuad.x=0;
				blueQuad.y=0;
				
				blueQuad.width=10;
				blueQuad.height=actualHeight;
				
				
				closeButton.x=actualWidth-closeButton.width-7;
				closeButton.y=(actualHeight-closeButton.height)/2;
				
			
				titleLabel.x=(36/2);
				titleLabel.y=7.5;
				
				titleLabel.text=_title;
				titleLabel.updateWithLanguage(AlertView.language);
				
				textLabel.x=(36/2);
				textLabel.y=22;
				
				textLabel.text=_text;
				textLabel.updateWithLanguage(AlertView.language);
				
				
			}
			
			
			if(isInvalid("title")){
				titleLabel.text=_title;
				titleLabel.updateWithLanguage(AlertView.language);
				
			}
			
			if(isInvalid("text")){
				textLabel.text=_text;
				textLabel.updateWithLanguage(AlertView.language);
				
			}
			
		}
	}
}