package com.despark.tuning3d.view.components.core {
import feathers.controls.Button;

import flash.geom.Point;
import flash.geom.Rectangle;

import starling.display.DisplayObject;

public class SimpleExtendedButton extends Button{
    private var _hitAreaPadding:Number;

    public function SimpleExtendedButton(hitAreaPadding : int = 0) {
        this.hitAreaPadding = hitAreaPadding
    }

    public override function hitTest(localPoint : Point) : DisplayObject
    {
        if (!visible || !touchable)
        {
            return null;
        }

        var theBounds : Rectangle = getBounds(this);
        theBounds.inflate(_hitAreaPadding, _hitAreaPadding);

        if (theBounds.containsPoint(localPoint))
        {
            return this;
        }

        return null;
    }

    public function get hitAreaPadding():int {
        return _hitAreaPadding;
    }

    public function set hitAreaPadding(value : int):void {
        if(value > 0) _hitAreaPadding = value;
    }
}
}
