package com.despark.tuning3d.view.components.core
{
    import starling.display.Image;
    import starling.display.Sprite;
    import starling.events.EnterFrameEvent;
    import starling.textures.Texture;

    public class SpinnerView extends Sprite {
    private var spinnerImage:Image;
    public function SpinnerView() {
        super();
        //
        var size:Number = 35;
        var spinnerTexture:Texture = ButtonFactory.assetManager.getTexture("spinner");
        spinnerImage = new Image(spinnerTexture);
        spinnerImage.width = size;
        spinnerImage.height = size;
        var div:Number = 2 * spinnerImage.scaleX;
        spinnerImage.pivotX =  size / div;
        spinnerImage.pivotY = size / div;
        spinnerImage.x = size / 2;
        spinnerImage.y = size / 2;
        addChild(spinnerImage);
        addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
    }

    public function hide():void {
        removeFromParent(true);
    }

    override public function dispose():void{
        super .dispose();
        removeEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
        if(spinnerImage){
            spinnerImage.removeFromParent(true);
            spinnerImage = null;
        }
    }

	private function enterFrameHandler(event : EnterFrameEvent) : void {
        if (spinnerImage && spinnerImage.visible) {
            spinnerImage.rotation += Math.PI / 18;
        }
    }
}
}