package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.utils.FontSelector;

import feathers.controls.Button;
import feathers.controls.TextInput;
import feathers.controls.text.StageTextTextEditor;
import feathers.core.FeathersControl;
import feathers.core.ITextEditor;
import feathers.events.FeathersEventType;

import flash.geom.Rectangle;
import flash.text.TextFormat;

import starling.display.Image;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class TextInputNewView extends FeathersControl implements Multilingual
	{
		public static var assetManager : AssetManager;
		
		private var titleLabel : MultilingualLabel;
		public var textInput : TextInput;
		private var _title : String;
		private var _password : Boolean;
		private var _text : String;
		
		public var fun_enterPress: Function;  
		
		private var _multiline:Boolean=false;
		
		private var _search:Boolean=false;
		
		private var clearButton:Button;
		
		//private var isIOS:Boolean=true;
		
		public function TextInputNewView(multiline:Boolean=false, search:Boolean=false)
		{
			
			_multiline=multiline;
			_search=search;
			super();
			if(_multiline){
				setSizeInternal(26, 80, false);
			}else{
				
				setSizeInternal(26, 40, false);
			}
			
			if(_search && !_multiline){
				setSizeInternal(22, 22, false);
			}
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		protected function onEnterFrame(event:Event):void{
			//var t:Constants
			if(!Constants.isIOS){


                // TODO VARDAN COMMENT
//				MeasureKeyboard.getInstance().setKeyboardAdjustDefault();
				
				
				
			}
		}
		
		override public function set width(value:Number):void{  
			
			if(_search){
				//setSizeInternal(22, value, true);
				if(value<22){
					if(textInput)
						textInput.width=22;
					else
						super.width=value;
				}else{
					
					if(textInput)
						textInput.width=value;
					else
						super.width=value;
				}
			}else{
				super.width=value;
			}
		}
		
		public function get password():Boolean
		{
			return _password;
		}
		
		public function set password(value : Boolean) : void
		{
			_password = value;
			invalidate("password");
		}
		
		public function get title() : String
		{
			return _title;
		}
		
		public function set title(value : String) : void
		{
			_title = value;
			invalidate("title");
		}
		
		public function get text() : String
		{
			return textInput.text;
		}
		
		public function set text(value : String) : void
		{
			_text = value;
			invalidate("text");
		}
		
		protected override function initialize() : void
		{
			super.initialize();
			
			
			textInput = new TextInput();
			textInput.padding = 3;//удалил!!! но не заенил
			if(!Device.isIos()){
				//textInput.focusPadding=3;
				//textInput.promptProperties.fontSize=15;
				//textInput.promptProperties.color=0xFFFFFF;
				//textInput.prompt="";
				
				
			}
			//textInput.fo
			
			var scale:Number=assetManager.scaleFactor/2;
			
			var rect:Rectangle=new Rectangle(13/scale,13/scale,13/scale,13/scale);
			
			var texName:String="a_text_input_bg";
			
			if(_multiline){
				texName="a_text_input_bg";
				
				
			}else if(_search){
				
				texName="textFieldWhite";
				rect=new Rectangle(13,13,13,13);
			}
				
			if(!_search){
			
				var texture : Texture = assetManager.getTexture(texName);
				//var textures : Scale9Textures = new Scale9Textures(texture, rect);
				
				
				
				textInput.backgroundSkin = new Image(texture);//удалил!!! но не заенил
				
				(textInput.backgroundSkin as Image).scale9Grid = rect;
				
				if(_multiline){
					textInput.backgroundSkin.alpha=0.8;
				}
			}
			textInput.addEventListener(Event.CHANGE, textInputChangeHandler);
			
			//textInput.addEventListener(Event.
			
			
			textInput.addEventListener(FeathersEventType.ENTER,enterPress);
			if(!Device.isIos()){
				
				/*textInput.textEditorFactory = function() : ITextEditor//удалил!!! но не заенил
				{
					var editor :TextFieldTextEditor = new TextFieldTextEditor();
					
					editor.textFormat=new TextFormat(FontSelector.getFont(), 14, 0xFFFFFF);
					
					
					editor.embedFonts=FontSelector.embedFonts();    
					
					
					return editor;
				}*/
				
				textInput.textEditorFactory = function() : ITextEditor//удалил!!! но не заенил
				{
					var editor:StageTextTextEditor = new StageTextTextEditor();
					
					//editor.fontFamily=FontSelector.getFont();
				//	editor.focusPaddingTop=2;
					//58595b
					
					if(_multiline || _search){
						editor.fontSize=13;
						editor.color=0xFFFFFF;
						if(_multiline) 	editor.color=0x58595b;
						
					}else{
						
						editor.fontSize=15;
						editor.color=0x58595b;
					}
				
					if(_multiline)
						editor.multiline=true;
					
					return editor;
				}
					
					
			
				
			}else{
				
				textInput.textEditorFactory = function() : ITextEditor//удалил!!! но не заенил
				{
					var editor:StageTextTextEditor = new StageTextTextEditor();
					
					
					if(_multiline || _search){
						editor.fontFamily=FontSelector.getFont();
						editor.fontSize=13;
						editor.color=0xFFFFFF;
						
						if(_multiline) 	editor.color=0x58595b;
					}else{
						editor.fontFamily=FontSelector.getFont();
						editor.fontSize=15;
						editor.color=0x58595b;
					}
					
					if(_multiline)
					editor.multiline=true;
					
					
					return editor;
				}
			}
			
			addChild(textInput);      
			
			
			if(!_search){
				var labelColor:uint=0x58595b;
				
				if(_multiline) 	labelColor=0x58595b;
				titleLabel = new MultilingualLabel();
				titleLabel.touchable = false;
				titleLabel.height = 10;
				titleLabel.textFormat = new TextFormat(FontSelector.getFont(true), 8, labelColor);
				titleLabel.textFormat.bold=true;
				titleLabel.isHTML=true;
				addChild(titleLabel);
			}else{
				
				
				if(!Device.isIos()){
					
					clearButton=ButtonFactory.circleButton("clearInput");
					
					clearButton.addEventListener(Event.TRIGGERED, clearTextTriggeredHandler);
					clearButton.width=14;
					clearButton.height=14;
					clearButton.visible=false;
					addChild(clearButton);
				}
				
			}
			
			
		}
		
		protected function clearTextTriggeredHandler(event:Event):void{
			
			_text="";
			textInput.text="";
			
			dispatchEventWith(Event.CHANGE);
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			if(titleLabel)
			titleLabel.updateWithLanguage(language);
		}
		
		protected override function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				if(!_search){
					if(_multiline){
						titleLabel.width = actualWidth;
						titleLabel.x = -1;
					}else{
						titleLabel.width = actualWidth;
						titleLabel.x = -3;
					}
					
					textInput.y = titleLabel.y + titleLabel.height + 5;
					textInput.height = 26;			
					textInput.width = actualWidth;
				}else{
					
					textInput.y =0;
					textInput.height = 22;			
					textInput.width = actualWidth;
					
				}
				
			
				
				if(_multiline){
					
					textInput.height=this.actualHeight;
				}
				
				if(!Device.isIos()){
					//textInput.focusPadding=3;
					
				//	textInput.pivotX=textInput.width/2;
				//	textInput.pivotY=textInput.height/2;
				}
				
				if(clearButton){
					
					clearButton.y=(actualHeight-clearButton.height)/2;
					
					clearButton.x=actualWidth-(clearButton.width+10);
					
					textInput.width = actualWidth-(clearButton.width+10);
				}
			}
			
			if(isInvalid("title") && titleLabel)
			{
				titleLabel.text = title;
			}
			
			if(isInvalid("password"))
			{
				textInput.displayAsPassword = password;
			}
			
			if(isInvalid("text"))
			{
				textInput.text = _text;
			}
			
			
		}
		
		private function textInputChangeHandler(event : Event) : void
		{	
			//_text=textInput.text;
			
			if(clearButton){
				if(text.length>0){
					clearButton.visible=true;
				}else{
					clearButton.visible=false;
				}
			}
			dispatchEventWith(Event.CHANGE);
		}
		
		//
		
		
		private function enterPress(event : Object) : void
		{
			if(fun_enterPress){
				fun_enterPress();
			}
			//trace("waw!!!!!!!!!!");
		}
		
		
	}
}


