package com.despark.tuning3d.view.components.gallery
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.users.User;
	import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
	import com.utils.DisplayObjectUtil;

	import feathers.layout.HorizontalAlign;
	import feathers.layout.VerticalAlign;

	import starling.events.TouchEvent;

	public class GalleryTuningFHDItem extends GalleryTuningItem {
		public function GalleryTuningFHDItem(){

		}

        override public function dispose():void {
            DisplayObjectUtil.disposeMesh(clipRectQuad);
			clipRectQuad = null;

			if(userAvatar){
                userAvatar.removeFromParent(true);
                userAvatar = null;
			}
			super.dispose();
        }

        protected override function draw() : void {
			super.draw();
			if(!imageLoader.mask){
				if(count == 1){
                    clipRectQuad.width = actualWidth;
                    clipRectQuad.height = actualHeight;
                    clipRectQuad.x = 0;
                    clipRectQuad.y = 0;
				}else{
                    if(horizontalAlign == HorizontalAlign.CENTER){
                        clipRectQuad.width = actualWidth - 2;
                        clipRectQuad.x = 1;
                    }else{
                        clipRectQuad.width = actualWidth - 1;
                        if(horizontalAlign == HorizontalAlign.RIGHT){
                            clipRectQuad.x = 1;
                        }
                    }

                    if(verticalAlign == VerticalAlign.MIDDLE){
                        clipRectQuad.height = actualHeight - 2;
                        clipRectQuad.y = 1;
                    }else{
                        clipRectQuad.height = actualHeight - 1;
                        if(verticalAlign == VerticalAlign.BOTTOM){
                            clipRectQuad.y = 1;
                        }
                    }
				}
                imageLoader.mask = clipRectQuad;
			}

			if(imageLoader){
				imageLoader.overrideDispose = true;
			}

			if(imageLoader.image){
                imgX = imageLoader.image.x;
                imgY = imageLoader.image.y;
                imgW = imageLoader.image.width;
                imgH = imageLoader.image.height;
			}
		}

		override protected function layout():void{
			if(!imageLoader){
				return;
			}
			super .layout();

			var imgWidth:Number = _imageWidth * actualScale * 0.45;
			var imgHeight:Number = _imageHeight * actualScale * 0.45;

			imageLoader.visible = true;
			if(imgWidth < actualWidth){
				imgHeight = actualWidth * imgHeight / imgWidth;
				imgWidth = actualWidth;
			}else if(imgHeight < actualHeight){
				imgWidth = actualHeight * imgWidth / imgHeight;
				imgHeight = actualHeight;
			}
			imageLoader.width = imgWidth;
			imageLoader.height = imgHeight;
			imageLoader.x = (actualWidth - imageLoader.width)/2;
			imageLoader.y = (actualHeight - imageLoader.height)/2;
		}
		
		protected override function commitData() : void{
			super.commitData();
			if(tuning){
				var car:Car = new Car();
				if(tuning.fullHdSnapshots && tuning.fullHdSnapshots[0]){
					car.imageURL = tuning.fullHdSnapshots[0];
					car.imageURL = car.imageURL.replace(/^\/\//gmi, "http://");
				}
				imageLoader.recieveImageSize = completeLoadImage;
				if(tuning.userObj){
					_user = new User(tuning.userObj);
					if(count == 1){
                        userAvatar = new UserCircularAvatar(_user, 30, true, 1.5);
						imageLoader.bitmapScale = 1;
					}else if(count == 4){
                        userAvatar = new UserCircularAvatar(_user, 30, true, 1.5);
                        imageLoader.bitmapScale = 0.5;
					}else if(count == 9){
                        userAvatar = new UserCircularAvatar(_user, 25, true, 1.5);
                        imageLoader.bitmapScale = 0.3;
					}
					if(userAvatar){
						userAvatar.addEventListener(TouchEvent.TOUCH, avatarTouchHandler);
						addChild(userAvatar);
						userAvatar.x = actualWidth - userAvatar.width - 7;
                        if(count == 4 && verticalAlign == VerticalAlign.BOTTOM){
                            userAvatar.y = actualHeight - (userAvatar.height + 7);
                        }else{
                            userAvatar.y = 7;
                        }
					}
				}
                imageLoader.persistentImageProvider = car;
			}
		}

	private function get actualScale():Number{
		if(stage){
			if(actualWidth/actualHeight < stage.stageWidth / stage.stageHeight){
				return actualWidth / stage.stageWidth;
			}
			return actualHeight / stage.stageHeight;
		}
		return 0.3;
	}
}
}
