package com.despark.tuning3d.view.components.gallery
{
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.tunings.Tuning;
	import com.despark.tuning3d.model.users.User;
	import com.despark.tuning3d.model.users.UsersProxy;
	import com.despark.tuning3d.view.components.core.ListItemRenderer;
	import com.despark.tuning3d.view.components.core.StackedScreen;
	import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
	import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
	import com.utils.DisplayObjectUtil;

	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.events.EventDispatcher;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;

	public class GalleryTuningItem extends ListItemRenderer {
		protected var clipRectQuad:Quad;
		protected var userAvatar:UserCircularAvatar;
		public var count:int = 0;
		public var horizontalAlign:String;
		public var verticalAlign:String;
    	protected var _eventDispatcher:EventDispatcher;
		protected var _user:User;
		protected var imgX:Number;
		protected var imgY:Number;
		protected var imgW:Number;
		protected var imgH:Number;

		public var row:int;
		public var cell:int;
	
		//
		protected var _imageWidth:Number = 0;
		protected var _imageHeight:Number = 0;
		public function GalleryTuningItem(){

		}

		public function get tuning() : Tuning {
			return data as Tuning;
		}
		
		protected override function initialize() : void {
			autoResize = false;
			clipRectQuad = new Quad(1,1, 0xFFFFFF);
			addChild(clipRectQuad);

			super.initialize();
			this.label.visible=false;
            addEventListener(TouchEvent.TOUCH, triggeredHandler);
			imageLoader.visible = false;
		}

        override public function dispose():void {
            DisplayObjectUtil.disposeMesh(clipRectQuad);
			clipRectQuad = null;

			if(userAvatar){
                userAvatar.removeFromParent(true);
                userAvatar = null;
			}

            removeEventListener(TouchEvent.TOUCH, triggeredHandler);
            super.dispose();
        }

        protected override function draw() : void {
			super.draw();
			if(imageLoader){
				imageLoader.overrideDispose = true;
			}

			if(imageLoader.image){
                imgX = imageLoader.image.x;
                imgY = imageLoader.image.y;
                imgW = imageLoader.image.width;
                imgH = imageLoader.image.height;
			}
		}
		
		protected function completeLoadImage(imageWidth:Number, imageHeight:Number):void{
			_imageWidth = imageWidth;
			_imageHeight = imageHeight;
			layout();
		}

		protected override function commitData() : void{
			super.commitData();
		}

	protected function avatarTouchHandler(event:TouchEvent):void {
		var touch:Touch = event.getTouch(userAvatar, TouchPhase.ENDED);
		if(touch && (!UsersProxy.loggedInUser() || _user.id != UsersProxy.loggedInUser().id)){
			_eventDispatcher.dispatchEventWith(StackedScreen.USER_DETAILS_SELECTED, false, {user:_user});
			event.stopImmediatePropagation();
		}
	}

		public function set eventDispatcher(eventDispatcher:EventDispatcher):void {
			_eventDispatcher = eventDispatcher;
		}

    protected function triggeredHandler(event:TouchEvent):void {
		var touch:Touch = event.getTouch(this, TouchPhase.ENDED);
		if(_eventDispatcher && touch && !owner.isScrolling){
			SoundManager.playSound(SoundManager.PART_MENU);
			_eventDispatcher.dispatchEvent(new Event(TuningsListScreen.TUNING_SELECTED, false, {user:_user, tuning:tuning}));
            Starling.juggler.delayCall(function():void{
				if(imageLoader.image && imgW && imgH) {
                    imageLoader.image.width = imgW;
                    imageLoader.image.height = imgH;
                    imageLoader.image.x = imgX;
                    imageLoader.image.y = imgY;
                }
            }, .01);
		}
    }

}
}
