package com.despark.tuning3d.view.components.garage {
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.view.components.core.ButtonFactory;

    import feathers.controls.ToggleButton;

    import starling.display.Image;

    public class DropToggleDownButton extends ToggleButton {
        private var dropDownSign:Image;
        private var colorizeSelection:Boolean;
        public function DropToggleDownButton(colorizeSelection:Boolean = true) {
            super();
            this.colorizeSelection = colorizeSelection;
        }

        override protected function initialize():void{
            super .initialize();
            dropDownSign = new Image(ButtonFactory.assetManager.getTexture("drop_down_arrow"));
            dropDownSign.scale = 0.75 * ButtonFactory.assetManager.scaleFactor / 2;
            addChild(dropDownSign);
            dropDownSign.color = UIColors.UI_COMPONENT_GRAY;
        }

        override protected function draw():void{
            super .draw();
            //
            if((isSelected && dropDownSign.scaleY > 0) || (!isSelected && dropDownSign.scaleY < 0)){
                dropDownSign.scaleY *= -1;
            }
            dropDownSign.color = (isSelected && colorizeSelection)? UIColors.WHITE: UIColors.UI_COMPONENT_GRAY;
            //
            dropDownSign.x = actualWidth - (dropDownSign.width + 1.5 * gap);
            dropDownSign.y = (actualHeight - dropDownSign.height * (isSelected? -1: 1)) / 2;
        }
    }
}
