package com.despark.tuning3d.view.components.mailbox {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.mails.MailsProxy;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.timeline.FeedData;
    import com.despark.tuning3d.view.components.timeline.FeedData;
    import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentInput;

    import starling.events.Event;

    public class InstantMailPopup extends PopUp {
    private var _postMailView:CommentInput;
        private var _user:User;
        private var _mailsProxy:MailsProxy;
    public function InstantMailPopup(data:Object = null) {
        super();
        FeedData.CURRENT_USER = UsersProxy.loggedInUser();
        _user = data.toUser;
    }

    override protected function initialize() : void {
        super.initialize();

        setSizeInternal(this.stage.stageWidth*1, this.stage.stageHeight, false);
        background.color = 0x555555;
        background.alpha = 0.8;
        contentBackgroundImage.visible = false;

        _mailsProxy = ApplicationFacade.getInstance().retrieveProxy(MailsProxy.NAME) as MailsProxy;

        _postMailView = new CommentInput(false, false);
        _postMailView.height = 100;
        _postMailView.addEventListener(FeedData.COMMENT_SEND, sendMessageHandler);
        addChild(_postMailView);
    }

        private function sendMessageHandler(event:Event):void {
            _mailsProxy.sendMessageTo(_user.id, event.data.text);
            close();
        }

    override protected function closeButtonTriggeredHandler(event:Event):void{
        super .closeButtonTriggeredHandler(event);
    }

    public function close() : void{
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }


    override protected function draw() : void {
        super.draw();
        //
        _postMailView.width = actualWidth - 100;
        _postMailView.x = 50;
        _postMailView.y = (actualHeight - _postMailView.height) / 2;
    }

    override public function dispose():void {
        super.dispose();
    }
}
}