package com.despark.tuning3d.view.components.news {
    import com.despark.tuning3d.model.core.AppMode;
    import com.utils.DateParser;
    import com.utils.RegExpUtil;

    public class NewsFeedData{
    public static const TUNING_NEWS:String = "tuning";
    public static const TRUCK_NEWS:String = "pickups";
    public static const MUSCLE_NEWS:String = "american_muscle";
    public var feedType:String;
    public var carId:String;
    public var id:String;
    public var textLine1:String;
    public var textLine2:String;
    public var carFullName:String;
    public var date:String;
    public var updateDate:Number;
    public function NewsFeedData(data:Object, feedType:String) {
        this.feedType = feedType;
        carId = data.carId;
        id = data._id;
        date = RegExpUtil.removeHtmlTags(data.date);
        var dateVal:Date = data.updateDate?DateParser.parseDate(data.updateDate):new Date();
        updateDate = dateVal.time;


        if(data.hasOwnProperty('text')){
            var str:String = data.text;
            var carNamePattern:RegExp = /(<strong>(?P<content>.*)<\/strong>)/gsm;
            var cn:* = carNamePattern.exec(str);
            var carName:String = cn.content;
            carFullName = carName;

            var pattern:RegExp = /((?P<plain1>.*)<br>)?<strong>.*<\/strong>(<br>(?P<plain2>.*))?/gsm;
            var r:* = pattern.exec(str);
            textLine1 = r.plain1?r.plain1:'';
            if(textLine1 == ''){
                textLine1 = r.plain2?r.plain2:'';
            }
            if(textLine1.indexOf("<br>") != -1){
                var txtArr:Array = textLine1.split("<br>");
                textLine1 = txtArr[0];
                textLine2 = txtArr[1];
            }else{
                textLine2 = '';
            }
        }
    }

    public function get uniqueId():String{
        return id + updateDate.toString();
    }

     public function  get iconTextureName() : String {
        var str : String = "news_tuning_icon";
        switch(feedType){
            case TUNING_NEWS:
                str = "news_tuning_icon";
                break;
            case TRUCK_NEWS:
                str = "news_truck_icon";
                break;
            case MUSCLE_NEWS:
                str = "news_muscle_icon";
                break;
        }
        return str;
    }

    public function get projectType() : String {
        var str : String = "news_tuning_icon";
        switch(feedType){
            case TUNING_NEWS:
                str = AppMode.MODE_TUNING;
                break;
            case TRUCK_NEWS:
                str = AppMode.MODE_TRUCK_CONFIGURATOR;
                break;
            case MUSCLE_NEWS:
                str = AppMode.MODE_AMERICAN_MUSCLE;
                break;
        }
        return str;
    }

    public static function isAllowedType(value:String):Boolean{
        switch (value) {
            case TUNING_NEWS:
            case TRUCK_NEWS:
            case MUSCLE_NEWS:
                return true;
            default:
                return false;
        }
    }
}
}
