package com.despark.tuning3d.view.components.partinfo
{
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import feathers.core.FeathersControl;
    import starling.animation.Transitions;
    import starling.animation.Tween;
    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.EnterFrameEvent;
    import starling.textures.Texture;

    public class WebViewLoader extends FeathersControl
    {
        private var quad:Quad=null;
        private var spinner:Sprite=null;
        private var _trasnparentBG : Boolean
        public function WebViewLoader(transparentBg: Boolean = false) {
            this._trasnparentBG = transparentBg;
            super();
        }

        private var _itemWidth  : Number = actualWidth;
        public function set itemWidth(value:Number) : void{
            _itemWidth = value;
        }
        public function get itemWidth() : Number{
            return _itemWidth = actualHeight;
        }

        private var _itemHeight : Number;
        public function set itemHeight(value:Number) : void{
            _itemHeight = value;
        }
        public function get itemHeight() : Number{
            return _itemHeight;
        }

        public function hide():void{
            this.removeFromParent(true);
        }

        public static function show():WebViewLoader
        {
            var blockerView : WebViewLoader = new WebViewLoader();
                blockerView.width  = Starling.current.stage.width;
                blockerView.height = Starling.current.stage.height;
            Starling.current.stage.addChild(blockerView);
            blockerView.alpha = 0;

            var tween : Tween = new Tween(blockerView, 0.35, Transitions.EASE_IN_OUT);
                tween.fadeTo(1.0);
            Starling.juggler.add(tween);

            return blockerView;
        }

        private function enterFrameHandler(event : EnterFrameEvent) : void
        {
            if (spinner && spinner.visible){
                spinner.rotation += Math.PI / 18;
            }
        }

        public function addImage(image:Image) : void{
            addChildAt(image, getChildIndex(quad) + 1);
        }


        protected override function initialize():void
        {

            super.initialize();

            if(!_trasnparentBG)
            {
                quad = new Quad(1,1,0x000000);
                quad.alpha = 0.1;
                addChild(quad);

            }


            spinner = new Sprite();
            var spinnerTexture:Texture = ButtonFactory.assetManager.getTexture("spinner");
            var spinnerImage:Image = new Image(spinnerTexture);
                spinnerImage.width = 40;
                spinnerImage.height = 40;
                spinnerImage.x = -20;
                spinnerImage.y =-20;
            spinner.addChild(spinnerImage);
            addChild(spinner);


            addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);

        }

        protected override function draw():void
        {
            super.draw();

            if(isInvalid(INVALIDATION_FLAG_SIZE))
            {
                if(!(_trasnparentBG))
                {
                    quad.x = 0;
                    quad.y = 0;
                    quad.width  = actualWidth;
                    quad.height = actualHeight;
                }

                spinner.x = actualWidth  / 2;
                spinner.y = actualHeight / 2;
            }
        }

        override public function dispose():void {

            removeEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
            spinner.removeFromParent(true);
            super.dispose();

        }
    }
}