package com.despark.tuning3d.view.components.parts {
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.disks.Disk;
	import com.despark.tuning3d.model.disks.DiskBrand;
	import com.despark.tuning3d.model.parts.PartDisk;
	import com.despark.tuning3d.model.parts.PartSlotDisk;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.ExtentedButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.tunings.colors.TuningDiskSettingsView;
	import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
	import com.distriqt.AdsManager;
	import com.utils.FontSelector;

	import feathers.controls.Button;
	import feathers.controls.List;
	import feathers.controls.PickerList;
	import feathers.controls.ScrollContainer;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.ITextRenderer;
	import feathers.layout.HorizontalAlign;
	import feathers.layout.VerticalLayout;

	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;

	public class PartDiskItemRenderer extends PartItemRenderer {
		
		public static const EVENT_CHANGE_PART_DATA:String="changePartData";
		public static const EVENT_OPEN_DISK_INFO_POP_UP:String="EVENT_OPEN_DISK_INFO_POP_UP";
		
		public static const EVENT_OPEN_DISK_SETTINGS_VIEW:String="EVENT_OPEN_DISK_SETTINGS_VIEW";
		private var BUTTON_SIZE : int = 12;
		
		
		protected var btnContainer : ScrollContainer;
		
		private var btnRadius : Button;
		private var btnRadiusPlus : Button;
		private var btnRadiusMinus : Button;
		
		private var curRadius : int = 15;
		public var isBack : Boolean;
		private var btnSettings:Button;
		private var _partDiskMenu : TuningDiskSettingsView;
		

		private var quad:Quad;
		protected var label2:MultilingualLabel;
		private static const MIN_STATE_COUNT:int = 1;
		public static var camberAllowForCar:Boolean=true;

		public var showBrandName:Boolean = false;

		public function PartDiskItemRenderer() {
			super();
			fontSize=10;
			_bold=true;
		}
		
		
		public function get partDisk() :PartDisk {
			return data as PartDisk;
		}
		
		protected override function initialize():void {
			quad = new Quad(1,1,0xeaeaea);
			quad.alpha = 0;
			addChild(quad);
			
			super.initialize();
			quad_back.visible=false;

			label2 = new MultilingualLabel();
			
			if(!overflowMultiLang){
				label2.textFormat = new TextFormat(FontSelector.getFont(false), fontSize, textColor);
			}else{
				label2.textFormat = new TextFormat("NotoSans", fontSize, textColor);
			}
			label.textFormat.align = TextFormatAlign.LEFT;
			label2.textFormat.align = TextFormatAlign.LEFT;
			label2.textFormat.bold = false;
			addChild(label2);
			if(!overflowMultiLang){
				label.updateWithLanguage(AlertView.language);
			}

			btnSettings  = ButtonFactory.circleButton("a_disk_settings_icon");
			btnSettings.addEventListener(Event.TRIGGERED, btnSettingsHandler);
			btnSettings.width = btnInfo.width;
			btnSettings.height = btnInfo.height;
			
			addChild(btnSettings);	
			
			
			btnContainer = new ScrollContainer();
			var btnGroup :  VerticalLayout = new  VerticalLayout();
			btnGroup.gap = 2;
			btnGroup.horizontalAlign = HorizontalAlign.CENTER;
			btnContainer.layout = btnGroup;	
			addChild(btnContainer);
			
			
			
			
			btnRadiusPlus = ButtonFactory.circleButton("a_plus_icon");

			btnRadiusPlus.width = 12;
			btnRadiusPlus.height = 11.5;


            (btnRadiusPlus as ExtentedButton).hitAreaPadding = 13;
			
			btnRadiusPlus.addEventListener(Event.TRIGGERED, btnRadiusPlusHandler);			
			btnContainer.addChild(btnRadiusPlus);
			
			// Radius
			//btnRadius = ButtonFactory.circleButton("btn_r15");
			btnRadius = ButtonFactory.circleButton("a_disk_radius_icon");
			
			btnRadius.width = 20;
			btnRadius.height = 20;
			btnRadius.touchable=false;
			btnRadius.isEnabled=false;
			btnRadius.labelFactory=function():ITextRenderer{
				var label:TextFieldTextRenderer=new TextFieldTextRenderer();
				label.textFormat=new TextFormat(FontSelector.getFont(true), 8, 0xc0c2c2 );
				label.textFormat.bold=true;
				label.textFormat.align="center";
				label.embedFonts=FontSelector.embedFonts();
				//label.snapToPixels=false; //tt
				label.focusPaddingRight=2;
				label.focusPaddingBottom=1;
					
				
					
					
				
				//label.textFormat
				//label.textFormat.  
				
				return label ;
				
			}
			if(FontSelector.embedFonts()){
				
				btnRadius.labelOffsetX=0.5;
				btnRadius.labelOffsetY=-0.5;       
				
			}else{
				btnRadius.labelOffsetX=-.5;
				btnRadius.labelOffsetY=-0.5;  
			}
			btnContainer.addChild(btnRadius);
			
			
			
			btnRadiusMinus = ButtonFactory.circleButton("a_minus_icon");
			btnRadiusMinus.width = 11.5;
			btnRadiusMinus.height = 11.5;
			
			
			btnRadiusMinus.addEventListener(Event.TRIGGERED, btnRadiusMinusHandler);
			
			(btnRadiusMinus as ExtentedButton).hitAreaPadding=13;
			btnContainer.addChild(btnRadiusMinus);

			label2.paddingLeft=5;
			label2.paddingRight=5;
			
		}
		
		private function btnRadiusMinusHandler():void
		{
			changeRadius(-1);

			if(owner.selectedItem){
				
				var partDisk:PartDisk=(owner.selectedItem as  PartDisk);
				partDisk.selectedDiskSize=curRadius;
				
				var prefix:String=PartSlotDisk.getPrefixDep(partDisk);
				var partDiskObj:Object=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize);
				
				while(!partDiskObj && curRadius>_min_size && curRadius<_max_size){
					
					changeRadius(-1);  
					
					partDisk.selectedDiskSize=curRadius;
					prefix=PartSlotDisk.getPrefixDep(partDisk);
					partDiskObj=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize);  
				}
				
				owner.dispatchEventWith(EVENT_CHANGE_PART_DATA, false, {disk: partDiskObj});

			}
		}
		
		private function btnRadiusPlusHandler():void
		{
			changeRadius(1);

			if(owner.selectedItem){
				
				var partDisk:PartDisk=(owner.selectedItem as  PartDisk);
				partDisk.selectedDiskSize=curRadius;
				
				var prefix:String=PartSlotDisk.getPrefixDep(partDisk);
				var partDiskObj:Object=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize);
			
				while(!partDiskObj && curRadius>_min_size && curRadius<_max_size){
					
					changeRadius(1);
					
					partDisk.selectedDiskSize=curRadius;
					prefix=PartSlotDisk.getPrefixDep(partDisk);
					partDiskObj=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize);
				}

				owner.dispatchEventWith(EVENT_CHANGE_PART_DATA, false, {disk: partDiskObj});
			}
		}

		
		private function changeRadius(delta:int):void
		{
			curRadius += delta;
			
			if(curRadius==_max_size && curRadius==_min_size){
				btnRadiusPlus.isEnabled =  false;
				btnRadiusMinus.isEnabled = false;
				
				btnRadiusPlus.alpha=0.5;
				btnRadiusMinus.alpha=0.5;
				
				
			}else
				if(curRadius>=_max_size){
					btnRadiusPlus.isEnabled =  false;
					btnRadiusMinus.isEnabled = true;
					
					btnRadiusPlus.alpha=0.5;
					btnRadiusMinus.alpha=1;
					
				}else if (curRadius<=_min_size){
					btnRadiusPlus.isEnabled =  true;
					btnRadiusMinus.isEnabled = false;	
					
					btnRadiusPlus.alpha=1;
					btnRadiusMinus.alpha=0.5;
				}else{
					btnRadiusPlus.isEnabled =  true;
					btnRadiusMinus.isEnabled = true;
					
					btnRadiusPlus.alpha=1;
					btnRadiusMinus.alpha=1;
				}
			
			if(_max_size==_min_size){
				this.btnContainer.visible=false;
			}else{
				this.btnContainer.visible=isSelected;
			}
			btnRadius.label = curRadius.toString();
			
		}
		
		private function closeMenuButtonTriggeredHandler(event:Event):void{
			var target : ExtentedButton = event.currentTarget as ExtentedButton;
			var list : List = target.parent as List;
			var pickList : PickerList = list.focusOwner as PickerList;
			//AlertView.show(target.label);
			this.closePickerList(pickList);
		}
		
		public function closePickerList(pickList:PickerList) : void
		{
			pickList.popUpContentManager.close();			
		}
		
		private function btnSettingsHandler(event:Event):void{

			SoundManager.playSound(SoundManager.PART_MENU);
			owner.dispatchEventWith(EVENT_OPEN_DISK_SETTINGS_VIEW, false, {part:this});
		}
		
		
		
		private var _min_size:int=0;
		private var _max_size:int=0;

		protected override function commitData() : void 
		{
			super.commitData();
			var typicalWidth:Number = 185;
            if (part && part.name == 'banner') {
				var bannerWidth: Number = AdsManager.$.bannerWidth + TuningScreen.PART_SELECTOR_WIDTH / 2;
				if(!AdsManager.$.bannerEnabled || owner.width - typicalWidth < bannerWidth){
					AdsManager.$.preventToggle = true;
					setSize(0, 50);
				}else{
					AdsManager.$.preventToggle = false;
					setSize(bannerWidth, 50);
				}
                profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible  = imageLoader.visible = false;
                this.touchable = false;
                btnSettings.visible= false;
                btnContainer.visible = false;
				label2.visible = false;
            } else {
				profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible = imageLoader.visible = true;
                btnSettings.visible=isSelected && countPartStates>=MIN_STATE_COUNT && Constants.CRAMB_ENABLED && camberAllowForCar;
                btnContainer.visible = _min_size < _max_size;
				label2.visible = true;
                if(part && part.parentSlot && part.parentSlot.name == "front_wheel") {
                    btnContainer.visible = false;
                }
                touchable = true;
                setSize(185, 50);
                label.validate();
				profileNewBadgeIcon.visible = (badgeIconName != null);
				if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
					profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
					profileNewBadgeIcon.setRequiresRedraw();
				}


				if (!partDisk) {
					return;
				}

                var diskBrand:DiskBrand = Disk.getDiskBrandById(partDisk.manufacturer);
				label.width = actualWidth - label.x - (btnSettings.width + 9);
				if (diskBrand && showBrandName) {
					label2.text = diskBrand.name;
					if(label.wordWrap){
						label.textFormat.align = TextFormatAlign.LEFT;
						label.wordWrap = false;
						label.height = 15;
						label.updateWithLanguage(null);
					}
				} else {
					label2.text = "";
					if(!label.wordWrap){
						label.textFormat.align = TextFormatAlign.LEFT;
						label.wordWrap = true;
						label.height = 35;
						label.updateWithLanguage(null);
					}
				}

                label2.updateWithLanguage(AlertView.language);

                if (partDisk && partDisk.radius > 0) {

                    _min_size = part.properties.min_size;

                    _max_size = part.properties.max_size;

                    if ((part as PartDisk).selectedDiskSize > 0) {

                        curRadius = (part as PartDisk).selectedDiskSize;

                    } else {
                        curRadius = part.properties.size;
                    }


                    _isExtanded = true;
                    invalidate("data_provider");
                } else {

                    if (part.parentSlot.name == "front_wheel") {
                        btnContainer.visible = false;
                    } else {
                        btnContainer.visible = isSelected;
                    }
                    _isExtanded = false;
                    invalidate("data_provider");
                }
            }
		}

		private var _isExtanded:Boolean=true;

		override protected function draw():void{
			super.draw();
		}
		
		private function get countPartStates():int{
			
			var i:int=0;
			
			if(!partDisk)
				return 0;

			if(!partDisk.states)        
				return 0;
			
			for each(var state:* in partDisk.states){
				if(state && state.hasOwnProperty('nameOfState') && state.nameOfState != "neon")
				i++;
			}
			
			return i;
			
			
		}
		protected override function autoSizeIfNeeded() : Boolean
		{
			var needsWidth : Boolean = isNaN(explicitWidth);
			
			if(!needsWidth)
			{
				return false;
			}
				
			if(this.isSelected && this._isExtanded){
				
				return this.setSizeInternal(370/2, 50,false);
			}else{
				
				return this.setSizeInternal(370/2, 50,false);
			}
		}
		
		protected override function commitSelection() :void
		{
			super.commitSelection();
			
			btnContainer.visible = isSelected && _min_size < _max_size;
			btnSettings.visible=isSelected && countPartStates>=MIN_STATE_COUNT && Constants.CRAMB_ENABLED && camberAllowForCar;
			
			if(_max_size==_min_size || part.parentSlot.name == "front_wheel"){
				
				btnContainer.visible = false;		
			}
			bold=isSelected;
			
		}


        override protected function updatePartIcon() : void{
            imageLoader.width = 40;
            imageLoader.height = 40;
            imageLoader.x = 10;
            imageLoader.y = 3.5;

            Starling.juggler.delayCall(function () : void {
                if(profileNewBadgeIcon) {
					profileNewBadgeIcon.visible = (badgeIconName != null);
					if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
						profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
						updateBadgeIcon();
					}
                }
            }, 0.3);
        }

        override  protected function updateBadgeIcon() : void {

            if(imageLoader && imageLoader.image) {
                profileNewBadgeIcon.width = profileNewBadgeIcon.height = actualHeight;
                profileNewBadgeIcon.x = 0;
                profileNewBadgeIcon.y = 0;
            }
            else {
                profileNewBadgeIcon.visible = false;
            }
        }
		
		   
		override protected function layout():void{
			super.layout();
			if(_isDisposed){
				return;
			}
			if(quad){
				quad.x=8;
				quad.width=actualWidth-16;
				quad.height=actualHeight;
			}
			if(isInvalid("data_provider")){
				
				
				if (part.isBack || !isSelected)
				{
					
					btnSettings.visible=false;
					btnContainer.visible = false;
				}
				else
				{
					btnSettings.visible=isSelected && countPartStates>=MIN_STATE_COUNT && Constants.CRAMB_ENABLED && camberAllowForCar
					btnContainer.visible = _min_size < _max_size;

                    if(part.parentSlot.name == "front_wheel")
                    {
                        btnContainer.visible = false;
                    }
				}

				if(_isExtanded){
					btnRadius.label=curRadius.toString();
					changeRadius(0);
                    if(part.parentSlot.name == "front_wheel")
                    {
                        btnContainer.visible = false;
                    }
					else {
                        btnContainer.visible = isSelected && _min_size < _max_size;
					}
				}else{
					changeRadius(0);
					
					btnContainer.visible=false;
					
					btnSettings.visible=isSelected && countPartStates>=MIN_STATE_COUNT && Constants.CRAMB_ENABLED && camberAllowForCar;
				}
			}



			imageLoader.width = 40;
			imageLoader.height = 40;
			imageLoader.x = 10;
			imageLoader.y = 3.5;


			btnSettings.x = btnInfo.x;
			btnSettings.y = 5;
			if(!isChopper) {
				btnContainer.x=59;
			} else {
				btnContainer.x=actualWidth/2+ imageLoader.width/2 + 10;
			}
			btnContainer.y=2.5;
			
			btnContainer.width = 23;

			var labelPosX:Number=60;
			
			if(btnContainer.visible){
					labelPosX=85;
			}

			label.x=labelPosX;
			label.y=9;
			
			label2.x=labelPosX;
			label2.y=label.y+label.height+3;
			
			
			label.maxWidth=actualWidth-label.x-(btnSettings.width+9);
			var diskBrand:DiskBrand;
			if(partDisk){
				diskBrand = Disk.getDiskBrandById(partDisk.manufacturer);
			}
			if (diskBrand && showBrandName) {
				label.height = 15;
			} else {
				label.height = 35;
			}
			label.validate();

            label2.maxWidth=actualWidth-label.x-(btnSettings.width+9);
            label2.validate();
            if(part && part.name == 'banner') {
                carLock.visible=false;
            }else if(part && part.lock && !this.isBack){
                carLock.visible=true;

            }else{
                if(isBack){
                    part.lock=false;
                }
                carLock.visible=false;
            }

			btnInfo.x = actualWidth - (btnInfo.width + 6);
			btnInfo.y = actualHeight - (btnInfo.height + 4);

			carLock.x = actualWidth - (carLock.width + 6);
			carLock.y = 4;
			
		}

		override public function set bold(value:Boolean):void{
			super.bold = value;
			if(label2) {
				label2.textFormat.color = 0xFFFFFF;
				label2.textFormat.font = FontSelector.getFont(value);
				label2.textFormat.bold = _bold;
				label2.invalidate();
			}
		}

		public function get partDiskMenu():TuningDiskSettingsView {
			return _partDiskMenu;
		}

		public function set partDiskMenu(value:TuningDiskSettingsView):void {
			_partDiskMenu = value;
		}

		override public function dispose():void{
			super .dispose();
			if(btnRadius){
				btnRadius.removeFromParent(true);
				btnRadius = null;
			}
			if(btnRadiusPlus){
				btnRadiusPlus.removeFromParent(true);
				btnRadiusPlus = null;
			}
			if(btnRadiusMinus){
				btnRadiusMinus.removeFromParent(true);
				btnRadiusMinus = null;
			}
			if(btnContainer){
				btnContainer.removeFromParent(true);
				btnContainer = null;
			}
			if(_partDiskMenu){
				_partDiskMenu.removeFromParent(true);
				_partDiskMenu = null;
			}
			if(quad){
				quad.removeFromParent(true);
				quad = null;
			}
			if(label2){
				label2.removeFromParent(true);
				label2 = null;
			}
		}
	}
}

