package com.despark.tuning3d.view.components.parts
{
    import com.despark.tuning3d.model.core.images.PersistentImageProvider;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.LayoutImage;
    import com.despark.tuning3d.view.components.core.ListItemRenderer;
    import com.despark.tuning3d.view.components.core.MultilingualLabel;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;

    import feathers.controls.Button;
    import feathers.controls.Label;

    import flash.geom.Rectangle;

    import flash.text.TextFormatAlign;
    import flash.utils.setTimeout;

    import starling.core.Starling;

    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.textures.Texture;
    import starling.utils.MathUtil;

    public class PartTurn5Renderer extends ListItemRenderer implements IPartItemRenderer{

    public static const EVENT_OPEN_INFO_POP_UP:String="EVENT_OPEN_INFO_POP_UP";


    protected var quad_back:Quad;
    protected var carLock:Image;
    protected var btnInfo : Button;

    private var _isTranslate:Boolean=false;
    private var _translateDescription:String="";

    private var _enabled:Boolean=true;



    private var _separator:Image;
    private var _selectedBorder:LayoutImage;

	private var button:Button;
    protected var profileNewBadgeIcon:Image;
    protected var badgeTextures:Object;
    private var priceLabel:Label;
    private var _activeIcon:Image;
    private static const _truncated_name:Object = {};
    public function PartTurn5Renderer() {
        super();
        fontSize = LabelFactory.TURN5_PRICE_SIZE;
        _textColor = 0xFFFFFF;
        _bold = false;
    }
	
	private function onTouch(event:Event):void{
		trace("onTouch", part.isFastModeLoaded);
		if(part.isFastModeLoaded){
			itemSelectedAgainBlocker = true;
			owner.dispatchEventWith("ExitFromFastMode", false, {part:part});
			trace("onTouch2", part.isFastModeLoaded);
		}
	}

    public function get translateDescription():String{

        return _translateDescription;
    }

    public function get part() : Part
    {
        return data as Part;
    }

    public function get isChopper():Boolean{
        return part ? part.parentSlot.parentCar.isChopper: false;
    }

    override public function dispose():void{
        if(quad_back){
            quad_back.removeFromParent(true);
            quad_back = null;
        }
        if(carLock){
            carLock.removeFromParent(true);
            carLock = null;
        }
        if(_separator){
            _separator.removeFromParent(true);
            _separator = null;
        }
        if(button){
            button.removeFromParent(true);
            button = null;
        }
        if(btnInfo){
            btnInfo.removeFromParent(true);
            btnInfo = null;
        }
        if(profileNewBadgeIcon){
            profileNewBadgeIcon.removeFromParent(true);
            profileNewBadgeIcon = null;
        }
        if(priceLabel){
            priceLabel.removeFromParent(true);
            priceLabel = null;
        }
        super.dispose();
    }

    protected override function initialize():void {
        quad_back=new Quad(1, 1, 0xeaeaea);
        quad_back.alpha=0;

        this.addChild(quad_back);
        super.initialize();

        var carLockTexture : Texture = AlertView.assetManager.getTexture("challenge_rewards_icon");
        carLock=new Image(carLockTexture);
        carLock.width = 18;
        carLock.scale = carLock.scaleX;
        addChild(carLock);

        var separatorTexture:Texture=ButtonFactory.assetManager.getTexture("a_seporator_1");
        _separator = new Image(separatorTexture);
        _separator.width=1.5;
        addChild(_separator);

        label.paddingLeft = label.paddingRight = 3;

        priceLabel = new Label();
        priceLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.getMontserratRegular(), LabelFactory.TURN5_PRICE_SIZE, 0xFFFFFF, TextFormatAlign.LEFT, true);
        priceLabel.paddingLeft = priceLabel.paddingRight = 3;
        addChild(priceLabel);
		
		button = ButtonFactory.transparentButton();
		button.addEventListener(Event.TRIGGERED, onTouch);
		addChild(button);

        btnInfo = ButtonFactory.circleButton("a_part_info_icon", 0.6, null, 7);
        btnInfo.width = 16;
        btnInfo.height = 16.5;
        btnInfo.addEventListener(Event.TRIGGERED, btnInfoHandler);
        addChild(btnInfo);

        badgeTextures = {
            "new_icon": ButtonFactory.assetManager.getTexture("new_icon"),
            "profile_icon": ButtonFactory.assetManager.getTexture("profile_icon"),
            "new_and_profile_icon": ButtonFactory.assetManager.getTexture("new_and_profile_icon")
        };
        profileNewBadgeIcon = new Image(badgeTextures["new_icon"]);
        profileNewBadgeIcon.width = 38;
        profileNewBadgeIcon.height = 38;
        addChild(profileNewBadgeIcon);


        var frameTxt:Texture = ButtonFactory.assetManager.getTexture("border_line");
        _selectedBorder = new LayoutImage(frameTxt);
        _selectedBorder.scale9Grid = new Rectangle(frameTxt.width/2 - 0.5, frameTxt.height / 2 - 0.5, 1, 1);
        _selectedBorder.touchable = _selectedBorder.includeInLayout = false;
        addChild(_selectedBorder);
        _selectedBorder.color = 0xFFFFFE;
        _selectedBorder.width = actualWidth;
        _selectedBorder.height = actualHeight;
        _selectedBorder.visible = false;
    }

    override protected function touchHandler(event:TouchEvent):void{
        var touch:Touch = event.getTouch(btnInfo);
        if(touch){
            return;
        }
        super .touchHandler(event)
    }

    private function btnInfoHandler(event:Event):void {
        if(isSelected){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
        owner.dispatchEventWith(EVENT_OPEN_INFO_POP_UP, false, {part:this});
        event.stopImmediatePropagation();
    }

    protected override function commitData() : void
    {
        super.commitData();
        label.wordWrap = true;
        label.textFormat.align = TextFormatAlign.LEFT;
        var typicalWidth:Number = 220;
        if (part && part.name == 'banner') {
            imageLoader.persistentImageProvider = null;
            profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible = _separator.visible = imageLoader.visible = false;

            var bannerWidth: Number = AdsManager.$.bannerWidth + TuningScreen.PART_SELECTOR_WIDTH / 2;
            if(!AdsManager.$.bannerEnabled || owner.width - typicalWidth < bannerWidth){
                AdsManager.$.preventToggle = true;
                setSize(0, 50);
            }else{
                AdsManager.$.preventToggle = false;
                setSize(bannerWidth, 50);
            }

            this.touchable = false;
            priceLabel.visible = false;
        } else {
            this.touchable = (part && part.name != '.');
            if(part){
                priceLabel.text = "Starting at: " + (part.priceString?part.priceString:"");
                priceLabel.visible = true;
            }else{
                priceLabel.text = "";
                priceLabel.visible = false;
            }

            profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible = _separator.visible = imageLoader.visible = true;
            setSize(typicalWidth, 50);

            if (part && AlertView.language.translate(part.id, "htmlCode") != null && AlertView.language.translate(part.id, "htmlCode") != "htmlCode") {
                _isTranslate = true;
                _translateDescription = AlertView.language.translate(part.id, "htmlCode");
            } else if (part && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != null && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != "htmlCode") {
                _isTranslate = true;
                _translateDescription = AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode");
            } else {
                _isTranslate = false;
                _translateDescription = "";
            }

            profileNewBadgeIcon.visible = (badgeIconName != null);
            if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
                profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
            }

            if(part && _truncated_name[part.id]){
                label.text = _truncated_name[part.id];
            }else if (part && part.name.indexOf("{custom}") >= 0) {
                var text:String = part.name;
                text = text.replace("{custom}", AlertView.language.translate("componentNames", "custom"));
                label.text = text;
            } else if (part && part.name.indexOf("{factory}") >= 0) {
                var text2:String = part.name;
                text2 = text2.replace("{factory}", AlertView.language.translate("componentNames", "factory"));
                label.text = text2;
            } else if (part) {
                label.text = part.name;
            }


            if (part) {
                if(part.isEnabled && _activeIcon){
                    _activeIcon.removeFromParent(true);
                    _activeIcon = null;
                }else if(!part.isEnabled && !_activeIcon){
                    _activeIcon = new Image(ButtonFactory.assetManager.getTexture("close_btn_texture"));
                    _activeIcon.width = _activeIcon.height = 18;
                    addChild(_activeIcon);
                    _activeIcon.x = (actualWidth - _activeIcon.width) / 2;
                    _activeIcon.y = (actualHeight - _activeIcon.height) / 2;
                }

                _enabled = part.enabled && !part.parentSlot.isExcluded;
                var newPersistentImageProvider:PersistentImageProvider = part;

                if (imageLoader.persistentImageProvider && imageLoader.persistentImageProvider.remoteUrl != newPersistentImageProvider.remoteUrl) {
                    imageLoader.persistentImageProvider = part;
                    imageLoader.completeHandler = completeIconLoad;
                } else if (!imageLoader.persistentImageProvider) {

                    imageLoader.completeHandler = completeIconLoad;
                    imageLoader.persistentImageProvider = part;
                } else {
                    updatePartIcon();
                }
            }
        }
        isEnabled = _enabled;
    }


        protected function get badgeIconName():String{
            var isNew:Boolean = false;
            var hasProfile:Boolean = false;
            if(part){
                isNew = (part.properties.hasOwnProperty("is_new") && part.properties["is_new"]);
                hasProfile = (part.properties.hasOwnProperty("profilesAvailable") && part.properties["profilesAvailable"]);
                if(isNew && !hasProfile){
                    return "new_icon";
                }
                if(!isNew && hasProfile){
                    return "profile_icon";
                }
                if(isNew && hasProfile){
                    return "new_and_profile_icon";
                }
                return null;
            }
            return null;
        }


        override public function set bold(value : Boolean) : void {
            if(value != _bold) {
                _bold = value;
                if (label) {
                    label.textFormat.color = isSelected ? 0xFFFFFF : 0xEFEFEF;
                    label.textFormat.font = FontSelector.getFont(_bold);
                    label.textFormat.bold = _bold;
                    label.invalidate();
                }
                if (priceLabel) {
                    priceLabel.textRendererFactory = LabelFactory.createTextRendererFactory(value?FontSelector.getMontserratBold():FontSelector.getMontserratRegular(), LabelFactory.TURN5_PRICE_SIZE, 0xFFFFFF, TextFormatAlign.LEFT, true);
                    priceLabel.invalidate();
                }
            }
    }

    protected override function commitSelection() :void {
        super.commitSelection();

        if (part && part.parentSlot) {
            if (!part.parentSlot.isExcluded) {
                bold = isSelected;
            }
            updatePartIcon();
        }
        layoutSelection();
    }

    protected function completeIconLoad(image:ImageLoaderWithStates) : void {
        updatePartIcon(true);
    }

    protected function updatePartIcon(truncateToFit:Boolean = false) : void{
        turn5Layout(truncateToFit);
        Starling.juggler.delayCall(function () : void {
            if(profileNewBadgeIcon)
            {
                profileNewBadgeIcon.visible = (badgeIconName != null);
                if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
                    profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
                    updateBadgeIcon();
                }
            }
        }, 0.3);
    }

    private function turn5Layout(truncateToFit:Boolean = false):void{
        imageLoader.height = actualHeight - 10;
        if(imageLoader.image){
            imageLoader.width = MathUtil.clamp(imageLoader.height * imageLoader.image.width / imageLoader.image.height, 40, 80);
        }
        var contentHeight:Number = 0;
        imageLoader.x = 5;
        imageLoader.y = (actualHeight - imageLoader.height) / 2;
        label.width = actualWidth - imageLoader.width - 10 - (btnInfo.visible?(btnInfo.width + 10):0);
        label.height = 25;
        label.x = imageLoader.x + imageLoader.width + 3;
        label.validate();

        if(truncateToFit && part && !_truncated_name.hasOwnProperty(part.id)){
            if(label.text && label.numLines > 2){
                while (label.numLines > 2){
                    label.text = label.text.substr(0, label.text.length - 1);
                    label.validate();
                }
                label.text = label.text.substr(0, label.text.length - 3) + "...";
                label.validate();
                trace(label.text, label.numLines);
            }
            _truncated_name[part.id] = label.text;
        }

        contentHeight = 24;
        if(priceLabel.text && priceLabel.text.length){
            priceLabel.validate();
            priceLabel.x = label.x;
            contentHeight += priceLabel.height + 1;
        }else{
            contentHeight = label.height;
        }
        label.y = (actualHeight - contentHeight) / 2;
        if(priceLabel.text && priceLabel.text.length){
            priceLabel.y = label.y + label.height + (label.height < 13? 13: 1);
        }

        carLock.x = actualWidth - (carLock.width + 6);
        carLock.y = 4;
    }

    protected function updateBadgeIcon() :void {
        if(imageLoader && imageLoader.image) {
            profileNewBadgeIcon.width = profileNewBadgeIcon.height = imageLoader.image.height * 0.8;
            profileNewBadgeIcon.x = imageLoader.x + imageLoader.image.x;
            profileNewBadgeIcon.y = imageLoader.y + imageLoader.image.y;
        } else {
            profileNewBadgeIcon.visible = false;
        }
    }

    protected override function layout():void {
        if(_isDisposed){
            return;
        }
        label.updateWithLanguage(AlertView.language);
        label.maxWidth = actualWidth - imageLoader.width;
        turn5Layout();
        quad_back.width = actualWidth;
        quad_back.height = actualHeight;

        btnInfo.x = actualWidth - (btnInfo.width + 6);
        btnInfo.y = actualHeight - (btnInfo.height + 4);

        carLock.x = actualWidth - (carLock.width + 6);
        carLock.y = 4;

        if(part && part.name == 'banner') {
            carLock.visible=false;
        }else {
            carLock.visible = (part && part.lock);
        }
        btnInfo.visible = (part && part.activeForInformation);
        if(!_enabled){
            this.alpha = 0.3;
        }else{
            this.alpha = 1;
        }

        _separator.height = actualHeight - 10;
        _separator.y = 5;
        _separator.x = actualWidth-_separator.width;
    }


    private function chopperLayout():void{
        var featuresWidth:Number=0;
        if(isSelected && _isTranslate){
            featuresWidth=(btnInfo.width)+4;
        }

        label.updateWithLanguage(AlertView.language);

        label.maxWidth=actualWidth-featuresWidth;
        label.validate();

        label.height = 15;
        label.validate();

        quad_back.width = this.actualWidth;
        quad_back.height = this.actualHeight;

        btnInfo.x = actualWidth - (btnInfo.width + 6);
        btnInfo.y = actualHeight - (btnInfo.height + 4);

        carLock.x = actualWidth - (carLock.width + 6);
        carLock.y = 4;

        carLock.visible = part.lock;
        btnInfo.visible = (part && part.activeForInformation);
        if(!_enabled){
            this.alpha = 0.3;
        }else{
            this.alpha = 1;
        }

        _separator.x = actualWidth - _separator.width;
        _separator.y = 0;
        _separator.height = actualHeight;
    }

    protected function layoutSelection():void{
        if(_selectedBorder){
            _selectedBorder.width = actualWidth;
            _selectedBorder.height = actualHeight;
            _selectedBorder.visible = isSelected;
            //
            if(owner && owner.dataProvider){
                var itemIndex:int = owner.dataProvider.getItemIndex(_data);
                if(itemIndex < owner.dataProvider.length - 1){
                    var rightRenderer:PartTurn5Renderer = owner.itemToItemRenderer(owner.dataProvider.getItemAt(itemIndex + 1)) as PartTurn5Renderer;
                    if(rightRenderer){
                        _separator.visible = (!isSelected && !rightRenderer.isSelected);
                    }else{
                        _separator.visible = !isSelected;
                    }
                }else{
                    _separator.visible = !isSelected;
                }
            }
            //
        }
    }


    protected override function draw():void {
        super.draw();
        if(part && part.parentSlot.parentCar.isChopper){
            chopperLayout();
        }else{
            layout();
        }
		button.width = actualWidth;
		button.height = actualHeight;

        layoutSelection();
    }
}
}

