/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.view.components.timeline {
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.challenges.ChallengeData;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Abstract.ATimelineCommentLikeItemRender;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedTextItemRenderer;
import com.despark.tuning3d.view.components.timeline.TimelineGarage.CommentsPocket;
import com.despark.tuning3d.view.components.timeline.components.TimelineFeedImageHolder;
import com.utils.DateParser;
import com.utils.ImageUtils;
import com.utils.ObjectUtils;
import com.utils.RegExpUtil;
import com.utils.TextureUtil;

import flash.display.Bitmap;
import flash.display.Loader;
import flash.events.Event;
import flash.events.IOErrorEvent;
import flash.net.URLRequest;

import org.as3commons.lang.ArrayUtils;

import starling.display.DisplayObjectContainer;
import starling.display.Image;
import starling.textures.Texture;

public class FeedData {

    public static const TYPE_NEW_FRIEND : String = "new_friend";
    public static const TYPE_TUNING_LIKE : String = "tuning_like";
    public static const TYPE_TUNING_COMMENT : String = "tuning_comment";
    public static const TYPE_NEW_TUNING : String = "new_tuning";
    public static const TYPE_TEXT : String = "text";
    public static const TYPE_POST_LIKE : String = "feedpost_like";
    public static const TYPE_POST_COMMENT : String = "feedpost_comment";
    public static const TYPE_TEXT_AND_IMAGES : String = "text/images";
    public static const TYPE_NEWBORN : String = "newborn";
    public static const TYPE_CHALLENGE_ANSWER : String = "challenge_answer";
    public static const TYPE_CHALLENGE_INVITE : String = "challenge_invite";
    public static const TYPE_CHALLENGE_WIN:String = "challenge_win";
    private static const NO_TUNING_TYPES:Array = [TYPE_TEXT, TYPE_TEXT_AND_IMAGES, TYPE_NEWBORN, TYPE_POST_LIKE, TYPE_POST_COMMENT];


    public static const COMMENT_SEND: String = "sendComment";
    public static const COMMENT_CANCEL: String = "cancelComment";
    public static const COMMENT_DELETE:String = "commentDelete";
    public static const COMMENT_MORE:String = "commentMore";
    public static const COMMENT_EDIT:String = "commentEdit";
    public static const NEW_POST:String = "newPost";
    public static const LIKE:String = "likePost";
    public static const TUNING_CAR_IMAGE_SELECTED : String = "tuningCarImageSelected";

    public static var CURRENT_USER : User;

    protected static var PROXY : TimelineProxy;

    public var id : String;
    public var feedType : String;
    public var feedActualType : String;
    public var owner : User;
    public var date : Date;
    public var updatedDate : Date;
    public var newFriend : User;
    public var creator : User;
    public var iLiked : Boolean;
    public var text : String;
    public var metadataList : Array;

    public var challengeData:ChallengeData;


    public var timeLineDateTime: String;

    public var likes : Array = [];
    public var tuning : Object;
    public var postImages : Array;
    public var tuningHd : Boolean;
    public var isCommentActive : Boolean;
    public var commentCount: int = 0;

    protected var _loader:Loader;
    protected var _isLoaded : Boolean = false;
    protected var _commentsPocket : CommentsPocket;

    protected var _holder:ATimelineCommentLikeItemRender;
    public static const FHDRatio:Number = 1920/1080;
    private var _sourceDimensions:Object;

    protected var _parent : TimelineFeedImageHolder;
    protected var _width : Number;
    protected var _height : Number = 0;
    protected var _bottomBarHeight : Number = 0;
    protected var _texture : Array;
    protected var _autosize: Function;
    protected var _loadQueue : Array;

    public function FeedData(data : Object, createView:Boolean = true) {
        if(data == null){
            return;
        }
        feedType  = feedActualType = data.type;

        if(data.hasOwnProperty("likes")) {
            likes = data.likes;
        }

        if (data.tuning && data.tuning.hasOwnProperty('counters')) {
            if(data.tuning.counters.comments) {
                commentCount = data.tuning.counters.comments;
            }
        }
        var challengesProxy:ChallengesProxy;
        var thisObj:FeedData;
        switch(data.type){
            case TYPE_CHALLENGE_ANSWER:
                thisObj = this;
                id = data._id;
                date = DateParser.parseDate(data.created);
                creator = new User(data.creator);
                owner = new User(data.owner);
                break;
            case TYPE_CHALLENGE_WIN:
                thisObj = this;
                id = data._id;
                iLiked = data.iLiked;
                date = DateParser.parseDate(data.created);
                creator = new User(data.creator);
                owner = new User(data.owner);
                break;
            case TYPE_NEW_FRIEND:
                id = data._id;
                date =DateParser.parseDate(data.created);
                creator = new User(data.creator);
                newFriend = new User(data.newFriend);
                updatedDate = DateParser.parseDate(data.updated);
                break;
            case TYPE_NEWBORN:
                id = data._id;
                date = DateParser.parseDate(data.created);
                creator = new User(data.creator);
                updatedDate = DateParser.parseDate(data.updated);
                break;
            case TYPE_TUNING_LIKE:
            case TYPE_NEW_TUNING:
            case TYPE_TUNING_COMMENT:
                id = data._id;
                date = DateParser.parseDate(data.created);
                creator = new User(data.creator);
                owner = new User(data.owner);
                iLiked = data.iLiked;

                _commentsPocket = new CommentsPocket(this);
                updatedDate = DateParser.parseDate(data.updated);
                if(data.hasOwnProperty("newFriend"))
                    newFriend = new User(data.newFriend);

                if(data.hasOwnProperty("tuning") && data["tuning"].hasOwnProperty("car")){
                    tuning = data.tuning;
                    tuningHd = (tuning.car.hasOwnProperty("hdsize") && tuning.car["hdsize"]);
                    loadImage(tuning.fullHdSnapshots[0]);
                }
                break;
            case TYPE_POST_LIKE:
            case TYPE_POST_COMMENT:
            case TYPE_TEXT:
                id = data._id;
                date = DateParser.parseDate(data.created);
                creator = new User(data.creator);
                iLiked = data.iLiked;
                if(data.owner){
                    owner = new User(data.owner);
                }
                var feedContent:Object;
                if(data.hasOwnProperty('feedPost')){
                    feedContent = data['feedPost'];
                    if(feedContent.hasOwnProperty('_id')) {
                        id = feedContent._id;
                    }
                    if(feedContent.creator){
                        owner = new User(feedContent.creator);
                    }
                } else {
                    feedContent = data;
                }
                if(createView && feedContent.hasOwnProperty("metadata") && feedContent['metadata'].length) {
                    postImages = [];
                    for each(var metadata : Object in feedContent['metadata']){
                        if(metadata && metadata.hasOwnProperty('type') && metadata['type'] == 'images' && metadata.hasOwnProperty('photos')){
                            for each (var photo : Object in metadata['photos']){
                                if(photo){
                                    postImages.push(photo);
                                }
                            }
                        }else if(metadata && metadata.hasOwnProperty('type') && metadata['type'] == 'url' && metadata.hasOwnProperty('meta')){
                            metadataList ||= [];
                            metadataList.push(metadata);
                            if(metadata.meta.image && RegExpUtil.isAllowedImageURL(metadata.meta.image)){
                                postImages.push(metadata.meta.image);
                            }else if(metadata.meta.logo && RegExpUtil.isAllowedImageURL(metadata.meta.logo)){
                                postImages.push(metadata.meta.logo);
                            }
                        }
                    }

                    if(postImages.length){
                        this.feedType = TYPE_TEXT_AND_IMAGES;
                        loadImage(ArrayUtils.clone(postImages));
                    }
                }


                _commentsPocket = new CommentsPocket(this);
                updatedDate = DateParser.parseDate(data.updated);
                if (feedContent.text) {
                    text = feedContent.text;
                }
                break;
        }
        timeLineDateTime = data.timeline;
        if(_commentsPocket) {
            _commentsPocket.initialLoad();
            loadInitialLikes();
            if(!iLiked){
                checkLike(useId);
            }
        }
    }

    protected function loadInitialLikes():void {
        PROXY.getLikes(isTuningUse,useId,function (obj:Object) :void {
            if(obj){
                likes = obj as Array;
                iLiked = false;
                var l : int = Math.min(likes.length,1000);// optimization
                for(var i : int = 0; i < l; i++){
                    if(CURRENT_USER && likes[i].user._id == CURRENT_USER.id){
                        iLiked = true;
                        break;
                    }
                }

                if(holder){
                    holder.invalidateLikeCommentsViews();
                }
            }
        });
    }

    public function checkLike(id:String):void {
        var httpClient:HttpClient = (ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy).httpClient;
        var url:String = 'http://ratings.3dtuning.com/api/v1/tunings/' + id + '/ratings';
        httpClient.getPath(url, null, function (success:Boolean, result:Object):void {
            if (success) {
                var obj:Object = JSON.parse(result.toString());
                iLiked = obj.liked;
            } else {
                iLiked = false;
            }
            if(holder){
                holder.invalidateLikeCommentsViews();
            }
        });
    }

    public function get holder() : ATimelineCommentLikeItemRender{
        return this._holder;
    }

    public function set holder(value : ATimelineCommentLikeItemRender) : void{
        this._holder = value;
    }

    public function get commentsPocket() : CommentsPocket{
        return _commentsPocket;
    }


    public function get isTuningUse() : Boolean{
        return NO_TUNING_TYPES.indexOf(feedType) == -1;
    }

    public function get useId() : String{
        if(isTuningUse)
            return tuning._id;
        else
            return id;
    }



    public function get availableDate() : Date
    {
        /*if(updatedDate)
            return updatedDate;*/

        return date;
    }

    public function getCarFullName() : String
    {
        if(tuning )
        {
            return tuning.car["make"] + " " + tuning.car.model + " " + tuning.car.year;
        }
        return null;
    }


    public function get currentUser() : User{
        return FeedData.CURRENT_USER;
    }

    public function  get nameLabel() : String {
        return (CURRENT_USER && creator.id == CURRENT_USER.id)? "I " : this.creator.nameToShow;
    }

    public function  get friendLabel() : String {
        return (CURRENT_USER && newFriend.id == CURRENT_USER.id) ? " me" : this.newFriend.nameToShow;
    }

    public function  get ownerLabel() : String {
        return (CURRENT_USER && owner.id == CURRENT_USER.id) ? " my" : this.owner.nameToShow;
    }

    public function  get ownerLabel1() : String {
        return (CURRENT_USER && owner.id == CURRENT_USER.id) ? "You" : this.owner.nameToShow;
    }

    public function  get descriptionLabel() : String
    {
        var str : String = "";
        switch(this.feedType){
            case TYPE_NEW_FRIEND:
                str = "became friends with";
                break;
            case TYPE_POST_LIKE:
                str = "liked a post";
                break;
            case TYPE_POST_COMMENT:
                str = "commented on post";
                break;
            case TYPE_TEXT:
            case TYPE_TEXT_AND_IMAGES:
                str = "added a new post";
                break;
            case TYPE_NEWBORN:
                str = "registered on 3DTuning.com";
                break;
            case TYPE_NEW_TUNING:
                str = ((CURRENT_USER && creator.id == CURRENT_USER.id) ? "tuned" : "tuned") + " a new car";
                break;
            case TYPE_TUNING_LIKE:
                str = (CURRENT_USER && creator.id == CURRENT_USER.id) ? "like" : "liked";
                break;
            case TYPE_TUNING_COMMENT:
                str = (CURRENT_USER && creator.id == CURRENT_USER.id) ? "commented on" : "commented on";
                break;
            case TYPE_CHALLENGE_ANSWER:
                str = "started tuning challenge";
                break;
            case TYPE_CHALLENGE_WIN:
                str = creator.id==currentUser.id?"win challenge with":"wins challenge with";
                break;
        }
        return str;
    }

    public function getMoreLabelText():String
    {
        var st : String = "<body>";

        if(commentsPocket.currentLength < commentsPocket.totalLength)
        {
            st += "<span class='heading'>view more comments </span>"
        }
        st+= "</body>";
        return st;
    }

    public function getLikesCountString():String {
        return getNumberString(likes.length);
    }

    public static function getNumberString(numb : int ) : String {
        if(numb > 1000000) {
            return (int(numb / 1000000)).toString() + "m"
        }
        if(numb > 1000)
        {
            return (int(numb / 1000)).toString() + "k"
        }

        return numb.toString();

    }




    public function bitmapProcessing(bitmap : Bitmap) : Bitmap {
        switch (feedType) {
            case TYPE_TEXT_AND_IMAGES:
                bitmap = new Bitmap(ImageUtils.scaleBitmapData(bitmap.bitmapData, 0.5));
                return bitmap;
            case TYPE_NEW_TUNING:
            case TYPE_TUNING_COMMENT:
            case TYPE_TUNING_LIKE:
            case TYPE_CHALLENGE_WIN:
                _sourceDimensions = {width:bitmap.width, height:bitmap.height};
                var isFHD:Boolean = bitmap.width/bitmap.height>=FHDRatio;
                var _cropCoef : Number = isFHD ? 0.05 : 0;//
                var w :Number = bitmap.width;
                var h :Number = bitmap.height;
                bitmap = ImageUtils.cropBMP(bitmap,w*_cropCoef, h*_cropCoef, w * (1-2*_cropCoef), h * (1-2*_cropCoef));
                bitmap = new Bitmap(ImageUtils.scaleBitmapData(bitmap.bitmapData, 0.5));
                return bitmap;
        }
        bitmap = new Bitmap(ImageUtils.scaleBitmapData(bitmap.bitmapData, 0.5));
        return bitmap;
    }

    public function setParent(container : TimelineFeedImageHolder, width : Number, height : Number, autoSize : Function, bottomBarHeight:Number = 0) : void{
        if(container.feed && container.feed != this) {
            container.feed.dispose();
            container.removeChildren();
        } else if(container.feed && container.feed == this && _isLoaded) {
            return;
        }

        container.setFeed(this);

        _width = width;
        _height = height ? height : _height;
        _bottomBarHeight = bottomBarHeight;
        _parent = container;
        _autosize = autoSize;
        if(_isLoaded) {
            for (var i : int = 0; i < _texture.length; i ++){
                addImage(i);
            }
            _autosize();
        } else if (!_texture) {
            switch (feedType) {
                case TYPE_TUNING_LIKE:
                case TYPE_TUNING_COMMENT:
                case TYPE_NEW_TUNING:
                case TYPE_CHALLENGE_WIN:
                    loadImage(tuning.fullHdSnapshots[0]);
                    break;
                case TYPE_TEXT_AND_IMAGES:
                    loadImage(ArrayUtils.clone(postImages));
                    break;
            }
        }
    }

    public function loadImage(image:*) : void {
        if(!_loadQueue) {
            _loadQueue = [];
            _texture = [];
        }
        if(image is String){
            _loadQueue.push(image);
        } else if(image is Array){
            ArrayUtils.addAll(_loadQueue , image);
        }
        loadNext();
    }

    public function loadNext() : void{
        var url : String = _loadQueue.shift();
        if(url && !_isLoaded) {
            if(url.indexOf("http") == - 1) url = "http:" + url;

            _loader = new Loader();
            _loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
            _loader.contentLoaderInfo.addEventListener(Event.COMPLETE,onLoadComplete);
            _loader.load(new URLRequest(url));
        }
        else if(_loadQueue.length){
            loadNext();
        }
        else{
            _isLoaded = true;
        }

    }

    protected function onIOErrorHandler(event:IOErrorEvent):void {
        _loader.contentLoaderInfo.removeEventListener(Event.COMPLETE,onLoadComplete);
        _loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
        _loader= null;
    }

    protected function addImage(index : int):void {
        var image : Image = new Image(_texture[index]);
        var h : Number;

        switch (feedType) {
            case TYPE_TUNING_LIKE:
            case TYPE_TUNING_COMMENT:
            case TYPE_NEW_TUNING:
            case TYPE_CHALLENGE_WIN:
                h = _height;
                image.width = _parent.stage?_parent.stage.stageWidth:_width;
                break;
            case TYPE_TEXT_AND_IMAGES:
                h = _width * _texture[index].height / _texture[index].width;
                image.width = _width;
                break;
        }
        image.scale = image.scaleX;
        if(!_parent.stage)
            return;
        _parent.height = NaN;
        _parent.addChild(image);
        var cropX:Number = 0;
        var cropY:Number = 0;
        if(image.texture.frameWidth < 1920 && image.texture.frameHeight < 1080 && feedType != TYPE_TEXT_AND_IMAGES){
            image.width = image.texture.frameWidth;
            image.height = image.texture.frameHeight;
            if(image.texture.frameWidth > 1440){
                cropX = (image.texture.frameWidth - 1440) / 2;
            }

            if(image.texture.frameHeight > 900){
                cropY = (image.texture.frameHeight - 900) / 2;
            }

            if(cropX || cropY){
                var pr:DisplayObjectContainer = image.parent;
                image = TextureUtil.cropImage2(image, cropY, cropY, cropX, cropX);
                pr.addChild(image);
            }

            if(image.width/image.height>_width/_height){
                image.width = _width;
                image.scale = image.scaleX;
            }else{
                image.height = _height;
                image.scale = image.scaleY;
            }
            image.x = 0;
        }else {
            if(feedType != TYPE_TEXT_AND_IMAGES){
                image.width = image.texture.frameWidth;
                image.height = image.texture.frameHeight;
                if(image.width/image.height>_width/_height){
                    image.width = _width;
                    image.scale = image.scaleX;
                }else{
                    image.height = _height;
                    image.scale = image.scaleY;
                }
            }else {
                if (_height && _height < image.height) {
                    var dx:Number = -(_width - image.width) / 2;
                    var dy:Number = -(_height - image.height) / 2;
                    TextureUtil.cropImage(image, dy, dy, dx, dx);
                    image.x = image.y = 0;
                } else {
                    image.width = _width;
                    image.scale = image.scaleX;
                    image.x = image.y = 0;
                }
            }
        }
        /*holder.height = NaN;*/
        //holder.invalidateLikeCommentsViews(true);
    }

    public  function onLoadComplete(event:Event) : void{
        var bitmap : Bitmap= event.currentTarget.loader.content as Bitmap;
        bitmap = bitmapProcessing(bitmap);
        _texture.push(Texture.fromBitmap(bitmap, false, false, 0.5));
        var isSnippetImage:Boolean = false;
        if(metadataList){
            for(var i:int = 0; i < metadataList.length; i++){
                if(event.currentTarget.url == metadataList[i].meta.image){
                    isSnippetImage = true;
                    break;
                }
            }
        }
        if(_parent){
            if(isSnippetImage && holder is FeedTextItemRenderer && FeedTextItemRenderer(holder).snippet){
                FeedTextItemRenderer(holder).snippet.addImage(_texture[_texture.length-1]);
                FeedTextItemRenderer(holder).height = NaN;
                FeedTextItemRenderer(holder).invalidate();
            }else{
                addImage(_texture.length-1);
                _autosize();
                _height = _parent.height;
            }
        }

        _loader.contentLoaderInfo.removeEventListener(Event.COMPLETE,onLoadComplete);
        _loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
        _loader= null;

        if(_loadQueue.length){
            loadNext();
        }else {
            _isLoaded = true;
        }
        if(feedType == TYPE_TEXT_AND_IMAGES || _isLoaded){
            if(holder){
                holder.invalidateDataContainer();
                holder.invalidateItem();
            }
        }
    }

    public function dispose():void {
        if(_texture){
            for each(var t : Texture in _texture){
                if(t){
                    t.dispose();
                }
            }
        }
        if (_loader) {
            _loader.contentLoaderInfo.removeEventListener(Event.COMPLETE,onLoadComplete);
            _loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
            _loader= null;
        }
        _texture = null;
        _loadQueue = null;
        _isLoaded = false;
        _parent = null;
    }


    public static function set Proxy(proxy : TimelineProxy) : void{
        PROXY = proxy;
    }

    public static  function get Proxy() : TimelineProxy{
        return PROXY;
    }

    public function get height():Number {
        return _height;
    }

    public function get width():Number {
        return _width;
    }

    public function get sourceDimensions():Object {
        return _sourceDimensions;
    }

    private static function getUserName(user:User):String{
        return user.id == CURRENT_USER.id ? "I " : user.nameToShow;
    }
}
}