package com.despark.tuning3d.view.components.timeline.ItemRenderers {
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Abstract.ATimelineBaseItemRenderer;
import com.utils.DateParser;

import feathers.layout.FlowLayout;
import feathers.layout.VerticalLayout;

import flash.geom.Rectangle;

import starling.display.Image;

public class FeedNewFriendItemRenderer extends ATimelineBaseItemRenderer{
    public function FeedNewFriendItemRenderer() {
        super();
    }

    protected override function commitData():void {
        super.commitData();
        update();
    }


    override protected function initialize():void {
        super.initialize();
        _border = new Image(ButtonFactory.assetManager.getTexture('timeline_feed_border'));
        _border.scale9Grid = new Rectangle(_border.texture.frameWidth / 3, _border.texture.frameHeight / 3, _border.texture.frameWidth / 3, _border.texture.frameHeight / 3);
        _feedTitleGroup.backgroundSkin = _border;
    }

    protected override function update() : void {
        if (!feedData) return;

        _nameLabel["text"] = feedData.nameLabel;
        _nameLabel.visible = true;

        _descriptionLabel["text"] = feedData.descriptionLabel;
        _descriptionLabel.visible = true;

        _friendNameLabel["text"] = feedData.friendLabel; //newFriend.nameToShow;
        _friendNameLabel.visible = true;

        _dateLabel.text = DateParser.getDateAppropriateText(feedData.availableDate);
        _dateLabel.visible = true;

        FlowLayout(_feedTitleGroup.layout).paddingLeft = FlowLayout(_feedTitleGroup.layout).paddingRight = 10;
        FlowLayout(_feedTitleGroup.layout).paddingTop = FlowLayout(_feedTitleGroup.layout).paddingBottom = 12;
        VerticalLayout(_mainContainer.layout).paddingTop = 2;
        VerticalLayout(_stageGroup.layout).paddingTop = VerticalLayout(_stageGroup.layout).paddingBottom = _gap;
        //
        invalidateItem();
    }

    override protected function initIcon() : void{
        _postIcon = new Image(iconsMap[FeedData.TYPE_NEW_FRIEND]);
        layoutIcon();
    }
}
}
