package com.despark.tuning3d.view.components.timeline.ItemRenderers {
    import com.despark.tuning3d.view.components.timeline.FeedData;
    import com.despark.tuning3d.view.components.timeline.components.TimelineFeedImageHolder;

    import feathers.layout.VerticalLayout;

    import starling.display.Image;

    public class FeedTextImagesItemRenderer extends FeedTextItemRenderer{

    private var _imagesContainer:TimelineFeedImageHolder;

    public function FeedTextImagesItemRenderer() {
    }

    override protected function initAllComponents():void {
        super.initAllComponents();

        var layout : VerticalLayout = new VerticalLayout();
        layout.gap = 2;

        _imagesContainer = new TimelineFeedImageHolder();
        _imagesContainer.layout = layout;
        _dataContainer.addChild(_imagesContainer);

        VerticalLayout(_dataContainer.layout).paddingBottom = _gap;
    }


    override protected function update():void {
        if(!feedData) {
            return;
        }
        super .update();
        loadPostImages();
    }

    public function loadPostImages() : void {
        var w : Number = contentWidth;
        var h : Number = 0;
        feedData.setParent(_imagesContainer, w, h, customAutosize);
    }

    override protected function customAutosize():void {
        _imagesContainer.height = NaN;
        _imagesContainer.validate();

        _dataContainer.height = NaN;
        _dataContainer.validate();

        super.customAutosize();

        invalidateItem();
    }

    override public function dispose():void {
        super.dispose();
        _imagesContainer.removeFromParent(true);
        _imagesContainer = null;
    }

    override protected function initIcon() : void{
        _postIcon = new Image(iconsMap[FeedData.TYPE_NEW_TUNING]);
        layoutIcon();
    }
}
}
