/**
 * Created by Armen on 8/9/2017.
 */
package com.despark.tuning3d.view.components.timeline.ItemRenderers.Likes
{
import com.despark.tuning3d.view.components.timeline.*;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Likes.LikeData;
import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;

import feathers.controls.Label;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;

public class LikeRenderer extends ListItemRenderer
    {

        private var _nameLabel:Label;

        public function LikeRenderer() {}

        private function get likeData() : LikeData{
			
			if(!_data) return null;
			
             return new LikeData(_data);
        }

        private var _eventDispatcher : *;
        public function set eventDispatcher(value:*) : void{
            _eventDispatcher = value;
        }
        public function get eventDispatcher() : *{
            return _eventDispatcher;
        }

        override protected function initialize():void {
            super.initialize();

            _nameLabel = new Label();
            _nameLabel.textRendererFactory = TimelineLabelFactory.likeNameLabelRenderer;
            _nameLabel.addEventListener(TouchEvent.TOUCH,onGarageSelectHandler);
            _nameLabel.paddingLeft = 4;
            _nameLabel.paddingTop = 1.5;
            addChild(_nameLabel);
            _nameLabel.validate();
        }

        private function onGarageSelectHandler(event:TouchEvent) : void {
            var touch : Touch= event.touches[0] as Touch;
            if (touch.phase == TouchPhase.ENDED && !this.owner.isScrolling){
                Constants.selectedUser = new User();
                Constants.selectedUser.id = likeData.owner.id;
                Constants.selectedUser.name = likeData.nameToShow;

                eventDispatcher.checkForUserAndDispatch();
            }
        }

        override protected function commitData():void {
            super.commitData();
            update();
        }

        private function update() : void {
            if (likeData){
                _nameLabel.text = likeData.nameToShow;
                setHeight();
                _nameLabel.validate();
            }
        }

        private function setHeight() : void {
            _nameLabel.height = actualHeight;
        }

        override public function dispose():void {
            super.dispose();

            if (_nameLabel){
                _nameLabel.removeEventListener(TouchEvent.TOUCH,onGarageSelectHandler);
                _nameLabel.removeFromParent(true);
                _nameLabel = null;
            }
        }

        override protected function draw():void {
            super.draw();
            if(isInvalid(INVALIDATION_FLAG_SIZE)) {
                update();
            }
        }
    }
}
