package com.despark.tuning3d.view.components.timeline.TimelineGarage
{
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.core.http.HttpClient;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.timeline.*;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentInput;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.GarageCommentItemRenderer;
import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;
import com.despark.tuning3d.view.components.timeline.components.TimelineLoadBar;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.ScrollBar;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.data.ListCollection;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;
import feathers.layout.Direction;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.utils.AssetManager;

public class CommentPopupList extends  LayoutGroup
	{
		public static var assetManager : AssetManager;

        private static var topHeight : int = 20;
        private static var bottomHeight : int = 47;
        private static var horizontalPadding : int = 6;
        private static var minimizeWidth : int;


        private var _parentActualWidth:Number;
        private var _parentActualHeight:Number;

		public var isOpened : Boolean = false;
		
		private var completeShowCallback : Function = null;
        private var _itemContainer:List;

        private var _comments : Array;

        private var _inputComment:WriteComment;

        private var _currentTuningID : String;
        private var _headerContainer:LayoutGroup;
        private var _bottomContainer:LayoutGroup;

        private var _maxMinButton:ToggleButton;
        private var _closeButton:Button;
        private var _commentLabel:Label;
        private var _loadBar:TimelineLoadBar;

        public function set currentTuningID(value:String) : void{
            _currentTuningID = value;
        }
        public function get currentTuningID() : String{
            return _currentTuningID;
        }

		public  function CommentPopupList(){
			super();
			this.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}

        public function addMoreComments (value : Array) : void {
            for(var i : int = 0 ; i < value.length; i++){
                _comments.push(value[i]);
            }
            _itemContainer.invalidate();
            updateCommentLabel();
        }

        public function updateCommentLabel() : void{
            if(_commentLabel) {
                if(_comments) {
                    _commentLabel.text = "Comments (" + _comments.length + ")";
                }else{
                    _commentLabel.text = "Comments (0)";
                }
            }
        }

        public function set comments(value:Array) : void{
            _comments = value;
            updateCommentLabel();
            Starling.juggler.delayCall(updateList,.2);
        }

        public function clear():void{
            _comments = [];
            if(_itemContainer) {
                _itemContainer.dataProvider = new ListCollection([]);
            }
        }

        private function updateList() : void {
            if(_itemContainer){
                _itemContainer.dataProvider = new ListCollection(_comments);
                if(!_itemContainer.hasEventListener(Event.SCROLL)){
                    _itemContainer.addEventListener(Event.SCROLL, scrollHandler);
                }

                if(_itemContainer.maxVerticalScrollPosition == 0 && _comments.length <= 3){
                    dispatchEventWith(FeedData.COMMENT_MORE);
                }
            }
        }

		private function onAddedToStage(event:Event):void {
            if (_comments){
                _itemContainer.dataProvider = new ListCollection(_comments);
                _itemContainer.verticalScrollPosition = _itemContainer.maxVerticalScrollPosition;
            }
            this.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			hide();
		}

        public function set parentActualWidth(value:Number):void{
            _parentActualWidth = value;
        }
        public function get parentActualWidth() : Number{
            return _parentActualWidth;
        }

        public function set parentActualHeight(value:Number):void{
            _parentActualHeight = value;
        }
        public function get parentActualHeight():Number{
            return _parentActualHeight;
        }

		public function hide(animation:Boolean=false):void
		{
			var target :* = this;
			if (animation)
			{
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
					tween.moveTo(parentActualWidth+actualWidth,this.y);
					tween.onComplete = completeHide;
				Starling.juggler.add(tween);
			}
			else
			{
				target.x = parentActualWidth+actualWidth;
				completeHide();
			}
		}
		
		private function completeHide() : void
		{
			dispatchEventWith(Event.CLOSE);    
			isOpened = false;
		}
		
		public function show(animation:Boolean=false, complete:Function=null):void
		{
			completeShowCallback = complete;
			
			var target :* = this;
			
			if (animation)
			{
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
				tween.moveTo(parentActualWidth-actualWidth,this.y);
				tween.onComplete = completeShow;
				Starling.juggler.add(tween);
			}
			else
			{
				target.x = parentActualWidth-actualWidth;
				completeShow();
			}
		}
		
		private function completeShow():void
		{
			dispatchEventWith(Event.OPEN);
			
			if (completeShowCallback) {
				completeShowCallback();
				completeShowCallback = null;
			}
			isOpened = true;
		}

		protected override function initialize() : void
		{
            minimizeWidth = actualWidth;
            trace("Comments width " + actualWidth);

			super.initialize();
            this.layout = new AnchorLayout();

            this.backgroundSkin = new Quad(actualWidth,actualHeight,0xffffff);

            initHeaderContainer();
            initBottomContainer();
            initCommentsList();


		}

        private function initBottomContainer():void {

            var layData : AnchorLayoutData = new AnchorLayoutData();
            layData.bottom = 0;
            layData.left = 0;
            layData.right = 0;

            _bottomContainer = new LayoutGroup();
            _bottomContainer.layoutData = layData;
            _bottomContainer.layout = new AnchorLayout();
            _bottomContainer.height = bottomHeight;
            addChild(_bottomContainer);

            _inputComment = new WriteComment();
            _inputComment.layoutData = new AnchorLayoutData(5,horizontalPadding,5,horizontalPadding)
            _inputComment.user = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
            _bottomContainer.addChild(_inputComment);

            _inputComment.addEventListener(FeedData.COMMENT_SEND, sendCommentHandler);

        }

        private function initCommentsList():void {
            var layData : AnchorLayoutData = new AnchorLayoutData();
            layData.right = 0;
            layData.left = horizontalPadding;
            layData.topAnchorDisplayObject = _headerContainer;
            layData.top = 10;
            layData.bottomAnchorDisplayObject = _bottomContainer;
            layData.bottom = 0;


            var layout : VerticalLayout = new VerticalLayout();
            layout.gap = horizontalPadding;
            layout.hasVariableItemDimensions = true;
            layout.horizontalAlign = HorizontalAlign.LEFT;
            layout.verticalAlign = VerticalAlign.TOP;

            _itemContainer  = new List();
            _itemContainer.layout = layout;
            _itemContainer.layoutData = layData;
            _itemContainer.dataProvider = new ListCollection();
            _itemContainer.horizontalScrollPolicy = ScrollPolicy.OFF;
            _itemContainer.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
            _itemContainer.verticalScrollPolicy = ScrollPolicy.ON;
            _itemContainer.verticalScrollBarFactory = verticalScrollBarFactory;
            _itemContainer.itemRendererFactory = commentItemRendererFactory;
            _itemContainer.setSize(actualWidth, actualHeight - topHeight - bottomHeight)
            addChild(_itemContainer);
        }

        private function initHeaderContainer():void {
            var headLayData : AnchorLayoutData = new AnchorLayoutData();
            headLayData.top = 0;
            headLayData.left = 0;
            headLayData.right = 0;

            _headerContainer = new LayoutGroup();
            _headerContainer.layoutData = headLayData;
            _headerContainer.layout = new AnchorLayout();
            _headerContainer.height = topHeight;
            _headerContainer.backgroundSkin = new Quad(1, 1, 0x363636);
            this.addChild(_headerContainer);

            var buttonsLayout : HorizontalLayout = new HorizontalLayout();
            buttonsLayout.gap = 12;
            buttonsLayout.verticalAlign = VerticalAlign.MIDDLE;
            var buttonsLayData : AnchorLayoutData = new AnchorLayoutData();
            buttonsLayData.right = horizontalPadding;
            buttonsLayData.verticalCenter = 0;

            var buttonsContainer : LayoutGroup = new LayoutGroup();
            buttonsContainer.layout = buttonsLayout;
            buttonsContainer.layoutData = buttonsLayData;
            _headerContainer.addChild(buttonsContainer);

            _maxMinButton = ButtonFactory.maxMinButton(12);
            _maxMinButton.addEventListener(Event.CHANGE, maxMinHandler);
            _maxMinButton.setSize(12,12);
            buttonsContainer.addChild(_maxMinButton);
            _maxMinButton.validate();

            buttonsContainer.addChild(new Quad(1, _maxMinButton.height , 0xffffff));

            _closeButton = ButtonFactory.popupCloseButton(10,10);
            _closeButton.setSize(10,10);
            _closeButton.addEventListener(Event.TRIGGERED, closeButtonHandler);
            buttonsContainer.addChild(_closeButton);

            var labelLayData : AnchorLayoutData = new AnchorLayoutData();
            labelLayData.verticalCenter = 0;
            labelLayData.left = horizontalPadding;

            _commentLabel = new Label();
            _commentLabel.textRendererFactory = TimelineLabelFactory.customLabelRenderer(TimelineLabelFactory.COLOR_TEXT_WHITE, false, 10);
            _commentLabel.text = "Comments(19)";
            _commentLabel.layoutData = labelLayData;
            _headerContainer.addChild(_commentLabel);

            updateCommentLabel();

        }

        private function closeButtonHandler(event:Event):void {
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            hide(true);

        }

        private function maxMinHandler(event:Event):void {
            if(_maxMinButton.isSelected) // means need to maximize
            {
                SoundManager.playSound(SoundManager.SELECT_PART_BACK);
                this.setSize(stage.stageWidth, stage.stageHeight);
            }else { // need to minimize
                SoundManager.playSound(SoundManager.SELECT_PART);
                this.setSize(minimizeWidth, stage.stageHeight);

            }

            _itemContainer.itemRendererProperties.width = actualWidth - 2*horizontalPadding;
            show(false);
        }

        private function cancelCommentHandler(event:Event):void {
            _inputComment.deactivate();
        }

        private function sendCommentHandler(event:Event):void
        {
            SoundManager.playSound(SoundManager.SELECT_PART);
            _inputComment.deactivate();
            addComment(_currentTuningID,event.data as String);
            dispatchEvent(new Event(CommentInput.COMMENT_ADDED));
        }

        public var httpClient : HttpClient;

        public function addComment(tuningId:String,text:String) : void {
            var tuningsProxy : TuningsProxy = ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
            tuningsProxy.addTuningComment(tuningId, text, function(json:Object):void{
                var comment : CommentData = new CommentData(json.comment);
                _comments.unshift(comment);
                _itemContainer.scrollToDisplayIndex(0);
                _itemContainer.invalidate(INVALIDATION_FLAG_DATA);
                updateCommentLabel();
            });
        }

        private function verticalScrollBarFactory() : ScrollBar
        {
            var scrollbar:ScrollBar = new ScrollBar();
            scrollbar.direction = Direction.VERTICAL;
            scrollbar.thumbFactory = function() : Button
            {
                var button : Button = new Button();
                var sprite : Sprite = new Sprite();
                var back : Quad = new Quad(8, 25, 0xffffff);
                back.alpha = 0;
                var quad : Quad = new Quad(4, 25, 0x555657);
                quad.x = 2;
				sprite.addChild(back);
                sprite.addChild(quad);
                button.defaultSkin = sprite;
                return button;
            };
            return scrollbar;
        }

        private function commentItemRendererFactory() : IListItemRenderer
        {
            var renderer : GarageCommentItemRenderer = new GarageCommentItemRenderer();
            renderer.setSize(actualWidth - 2*horizontalPadding, NaN);
            renderer.eventDispatcher = this;
            return renderer;
        }


		public function toggle(value:Boolean=true):void{
			isOpened ? hide(value) : show(value);
		}

		override protected function draw() : void
		{
			super.draw();
			
			if (isInvalid(INVALIDATION_FLAG_SIZE))
			{
            }
		}

        private function scrollHandler(e : Event) : void {
            if(_itemContainer && _itemContainer.verticalScrollPosition == _itemContainer.maxVerticalScrollPosition  && _itemContainer.dataProvider.length >= 3 && _itemContainer.maxVerticalScrollPosition > 10) // 3 is the number of comments, that by default are coming from server
            {
                // Removing event listener in order to prevent a lot of "MORE_COMMENT" dispatch
                _itemContainer.removeEventListener(Event.SCROLL, scrollHandler);
                Starling.juggler.delayCall(function () : void {
                    if(_itemContainer && !_itemContainer.hasEventListener(Event.SCROLL))
                    {
                        _itemContainer.addEventListener(Event.SCROLL, scrollHandler);
                    }
                }, 1);
                dispatchEventWith(FeedData.COMMENT_MORE);

            }
        }

		override  public  function dispose() : void
		{
            super.dispose();

            if(_maxMinButton)
            {
                _maxMinButton.removeEventListener(Event.CHANGE, maxMinHandler);
                _maxMinButton.removeFromParent(true);
                _maxMinButton = null;
            }

            if(_closeButton)
            {
                _closeButton.removeEventListener(Event.TRIGGERED, closeButtonHandler);
                _closeButton.removeFromParent(true);
                _closeButton = null;
            }


            if(_headerContainer)
            {
                _headerContainer.removeFromParent(true);
                _headerContainer = null;
            }

            if(_itemContainer)
            {
                _itemContainer.removeEventListener(Event.SCROLL, scrollHandler);
                _itemContainer.dispose();
                _itemContainer = null;

            }

            if (_inputComment) {
                _inputComment.removeEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
                _inputComment.removeEventListener(FeedData.COMMENT_CANCEL, cancelCommentHandler);
                _inputComment.removeFromParent(true);
            }
		}

        public function showLoader():void {
            _loadBar ||= new TimelineLoadBar();
            addChild(_loadBar);
            _loadBar.setSize(actualWidth, actualHeight);
        }

        public function hideLoader():void {
            if(_loadBar){
                _loadBar.removeFromParent();
            }
        }
    }
}


