package com.despark.tuning3d.view.components.timeline.TimelineGarage {
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedTextImagesItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedTextItemRenderer;

import feathers.controls.List;

import feathers.controls.renderers.IListItemRenderer;
import feathers.data.ListCollection;

import starling.display.Image;
import starling.events.Event;

public class TimelineFeedViewPopup extends PopUp {
    private var _feedData:FeedData;
    private var _feedView:List;
    public function TimelineFeedViewPopup(data:Object) {
        super();
        _feedView = new List();
        _feedData = data.feed;
        if(_feedData.feedType == FeedData.TYPE_TEXT || _feedData.feedType == FeedData.TYPE_POST_LIKE || _feedData.feedType == FeedData.TYPE_POST_COMMENT) {
            _feedView.itemRendererFactory = textFeedItemRendererFactory;
        }else{
            _feedView.itemRendererFactory = textAndImageFeedItemRendererFactory;
        }
        _feedView.addEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
        _feedView.dataProvider = new ListCollection([_feedData]);
    }

    override protected function initialize():void {
        super.initialize();
        setSizeInternal(this.stage.stageWidth*1, this.stage.stageHeight,false);
        background.color = 0xFFFFFF;
        background.alpha = 1;
        contentBackgroundImage.visible = false;
        addChild(_feedView);
        addChild(closeButton);
        closeButton.defaultSkin = new Image(ButtonFactory.assetManager.getTexture('garage_close'));
        closeButton.setSize(20, 20);
    }

    override protected function draw():void {
        super.draw();
        if(_feedView){
            _feedView.setSize(actualWidth, actualHeight);
}
        if(closeButton){
            closeButton.x = actualWidth - 10-closeButton.width;
            closeButton.y = 10;
        }
    }

    private function sendCommentHandler(event:Event):void {
        this.dispatchEventWith(FeedData.COMMENT_SEND, false, event.data);
    }

    private function textFeedItemRendererFactory() : IListItemRenderer {
        var renderer :FeedTextItemRenderer = new FeedTextItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedView.width-_feedView.paddingLeft - _feedView.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }

    private function textAndImageFeedItemRendererFactory() : IListItemRenderer {
        var renderer :FeedTextImagesItemRenderer = new FeedTextImagesItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedView.width-_feedView.paddingLeft - _feedView.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }
}
}
