/**
 * Created by Render-2 on 8/10/2017.
 */
package com.despark.tuning3d.view.components.timeline.TimelineGarage
{
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.friend.Friend;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeViewUserLabel;
import com.despark.tuning3d.view.components.timeline.*;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.tunings.ITuningListMenuVIew;
import com.despark.tuning3d.view.components.tunings.TuningsListMenuView;
import com.utils.StageUtil;

import feathers.controls.Button;
import feathers.controls.List;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.FeathersControl;
import feathers.data.ListCollection;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.VerticalAlign;

import flash.display.StageAspectRatio;

import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;

public class TimelineTuningView extends FeathersControl implements ITuningListMenuVIew
    {
        private var _slidesList:List;
        private var _snapshots : Array;
        private var _bg:Quad;
        private var closeButton:Button;
        public  var tuningsListMenuView : TuningsListMenuView;
        private var _params : Object;
        private var _owner  : *;
        private var pageIndicatorContainer : Sprite;
        private var _feedData : FeedData;
        private var _onClose:Function;
        private var _userLabel:ChallengeViewUserLabel;
        public function TimelineTuningView(params:Object) {
            super();
            if (params) {
                _params = params;
                _snapshots = _params.images;

                _feedData = params.feedData;
                Constants.selectedUser =_params.user;
            }
            onClose = null;
        }

		public function beginScreenShot(resultHandler : Function = null) : void
		{   
			this.closeButton.visible=false;
			this.pageIndicatorContainer.visible = false;
			this.tuningsListMenuView.visible=false;
			resultHandler();
		}
		
		public function get siteGarageLink():String{
			
			var car:Car = new Car();
			car.name = _params.tuning.car.make;
			car.model =  _params.tuning.car.model;
			car.year =  _params.tuning.car.year;
			car.type =  _params.tuning.car.type;
			
			return car.getSiteLinkGrage( _params.user.username, _params.tuning.shortId);
			
			
		}
		
		public function endScreenShot( ) : void
		{
			this.closeButton.visible=true;
			this.pageIndicatorContainer.visible = true;
			this.tuningsListMenuView.visible=true;
		}

        public function set owner(value:*) : void{
            _owner = value;
        }

        public function getCarFullName() : String
        {
            return _params.tuning.car.make + " " + _params.tuning.car.model + " " + _params.tuning.car.year;
        }

        override protected function initialize():void
        {
            super.initialize();

            _bg  = new Quad(1,1,0xffffff);
            addChild(_bg);
            _bg.alpha = 1;

            var layout : HorizontalLayout = new HorizontalLayout();
                //layout.manageVisibility = true; //tt
                layout.gap = 0;
                layout.horizontalAlign = HorizontalAlign.CENTER;
                layout.verticalAlign = VerticalAlign.MIDDLE;

            _slidesList = new List();
            _slidesList.minimumPageThrowVelocity = 1;
            _slidesList.dataProvider = new ListCollection();
            _slidesList.layout = layout;
            _slidesList.snapToPages = true;
            _slidesList.hasElasticEdges = false;
            _slidesList.scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
            _slidesList.horizontalScrollPolicy = ScrollPolicy.ON;
            _slidesList.addEventListener(Event.SCROLL, onCarIndexChanged);
            _slidesList.itemRendererFactory = itemRendererFactory;



            addChild(_slidesList);

            closeButton =  ButtonFactory.screenCloseButton();
            closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
            addChild(closeButton);



            tuningsListMenuView = new TuningsListMenuView(this);
            tuningsListMenuView.parentHeight = actualHeight;
            tuningsListMenuView.owner = this._owner;
            addChild(tuningsListMenuView);

            if (_params){
                if ( _params.tuning && _params.tuning._id){
                    tuningsListMenuView.currentTuningID = _params.tuning._id;
                    tuningsListMenuView.currentTuning = TuningsProxy.parseTuning(_params.tuning);
                }
                if (_params.tuning.car && _params.tuning.car._id){
                    tuningsListMenuView.currentCarID = _params.tuning.car._id
                }
                if(_params.data){
                    tuningsListMenuView.comments = (_params.data as Array);
                }
                if (_params.likes){
                    tuningsListMenuView.likes = (_params.likes as Array).length;
                }
                if (_params.iLiked){
                    tuningsListMenuView.iLiked = _params.iLiked;
                }
            }
            tuningsListMenuView.addEventListener(TuningsListMenuView.START_CHALLENGE, challengeHandler);
            tuningsListMenuView.setCarName();
            if(_feedData && _feedData.tuning){
                var user:Object;
                if(_feedData.tuning.user){
                    user = _feedData.tuning.user;
                }else if(_feedData.tuning.userObj){
                    user = _feedData.tuning.userObj;
                }
                if(user && _feedData.currentUser && _feedData.currentUser.id != user._id){
                    _userLabel = new ChallengeViewUserLabel(user);
                    _userLabel.x = _userLabel.y = 6;
                    addChild(_userLabel);
                }
            }
        }


        public function initPagingIcons() : void
        {
            if (!pageIndicatorContainer)
            {
                pageIndicatorContainer = new Sprite();
                addChild(pageIndicatorContainer);
            }

            if (pageIndicatorContainer.numChildren > 0)
            {
                var item  : Sprite;
                for (var i : int = 0; i < pageIndicatorContainer.numChildren; i++)
                {
                    item = (pageIndicatorContainer.getChildAt(i) as Sprite);

                    item.getChildAt(1).visible = false;
                    if(_slidesList.horizontalPageIndex == i){
                        item.getChildAt(1).visible = true;
                    }
                    item.x = i * 18;
                }
            }
            else
            {

                var stateContainer:Sprite;
                var state1Image : Image;
                var state2Image : Image;
                for (var ii:int = 0; ii < _slidesList.dataProvider.length; ii++)
                {
                    stateContainer = new Sprite();
                    state1Image = new Image(AlertView.assetManager.getTexture("pageIndicator"));
                    state2Image = new Image(AlertView.assetManager.getTexture("pageIndicatorSelected"));
                    state1Image.width = state1Image.height = 9;
                    state2Image.width = state2Image.height = 9;

                    stateContainer.addChild(state1Image);
                    stateContainer.addChild(state2Image);
                    if (ii != 0) stateContainer.getChildAt(1).visible = false;
                    stateContainer.x = ii * 15;
                    pageIndicatorContainer.addChild(stateContainer);
                }
            }
        }

        private function closeButtonTriggeredHandler(e:Event) :void
        {
            _params = null;
            tuningsListMenuView.removeFromParent(true);
            pageIndicatorContainer.removeFromParent(true);

            _slidesList.removeEventListener(Event.CHANGE, onCarIndexChanged);
            _slidesList.removeFromParent(true);

            Constants.selectedUser = null;

            this.removeFromParent(true);
            //StageUtil.setAspectRatio(StageAspectRatio.PORTRAIT);
            _onClose.call();
        }

        private function challengeHandler(event:Event):void{
            var user : User  = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
            var tuning:Tuning;
            if(_feedData && _feedData.tuning){
                tuning = TuningsProxy.parseTuning(_feedData.tuning);
            }else if(_params && _params.tuning){
                tuning = TuningsProxy.parseTuning(_params.tuning);
            }
            if(tuning) {
                var userId:String = (tuning.userObj.hasOwnProperty("_id")?tuning.userObj._id:tuning.userObj) as String;
                tuning = (userId == user.id)?tuning:null;
                var opponentUser:User = tuning?null:Constants.selectedUser;
                var data:Object = ChallengeEvent.getData(user, tuning, opponentUser, null);
                dispatchEvent(new Event(ChallengeEvent.CHALLENGE_REQUEST, false, data));
            }
        }


        private function onCarIndexChanged(event:Event) : void
        {
            if (!_slidesList.isScrolling){
                initPagingIcons();
            }
        }

        override protected function draw():void {
            super.draw();

            if(isInvalid(INVALIDATION_FLAG_SIZE)) {
                _bg.width =actualWidth;
                _bg.height=actualHeight;

                _slidesList.setSize(actualWidth, actualHeight);
                if (_slidesList.dataProvider.length == 0 && _snapshots.length > 0) {
                    _slidesList.dataProvider = new ListCollection(_snapshots);
                    initPagingIcons();
                }

                closeButton.y = 8;
                closeButton.x = actualWidth - closeButton.height - 8;

                tuningsListMenuView.width  = actualWidth;
                tuningsListMenuView.height = 50;
                tuningsListMenuView.y = actualHeight - tuningsListMenuView.height;

                if (pageIndicatorContainer) {
                    pageIndicatorContainer.x = (actualWidth - pageIndicatorContainer.width) / 2;
                    pageIndicatorContainer.y = tuningsListMenuView.y - pageIndicatorContainer.height - 9;
                }
            }
        }

        private function itemRendererFactory() : IListItemRenderer {
            var renderer :TimelineTuningViewItemRenderer = new TimelineTuningViewItemRenderer(_feedData.sourceDimensions);
            var item_w:Number=(actualWidth );
            var item_h:Number=(actualHeight);
            renderer.setSize(item_w, item_h);
            return renderer;
        }

        public function getVisibleTuningURL():String {
            return _snapshots[_slidesList.horizontalPageIndex];
        }

        public function set onClose(value:Function):void {
            if(value == null){
                _onClose = function (...args):void {

                };
                return;
            }
            _onClose = value;
        }
    }
}
