package com.despark.tuning3d.view.components.tunings {
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.friend.Friend;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
import com.despark.tuning3d.model.social.SocialStats;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.gallery.GalleryTuningPopup;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentInput;
import com.despark.tuning3d.view.components.timeline.TimelineGarage.CommentPopupList;
import com.despark.tuning3d.view.components.timeline.TimelineGarage.TimelineAddFriendButton;
import com.despark.tuning3d.view.components.timeline.TimelineScreen;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;
import com.utils.ImageUtils;

import feathers.controls.Button;
import feathers.controls.LayoutGroup;
import feathers.controls.ToggleButton;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
import feathers.core.ITextRenderer;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.HorizontalLayoutData;
import feathers.layout.VerticalAlign;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.utils.setTimeout;

import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
    import starling.events.EventDispatcher;
    import starling.filters.FragmentFilter;
import starling.filters.GlowFilter;
import starling.textures.Texture;

public class TuningsListMenuView extends FeathersControl implements Multilingual {
        public static const TUNING_SELECTED:String = 'TUNING_SELECTED';
        public static const CAR_SELECTED:String = 'CAR_SELECTED';
        public static const TUNING_DELETE:String = 'TUNING_DELETE';
        public static const TUNING_SHARE:String = 'TUNING_SHARE';
        public static const START_CHALLENGE:String = 'TuningsListMenuView:START_CHALLENGE';
        public static const POST_TO_TIMELINE:String = 'TuningsListMenuView:POST_TO_TIMELINE';
        public static const FILTER_SELECTED:String = 'TuningsListMenuView:FILTER_SELECTED';

        public static const LIKE_SELECTED:String = 'popupLikeSelected';
        public static const COMMENT_SELECTED:String = 'popupCommentSelected';
        public static const CHALLENGE_SELECTED:String = 'tuningsMenuChallengeSelected';



        private var _language:Language;
        private var _quad:Quad;

        private var _deleteButton:Button;
        private var _deleteNormal:Image;
        private var _deleteActive:Image;

        private var _editButton:Button;
        private var _startNewButton:Button;

        private var _carName:String;
        private var _deleteBackgroundImage:Image;
        private var _tuningDeletePrompt:TuningDeletePrompt;


        private var _currentTuningID:String;
        private var _currentTuning:Tuning;
        private var _isMoreCommentsLoading:Boolean = false;
        private var _isMaxNumberOfComments:Boolean = false;


        private var _carNameLabel:TuningNameLabel;
        // private var _carTypeLabel:TuningNameLabel;
        private var _selectedSocial:String = null;

        private var _owner:*;

        private var _parentHeight:Number;

        public var comments:Array = [];
        public var likes:int = 0;
        public var iLiked:Boolean = false;

        protected var _data:Object;
        private var commentPopupList:CommentPopupList;
        private var _cancelLabel:MultilingualButton;


    private var _holder:ITuningListMenuVIew;

        private static var gap:int = 14;
        private static var margin:int = 10;
        private var _currentCarID:String;

    //
        private var bottomGroup:LayoutGroup;
        /*private var vsStartGroup:LayoutGroup;
        private var socialGroup:LayoutGroup;
        private var commentGroup:LayoutGroup;*/
        // ***** vs group buttons *******
        private var _startButton:Button;
        private var _filterButton: Button;
        // ***** social buttons *********
        private var _twButton:Button;
        private var _instagramButton:Button;
        private var _vkButton:Button;
        private var _fbButton:Button;
        private var _postButton: Button;
        // ***** comment group **********
        private var _winChallengeIcon:Button;
        private var _likeButtonToggle:ToggleButton;
        private var _commentButton:Button;
        private var _addFriendButton:TimelineAddFriendButton;
        private var _requireLogin:Boolean = false;
        private var _deleteAvailable:Boolean = false;
    public function TuningsListMenuView(holder:ITuningListMenuVIew) {
            super();
            this._holder = holder;
        }
        public function set currentCarID(value:String):void {
            _currentCarID = value;
        }


    override protected function initialize():void {
        super.initialize();
        _quad = new Quad(1, 1, 0x000000);
        _quad.alpha = 0.65;
        addChild(_quad);

        _carNameLabel = new TuningNameLabel(true);
        addChild(_carNameLabel);
        _startButton = ButtonFactory.startButton();
        _startButton.addEventListener(Event.TRIGGERED, startButtonTriggeredHandler);
        _postButton = ButtonFactory.postToTimelineButton();
        _postButton.addEventListener(Event.TRIGGERED, postToTimelineHandler);

        _instagramButton = ButtonFactory.simpleButtonByTextureName('tuning_popup_share');
        _instagramButton.name = 'instagram';
        _instagramButton.width = 30;
        _instagramButton.height = 30;
        _instagramButton.addEventListener(Event.TRIGGERED, onSocialHandler);

        _vkButton = ButtonFactory.simpleButtonByTextureName('garage_vk');
        _vkButton.name = 'vk';
        _vkButton.width = 30;
        _vkButton.height = 30;
        _vkButton.addEventListener(Event.TRIGGERED, onSocialHandler);
        //addChild(_vkButton);

        _fbButton = ButtonFactory.simpleButtonByTextureName('garage_fb');
        _fbButton.name = 'fb';
        _fbButton.width = 30;
        _fbButton.height = 30;
        _fbButton.addEventListener(Event.TRIGGERED, onSocialHandler);



        var backgroundTexture:Texture = AlertView.assetManager.getTexture('a_effect_bg');
        _deleteBackgroundImage = new Image(backgroundTexture);
        _deleteBackgroundImage.visible = false;

        _likeButtonToggle = ButtonFactory.garageLikeButton();
        _likeButtonToggle.isSelected = iLiked;
        _likeButtonToggle.label = likes.toString();
        _likeButtonToggle.addEventListener(Event.CHANGE, onLikeHandler);

        _commentButton = ButtonFactory.simpleButtonByTextureName('garage_comment');
        _commentButton.labelFactory = function ():ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), 11, 0xFFFFFF);
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            textRenderer.textFormat.leftMargin = 0;
            textRenderer.textFormat.bold = true;
            textRenderer.embedFonts = true;
            return textRenderer;
        };
        _commentButton.setSize(60, 30);
        _commentButton.labelOffsetX = 12;
        _commentButton.addEventListener(Event.TRIGGERED, commentButtonTriggeredHandler);

        _winChallengeIcon = ButtonFactory.challengeWinCountButton();


        if (_currentTuning) {
            currentTuning = _currentTuning;
        }




        _tuningDeletePrompt = new TuningDeletePrompt();
        _tuningDeletePrompt.visible = false;

        _deleteButton = ButtonFactory.deleteButton();
        _deleteNormal = _deleteButton.defaultSkin as Image;
        _deleteActive = new Image(ButtonFactory.assetManager.getTexture('a_delete_bg_button_actv'));
        _deleteActive.scale = ButtonFactory.assetManager.scaleFactor / 2;
        _deleteButton.addEventListener(Event.TRIGGERED, Constants.selectedUser ? onLikeHandler : onDeleteHandler);
        addChild(_deleteButton);

        _editButton = ButtonFactory.editButton();
        _editButton.addEventListener(Event.TRIGGERED, editButtonTriggeredHandler);
        _editButton.visible = false;
        addChild(_editButton);

        _startNewButton = ButtonFactory.newTuningButton();
        _startNewButton.addEventListener(Event.TRIGGERED, startButtonTriggeredHandler);
        _startNewButton.visible = false;
        addChild(_startNewButton);

        _cancelLabel = new MultilingualButton();
        _cancelLabel.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 11, 0xFFFFFF);
        _cancelLabel.textFormat.align = TextFormatAlign.CENTER;
        _cancelLabel.textFormat.bold = false;
        _cancelLabel.paddingLeft = 5;
        _cancelLabel.paddingRight = 5;
        _cancelLabel.wordWrap = true;
        _cancelLabel.label = 'Cancel';

        var cancelImage:Image = new Image(ButtonFactory.assetManager.getTexture("cancel_button_bg"));
        cancelImage.scale9Grid = new Rectangle(cancelImage.texture.frameWidth/3, cancelImage.texture.frameHeight/3, cancelImage.texture.frameWidth/3, cancelImage.texture.frameHeight/3);
        cancelImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        _cancelLabel.defaultSkin = cancelImage;

        _cancelLabel.width = 60;
        _cancelLabel.height = 26.5;
        _cancelLabel.validate();

        _cancelLabel.updateWithLanguage(AlertView.language);
        _cancelLabel.addEventListener(Event.TRIGGERED, onDeleteCancel);
        _cancelLabel.visible = false;
        addChild(_cancelLabel);

        _tuningDeletePrompt.onChange = function():void{
            if(_tuningDeletePrompt.isSelected){
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
            if(_tuningDeletePrompt.isSelected){
                _deleteButton.defaultSkin = _deleteActive;
            }else{
                _deleteButton.defaultSkin = _deleteNormal;
            }
        };

        bottomGroup = new LayoutGroup();
        bottomGroup.layout = new HorizontalLayout();
        bottomGroup.addChild(_startButton);
        bottomGroup.addChild(createSeporator());

        // bottomGroup.addChild(_postButton);
        bottomGroup.addChild(_instagramButton);
        bottomGroup.addChild(_fbButton);
        bottomGroup.addChild(createSeporator());

        bottomGroup.addChild(_winChallengeIcon);
        bottomGroup.addChild(_likeButtonToggle);
        bottomGroup.addChild(_commentButton);
        addChild(bottomGroup);

        addChild(_deleteBackgroundImage);
        addChild(_tuningDeletePrompt);
        Starling.juggler.delayCall(updateVisibility, .1);


    }

    private function postToTimelineHandler(event:Event):void {
        _selectedSocial = "timeline";
        dispatchEvent(new Event(POST_TO_TIMELINE));
    }

        public function get currentCarID():String {
            return _currentCarID;
        }

        public function set currentTuningID(value:String):void {
            _currentTuningID = value;
        }

        public function get currentTuningID():String {
            return _currentTuningID;
        }

        public function set parentHeight(value:Number):void {
            _parentHeight = value;
        }

        public function updateWithLanguage(language:Language):void {
            _language = language;
        }

        public function set owner(value:*):void {
            _owner = value;
        }

        public function get owner():* {
            return _owner;
        }

        public function setCarName():void {
            if(_currentTuning && _currentTuning.car) {
                _carNameLabel.text = getTuningName();
                // _carTypeLabel.text = _currentTuning.car.type;
                _carNameLabel.invalidate(INVALIDATION_FLAG_SIZE);
                // _carTypeLabel.invalidate(INVALIDATION_FLAG_SIZE);
                Starling.juggler.delayCall(function():void{
                    updateLabelPositions();
                }, .03);
            }
        }

        public function get carName():String {
            return _carName;
        }

        public function enterNormalState():void {
            _deleteBackgroundImage.visible = false;
            if(_cancelLabel){
                _cancelLabel.visible = false;
            }
            if(_tuningDeletePrompt){
                _tuningDeletePrompt.visible = false;
                _tuningDeletePrompt.isSelected = false;
            }

            if(_editButton){
                _editButton.visible = false;
            }

            if(_startNewButton){
                _startNewButton.visible = false;
            }
        }

        public function enterDeleteState():void {
            _tuningDeletePrompt.height = actualHeight;
            _tuningDeletePrompt.onCancel = function():void{
                onDeleteCancel(null);
            };
            _deleteBackgroundImage.visible = true;
            _tuningDeletePrompt.visible = true;
            _cancelLabel.visible = true;
        }

        private function moreCommentsHandler(e:Event):void {
            httpClient = (ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy).httpClient;
            if (_isMoreCommentsLoading || _isMaxNumberOfComments) return;

            _isMoreCommentsLoading = true;
            commentPopupList.showLoader();
            var url:String = 'http://ratings.3dtuning.com/api/v1/tunings/' + _currentTuningID + '/comments';
            httpClient.getPath(url, {
                skip: comments.length,
                limit: 6,
                order: 1
            }, function (success:Boolean, result:Object):void {
                _isMoreCommentsLoading = false;
                commentPopupList.hideLoader();
                if (success) {
                    var cm:Array = JSONer.parse(result as String);
                    if (cm.length > 0) {
                        var commentsData:Array = [];
                        for (var i:int = 0; i < cm.length; i++) {
                            commentsData.push(new CommentData(cm[i]));
                        }
                        commentPopupList.addMoreComments(commentsData);
                    } else {
                        _isMaxNumberOfComments = true;
                    }
                } else {
                    Tracer.print('Failed to load more comments: ' + httpClient.lastErrorStatusCode, 'TuningsListMenuView');
                }

            });
        }

        private function commentAddedHandler(e:Event):void {
            _currentTuning.stats.comments++;
            _commentButton.label = _currentTuning.stats.comments.toString();
        }

        private function userDetailsSelectedHandler(e:Event):void {
            if(_holder is EventDispatcher){
                EventDispatcher(_holder).dispatchEventWith(e.type, false, e.data);
            }
        }


        private function initCommentInput():void {
            if (!commentPopupList) {
                commentPopupList = new CommentPopupList();
                commentPopupList.name = 'commentPopupList';
                commentPopupList.setSize(220, stage.stageHeight);
                commentPopupList.parentActualWidth = actualWidth;
                commentPopupList.parentActualHeight = stage.stageHeight;
                commentPopupList.y = 0;
                commentPopupList.addEventListener(FeedData.COMMENT_MORE, moreCommentsHandler);
                commentPopupList.addEventListener(CommentInput.COMMENT_ADDED, commentAddedHandler);
                commentPopupList.addEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);
                this.parent.addChild(commentPopupList);
            }
            comments = [];
            commentPopupList.currentTuningID = _currentTuningID;
            _isMoreCommentsLoading = _isMaxNumberOfComments = false;
            commentPopupList.clear();
            commentPopupList.comments = comments;
        }

        public function closeAll():void {
            if (commentPopupList && commentPopupList.isOpened) {
                commentPopupList.hide();
            }
        }

        override public function dispose():void {
            if (comments) {
                comments = null;
            }

            if (commentPopupList) {
                commentPopupList.removeFromParent(true);
                commentPopupList.removeEventListener(FeedData.COMMENT_MORE, moreCommentsHandler);
                commentPopupList = null;
            }

            if(_startButton) {
                _startButton.removeFromParent(true);
                _startButton = null;
            }
            if (_likeButtonToggle) {
                _likeButtonToggle.removeEventListener(Event.CHANGE, onLikeHandler);
                _likeButtonToggle.removeFromParent(true);
            }

            if (_deleteButton) {
                _deleteButton.removeEventListener(Event.TRIGGERED, onDeleteHandler);
                _deleteButton.removeFromParent(true);
            }

            if (_editButton) {
                _editButton.removeEventListeners();
                _editButton.removeFromParent(true);
            }

            if (_commentButton) {
                _commentButton.removeFromParent(true);
                _commentButton = null;
            }
            if (_winChallengeIcon) {
                _winChallengeIcon.removeFromParent(true);
                _winChallengeIcon = null;
            }

            if(_filterButton){
                _filterButton.removeFromParent(true);
                _filterButton = null;
            }

            if(_addFriendButton){
                _addFriendButton.removeFromParent(true);
                _addFriendButton = null;
            }

            if(_postButton){
                _postButton.removeFromParent(true);
                _postButton = null;
            }

            if(bottomGroup){
                bottomGroup.removeFromParent(true);
                bottomGroup = null;
            }

            if(_tuningDeletePrompt){
                _tuningDeletePrompt.removeFromParent(true);
                _tuningDeletePrompt = null;
            }

            super.dispose();
        }

        public function set initComments(value:Array):void {
            comments = value;
            initCommentInput();
        }


        private function onSocialHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            _selectedSocial = (event.currentTarget as Button).name;
            SharingProxy.TUNING_FOR_SHARE = _currentTuning;
            //if (Constants.selectedUser) {
                switch (selectedSocial) {
                    case 'fb':
                        var sharingFbProxy:SharingProxy = ApplicationFacade.getInstance().retrieveProxy(SharingProxy.NAME) as SharingProxy;
                        sharingFbProxy.prepare();
                        break;
                    case 'vk':
                        var sharingVkProxy:SharingVkProxy = ApplicationFacade.getInstance().retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
                        sharingVkProxy.prepare();
                        break;
                    case 'instagram':
                        var sharingInstagramProxy:SharingInstagramProxy = ApplicationFacade.getInstance().retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
                        sharingInstagramProxy.prepare();
                        break;
                    case 'tw':
                        AlertView.show('Нет твитер шаринга', 5);
                        break;
                }
            /*} else {
                dispatchEventWith(TUNING_SHARE);
            }*/
        }

        public function get selectedSocial():String {
            return _selectedSocial;
        }

        private function startButtonTriggeredHandler(event:Event):void {
            if(_editButton && event.currentTarget != _startNewButton){
                if(_currentTuning && _currentTuning.car && !_currentTuning.car.isEditable){
                    _editButton.isEnabled = false;
                    _editButton.alpha = 0.8;
                }
                if(_editButton.visible){
                    SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
                    _editButton.visible = false;
                    _startNewButton.visible = false;
                }else{
                    SoundManager.playSound(SoundManager.PART_MENU);
                    _editButton.x = _startButton.x;
                    _editButton.y = _startButton.y - (5 + _editButton.height);
                    _editButton.visible = true;

                    _startNewButton.x = _startButton.x;
                    _startNewButton.y = _editButton.y - _startNewButton.height - 5;
                    _startNewButton.visible = true;
                }
                return;
            }
            SoundManager.playSound(SoundManager.SELECT_PART);
            BlockerView.show();
            requestTuningScreen(displayTuningScreen, true);
        }

        private function displayTuningScreen():void{
            BlockerView.hide();
            var isEditing:Boolean = false;
            var params:Object = {isEditing: isEditing};
            if (!owner) {
                ImageUtils.clearAllTexture();
                dispatchEventWith(TUNING_SELECTED, false, params);
            } else {
                if (owner is TimelineScreen) {
                    (owner as TimelineScreen).currentCar = new Car();
                    (owner as TimelineScreen).currentCar.id = currentCarID;

                    TimelineScreen(owner).dispatchEventWith(TimelineScreen.CAR_SELECTED, false, params);
                    if(_holder && _holder is GalleryTuningPopup){
                        GalleryTuningPopup(_holder).close();
                    }
                } else if (owner is TuningsListScreen) {
                    dispatchEventWith(CAR_SELECTED, false, params);
                }else if (owner is BrandsScreen) {
                    BrandsScreen(owner).dispatchEventWith(BrandsScreen.SELECT_CAR, false, params);
                } else {
                    dispatchEventWith(TUNING_SELECTED, false, params);
                }
            }
        }

    protected function requestTuningScreen(callback:Function, showWarning:Boolean = false):void{
        /*if(UsersProxy.loggedInUser()){
            showInterstitial(callback);
            return;
        }*/

        if(showWarning){
            var textOfMessage:String = AlertView.language.translate("carchooserTop", "agreement_text");
            var title:String = AlertView.language.translate("carchooserTop", "agreement_title");
            var agree:String = AlertView.language.translate("carchooserTop", "agree");
            var disagree:String = AlertView.language.translate("carchooserTop", "disagree");
            if(!textOfMessage){
                textOfMessage = "Вы согласны с <u><a href=\"http://google.com\">лицензионным соглашением</a></u>?";
            }
            AlertViewHL.show(title,textOfMessage, agree,disagree, -1, false, function(yesSelected : Boolean) : void {
                if(yesSelected){
                    showInterstitial(callback);
                }else{
                    BlockerView.hide();
                }
            },  0x49cc46);
        }else{
            showInterstitial(callback);
        }
    }

    private function showInterstitial(callback:Function):void{
        if(AdsManager.ENABLED){
            AdsManager.$.requestInterstitial(function(success:Boolean):void{
                callback();
            });
        }else{
            callback();
        }
    }

        private function editButtonTriggeredHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            var params:Object = {isEditing: true};
            if (!owner) {
                ImageUtils.clearAllTexture();
                dispatchEventWith(TUNING_SELECTED, false, params);
            } else {
                if (owner is TimelineScreen) {
                    (owner as TimelineScreen).currentCar = new Car();
                    (owner as TimelineScreen).currentCar.id = currentCarID;

                    TimelineScreen(owner).dispatchEventWith(TimelineScreen.CAR_SELECTED, false, params);
                    if(_holder && _holder is GalleryTuningPopup){
                        GalleryTuningPopup(_holder).close();
                    }
                } else if (owner is TuningsListScreen) {
                    dispatchEventWith(CAR_SELECTED, false, params);
                }else if (owner is BrandsScreen) {
                    BrandsScreen(owner).dispatchEventWith(BrandsScreen.SELECT_CAR, false, params);
                } else {
                    dispatchEventWith(TUNING_SELECTED, false, params);
                }
            }
        }



        private function getTuningUserID():String{
            var result:String;
            if(_currentTuning && (_currentTuning.userObj || _currentTuning.tuningUserID)){
                if(_currentTuning.userObj){
                    if(_currentTuning.userObj is User){
                        result = User(_currentTuning.userObj).id;
                    }else if(_currentTuning.userObj is String){
                        result = _currentTuning.userObj as String;
                    }else if(_currentTuning.userObj is Object && _currentTuning.userObj.hasOwnProperty('_id')){
                        result = _currentTuning.userObj._id;
                    }
                }else if(_currentTuning.tuningUserID){
                    result = _currentTuning.tuningUserID;
                }
            }
            _currentTuning.tuningUserID ||= result;
            return result;
        }

        private function commentButtonTriggeredHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            if(_requireLogin){
                dispatchEvent(new Event(COMMENT_SELECTED));
            }else {
                initCommentInput();
                commentPopupList.show(true);
            }
        }

        override protected function draw():void {
            super.draw();
            var sizeInvalid:Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
            if(!_deleteAvailable){
                if(_deleteButton){
                    _deleteButton.removeFromParent(true);
                    _deleteButton = null;
                }
                if(Constants.selectedUser){
                    if(_editButton){
                        _editButton.removeFromParent(true);
                        _editButton = null;
                    }

                    if(_startNewButton){
                        _startNewButton.removeFromParent(true);
                        _startNewButton = null;
                    }
                }
            }else if(Constants.selectedUser){
                if(_deleteButton){
                    _deleteButton.removeFromParent(true);
                    _deleteButton = null;
                }

                if(_editButton){
                    _editButton.removeFromParent(true);
                    _editButton = null;
                }

                if(_startNewButton){
                    _startNewButton.removeFromParent(true);
                    _startNewButton = null;
                }
            }else if((!Constants.selectedUser && _deleteAvailable)){
                if(!_deleteButton){
                    _deleteButton = ButtonFactory.deleteButton();
                    _deleteButton.addEventListener(Event.TRIGGERED, Constants.selectedUser ? onLikeHandler : onDeleteHandler);
                    addChild(_deleteButton);
                }

                if(!_editButton){
                    _editButton = ButtonFactory.editButton();
                    _editButton.addEventListener(Event.TRIGGERED, editButtonTriggeredHandler);
                    _editButton.visible = false;
                    addChild(_editButton);
                }

                if(!_startNewButton){
                    _startNewButton = ButtonFactory.newTuningButton();
                    _startNewButton.addEventListener(Event.TRIGGERED, startButtonTriggeredHandler);
                    _startNewButton.visible = false;
                    addChild(_startNewButton);
                }
            }


            if (sizeInvalid) {
                updateVisibility();
            }

            if (bottomGroup && _currentTuning && ((bottomGroup.layout && HorizontalLayout(bottomGroup.layout).gap == 0) || !bottomGroup.layout) && actualWidth) {
                bottomGroup.validate();
                var mainGap:Number = (actualWidth - (2 * margin + bottomGroup.width)) / (bottomGroup.numChildren - 1);
                var mainLayout:HorizontalLayout = new HorizontalLayout();
                mainLayout.gap = mainGap;
                mainLayout.verticalAlign = VerticalAlign.MIDDLE;
                mainLayout.paddingLeft = mainLayout.paddingRight = margin;
                bottomGroup.maxWidth = actualWidth;
                bottomGroup.height = actualHeight;
                bottomGroup.layout = mainLayout;
            }
            updateLabelPositions();
        }

        public function updateLabelPositions():void{
            if(_carNameLabel/* && _carTypeLabel*/) {
                _carNameLabel.validate();
                // _carTypeLabel.validate();
                _carNameLabel.x = (actualWidth - _carNameLabel.width) / 2;
                // _carTypeLabel.x = (actualWidth - _carTypeLabel.width) / 2;
                _carNameLabel.visible = true;
                _carNameLabel.y = -y + margin;
                // _carTypeLabel.y = _carNameLabel.y + _carNameLabel.height;
                _carNameLabel.visible = _carNameLabel.visible;
            }
        }

        private function getTuningName():String{
            if(_currentTuning && _currentTuning.car){
                var year:String = _currentTuning.car.year.toString();
                return year.substr(year.length - 2) + "'"/*'”'*/+ ' ' + _currentTuning.car.name + ' ' + _currentTuning.car.model;
            }
            return '';
        }

        public function updateVisibility():void {
            _quad.width = actualWidth;
            _quad.height = actualHeight;

            if(_deleteBackgroundImage) {
                _deleteBackgroundImage.width = actualWidth;
                _deleteBackgroundImage.height = actualHeight;
            }

            if (_deleteButton) {
                _deleteButton.x = actualWidth - (_deleteButton.width + margin);
                _deleteButton.y = -(margin / 2 + _deleteButton.height);

                _editButton.x = _startButton?_startButton.x:0;
                _editButton.y = _deleteButton.y;


                if(_cancelLabel){
                    _cancelLabel.x = _deleteButton.x - _cancelLabel.width - 20;
                    _cancelLabel.y = _deleteButton.y;
                }
            }

            if(_tuningDeletePrompt){
                _tuningDeletePrompt.x = actualWidth - _tuningDeletePrompt.width;
            }

            setCarName();
        }


        public function open():void {
            this.visible = true;
        }

        public function close():void {
            this.visible = false;
        }

        private function createSeporator():Image {
            var seporatorTexture:Texture = AlertView.assetManager.getTexture('a_seporator_1');
            var seporatorImage:Image = new Image(seporatorTexture);
            seporatorImage.width = 1.5;
            seporatorImage.height = 34;

            return seporatorImage;
        }

        private function onDeleteCancel(event:Event):void {
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            enterNormalState();
        }


        private function onLikeHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            if(_requireLogin){
                if(_likeButtonToggle.isSelected) {
                    _likeButtonToggle.isSelected = false;
                    dispatchEvent(new Event(LIKE_SELECTED));
                }
            }else{
                iLiked = !iLiked;
                likeTuning(currentTuningID, iLiked);
            }
        }

        public var httpClient:HttpClient;

        public function likeTuning(id:String, iLiked:Boolean):void {
            var tuningsProxy : TuningsProxy = ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
            tuningsProxy.likeTuning(id, iLiked,
                    function():void{_log('Like success...');
                        if (_currentTuning) {
                            _currentTuning.stats.likes++;
                            _iLikedList[id] = true;
                            updateLikeLabel(true);
                        }
                        if (_owner is TimelineScreen) {
                            (_owner as TimelineScreen).likeSelectedTuning();
                        }
                    }, function():void{
                        updateLikeLabel(false);
                        _log('Like failed...');
                    }, function():void{
                        _log('UnLike success...');
                        if (_owner is TimelineScreen) {
                            (_owner as TimelineScreen).dislikeSelectedTuning();
                        }
                        if (_currentTuning) {
                            _currentTuning.stats.likes--;
                            _iLikedList[id] = false;
                            updateLikeLabel(false);
                        }
                    }, function():void{
                        updateLikeLabel(true);
                        _log('UnLike failed...');
                    });
            /*httpClient = (ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy).httpClient;
            var url:String = 'http://ratings.3dtuning.com/api/v1/tunings/' + id + '/ratings?activation=true';
            if (iLiked) {
                httpClient.postPath('', null, function (success:Boolean, result:Object):void {
                    if(result == "requestFailed"){
                        success = false;
                    }
                    if (success) {
                        _log('Like success...');
                        if (_currentTuning) {
                            _currentTuning.stats.likes++;
                            _iLikedList[id] = true;
                            updateLikeLabel(true);
                        }
                        if (_owner is TimelineScreen) {
                            (_owner as TimelineScreen).likeSelectedTuning();
                        }
                    } else {
                        updateLikeLabel(false);
                        _log('Like failed...');
                    }
                }, url);
            } else {
                httpClient.deletePath('', null, function (success:Boolean, result:Object):void {
                    if(result == "requestFailed"){
                        success = false;
                    }
                    if (success) {
                        _log('UnLike success...');
                        if (_owner is TimelineScreen) {
                            (_owner as TimelineScreen).dislikeSelectedTuning();
                        }
                        if (_currentTuning) {
                            _currentTuning.stats.likes--;
                            _iLikedList[id] = false;
                            updateLikeLabel(false);
                        }
                    } else {
                        updateLikeLabel(true);
                        _log('UnLike failed...');
                    }
                }, url);
            }*/
        }

        private function onDeleteHandler(event:Event):void {
            if (_deleteBackgroundImage.visible) {
                if(_tuningDeletePrompt.isSelected) {
                    SoundManager.playSound(SoundManager.SELECT_PART);
                    if (_tuningDeletePrompt.isCurrentFrame && _currentTuning.snapshots.length > 1) {
                        dispatchEventWith(TUNING_DELETE, false, {deleteFrame: true});
                    } else {
                        dispatchEventWith(TUNING_DELETE);
                    }
                    enterNormalState();
                }
            } else {
                SoundManager.playSound(SoundManager.PART_MENU);
                enterDeleteState();
            }
        }



        private function _log(msg:String):void {
            if (Constants.IS_DEBUG) {
                trace(msg);
            }
        }

        private var _iLikedList:Object = {};

        public function set currentTuning(value:Tuning):void {
            if(isInitialized) {
                var updateComments:Boolean = false;
                if (!_currentTuning || _currentTuning.id != value.id) {
                    getCounters(value);
                    if(commentPopupList && commentPopupList.isOpened){
                        updateComments = true;
                    }
                }

                _currentTuning = value;
                if(_currentTuning.stats && _currentTuning.stats.hasOwnProperty("likes")) {
                    likes = _currentTuning.stats.likes;
                    if (_likeButtonToggle) {
                        updateLikeLabel(_iLikedList[_currentTuning.id]);
                        if (!_iLikedList.hasOwnProperty(_currentTuning.id)) {
                            _iLikedList[_currentTuning.id] = false;
                            checkLike(_currentTuning.id);
                        }
                    }
                }

                if (_commentButton && _currentTuning.stats && _currentTuning.stats.hasOwnProperty("comments")) {
                    _commentButton.label = _currentTuning.stats.comments.toString();
                }

                if (_winChallengeIcon && _currentTuning.stats && _currentTuning.stats.hasOwnProperty("challangeWins")) {
                    _winChallengeIcon.label = _currentTuning.stats.challangeWins.toString();
                }

                if(updateComments){
                    commentPopupList.clear();
                    comments = [];
                    commentPopupList.comments = comments;
                }

                if(_currentTuning.hasDeletedComponents){
                    if(_startButton) {
                        _startButton.isEnabled = false;
                    }
                }
                var currentUser : User  = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
                var tuningUser:User;
                if(_currentTuning.userObj){
                    if(_currentTuning.userObj is User){
                        tuningUser = _currentTuning.userObj as User;
                    }else{
                        tuningUser = new User(_currentTuning.userObj);
                    }
                }
                var isCurrentTuning:Boolean = false;
                if(currentUser){
                    isCurrentTuning = ((_currentTuning.tuningUserID && currentUser.id==_currentTuning.tuningUserID) || (tuningUser.id == currentUser.id));
                }

                if (isCurrentTuning) {
                    if (!_filterButton) {
                        _filterButton = ButtonFactory.filterButton();
                        _filterButton.addEventListener(Event.TRIGGERED, filterButtonHandler);
                        bottomGroup.addChildAt(_filterButton, bottomGroup.getChildIndex(_startButton) + 1);
                        if(bottomGroup && bottomGroup.layout){
                            HorizontalLayout(bottomGroup.layout).gap = 0;
                        }
                    }
                } else if (!currentUser || (currentUser.id != tuningUser.id)) {
                    if (_postButton) {
                        _postButton.isEnabled = false;
                    }
                    if (!_addFriendButton) {
                        var friend:Friend = new Friend(Friend.STATE_NO_FRIEND, null);
                        friend.user = Constants.selectedUser;
                        if(friend.user) {
                            _addFriendButton = new TimelineAddFriendButton(friend);
                            _addFriendButton.setSize(30, 30);
                            bottomGroup.addChildAt(_addFriendButton, bottomGroup.getChildIndex(_startButton) + 1);
                        }
                        bottomGroup.addChildAt(createSeporator(), bottomGroup.getChildIndex(_startButton) + 1);
                        if(bottomGroup && bottomGroup.layout){
                            HorizontalLayout(bottomGroup.layout).gap = 0;
                        }
                    }
                }

                if (bottomGroup && HorizontalLayout(bottomGroup.layout).gap == 0 && actualWidth) {
                    bottomGroup.validate();
                    var mainGap:Number = (actualWidth - (2 * margin + bottomGroup.width)) / (bottomGroup.numChildren - 1);
                    var mainLayout:HorizontalLayout = new HorizontalLayout();
                    mainLayout.gap = mainGap;
                    mainLayout.verticalAlign = VerticalAlign.MIDDLE;
                    mainLayout.paddingLeft = mainLayout.paddingRight = margin;
                    bottomGroup.maxWidth = actualWidth;
                    bottomGroup.height = actualHeight;
                    bottomGroup.layout = mainLayout;
                }
                _startButton.isEnabled = !(_currentTuning && _currentTuning.car.wheelConfigurator) && (_currentTuning && _currentTuning.car && Car.HD_TYPES.indexOf(_currentTuning.car.carType) != -1);
            }else{
                resetCurrentTuning(value);
            }
        }

        private function resetCurrentTuning(value:Tuning):void{
            Starling.juggler.delayCall(function():void{
                if(isInitialized) {
                    currentTuning = value;
                    invalidate();
                }else{
                    resetCurrentTuning(value);
                }
            }, .03);
        }

        private function filterButtonHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            dispatchEvent(new Event(FILTER_SELECTED));
        }

        private function updateChallengeLabel(count:int):void {
            if(!_winChallengeIcon)
                return;
            if (count > 0) {
                _winChallengeIcon.label = count.toString();
            } else {
                _winChallengeIcon.label = count.toString();
            }
        }

        private function getCounters(tuning:Tuning):void {
            httpClient = (ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy).httpClient;
            var url:String = HttpClient.TUNING_DOMAIN + '/api/v1/tunings/' + tuning.id + '/counters';
            httpClient.getPath(url, null, function (success:Boolean, result:Object):void {
                if (success) {
                    var obj:Object = JSONer.parse(result.toString());
                    if (obj.challangeWins) {
                        updateChallengeLabel(obj.challangeWins);
                    } else {
                        updateChallengeLabel(0);
                    }
                    tuning.stats ||= new SocialStats();
                    tuning.stats.likes = likes = obj.likes;
                    tuning.stats.comments = obj.comments;
                    tuning.stats.challangesCount = obj.challangesCount;
                    tuning.stats.challangeWins = obj.challangeWins;
                    updateLabels();
                } else {
                    updateChallengeLabel(0);
                }
            });
        }

        private function updateLabels():void{
            if(_currentTuning && _currentTuning.stats) {
                if (_likeButtonToggle) {
                    _likeButtonToggle.label = (_currentTuning.stats.likes > 0 ? _currentTuning.stats.likes.toString() : '0');
                }
                if (_winChallengeIcon) {
                    _winChallengeIcon.label = (_currentTuning.stats.challangeWins > 0 ? _currentTuning.stats.challangeWins.toString() : '0');
                }
                if (_commentButton) {
                    _commentButton.label = (_currentTuning.stats.comments > 0 ? _currentTuning.stats.comments.toString() : '0');
                }
            }
        }

        public function checkLike(id:String):void {
            httpClient = (ApplicationFacade.getInstance().retrieveProxy(TuningsProxy.NAME) as TuningsProxy).httpClient;
            var url:String = 'http://ratings.3dtuning.com/api/v1/tunings/' + id + '/ratings';
            httpClient.getPath(url, null, function (success:Boolean, result:Object):void {
                if (success) {
                    var obj:Object = JSONer.parse(result.toString());
                    _iLikedList[_currentTuning.id] = obj.liked;
                    updateLikeLabel(obj.liked);
                } else {
                    updateLikeLabel(iLiked);
                }
            });
        }

        private function updateLikeLabel(iLike:Boolean):void {
            if (Math.abs(likes - _currentTuning.stats.likes) > 1) {
                if (likes > _currentTuning.stats.likes) {
                    _currentTuning.stats.likes = likes - 1;
                } else {
                    _currentTuning.stats.likes = likes + 1;
                }
            }
            _likeButtonToggle.label = (_currentTuning.stats.likes > 0 ? _currentTuning.stats.likes.toString() : '0');
            _likeButtonToggle.removeEventListener(Event.CHANGE, onLikeHandler);
            _likeButtonToggle.isSelected = iLiked = iLike;
            _likeButtonToggle.addEventListener(Event.CHANGE, onLikeHandler);
        }

    public function set requireLogin(value:Boolean):void {
        _requireLogin = value;
    }

    public function set deleteAvailable(value:Boolean):void {
        _deleteAvailable = value;
    }
}
}