package com.despark.tuning3d.view.components.tunings.colors
{
import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualCheck;
	import com.utils.FontSelector;

	import feathers.layout.RelativePosition;

	import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.DisplayObject;
import starling.display.Image;
import starling.display.Quad;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class PartColorButton extends MultilingualCheck {
		private var defaultBackgroundQuad:Quad;
		private var downBackgroundQuad:Quad;
		private var _downSkin:DisplayObject;
		private var assetManager:AssetManager;
		private var language:Language;
		private var _partSlot:PartSlot;

		public function PartColorButton() {
			assetManager=AlertView.assetManager;
			language=AlertView.language;
			
			super();
		}
		
		override protected function initialize():void{
			super.initialize();
			
			textFormat = new TextFormat(FontSelector.getFont(true), 7, 0xFFFFFF );
			textFormat.align = TextFormatAlign.CENTER;
			textFormat.bold = false;
			paddingLeft = paddingRight = 0;
			paddingTop = 0;
			wordWrap = true;
			label = "Body";
			updateWithLanguage(language);
			
			_defaultSkin = createDefaultSkin();
			_downSkin = createDownSkin();

			defaultSkin =_defaultSkin;
			downSkin =_downSkin;
			
			
			var defaultTexture:Texture=assetManager.getTexture("a_part_color");
			var defaultIconImg:Image = new Image(defaultTexture);
			defaultIconImg.width = 12;
			defaultIconImg.height = 13;
			defaultIconImg.color = 0xfefefe;

			defaultIcon = defaultIconImg;

			var selectedTexture:Texture=assetManager.getTexture("a_circle_button_bg");
			var selectedIconImg:Image = new Image(selectedTexture);
			selectedIconImg.width = 12;
			selectedIconImg.height = 12;
			selectedIconImg.color = 0xFFFFFE;

			defaultIcon = defaultIconImg;
			defaultSelectedIcon = selectedIconImg;


			iconPosition = RelativePosition.MANUAL;
			labelOffsetY = 10;
		}

		protected function createDefaultSkin():DisplayObject{
			defaultBackgroundQuad=new Quad(1,1, 0x000000);
			defaultBackgroundQuad.alpha=0;
			return defaultBackgroundQuad;
		}
		
		protected function createDownSkin():DisplayObject{
			downBackgroundQuad = new Quad(1,1, 0x000000);
			downBackgroundQuad.alpha = 0.3;
			return downBackgroundQuad;
		}
		
		override protected function draw():void{
			super.draw();
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			if(sizeInvalid){
				defaultBackgroundQuad.width = actualWidth;
				defaultBackgroundQuad.height = actualHeight;

				downBackgroundQuad.width = actualWidth;
				downBackgroundQuad.height = actualHeight;
			}

			if(defaultIcon){
				defaultIcon.x = (actualWidth - defaultIcon.width) / 2;
				defaultIcon.y = 12;
			}
			if(defaultSelectedIcon){
				defaultSelectedIcon.x = (actualWidth - defaultSelectedIcon.width) / 2;
				defaultSelectedIcon.y = 12.5;
			}
		}

	public function get partSlot():PartSlot {
		return _partSlot;
	}

	public function set partSlot(value:PartSlot):void {
		_partSlot = value;
	}
}
}


