package com.despark.tuning3d.view.components.tunings.editing
{
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.despark.tuning3d.view.components.core.PopUp;
import com.utils.FontSelector;

import feathers.controls.Button;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.core.Starling;
import starling.events.Event;

public class TuningStartSharingPopUp extends PopUp implements Multilingual
	{
		public static var ON_SELECTED_SOCIAL : String = "ON_SELECTED_SOCIAL";
		
		
		private var fbButton:Button;
		private var twButton:Button;
		private var vkButton:Button;
		private var instagramButton:Button;
		
		private var _socialId:String="";
		
		
		
		public function TuningStartSharingPopUp()
		{
			super();
				
			setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
			
			
			
		}
		
//		public function TuningSharingPopUp()
//		{
//			super();
//			if(!title)
//				title = "SHARE ON FACEBOOK";
//			setSizeInternal(200, 120, false);
//		}
		
		public function updateWithLanguage(language : Language) : void
		{
			
			titleLabel.updateWithLanguage(language);
		
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			contentBackgroundImage.visible = false;
				
			this.closeButton.visible=true;
			
			
			this.titleLabel.removeFromParent(true);
			
			titleLabel = new MultilingualLabel();
			titleLabel.textFormat = new TextFormat(FontSelector.getFont(true), 12, 0xffffff);
			titleLabel.textFormat.align = TextFormatAlign.CENTER;
			titleLabel.textFormat.bold=true;
			titleLabel.width = 260/2;
			titleLabel.height = 30;
			titleLabel.wordWrap=true;
			titleLabel.text = "Share this masterpiece with your friends!";
			titleLabel.updateWithLanguage(AlertView.language);
			addChild(titleLabel);
			
			
			fbButton=ButtonFactory.circleButton("a_fb_icon");
			fbButton.name="fb";
			fbButton.width=72/2;
			fbButton.height=71/2;
			fbButton.addEventListener(Event.TRIGGERED, onSocialHandler);
			addChild(fbButton);
			
			twButton=ButtonFactory.circleButton("a_tw_icon");
			twButton.name="tw";
			twButton.width=72/2;
			twButton.height=71/2;
			twButton.addEventListener(Event.TRIGGERED, onSocialHandler);
			addChild(twButton);
			
			vkButton=ButtonFactory.circleButton("a_vk_icon");
			vkButton.name="vk";
			vkButton.width=72/2;
			vkButton.height=71/2;
			vkButton.addEventListener(Event.TRIGGERED, onSocialHandler);
			addChild(vkButton);
			
			instagramButton=ButtonFactory.circleButton("a_pin_icon");
			instagramButton.name="instagram";
			instagramButton.width=72/2;
			instagramButton.height=71/2;
			instagramButton.addEventListener(Event.TRIGGERED, onSocialHandler);
			addChild(instagramButton);
			
			
		}
		
		public function get socialId():String{
			
			return _socialId;
		}
		
	
		protected function onSocialHandler(event:Event):void{
			
			var socialName:String=(event.currentTarget as Button).name;
			
			_socialId=socialName;
			
			trace("onSocialHandler:"+socialName);
			
			this.dispatchEventWith(ON_SELECTED_SOCIAL,false, {socialId:_socialId});
		}
		
		/*public function get message() : String
		{
			
				return "";
			
		}*/
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				
				
				titleLabel.y=232/2 + 12;
				
				titleLabel.width=260/2;
				titleLabel.x=(actualWidth-titleLabel.width)/2 + 20;
				
		
				var socialPosY:Number=324/2;
				
				var socialBlockWidth:Number=(((fbButton.width)*3)+(11.5*3));
				
				
				fbButton.x=(actualWidth-socialBlockWidth)/2;
				fbButton.y=socialPosY;
				
				
				twButton.visible=false;
				twButton.x=fbButton.x+fbButton.width+11.5;
				twButton.y=socialPosY;
				
				
				vkButton.x=fbButton.x+fbButton.width+11.5;
				vkButton.y=socialPosY;
				
				instagramButton.x=vkButton.x+vkButton.width+11.5;
				instagramButton.y=socialPosY;
				
			}
		}
		
		
	}
}

