package com.despark.tuning3d.view.core
{
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.ErrorTracker;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.model.settings.Settings;
    import com.despark.tuning3d.model.users.ChallengeUser;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.BrandsScreenMediator;
    import com.despark.tuning3d.view.BuyAdsRemoverPopUpMediator;
    import com.despark.tuning3d.view.BuyCarPopUpMediator;
    import com.despark.tuning3d.view.BuyPacketPopUpMediator;
    import com.despark.tuning3d.view.ChallengeNotificationTuningScreenMediator;
    import com.despark.tuning3d.view.ChallengeTuningViewPopupMediator;
    import com.despark.tuning3d.view.ChallengesLeaderboardScreenMediator;
    import com.despark.tuning3d.view.ChallengesListScreenMediator;
    import com.despark.tuning3d.view.ChallengesNotificationsScreenMediator;
    import com.despark.tuning3d.view.ChallengesTuningsListScreenMediator;
    import com.despark.tuning3d.view.ChallengesUserTuningsScreenMediator;
    import com.despark.tuning3d.view.ChallengesVotingScreenMediator;
    import com.despark.tuning3d.view.EnterChallengePopupMediator;
    import com.despark.tuning3d.view.ForgottenPasswordScreenMediator;
    import com.despark.tuning3d.view.FriendsListPopUpMediator;
    import com.despark.tuning3d.view.GalleryScreenMediator;
    import com.despark.tuning3d.view.GalleryTuningPopupMediator;
    import com.despark.tuning3d.view.HomeScreenPopUpMediator;
    import com.despark.tuning3d.view.InAppNotificationsPopupMediator;
    import com.despark.tuning3d.view.InfoPopUpMediator;
    import com.despark.tuning3d.view.InstantMailPopupMediator;
    import com.despark.tuning3d.view.LoginScreenMediator;
    import com.despark.tuning3d.view.MailBoxPopupMediator;
    import com.despark.tuning3d.view.MailsScreenMediator;
    import com.despark.tuning3d.view.PartInfoPopUpMediator;
    import com.despark.tuning3d.view.ProfilePopupMediator;
    import com.despark.tuning3d.view.RegisterScreenMediator;
    import com.despark.tuning3d.view.TimelineFeedViewPopupMediator;
    import com.despark.tuning3d.view.TimelineScreenMediator;
    import com.despark.tuning3d.view.TuningEditorPopUpMediator;
    import com.despark.tuning3d.view.TuningScreenMediator;
    import com.despark.tuning3d.view.TuningSettingsPopUpMediator;
    import com.despark.tuning3d.view.TuningVideoPopupMediator;
    import com.despark.tuning3d.view.TuningsListScreenMediator;
    import com.despark.tuning3d.view.UserDetailsPopupMediator;
    import com.despark.tuning3d.view.VotesListScreenMediator;
    import com.despark.tuning3d.view.components.auth.LoginScreen;
    import com.despark.tuning3d.view.components.auth.ProfileAlertView;
    import com.despark.tuning3d.view.components.brands.BrandsScreen;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.distriqt.AdsManager;
    import com.distriqt.BillingManager;
    import com.distriqt.extension.inappbilling.InAppBilling;
    import com.distriqt.extension.inappbilling.Purchase;
    import com.distriqt.extension.inappbilling.events.InAppBillingEvent;
    import com.distriqt.extension.inappbilling.events.PurchaseEvent;
    import com.hurlant.util.Base64;
    import com.utils.ArrayUtil;
    import com.utils.Console;
    import com.utils.DateParser;

    import flash.utils.setTimeout;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;
    import starling.events.Event;

    public class StackedScreenMediator extends ExtendedMediator
	{
		// In order to get getDefinitionByName to work we need to
		// reference these classes at least in one place
		public var homeScreenMediator : BrandsScreenMediator;
		public var tuningEditorPopUpMediator : TuningEditorPopUpMediator;
		public var garageScreenMediator : TuningsListScreenMediator;
		public var votesScreenMediator :VotesListScreenMediator;
		public var tuningScreenMediator : TuningScreenMediator;
		public var loginScreenMediator : LoginScreenMediator;
		public var registerScreenMediator : RegisterScreenMediator; 
		public var tuningSettingsPopUp : TuningSettingsPopUpMediator;
		public var forgottenPasswordMediator : ForgottenPasswordScreenMediator;  
		public var infoPopUpMediator:InfoPopUpMediator;
		public var buyPacketPopUpMediator:BuyPacketPopUpMediator;
		public var buyCarPopUpMediator:BuyCarPopUpMediator;
		public var buyAdsRemoverPopUpMediator:BuyAdsRemoverPopUpMediator;		
		public var partInfoPopUpMediator:PartInfoPopUpMediator;
		public var homeScreenPopUpMediator:HomeScreenPopUpMediator;
		public var mailsScreenMediator:MailsScreenMediator;
        public var friendsScreenMediator : FriendsListPopUpMediator;
        public var timelineScreenMediator : TimelineScreenMediator;
        public var galleryScreenMediator : GalleryScreenMediator;
        public var tuningVideoPopupMediator : TuningVideoPopupMediator;

        public var timelineFeedViewPopupMediator : TimelineFeedViewPopupMediator;
        /**
         * New challenges mediators
         */
        public var challengesListScreenMediator: ChallengesListScreenMediator;
        public var challengesLeaderboardScreenMediator: ChallengesLeaderboardScreenMediator;
        public var enterChallengePopupMediator: EnterChallengePopupMediator;
        public var challengesNotificationsScreenMediator: ChallengesNotificationsScreenMediator;
        /**
         * Start challenge
         */
        public var challengeNotesPopupMediator : InAppNotificationsPopupMediator;
        public var challengeNotificationTuningScreenMediator : ChallengeNotificationTuningScreenMediator;
        public var viewChallengeTuningPopupMediator : ChallengeTuningViewPopupMediator;
        public var challengesTuningsListScreenMediator : ChallengesTuningsListScreenMediator;
        public var challengesUserTuningsScreenMediator : ChallengesUserTuningsScreenMediator;
        public var challengesVotingScreenMediator : ChallengesVotingScreenMediator;
        public var galleryTuningPopupMediator : GalleryTuningPopupMediator;
        public var mailBoxPopupMediator : MailBoxPopupMediator;
        public var instantMailPopupMediator : InstantMailPopupMediator;

        public var profilePopupMediator : ProfilePopupMediator;
        public var userDetailsPopupMediator : UserDetailsPopupMediator;

        public var backLevel : int;



        // ******************* Restore dependent variables
        private var alertLoadingForRestore:AlertView;
        private var _pendingForAuthAction : String;
        private var _pendingForAuthData : Object;
        private var packetForRestores:Array;
        private var startRestoreflag:Boolean = false;
        private var restoreIndex:int = 0;
        private var activePopUp:PopUp = null;
        private var pendingPacket:Packet = null;
        private var alertPurchaseView:AlertView = null;
        //
        private var stopNotePropagation:Object = {};
        //
		public function StackedScreenMediator(stackedScreen : StackedScreen) {
			super(stackedScreen.screenName, stackedScreen);
			stackedScreen.assetManager = (facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy).assetManager;
		}
		
		public function get stackedScreen() : StackedScreen {
			return viewComponent as StackedScreen;   
		}
		
		override public function onRegister() : void {
			super.onRegister();
			stackedScreen.addEventListener(StackedScreen.BACK_BUTTON_SELECTED, stackedScreenBackButtonSelectedHandler);
			stackedScreen.addEventListener(ChallengeEvent.DISPLAY_CHALLENGE_VOTE_POPUP, showChallengeVotePopup);

            stackedScreen.addEventListener(StackedScreen.USER_PROFILE_SELECTED, userProfileSelectedHandler);
            stackedScreen.addEventListener(StackedScreen.USER_RESTORE_SELECTED, restoreSelectedHandler);

            ErrorTracker.setMediator(this);
		}
		
		override public function onRemove() : void {
			super.onRemove();
			stackedScreen.assetManager=null;
			stackedScreen.removeEventListener(StackedScreen.BACK_BUTTON_SELECTED, stackedScreenBackButtonSelectedHandler);
            stackedScreen.removeEventListener(ChallengeEvent.DISPLAY_CHALLENGE_VOTE_POPUP, showChallengeVotePopup);

            stackedScreen.removeEventListener(StackedScreen.USER_PROFILE_SELECTED, userProfileSelectedHandler);
            stackedScreen.removeEventListener(StackedScreen.USER_RESTORE_SELECTED, restoreSelectedHandler);
        }

        override public function listNotificationInterests():Array {
            return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
                Notifications.EMAIL_VERIFICATION_ERROR,
                Notifications.INSTANT_MAIL_POPUP_SELECTED,
                Notifications.USER_AUTHENTICATED
            ])
        }

        override public function handleNotification(note:INotification):void {
            super.handleNotification(note);
            if(!stackedScreen || stackedScreen.isDisposed()){
                facade.removeMediator(mediatorName);
                return;
            }

            if(stopNotePropagation[note.getName()]){
                return;
            }
			switch (note.getName()){
				case Notifications.EMAIL_VERIFICATION_ERROR:
                        if(stackedScreen && stackedScreen.parent) {
                            var complete:Function = function ():void {
                                if (note.getBody().event == 'comment' || note.getBody().event == 'like' || note.getBody().event == 'challenge') {
                                    if(note.getBody().hasOwnProperty("statusCode") && note.getBody().statusCode == 400){
                                        ProfileAlertView.show("Unsupported action:", "You can't vote on the same challenge<br/>multiple times.", 0, null, "CLOSE");
                                    }else{
                                        ProfileAlertView.show("Unverified email:", "Please sign in and confirm your email<br/>to Like/Comment/Challenge Like.", 0, function ():void {
                                            sendNotification(Notifications.DISPLAY_USER_PROFILE_SCREEN, {homeScreenPopup: stackedScreen});
                                        });
                                    }

                                }
                            };
                            var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                            assetsProxy.loadProfileScreenAssets(complete);
                        }
					break;
                case Notifications.USER_AUTHENTICATED:
                    handleUserAuthenticated(note.getBody());
                    break;
                case Notifications.BUY_NOW_PACKET:
                    if(!note.getBody().isLocal){
                        handleBuyNowPacket(note.getBody().packet, note.getBody().popUp);
                    }
                    break;
                case Notifications.INSTANT_MAIL_POPUP_SELECTED:
                    handleMailBoxSelected();
                    break;
                case Notifications.USER_DATA_UPDATED:
                    handleUserDataUpdate(note.getBody());
                    break;
			}
            if(note.getBody() && note.getBody().hasOwnProperty("stopPropagation") && note.getBody().stopPropagation){
                stopNotePropagation[note.getName()] = true;
                Starling.juggler.delayCall(function():void{
                    if(stopNotePropagation[note.getName()]) {
                        delete stopNotePropagation[note.getName()];
                    }
                }, .01);
            }
        }

        private function handleUserDataUpdate(body:Object):void {
            var userProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            userProxy.saveUserJSONData(body);
        }

        private function handleUserAuthenticated(data:Object = null):void{
            if(_pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_BUY_PACKET){
                Starling.juggler.delayCall(function():void{
                    initPurchase(pendingPacket);
                    pendingPacket=null;
                }, 1);
            }else if(_pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_RESTORE){
                if(!Device.isIos()){
                    packetForRestores = [];
                    InAppBilling.service.addEventListener(InAppBillingEvent.RESTORE_PURCHASES_SUCCESS, onAndroidRestoreInfoReceived );
                    InAppBilling.service.restorePurchases();
                }
            }else if(_pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_MAIL_BOX){
                sendNotification(Notifications.DISPLAY_INSTANT_MAIL_POPUP, data);
            }else if(_pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_LOGIN){
                if(!Device.isIos()){

                }
            }
            dailyRewardsHandler();
            if(!Starling.juggler.containsDelayedCalls(dailyRewardsHandler)){
                var nowDate:Date = new Date();
                var tomorrowDate:Date = new Date();
                tomorrowDate.date += 1;
                var delay:Number = 1 + (DateParser.getDateTime(tomorrowDate) - nowDate.time)/DateParser.SECOND;
                Starling.juggler.delayCall(dailyRewardsHandler, delay);
            }
        }

        protected function dailyRewardsHandler(checkSage:Boolean = true):void{
            if(!UsersProxy.loggedInUser() || (checkSage && !stackedScreen.stage)){
                return;
            }

            var challengeProxy:ChallengesProxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            challengeProxy.getUserRewardData(UsersProxy.loggedInUser().id, function (result:Object):void {
                if(result){
                    var alertView:ChallengeAlertView;
                    var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                    var challengeUser:ChallengeUser = new ChallengeUser(usersProxy.currentUserJSON);
                    var keys:int = Math.min(0, Constants.MAX_KEY_AMOUNT - challengeUser.keys);
                    if(result.hasOwnProperty("firstVisit")){
                        challengeProxy.addUserDailyRewardData(UsersProxy.loggedInUser().id, {keys: keys, diamonds: 0});
                        alertView = ChallengeAlertView.show(ChallengeAlertView.WELCOME_USER_POPUP, null, stackedScreen.stage);
                    }else{
                        var lastVisitDate:Date = DateParser.parseDate(result.date);
                        var lastVisitTime:Number = DateParser.getDateTime(lastVisitDate);
                        var currentTime:Number = DateParser.getDateTime(new Date());
                        if(lastVisitTime != currentTime){
                            keys = Math.min(3, Constants.MAX_KEY_AMOUNT - challengeUser.keys);
                            var rewardData:Object = {keys:keys, diamonds: 2};
                            alertView = ChallengeAlertView.show(ChallengeAlertView.DAILY_REWARDS, {keys:(keys>0?keys:0), diamonds: 2}, stackedScreen.stage);
                            challengeProxy.addUserDailyRewardData(UsersProxy.loggedInUser().id, rewardData);
                            var rewardsData:Object = challengeProxy.resetRewardsData(UsersProxy.loggedInUser().id);
                            AdsManager.$.updateRewardsStats(rewardsData);
                        }
                    }

                    if(alertView){
                        alertView.open();
                    }
                }else{
                    Console.log();
                }
            });
        }

        protected function stackedScreenBackButtonSelectedHandler(event : Event) : void {
			sendNotification(Notifications.DISPLAY_PREVIOUS_SCREEN, {backLevel: stackedScreen.backLevel});
		}

        private function userProfileSelectedHandler(event : Event) : void {
            sendNotification(Notifications.DISPLAY_USER_PROFILE_SCREEN, {stopPropagation:true, homeScreenPopup: stackedScreen});
        }

        private function handleMailBoxSelected(data:Object = null) : void {
            _pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_MAIL_BOX;
            sendNotification(Notifications.AUTHENTICATE_USER, data);
        }

        // ************************ Restore functionality *****************************
        private function restoreSelectedHandler(event : Event) : void {
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            var login:Boolean=false;
            if (usersProxy.currentUser){
                login=true;
            }
            if (alertView){
                alertView.hide();
                alertView=null;
            }

            if(Device.isIos()){
                if(!alertLoadingForRestore) {
                    alertLoadingForRestore = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
                }
                packetForRestores = [];
                BillingManager.$.packetForRestores = packetForRestores;
                BillingManager.$.restorePurchases(
                        function(val:Object):void{
                            saveRestoredPurchases(val.productId);
                        }
                        /*onIOSTransactionsRestoreComplete*/,
                    function():void{
                        packetForRestores=null;
                        if(alertLoadingForRestore){
                            alertLoadingForRestore.hide();
                            alertLoadingForRestore=null;
                        }
                        AlertView.show(AlertView.language.translate("mob_settings", "purchaseRestore"), -1, false);
                        startRestoreflag=false;
                        var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                        packagesProxy.getFilteredProducts();
                    }, function (errorText:String = null):void {
                        if(alertPurchaseView){
                            alertPurchaseView.hide();
                            alertPurchaseView = null;
                        }
                        AlertView.show(errorText||"Failed to restore purchases", -1, false);
                    }
                );
            }else{
                if(login){
                    usersProxy.getPurchases(function (result : Array):void  {
                        AlertView.show(AlertView.language.translate("mob_settings", "purchaseRestore"), -1, false);
                    });
                }else{
                    _pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_RESTORE;
                    AlertView.show(AlertView.language.translate("signUp", "register_for_purchase") , -1, false);
                    sendNotification(Notifications.AUTHENTICATE_USER, {type: LoginScreen.TYPE_NORMAL, msg:AlertView.language.translate("signUp", "register_for_purchase")});
                }
            }
        }


        private function onAndroidRestoreInfoReceived(event:InAppBillingEvent):void{
            InAppBilling.service.removeEventListener( InAppBillingEvent.RESTORE_PURCHASES_SUCCESS, onAndroidRestoreInfoReceived );
            var purchases: Array = event.data as Array;
            for each(var purchase: Purchase in purchases){
                var data:Object={
                    receipt:purchase.transactionReceipt,
                    transactionId:purchase.transactionId,
                    productId:purchase.productId,
                    restoreUrl:true
                };
                packetForRestores.push({productId:purchase.productId, data: JSON.stringify(data), transactionId:purchase.transactionId });
            }
            startRestoreflag=true;
            startRestore(function():void{
                packetForRestores=null;
                if(alertLoadingForRestore){
                    alertLoadingForRestore.hide();
                    alertLoadingForRestore=null;
                }
                AlertView.show(AlertView.language.translate("mob_settings", "purchaseRestore"), -1, false);
                startRestoreflag=false;
                var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                packagesProxy.getFilteredProducts();
            });
        }

        private function nextRestore(callback:Function=null):void{
            if(restoreIndex>=packetForRestores.length){
                if(callback)
                    callback();
                return;
            }
            getPurchaseItem(packetForRestores[restoreIndex].productId, packetForRestores[restoreIndex].data, packetForRestores[restoreIndex].transactionId, function():void{
                restoreIndex++;
                if(restoreIndex<packetForRestores.length){
                    setTimeout(
                            nextRestore, 500, callback);
                }else{
                    if(callback)
                        callback();
                }
            });
        }

        private function saveRestoredPurchases(productId:String):void{
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
            var packet:Packet = packagesProxy.findPacketByProductId(productId);
            var json:String = usersProxy.readPurchases();
            var purchases:Array = JSON.parse(json) as Array;
            if(packet){
                sendNotification(Notifications.PACKET_PURCHASE_SUCCESS, {packet:packet, isRestoring: true});
                if(!packetExistsInArray(purchases, packet.productId)){
                    purchases.push({product:packet.id, productId:packet.productId});
                }
            }else {
                purchases.push({product:productId, productId:productId});
            }

            usersProxy.savePurchases(JSON.stringify(purchases));
        }

        private function getPurchaseItem(productId:String, receipt:String, transactionId:String, callback:Function=null):void{
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            var packgesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
            var packet:Packet=packgesProxy.findPacketByProductId(productId);
            if(!packet){
                return;
            }

            var receiptData:Object=JSON.parse(receipt);
            var completeVerify:Function=function(verify:Boolean, error:String):void{
                verify = true;
                if(activePopUp){
                    sendNotification(Notifications.REMOVE_POP_UP, activePopUp);
                    activePopUp=null;
                }
                if(verify){
                    sendNotification(Notifications.PACKET_PURCHASE_SUCCESS, {packet:packet, isRestoring: true});
                    var json:String=usersProxy.readPurchases();
                    var purchases:Array=JSON.parse(json) as Array;
                    if(!packetExistsInArray(purchases, packet.productId))
                        purchases.push({product:packet.id, productId:packet.productId});
                    usersProxy.savePurchases(JSON.stringify(purchases));
                    if(Device.isIos()){
                        // InAppBilling.service.finishPurchase( purchase );
                    }else{

                    }
                }else{
                    if(!startRestoreflag){
                        if(error!="IOError"){
                            AlertView.show(error,-1, false);
                        }else{
                            usersProxy.iapVerify(receiptData, packet, completeVerify);
                            return;
                        }
                    }
                }
                if(callback){
                    callback();
                }
            };
            usersProxy.iapVerify(receiptData, packet, completeVerify);
        }


        private function packetExistsInArray(purchases:Array, packet_id):Boolean {
            for(var index : int in purchases){
                if (purchases[index].product == packet_id) return true;
            }
            return false;
        }

        private function startRestore(complete:Function):void {
            restoreIndex = 0;
            nextRestore(function():void{complete();});
        }

        private function handleBuyNowPacket(packet:Packet, popUp:PopUp):void{
            if(!stackedScreen)
                return;
            if(!(stackedScreen.owner as  StackedScreenNavigator))
                return;
            if((stackedScreen.owner as  StackedScreenNavigator).activeScreen.name!=stackedScreen.name)
                return;
            if(!(stackedScreen is BrandsScreen)){
                return;
            }
            var stackedScreenOwner:Object =(stackedScreen.owner);
            if(!stackedScreenOwner)
                return;
            if(!stackedScreenOwner.activeScreen)
                return;
            if( stackedScreenOwner.activeScreen.name!=stackedScreen.name)
                return;
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if (packet.tempOpened) {
                addTempOpenPacket(packet);
                if (popUp) {
                    sendNotification(Notifications.REMOVE_POP_UP, popUp);
                }
                BrandsScreen(stackedScreen).updateTempOpenPacket(packet);
            }

            if (Device.isIos()) {
                activePopUp = popUp;
                initPurchase(packet);
            } else {
                if (!usersProxy.currentUser && !packet.tempOpened) {
                    if (popUp)
                        sendNotification(Notifications.REMOVE_POP_UP, popUp);
                    _pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_BUY_PACKET;
                    pendingPacket = packet;
                    AlertView.show(AlertView.language.translate("signUp", "register_for_purchase"), -1, false);
                    sendNotification(Notifications.AUTHENTICATE_USER, {
                        type: LoginScreen.TYPE_NORMAL,
                        msg: AlertView.language.translate("signUp", "register_for_purchase")
                    });
                } else {
                    activePopUp = popUp;
                    initPurchase(packet);
                }
            }
        }

        private function initPurchase(packet:Packet):void {

            if (!Constants.IN_APP_PURCHASE_ENABLED || !packet) {
                return;
            }

            if (packet.tempOpened) {
                sendNotification(Notifications.PACKET_PURCHASE_SUCCESS, {packet:packet});
            } else {
                var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                if (usersProxy.isExistPacket(packet.productId))
                    return;
                if (!alertPurchaseView) {
                    alertPurchaseView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
                }

                BillingManager.$.makePurchase(packet.productId, function (purchase:Purchase):void {
                    var productInfo: Object = JSON.parse(purchase.originalMessage);
                    var receipt: Object = {
                        signature: purchase.signature,
                        signedData: purchase.originalMessage
                    };
                    var data:Object = {
                        receipt: Base64.encode(JSON.stringify(receipt)),
                        transactionId: purchase.transactionId,
                        productId: purchase.productId,
                        packageName: productInfo['packageName']
                    };
                    getPurchaseItem(purchase.productId, JSON.stringify(data), purchase.transactionId, function ():void {
                        removePurchaseAlertView();
                    });
                }, onPurchaseFailed);
            }

        }

        private function onPurchaseFailed(event:PurchaseEvent):void {
            if (activePopUp) {
                sendNotification(Notifications.REMOVE_POP_UP, activePopUp);
                activePopUp = null;
            }

            removePurchaseAlertView();
        }

        private function removePurchaseAlertView() : void {
            if(alertPurchaseView) {
                alertPurchaseView.hide();
                alertPurchaseView = null;
            }
        }

        // ************************ End restore functionality ******************************************

		private function showChallengeVotePopup(event:Event):void{
			var data:Object = event.data;
			var isTuningScreen:Boolean = stackedScreen && stackedScreen is TuningScreen;
			if(!isTuningScreen || (isTuningScreen && (TuningScreen(stackedScreen).infoView == null || !TuningScreen(stackedScreen).infoView.isOpened))) {
                sendNotification(Notifications.DISPLAY_CHALLENGE_VOTE_POPUP, data);
            }else{
				Starling.juggler.delayCall(
						function():void{
                            showChallengeVotePopup(event);
						}, 3
				);
			}
		}

        private static function addTempOpenPacket(packet:Packet):void{
            StackedScreen.tempOpenPackages[packet.id] = packet;
        }

        public function get pendingForAuthAction():String {
            return _pendingForAuthAction;
        }

        public function set pendingForAuthAction(value:String):void {
            _pendingForAuthAction = value;
        }

        public function get pendingForAuthData():Object {
            return _pendingForAuthData;
        }

        public function set pendingForAuthData(value:Object):void {
            _pendingForAuthData = value;
        }
    }
}