package com.distriqt {
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.http.HttpClient;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.distriqt.extension.adverts.AdSize;
    import com.distriqt.extension.adverts.AdView;
    import com.distriqt.extension.adverts.InterstitialAd;
    import com.distriqt.extension.adverts.events.AdvertsEvent;
    import com.distriqt.extension.adverts.events.FullScreenContentEvent;
    import com.distriqt.extension.adverts.rewarded.RewardedVideoAd;

    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.distriqt.extension.adverts.AdSize;
    import com.distriqt.extension.adverts.AdViewParams;
    import com.distriqt.extension.adverts.AdvertPlatform;
    import com.distriqt.extension.adverts.Adverts;
    import com.distriqt.extension.adverts.builders.AdRequestBuilder;
    import com.distriqt.extension.adverts.events.AdViewEvent;
    import com.distriqt.extension.adverts.events.InterstitialAdEvent;
    import com.distriqt.extension.adverts.events.RewardedVideoAdEvent;
import com.distriqt.extension.application.Application;
    import com.distriqt.extension.application.IDType;
    import com.utils.Console;
    import com.utils.DateParser;
    import com.utils.FileUtil;

    import flash.filesystem.File;

    import flash.geom.Rectangle;


    import flash.utils.setTimeout;

import org.puremvc.as3.patterns.command.SimpleCommand;

    import starling.core.Starling;

    import starling.core.Starling;

public class AdsManager extends SimpleCommand {

    private static var self : AdsManager;

    private static const STATE_IDLE : String = "idle";
    private static const STATE_LOADING : String = "loading/requesting";
    private static const STATE_READY : String = "ready";
    private static const STATE_OPENED : String = "opened";
    private static const STATE_ASK_TO_OPEN : String = "ask_to_open/show";
    private static const STATE_CLOSED : String = "closed";
    private static const STATE_APP_LEFT : String = "app_left";
    private var httpClient : HttpClient;

    private static var APP_ID_ANDROID : String = "ca-app-pub-4497440830258113~2169875914";
    private static var APP_ID_IOS : String = "ca-app-pub-4497440830258113~8347916233";

    private static var INTERSTITIAL_ID_ANDROID : String = "ca-app-pub-4497440830258113/5348054669";
    private static var INTERSTITIAL_ID_IOS : String = "ca-app-pub-4497440830258113/9651413138";

    private static var REWARD_ID_ANDROID: String = 'ca-app-pub-4497440830258113/6861598264';
    private static var REWARD_ID_IOS: String = 'ca-app-pub-4497440830258113/6777837789';

    private static var BANNER_ID_ANDROID : String = "ca-app-pub-4497440830258113/3852291543";
    private static var BANNER_ID_IOS : String = "ca-app-pub-4497440830258113/1142367725";


    public static var bannerY: Number;
    private static var ADS_ENABLED : Boolean = true;

    private var _state : String;
    private var _isInitialized : Boolean = false;
    private var _interstitial : InterstitialAd;
    private var _callBackFunction : Function;
    private var _rewardsCallback : Function;
    private var _initializedCallback: Function;
    private var _tracer : Tracer = new Tracer("ADS_MANAGER");

    private var _reward: RewardedVideoAd;
    private var _rewardCB: Function;
    public var haveRewardAds: Boolean = false;
    private var adView:AdView;
    private var adViewSize:AdSize;
    private var adViewVisible:Boolean = false;

    public var bannerLoaded: Boolean = false;
    public var bannerWidth: int = 248;
    public var bannerHeight: int = 38;
    public var preventToggle:Boolean = false;
    private var _bannerEnabled: Boolean = false;

    private var bannerIsShown: Boolean = false;
    private var bannerLoadAttempts: int = 0;
    private var _showBannerAfterComplete:Boolean = false;

    private var _currentBannerScreen: String;
    private var viewParams:AdViewParams;
    private var _lastBannerStatus:Boolean;

    private static const MAX_ATTEMPT_COUNT:int = 15;
    private static const MAX_REWARDS_COUNT:int = 6;
    private var _bannerBounds:Rectangle;
    private static var isMute:Boolean = false;
    private var _rewardAdsStats:Object;
    private var _rewardLimitCallback:Function;
    private var _rewardUpdateCallback:Function;


    public static function get $() : AdsManager{
        if(!self){
            self = new AdsManager();
        }
        return self;
    }

    public static function get ENABLED() : Boolean {
        return ADS_ENABLED;
    }
    public static function turnOffAds() : void {
        Console.log("turnOffAds");
        if(ADS_ENABLED){
            ADS_ENABLED = false;
            $.bannerHide(true);
        }
    }

    public function AdsManager() {
        if(self){
            throw new Error("Advert Manager is singleton");
        }

        if(!ADS_ENABLED ) {
            return;
        }

        DistriqtController.init();
        var advertIsSupported:Boolean;
        try{
            advertIsSupported = Adverts.isSupported;
            if(advertIsSupported){
                advertIsSupported = Adverts.service.isPlatformSupported(AdvertPlatform.PLATFORM_ADMOB);
            }
        }catch (e:Error) {
            advertIsSupported = false;
        }
        if (advertIsSupported){
            Adverts.service.addEventListener( AdvertsEvent.INITIALISED, initialisedHandler);
            Adverts.service.setup(AdvertPlatform.PLATFORM_ADMOB);
            Adverts.service.initialise();
        } else {
            _tracer.print("Ads do not supported");
            AdsManager.turnOffAds();
        }
    }

    private function initialisedHandler(event:AdvertsEvent ):void {
        initReward();
        initInterstitial();
        initBanner();
        _isInitialized =  true;
        _tracer.print("INITIALIZED");
        this.changeState(STATE_IDLE);
        if(_initializedCallback != null){
            _initializedCallback();
            _initializedCallback = null;
        }
    }

    public function showReward(): Boolean {
        if(_rewardAdsStats && UsersProxy.loggedInUser() && _rewardAdsStats.userId == UsersProxy.loggedInUser().id){
            if(_rewardAdsStats.rewardCount >= MAX_REWARDS_COUNT && _rewardAdsStats.date == DateParser.getDateTime(new Date())){
                if(_rewardLimitCallback != null){
                    _rewardLimitCallback.call();
                }
            }else {
                if(_rewardAdsStats.date != DateParser.getDateTime(new Date())){
                    updateRewardsStats(null);
                }
                _reward.show();
            }
            return true;
        }
        return false;
    }

    public function checkRewardAds(completeCallback:Function):void{
        GameService.$.getSaveData(function (gameData: String): void {
            requestReward();
            GameService.$.rewardsIsSupport(function(status: Boolean): void {
                completeCallback(status);
            });
        });
    }

    private function initInterstitial() : void{
        if(!ADS_ENABLED ) {
            return;
        }

        if(Adverts.service.interstitials.isSupported) {
            var id : String = Device.isIos() ? INTERSTITIAL_ID_IOS : INTERSTITIAL_ID_ANDROID;
            _interstitial = Adverts.service.interstitials.createInterstitialAd();
            _interstitial.setAdUnitId( id );
            _interstitial.addEventListener( InterstitialAdEvent.LOADED, interstitialLoadedHandler);
            _interstitial.addEventListener( InterstitialAdEvent.ERROR, interstitialErrorHandler);
            _interstitial.addEventListener( FullScreenContentEvent.FAILED_TO_SHOW, interstitialFailedToShowHandler );
            _interstitial.addEventListener( FullScreenContentEvent.DISMISSED, interstitialDismissedHandler );
            _interstitial.addEventListener( FullScreenContentEvent.SHOW, interstitialShowHandler);
            _tracer.print("Interstitial is initialized");
        } else {
            _tracer.print("Interstitial is not supported");
            AdsManager.turnOffAds();
        }
    }

    private function initReward(): void {
        if (Adverts.service.rewardedVideoAds.isSupported) {
            var id : String = Device.isIos() ? REWARD_ID_IOS : REWARD_ID_ANDROID;
            _reward = Adverts.service.rewardedVideoAds.createRewardedVideoAd();
            _reward.setAdUnitId(id);
            _reward.addEventListener( RewardedVideoAdEvent.LOADED, rewardLoadedHandler);
            _reward.addEventListener( RewardedVideoAdEvent.ERROR, rewardErrorHandler);
            _reward.addEventListener( RewardedVideoAdEvent.REWARD, rewardHandler);
            _reward.addEventListener( FullScreenContentEvent.DISMISSED, rewardDismissedHandler);
            _reward.addEventListener( FullScreenContentEvent.SHOW, rewardShowHandler);
        } else {
            _tracer.print('Rewards is not supported');
        }
    }

    private function initBanner(): void {
        if(!ADS_ENABLED) {
            return;
        }
        bannerLoaded = false;
        var id : String = Device.isIos() ? BANNER_ID_IOS : BANNER_ID_ANDROID;
        adView = Adverts.service.createAdView();
        adView.setAdUnitId( id );
        adView.addEventListener( AdViewEvent.LOADED, bannerLoadedHandler );
        adView.addEventListener( AdViewEvent.ERROR, bannerErrorHandler );
        bannerLoadAttempts = 0;
    }

    public function requestBanner(bannerScreen:String = null): void {
        if(!ADS_ENABLED){
            return;
        }
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        if (adView && !adView.isLoading()) {
            if(!adViewSize){
                if (bannerScreen == BannerScreen.TUNING_SCREEN) {
                    adViewSize = AdSize.BANNER;
                } else if (bannerScreen == BannerScreen.HOME_SCREEN){
                    var halfScreenWidth: Number = 2 * Constants.SCREEN_WIDTH / Starling.current.contentScaleFactor;
                    if (halfScreenWidth < 320) {
                        adViewSize = AdSize.BANNER;
                    } else if (halfScreenWidth >= 320 && halfScreenWidth < 468) {
                        adViewSize = AdSize.BANNER;
                    } else if (halfScreenWidth >= 468 && halfScreenWidth < 728) {
                        adViewSize = AdSize.BANNER;
                    } else {
                        adViewSize = AdSize.BANNER;
                    }
                } else if (bannerScreen == BannerScreen.BANNER_SCREEN){
                    adViewSize = AdSize.BANNER;
                }
                adView.setAdSize(adViewSize);
            }
            adView.load(new AdRequestBuilder().build());
        }
    }

    public function setBannerPosition(y: Number, bannerScreen:String = null): void {
        if(!ADS_ENABLED){
            return;
        }
        viewParams = getAdViewParams(bannerScreen);
        viewParams.y =  bannerY = y;
        if (bannerLoaded) {
            adView.setViewParams(viewParams);
            adView.show();
            bannerIsShown = true;
        }
    }

    private function getAdViewParams(bannerScreen:String = null):AdViewParams{
        var horizontalAlign:String;
        var result:AdViewParams = new AdViewParams();
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        if(bannerScreen == BannerScreen.HOME_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_CENTER;
        }else if(bannerScreen == BannerScreen.TUNING_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_NONE;
            var w:Number = Starling.current.stage.stageWidth;
            result.x = (w - TuningScreen.PART_SELECTOR_WIDTH * 5/4) * Starling.current.contentScaleFactor - bannerWidth * Starling.current.contentScaleFactor;
        }else if(bannerScreen == BannerScreen.BANNER_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_CENTER;
        }

        result.horizontalAlign = horizontalAlign;
        return result;
    }

    public function set bannerEnabled ( value : Boolean ) : void {
        _bannerEnabled = (value && ADS_ENABLED);
        if(!_bannerEnabled) {
            bannerHide();
        }
    }

    public function bannerShow(bannerScreen: String = null): void {
        if(!ADS_ENABLED){
            return;
        }
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        _currentBannerScreen = bannerScreen;
        viewParams = getAdViewParams(_currentBannerScreen);
        viewParams.y =  bannerY;
        if(_bannerEnabled && !bannerIsShown){
            if (bannerLoaded) {
                adView.setViewParams(viewParams);
                adView.show();
                bannerIsShown = true;
            } else if (bannerLoadAttempts < MAX_ATTEMPT_COUNT) {
                showBannerAfterComplete = true;
                requestBanner(_currentBannerScreen);
            }
        }
    }

    public function bannerHide(exitScreen:Boolean = false): Boolean {
        if(exitScreen){
            showBannerAfterComplete = false;
        }
        if (bannerLoaded && bannerIsShown) {
            adView.hide();
            bannerIsShown = false;
            _lastBannerStatus = !exitScreen;
            return _lastBannerStatus;
        }
        _lastBannerStatus = false;
        return _lastBannerStatus;
    }

    public function destroyBanner(): void {
        if (adView) {
            bannerHide();
        }
    }

    private function bannerLoadedHandler(event: AdViewEvent): void {
        bannerLoaded = true;
        var oldHeight:int = bannerHeight;
        var size: AdSize = adView.getAdSize();
        if(size){
            adViewSize = size;
        }
        if(adViewSize && adViewSize.widthInPixels && adViewSize.heightInPixels){
            bannerWidth = adViewSize.widthInPixels / Starling.current.contentScaleFactor;
            bannerHeight = adViewSize.heightInPixels / Starling.current.contentScaleFactor;
        }

        if(!ADS_ENABLED){
            adView.hide();
            return;
        }
       if(bannerIsShown){
            viewParams.y -= (bannerHeight - oldHeight) / 2;
            adView.setViewParams(viewParams);
            adView.show();
        }else if(showBannerAfterComplete){
            bannerShow(_currentBannerScreen);
        }
    }

    private function bannerErrorHandler(event: AdViewEvent): void {
        if(bannerLoadAttempts < MAX_ATTEMPT_COUNT){
            bannerLoadAttempts++;
            Starling.juggler.delayCall(requestBanner, bannerLoadAttempts, _currentBannerScreen);
        } else {

        }
    }


    private function rewardShowHandler(event: FullScreenContentEvent): void {
        haveRewardAds = false;
        sendNotification(Notifications.REWARD_ARS_OPENED);
    }

    private function rewardLoadedHandler( event: RewardedVideoAdEvent ): void {
        haveRewardAds = true;
        sendNotification(Notifications.REWARD_ARS_LOAD);
        trace('Reward Ads Loaded');
    }

    private function rewardErrorHandler( event: RewardedVideoAdEvent ): void {

        if (_rewardCB) {
            _rewardCB(false);
        }

        haveRewardAds = false;
        setTimeout(function (): void {
            requestReward(_rewardCB);
        }, 6000);

    }

    private function rewardHandler( event: RewardedVideoAdEvent ): void {
        GameService.$.addReward(1);
        addRewardsCount();
        haveRewardAds = false;
        requestReward(_rewardCB);
    }

    private function rewardDismissedHandler(event: FullScreenContentEvent): void {
        haveRewardAds = false;
        requestReward(_rewardCB);
        if(_rewardsCallback != null){
            _rewardsCallback.call();
            _rewardsCallback = null;
        }
        sendNotification(Notifications.REWARD_ADS_DISMISSED);
    }

    private function changeState(state : String) : void {
        this._state = state;
        _tracer.print("STATE : " + state);
    }

    private function interstitialShowHandler(event:FullScreenContentEvent):void {
        this.changeState(STATE_OPENED);
        sendNotification(Notifications.INTERSTITIAL_ADS_OPENED);
    }


    private function interstitialDismissedHandler(event:FullScreenContentEvent):void {
        this.changeState(STATE_CLOSED);
        completeRequest(true);
        this.changeState(STATE_IDLE);
        sendNotification(Notifications.INTERSTITIAL_ADS_DISMISSED);
    }

    private function interstitialFailedToShowHandler(event:FullScreenContentEvent):void {
        this.changeState(STATE_APP_LEFT);
        completeRequest(false);
        this.changeState(STATE_IDLE);
    }

    private function interstitialErrorHandler(event:InterstitialAdEvent):void {
        _tracer.print("Interstitial load error");
        this.changeState(STATE_IDLE);
        completeRequest(false);
    }

    private function interstitialLoadedHandler(event:InterstitialAdEvent):void {
        _tracer.print("Interstitial is loaded");
        this.changeState(STATE_READY);
        if(_callBackFunction){ // means waiting for load to show
            showInterstitial();
        }
    }

    public function prepareInterstitial() : void{
        if(!ADS_ENABLED || !_isInitialized) {
            return;
        }

        if (Adverts.service.interstitials.isSupported) {
            _tracer.print("Prepare interstitial");
            if(_interstitial.isLoading()) return;

            _interstitial.load( new AdRequestBuilder().build() );
            this.changeState(STATE_LOADING);
        }
    }

    public function requestInterstitial(callBack:Function) : void{
        if(!ADS_ENABLED || !_isInitialized) {
            callBack(false);
            return
        }
        if (Adverts.service.interstitials.isSupported) {
            _tracer.print("Request");
            _callBackFunction = callBack;

            if(_interstitial.isLoaded()){
                showInterstitial();
            }else if(!_interstitial.isLoading()) {
                prepareInterstitial();
            }
        }
    }

    public function requestReward(cb: Function = null): void {
        if(!_isInitialized){
            return;
        }
        if(!_reward){
            initReward();
        }
        if (Adverts.service.rewardedVideoAds.isSupported && !haveRewardAds && _reward) {
            _reward.load(new AdRequestBuilder().build());
            if (cb != null) {
                _rewardCB = cb;
            }
        } else {
            if (cb != null) {
                cb(false);
            }
        }
    }

    private function showInterstitial() : void{

        if(_interstitial.isLoaded()){
            this.changeState(STATE_ASK_TO_OPEN);
            _interstitial.show();
        }else {
            completeRequest(false);
        }

    }

    private function completeRequest(status : Boolean) : void{
        if(_callBackFunction){
            _tracer.print("Complete with status : " + status );
            _callBackFunction(status);
            _callBackFunction = null;
        }
    }

    public function get currentBannerScreen():String {
        return _currentBannerScreen;
    }

    public function get showBannerAfterComplete():Boolean {
        return _showBannerAfterComplete;
    }

    public function set showBannerAfterComplete(value:Boolean):void {
        _showBannerAfterComplete = value;
    }

    private function _sendAdsDebug(): void {
        if (!httpClient) {
            httpClient = new HttpClient();
        }

        var data: * = {
            deviceName: Application.service.device.name,
            deviceBrand: Application.service.device.brand,
            deviceManufacturer: Application.service.device.manufacturer,
            deviceDevice: Application.service.device.device,
            deviceModel: Application.service.device.model,
            deviceProduct: Application.service.device.product,
            deviceId: Application.service.device.uniqueId(IDType.VENDOR, true)


        }
        httpClient.postPath("/ads", data, function(success : Boolean, result : Object) : void {

        })
    }

    public function set rewardsCallback(value:Function):void {
        _rewardsCallback = value;
    }

    public function get lastBannerStatus():Boolean {
        return _lastBannerStatus;
    }

    public function get bannerBounds():Rectangle{
        return _bannerBounds;
    }



    public function updateBannerBounds():Rectangle{
        if(ADS_ENABLED && bannerLoaded){
            var size:AdSize = adViewSize;
            _bannerBounds ||= new Rectangle();
            var rX:Number = 0;
            var rY:Number = 0;
            var rW:Number = bannerWidth;
            var rH:Number = bannerHeight;
            if(size && size.widthInPixels && size.heightInPixels){
                rW = size.widthInPixels / Starling.current.contentScaleFactor;
                rH = size.heightInPixels / Starling.current.contentScaleFactor;
            }
            if(viewParams.x == 0) {
                if(viewParams.horizontalAlign == AdViewParams.ALIGN_RIGHT){
                    rX = Starling.current.stage.stageWidth - rW;
                }else if(viewParams.horizontalAlign == AdViewParams.ALIGN_CENTER){
                    rX = (Starling.current.stage.stageWidth - rW) / 2;
                }
            }
            if(viewParams.y == 0) {
                if(viewParams.verticalAlign == AdViewParams.ALIGN_BOTTOM){
                    rY = Starling.current.stage.stageHeight - rH;
                }else if(viewParams.verticalAlign == AdViewParams.ALIGN_CENTER){
                    rY = (Starling.current.stage.stageHeight - rH) / 2;
                }
            }
            _bannerBounds.setTo(rX, rY, rW, rH);
            return _bannerBounds;
        }
        return null;
    }

    public function turnOffSound(value:Boolean):void {
        if(ADS_ENABLED && value != isMute){
            isMute = value;
            Adverts.service.setAppMuted(isMute);
            if(_interstitial){
                _interstitial.destroy();
                _interstitial = null;
            }
            initInterstitial();

            if(_reward){
                _reward.destroy();
                _reward = null;
                haveRewardAds = false;
            }
            //initReward();

            if(adView){
                adView.destroy();
                adView = null;
            }
            initBanner();
        }
    }

    public function get isInitialized():Boolean {
        return _isInitialized;
    }

    public function set initializedCallback(value:Function):void {
        _initializedCallback = value;
        if(_isInitialized && _initializedCallback != null){
            _initializedCallback();
        }
    }

    public function get bannerEnabled():Boolean {
        return _bannerEnabled;
    }

    private function addRewardsCount():void{
        _rewardAdsStats.rewardCount++;
        if(_rewardUpdateCallback != null){
            _rewardUpdateCallback.call();
        }
        if(_rewardAdsStats.rewardCount >= MAX_REWARDS_COUNT && _rewardAdsStats.date == DateParser.getDateTime(new Date())){
            if(_rewardLimitCallback != null){
                _rewardLimitCallback.call();
            }
        }
    }

    public function updateRewardsStats(rewardsData:Object):void{
        var userId:String;
        if(UsersProxy.loggedInUser()){
            userId = UsersProxy.loggedInUser().id;
        }
        var defaultStats:Object = {userId:userId, rewardCount: 0, date: DateParser.getDateTime(new Date())};
        if(rewardsData && rewardsData.date){
            if(rewardsData.date != defaultStats.date){
                _rewardAdsStats = defaultStats;
            }else{
                _rewardAdsStats = rewardsData;
            }
        }else{
            _rewardAdsStats = defaultStats;
        }
    }

    public function set rewardLimitCallback(value:Function):void {
        _rewardLimitCallback = value;
    }

    public function set rewardUpdateCallback(value:Function):void {
        _rewardUpdateCallback = value;
    }

    public function get rewardAdsStats():Object {
        return _rewardAdsStats;
    }
}
}
