package  com.utils
{
	import flash.display.BitmapData;
	import flash.utils.Dictionary;
	

	public class BitmapDataManager
	{
		private static var _instance:BitmapDataManager=null;
		
		private var _bitmaps:Dictionary=new Dictionary();
		
		private var _totalMemory:int=0;
		private var _cacheMemory:int=0;
		private var _useMemory:int=0;
		private var _bitmapCount:int=0;
		
		public function BitmapDataManager()
		{
			if(_instance){
				throw new Error("use getInstance()");
			}
		}
		
		[Inline]
		public static function getInstance():BitmapDataManager{
			
			if(!_instance){
				_instance=new BitmapDataManager();
			}
			return _instance;
		}
		
		public function addBitmapData(id:String, bitmapData:BitmapData):void{

			if(_bitmaps[id]){
				//throw new Error("addBitmapData id alredy exists:", id);
				return;
			}
			
			_totalMemory+=bitmapData.width*bitmapData.height*4;
			_useMemory+=bitmapData.width*bitmapData.height*4;
			_bitmapCount++;
			
			_bitmaps[id]=new CachedBitmapData(id, bitmapData);   
		}
		
		public function getBitmapData(id:String):BitmapData{
			
			
			
			if(!_bitmaps[id]){
				
				throw new Error("getBitmapData not found for id:"+id);
				return null;
			}
			
			var cachedBD:CachedBitmapData=_bitmaps[id];
			
			
			if(cachedBD.inMemory){
				
				return cachedBD.bitmapData;
			}else{
				
				cachedBD.loadFromDisk();
				
				_useMemory+=cachedBD.bitmapData.width*cachedBD.bitmapData.height*4;
				return cachedBD.bitmapData;
			}
		}
		
		public function hasBitmapData(id:String):Boolean{
			
			if(_bitmaps[id]) return true;
			return false;
				
		}
		
		public function removeBitmapData(id:String):void{
			
			
			
			if(!_bitmaps[id]){
				
				//throw new Error("removeBitmapData not found for id:", id);
				return;
			}
			
			var cachedBD:CachedBitmapData=_bitmaps[id];
			
			if(cachedBD.inMemory){
				
				_useMemory-=cachedBD.bitmapData.width*cachedBD.bitmapData.height*4;
				_totalMemory-=cachedBD.bitmapData.width*cachedBD.bitmapData.height*4;
				_bitmapCount--;
			}else{
				
				_cacheMemory-=cachedBD.width*cachedBD.height*4;
				_totalMemory-=cachedBD.width*cachedBD.height*4;
				_bitmapCount--;
			}
			
			cachedBD.dispose();
			cachedBD=null;
			delete _bitmaps[id];
			//_bitmaps[id]=null;
			
		}
		
		public function cacheToDisk(id:String):void{
			
			if(_bitmaps[id]){
				var cachedBD:CachedBitmapData=_bitmaps[id];
				
				if(cachedBD.inMemory){
					
					_useMemory-=cachedBD.bitmapData.width*cachedBD.bitmapData.height*4;
					_cacheMemory+=cachedBD.bitmapData.width*cachedBD.bitmapData.height*4;
					cachedBD.saveToDisk();
				}
			}
		}
		
		
		public function cacheAllToDisk():void{
			
			for (var id:String in _bitmaps){
				
				cacheToDisk(id);
			}
		}
		
		public function get totalMemory():int{
			
			return _totalMemory;
		}
		
		public function get useMemory():int{
			return _useMemory;
		}
		
		public function get cacheMemory():int{
			return _cacheMemory;
		}
		
		public function get bitmapCount():int{
			return _bitmapCount;
		}
		
		public function removeAllBitmapData():void{
			
			for (var id:String in _bitmaps){
				
				removeBitmapData(id);
			}
			_totalMemory=0;
			_cacheMemory=0;
			_useMemory=0;
			_bitmapCount=0;
		}
	}
}