package com.maxbsoft2.object360lib
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;

	public class BitmapDataRenderableObject
	{
		
		//protected var _displayBitmapData:BitmapData=null;
		
		protected var _childs:Vector.<BitmapDataRenderableObject>=null;
		
		private var _x:int=0;
		private var _y:int=0;
		
		protected var _width:int=0;
		protected var _height:int=0;
		
		//protected var _changed:Boolean=true;
		
		
		public function BitmapDataRenderableObject()
		{
			_childs=new Vector.<BitmapDataRenderableObject>
		}
		
		public function hasChild(child:BitmapDataRenderableObject):Boolean{
			var item:BitmapDataRenderableObject;
			for each(item in _childs){
				
				if(item==child){
					
					return true;
				}
			}
			
			return false;
		}
		
		public function addChild(child:BitmapDataRenderableObject):void{
			
			if(hasChild(child))
				return;
		
			_childs.push(child);
			//updateSize();
			//_changed=true;
			
		}
		
		public function get childs():Vector.<BitmapDataRenderableObject>{
			
			return _childs;
		}
		
		public function removeChild(child:BitmapDataRenderableObject):void{
			
			if(hasChild(child)){
				
				var new_childs:Vector.<BitmapDataRenderableObject>=new Vector.<BitmapDataRenderableObject>();
				var item:BitmapDataRenderableObject;
				
				for each(item in _childs){
					
					if(item!=child){
						
						new_childs.push(item);
					}
				}
				_childs=new_childs;
			}
		}
		
		public function set x(value:int):void{
			
			_x=value;
		}
		
		public function get x():int{
			
			return _x;
		}
		
		public function set y(value:int):void{
			
			_y=value;
		}
		
		public function get y():int{
			
			return _y;
		}
		
		public function get width():int{
			
			return _width;
		}
		
		public function get height():int{
			
			return _height;
		}
		
		public function clean():void{
			
			//_imageBitmapData.dispose();
			//_imageBitmapData=null;
		}
		
		public function hitTest(localX:int, localY:int):Boolean{
			
			var rect:Rectangle=getBounds();
			
			return rect.contains(localX, localY);
			
		}
		
		protected function updateSize():void{
			
			var w:int=0;
			var h:int=0;
			
			var min_x:int=0;
			var min_y:int=0;
			
			if(_childs.length>0){
				min_x=_childs[0].x;
				min_y=_childs[0].y;
			}
			
			var item:BitmapDataRenderableObject;
			for each(item in _childs){
				
				if(w<item.x+item.width){
					w=item.x+item.width;
				}
				
				if(h<item.y+item.height){
					h=item.y+item.height;
				}
				
				if(item.x<min_x){
					min_x=item.x;
				}
				
				if(item.y<min_y){
					min_y=item.y;
				}
			}
			
			_width=w-min_x;
			_height=h-min_y;
			
			
			
			//_offset_x=min_x;
			//_offset_y=min_y;
			
			//_x=_offset_x;
			//_y=_offset_y;
		}
		
		//private var _offset_x:int=0;
		//private var _offset_y:int=0;
		
		//public function get bitmapDa
		
		public function getBounds():Rectangle{
			
			var index:int;
			
			var min_x:int=0;
			var min_y:int=0;
			var max_x:int=0;
			var max_y:int=0;
			
			var rect:Rectangle;
			
			var item:BitmapDataRenderableObject;
			
			if(_childs.length>0){
				
				item=_childs[0];
				
				rect=item.getBounds();
				
				min_x=rect.x;
				min_y=rect.y;
				
				max_x=rect.x+rect.width;
				max_y=rect.y+rect.height;
			}
			
			
		
			
			
			for (index in _childs){
				
				if(index==0)
					continue;
				
				item=_childs[index];
				
				rect=item.getBounds();
				
				if(rect.x<min_x){
					
					min_x=rect.x;
				}
				
				if(rect.y<min_y){
					
					min_y=rect.y;
				}
				
				
				if(rect.x+rect.width>max_x){
					
					max_x=rect.x+rect.width;
				}
				
				if(rect.y+rect.height>max_y){
					
					max_y=rect.y+rect.height;
				}
				
			}
			
			
			x=min_x;
			y=min_y;
			
			_width= max_x-min_x;
			_height= max_y-min_y;
			
			return new Rectangle(x, y,   _width, _height);
		}
		
		public function renderOneImage(offsetX:int=0, offsetY:int=0, image:Image=null, bitmapData:BitmapData=null):void{
			
			
			
			
			var item:BitmapDataRenderableObject;
			var bitmap:Bitmap;
			var bd:BitmapData;
			//var matrix:Matrix=new Matrix();
			
			//if(this as Layer){
				
				//trace("Layer num child:", _childs.length);
			//}
			
			for each(item in _childs){
				
				item.renderOneImage(offsetX, offsetY,image, bitmapData);
				/*if(bd==null)
				continue;
				
				bitmap=new Bitmap(bd);
				
				matrix.tx=x+item.x;
				matrix.ty=y+item.y;
				bitmapData.draw(bitmap,matrix);
				
				item.clean();
				
				bitmap=null;*/
			}
			
			//matrix=null;
			
			//_changed=false;
			
			
			//return _displayBitmapData;
			
		}
		
		
		public function render(offsetX:int=0, offsetY:int=0, bitmapData:BitmapData=null):void{
			
			
			
			
			var item:BitmapDataRenderableObject;
			var bitmap:Bitmap;
			var bd:BitmapData;
			//var matrix:Matrix=new Matrix();
			
			//if(this as Layer){
				
			//	trace("Layer num child:", _childs.length);
			//}
			
			for each(item in _childs){
				
				item.render(offsetX, offsetY, bitmapData);
				/*if(bd==null)
					continue;
				
				bitmap=new Bitmap(bd);
				
				matrix.tx=x+item.x;
				matrix.ty=y+item.y;
				bitmapData.draw(bitmap,matrix);
				
				item.clean();
				
				bitmap=null;*/
			}
			
			//matrix=null;
			
			//_changed=false;
			
			
			//return _displayBitmapData;
			
		}
		
		
		public function removeAll():void{
			
			var item:BitmapDataRenderableObject;
			var i:int;
			
			for (i in _childs){
				
				item=_childs[i];
				
				item.removeAll();
			
			}
			
			
			_childs=new Vector.<BitmapDataRenderableObject>;
		}
		
		
		
	}
}