package  com.utils
{
	import flash.display.BitmapData;
	import flash.display.PNGEncoderOptions;
	import flash.errors.IOError;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.geom.Matrix;
	import flash.utils.ByteArray;

	public class BitmapDataUtils
	{
		private static var fileStream:FileStream=new FileStream();
		private static var byteArray:ByteArray=new ByteArray();
		
		public function BitmapDataUtils()
		{
			
		}
		
		public static function saveToDisk(file:File, bitmapData:BitmapData):Boolean{
			
			//trace("saveToDisk:", file.nativePath)
			var error:Boolean = false;
			if(!file.exists){
				
				
				byteArray.position=0;
				bitmapData.copyPixelsToByteArray(bitmapData.rect, byteArray);
				
				try{
					file.preventBackup = true;
					//fileStream.
					fileStream.open(file, FileMode.WRITE);
					fileStream.writeBytes(byteArray);
					fileStream.close();
					
					error = false;
					//return true;
				}catch(e:IOError){
					trace(e.message);
					error = true;
				}finally{
					
					fileStream.close();
					//error = true;
				}
				
				byteArray.clear();
			}else{
				
				//trace("file.size:",file.size);
				return true;
				
			}
			
			return !error;
			
		}
		
		public static function loadFromDisk(file:File, width:Number, height:Number):BitmapData{
			
			
			//var file:File=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id);
			
			if(file.exists){
				
				byteArray.position=0;
				fileStream.open(file, FileMode.READ);
				fileStream.readBytes(byteArray);
				fileStream.close();
				
				var bitmapData:BitmapData=new BitmapData(width, height,true, 0xff000000);
				
				try{
					bitmapData.setPixels(bitmapData.rect, byteArray);
				}catch (e:Error) {

				}
				return bitmapData;
			}else{
				
				throw new Error("Cache file not find:"+file.nativePath);
				return null;
			}
		}
		
		public static function savePngToDisk(file:File, bitmapData:BitmapData):void{
			
			//trace("savePngToDisk", file.)
			var byteArray:ByteArray=new ByteArray();
			
			
			bitmapData.encode(bitmapData.rect, new PNGEncoderOptions(true), byteArray);
			//file=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id+".png");
			
			fileStream.open(file, FileMode.WRITE);
			fileStream.writeBytes(byteArray);
			fileStream.close();
		}
		
		
		public static function scaleBitmapData(bitmapData:BitmapData, scale:Number):BitmapData {
			scale = Math.abs(scale);
			var width:int = (bitmapData.width * scale) || 1;
			var height:int = (bitmapData.height * scale) || 1;
			var transparent:Boolean = bitmapData.transparent;
			var result:BitmapData = new BitmapData(width, height, transparent, transparent ? 0x00808080: 0xffffff);
			var matrix:Matrix = new Matrix();
			matrix.scale(scale, scale);
			result.draw(bitmapData, matrix);
			return result;
		}
		
		
		public static function scaleBitmapDataXY(bitmapData:BitmapData, scaleX:Number, scaleY:Number, disposeSrcBitmapData:Boolean = false):BitmapData {
			//scale = Math.abs(scale);
			var width:int = (bitmapData.width * scaleX) ;
			var height:int = (bitmapData.height * scaleY) ;
			var transparent:Boolean = bitmapData.transparent;
			var result:BitmapData = new BitmapData(width, height, transparent, transparent ? 0x00808080: 0xffffff);
			var matrix:Matrix = new Matrix();
			matrix.scale(scaleX, scaleY);
			result.draw(bitmapData, matrix);
			if(disposeSrcBitmapData) bitmapData.dispose();
			return result;
		}

		public static function isValid(bmd:BitmapData):Boolean{
            var r:Boolean = false;
			if(bmd){
				r = true;
				try{
					bmd.rect;
				}catch (e:Error) {
					r = false;
                }
			}
			return r;
		}
		
		
		
	}
}