/**
 * Created by Render-2 on 8/9/2017.
 */
package com.utils {
import com.adobe.utils.DateUtil;
    import com.despark.tuning3d.view.components.core.LabelFactory;

    public class DateParser {

    private static const REGEX: RegExp = /[A-Z,:\-]/;
    public static const SECOND:int = 1000;
    public static const MINUTE:int = 60 * SECOND;
    public static const HOUR:int = 60 * MINUTE;
    public static const DAY:int = 24 * HOUR;
    public static function parseDate(dateString : String) : Date
    {
        var ddd : Date = DateUtil.parseW3CDTF(dateString);
        return ddd;

        var d : Array = dateString.split(REGEX);
        var date : Date = new Date(d[0], int(d[1]) -1, d[2], d[3],d[4], d[5]);
        date.minutes -= date.timezoneOffset;
        return date;
    }

    public static function toW3CDTF(d:Date,includeMilliseconds:Boolean=false):String
    {
        var date:Number = d.getUTCDate();
        var month:Number = d.getUTCMonth();
        var hours:Number = d.getUTCHours();
        var minutes:Number = d.getUTCMinutes();
        var seconds:Number = d.getUTCSeconds();
        var milliseconds:Number = d.getUTCMilliseconds();
        var sb:String = new String();

        sb += d.getUTCFullYear();
        sb += "-";

        //thanks to "dom" who sent in a fix for the line below
        if (month + 1 < 10)
        {
            sb += "0";
        }
        sb += month + 1;
        sb += "-";
        if (date < 10)
        {
            sb += "0";
        }
        sb += date;
        sb += "T";
        if (hours < 10)
        {
            sb += "0";
        }
        sb += hours;
        sb += ":";
        if (minutes < 10)
        {
            sb += "0";
        }
        sb += minutes;
        sb += ":";
        if (seconds < 10)
        {
            sb += "0";
        }
        sb += seconds;
        if (includeMilliseconds && milliseconds > 0)
        {
            sb += ".";
            sb += milliseconds;
        }
        //sb += "+" + getTimezoneString(d);
        sb += "Z";
        return sb;
    }

    private static function getTimezoneString(date:Date):String{
        var value:String = Math.floor(-date.timezoneOffset / 60).toString();
        if(value.length == 1){
            value = "0" + value;
        }
        var minStr:String = (-date.timezoneOffset % 60).toString();
        if(minStr.length == 1){
            minStr = "0" + minStr;
        }
        value = value + ":" + minStr;
        return value;
    }

    public static function getDateAppropriateText(date : Date) : String {
        var newDate : Date = new Date();
        var currentTime : Number = newDate.getTime();
        var postTime : Number = date.getTime();
        var time : Number = currentTime - postTime;
        var roundTime : int = -1;
        var timeText : String;
        if (time < 3 * 1000) {
            timeText = "a few seconds ago";
        } else if (time < 60 * 1000) {
            roundTime = time / 1000; // make second
            roundTime = (roundTime == 0) ? 1 : roundTime;
            timeText = roundTime + " sec ago";
        } else if (time < 60 * 60 * 1000){ // minutes - hour
            roundTime = time / (60 * 1000)  ;//make minute
            timeText = roundTime+ " min ago";
        } else if (time < 60 * 60 * 24*1000){ // minutes - hour
            roundTime = time / (60 * 60 * 1000);//make minute
            timeText = roundTime+ " hour ago";
        } else {
            var zeroM : String = (int(date.month+1) < 10) ? "0" : ""
            var zeroD : String = ((date.date) < 10) ? "0" : ""
            timeText = zeroD + date.date + "."  + zeroM +  int(date.month +1) + "." + date.fullYear;
        }
        return timeText;
    }

    public static function getTimeAppropriateText(date : Date) : String {
        var newDate : Date = new Date();
        var currentTime : Number = newDate.getTime();
        var postTime : Number = date.getTime();
        var time : Number = currentTime - postTime;
        var roundTime : int = -1;
        var timeText : String;
        if (time < 3 * 1000) {
            timeText = "a few seconds ago";
        } else if (time < 60 * 1000) {
            roundTime = time / 1000; // make second
            roundTime = (roundTime == 0) ? 1 : roundTime;
            timeText = roundTime + " sec ago";
        } else if (time < 60 * 60 * 1000){ // minutes - hour
            roundTime = time / (60 * 1000) ;//make minute
            timeText = roundTime+ " min ago";
        } else if (time < 60 * 60 * 24*1000){ // minutes - hour
            roundTime = time / (60 * 60 * 1000);//make minute
            timeText = roundTime+ " hour" +(roundTime>1?"s":"")+" ago";
        } else {
            timeText = date.hours + ":" + (date.minutes < 10?"0":"") + date.minutes;
        }
        return timeText;
    }

    public static function getHeaderDateAppropriateText(date : Date) : String {
        var currentDate : Date = new Date();
        var timeText : String;
        if(currentDate.fullYear == date.fullYear && currentDate.month == date.month){
            if(currentDate.date == date.date){
                timeText = "Today";
            }else{
                currentDate.date -= 1;
                if(currentDate.date == date.date){
                    timeText = "Yesterday";
                }else{
                    timeText = date.toDateString();
                }
            }
        }else{
            timeText = date.toDateString();
        }
        return timeText;
    }

        public static function getDateTime(date:Date):Number{
            return new Date(date.fullYear, date.month, date.date, 0,0,0,0).time;
        }


    private static const LABELS:Object = {sec:["SEC"], min:["MIN"], hr:["HR", "HRS"], day:["DAY", "DAYS"]};
    public static function getInChallengeLabel(time:Number, labels:Object = null):String{
        labels ||= LABELS;
        var result:int;
        if(time < MINUTE){
            result = Math.floor(time / SECOND);
            return result.toString() + " " + getLabel(labels, "sec", result);
        }
        if(time < HOUR){
            result = Math.floor(time / MINUTE);
            return result.toString() + " " + getLabel(labels, "min", result);
        }
        if(time < DAY){
            result = Math.floor(time / HOUR);
            return result.toString() + " " + getLabel(labels, "hr", result);
        }
        result = Math.floor(time / DAY);
        return result.toString() + " " + getLabel(labels, "day", result);
    }

    private static function getLabel(labelObj:Object, name:String, value:int):String{
        if(value != 1 && labelObj[name].length == 2){
            return labelObj[name][1];
        }
        return labelObj[name][0];
    }

}
}
