package com.utils {
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;

public class FileUtil {
    private static function filePutContent(file: File, content: String):Boolean{
        try{
            var fileStream: FileStream = new FileStream();
            fileStream.open(file, FileMode.WRITE);
            fileStream.writeUTFBytes(content);
            fileStream.close();
            return true;
        }catch (e:Error) {
            return false;
        }
    }

    private static function fileGetContent(file: File):String{
        try {
            var fileStream:FileStream = new FileStream();
            fileStream.open(file, FileMode.READ);
            var myChallengeVotesJson:String = fileStream.readUTFBytes(fileStream.bytesAvailable);
            fileStream.close();
            return myChallengeVotesJson;
        }catch (e:Error) {
            return null;
        }
    }

    public static function filePutMultibyteContent(file: File, content: String):Boolean{
        try{
            var fileStream: FileStream = new FileStream();
            fileStream.open(file, FileMode.WRITE);
            fileStream.writeMultiByte(content, File.systemCharset);
            fileStream.close();
            return true;
        }catch (e:Error) {
            return false;
        }
    }

    public static function fileGetMultibyteContent(file: File):String{
        try {
            var fileStream:FileStream = new FileStream();
            fileStream.open(file, FileMode.READ);
            var str:String = fileStream.readMultiByte(file.size, File.systemCharset);
            fileStream.close();
            return str;
        }catch (e:Error) {
            return null;
        }
    }

    private static function filePutContentUTF(file: File, content: String):Boolean{
        try{
            var fileStream: FileStream = new FileStream();
            fileStream.open(file, FileMode.WRITE);
            fileStream.writeUTF(content);
            fileStream.close();
            return true;
        }catch (e:Error) {
            return false;
        }
    }

    private static function fileGetContentUTF(file: File):String{
        try {
            var fileStream:FileStream = new FileStream();
            fileStream.open(file, FileMode.READ);
            var stringJSON:String = fileStream.readUTF();
            fileStream.close();
            return stringJSON;
        }catch (e:Error) {
            return null;
        }
    }

    public static function getFileContent(file: File):String{
        try {
            var result:String;
            if(file.exists){
                result = fileGetContentUTF(file);
                if(!result){
                    result = fileGetContent(file);
                }
            }
            result = fixJSONData(result);
            return result;
        }catch (e:Error) {
            return null;
        }
    }

    public static function putFileContent(file: File, content: String):Boolean{
        content = fixJSONData(content);
        if(!filePutContentUTF(file, content)){
            return filePutContent(file, content);
        }
        return true;
    }

    public static function fixJSONData(jsonStr:String):String{
        var i:int;
        if(jsonStr){
            if(jsonStr.length){
                i = 0;
                while(i < jsonStr.length-1 && jsonStr.charAt(i) != '[' && jsonStr.charAt(i) != '{'){
                    i++;
                }
                jsonStr = jsonStr.substr(i);
            }
            if(jsonStr.length){
                i = jsonStr.length-1;
                while(i > 0 && jsonStr.charAt(i) != ']' && jsonStr.charAt(i) != '}'){
                    i--;
                }
                jsonStr = jsonStr.substr( 0, i + 1);
            }
            return jsonStr;
        }
        return "";
    }
}
}
