package com.utils
{
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.shephertz.app42.paas.sdk.as3.App42API;
import com.shephertz.app42.paas.sdk.as3.App42CallBack;
import com.shephertz.app42.paas.sdk.as3.App42Exception;
import com.shephertz.app42.paas.sdk.as3.log.LogService;
import com.shephertz.app42.paas.sdk.as3.upload.UploadService;

import flash.desktop.NativeApplication;
import flash.filesystem.File;
import flash.filesystem.FileStream;
import flash.system.System;
import flash.utils.getQualifiedClassName;
import flash.utils.getTimer;

public class Logger implements App42CallBack
	{
		public static var REF:Logger=null;
		
		public static const ERROR:String="error";
		public static const DEBUG:String="debug";
		public static const INFO:String="info";
		
		private var _logService:LogService=null;
		
		
		private var _uploadService:UploadService=null;
		private var _fileStream:FileStream=null;
		
		private var _sessionId:String=null;
		
		private var _startDate:Date=null;
		
		public function Logger()
		{
			if(REF==null){
				//REF=this;
				if(Constants.APP42API_ENABLED){
					
					App42API.initialize(Constants.APP42API_KEY,Constants.APP42API_SECRET); 					
					_logService=new LogService(Constants.APP42API_KEY,Constants.APP42API_SECRET);
					_uploadService=new UploadService(Constants.APP42API_KEY, Constants.APP42API_SECRET);
					//_logService=App42API.buildLogService();
				}				
			}else{
				throw new Error("use getInstance");
			}
			
			
		}
		
		private function sendLogFile(file:File):void{
			
			
			var prefix:String='Android';
			
			if(Device.isIos()){
				prefix='iOS';
			}
			
		
			var version : String = getAppVersion();	
			
			/*var date:Date=new Date();
			var filename:String="app_ver"+version+"_"+AirCapabilities.instance.getDeviceModel()+"_"+AirCapabilities.instance.getOSVersion()+"_"+date.toUTCString();			
			_logService.info("sendLogFile START:"+filename, "Logger", this);			
			_logService.info("log size:"+file.size, "Logger", this);
			_uploadService.uploadFile(filename, file.nativePath, 'csv', date.toDateString(), this); 			
			_logService.info("sendLogFile END", "Logger", this);			*/
			
		}
		
		public function getAppVersion():String{
			
			var xml : XML = NativeApplication.nativeApplication.applicationDescriptor;			
			var ns : Namespace = xml.namespace();			
			return xml.ns::versionNumber;
			
		}
		
		public  function get logService():LogService{
			
			return _logService;
		}
		
		public static function logger():LogService{
			
			return Logger.getInstance().logService;
		}
		
		
		
		public static function getInstance():Logger{

			if(REF==null){
				REF=new Logger();
			}
			return REF;
		
		}
		
		public function onSuccess(response:Object):void  
		{     
			

		}  
		public function onException(exception:App42Exception):void  
		{  
			
			_logService.debug("onException:"+exception.message, "Logger", this);

		}
		
		private function writeLogLine(timestamp:uint, type:String, module:String, msg:String, params:Object ):void{
			
			try{
				_fileStream.writeUTFBytes("'"+timestamp+"'," + "'"+type+"'," + "'"+module+"'," + "'"+msg+"'," +  "'"+JSON.stringify(params)+"'" + "\r\n");
			}catch(e:Error){				
				_logService.debug("writeLogLine error:"+e.message, "Logger", this);
			}
			
		}
		
		public function start(module:String):void{
			
			if(!Constants.APP42API_ENABLED)
				return;
			
			/*var file:File=File.documentsDirectory.resolvePath("log.csv");
			
			if(file.exists){
				
				sendLogFile(file);
				
				file.deleteFile();
			}
			
			_fileStream=new FileStream();
			
			_fileStream.openAsync(file, FileMode.WRITE);
						
			_sessionId=GUID.create();
			var deviceInfo:String=Capabilities.serverString;
			var data:Object={device_info:deviceInfo, machine_name:AirCapabilities.instance.getMachineName()};
			
			
			var version : String = getAppVersion();	
			
			
			var filename:String="app_ver"+version+"_"+AirCapabilities.instance.getDeviceModel()+"_"+AirCapabilities.instance.getOSVersion();		
			_logService.info("Start Session:"+filename, "Logger", this);
						
			writeLogLine(flash.utils.getTimer(), "INFO",  module,"START LOG SESSION", data);
	
			data=null;*/
		}
		
		public function end(module:String):void{
			if(!Constants.APP42API_ENABLED)
				return;
			
			/*var deviceInfo:String=Capabilities.serverString;
			var data:Object={device_info:deviceInfo};
			
			writeLogLine(flash.utils.getTimer(), "INFO",  module,"END LOG SESSION", data);
			
			_fileStream.close();
			
			var version : String = getAppVersion();	
			
			var filename:String="app_ver"+version+"_"+AirCapabilities.instance.getDeviceModel()+"_"+AirCapabilities.instance.getOSVersion();		
			_logService.info("End Session:"+filename, "Logger", this);
			
			
			//_logService.info(JSON.stringify(data), module, this);
			data=null;
			_sessionId=null;*/
		}
		
		public function info(msg:String, module:String):void{
			
			if(_sessionId==null)
				return;
			
			var data:Object={};		
			
			writeLogLine(getTimer(), "INFO",  module,data.msg, data);
			//_logService.info(JSON.stringify(data), module, this);
			data=null;
		}
		
		public function error(msg:String, module:String):void{
			if(_sessionId==null)
				return;
			
			var data:Object={};	
			
			writeLogLine(getTimer(), "ERROR",  module,msg, data);
			//_logService.error(JSON.stringify(data), module, this);
			data=null;
		}
		
		public function debug(msg:String, module:String):void{
			if(_sessionId==null)
				return;
			
			
			var data:Object={total_memory:System.totalMemory, free_momory:System.freeMemory, cpu:System.processCPUUsage, private_memory:System.privateMemory};			
			
			writeLogLine(getTimer(), "DEBUG",  module, msg, data);
			//_logService.debug(JSON.stringify(data), module, this);
			data=null;
		}
		
		// Static interface
		public static function i(msg:String, module:*):void{
			
			Logger.getInstance().info(msg, getQualifiedClassName(module));
		}
		
		public static function d(msg:String, module:*):void{
			
			Logger.getInstance().debug(msg, getQualifiedClassName(module));
		}
		
		public static function e(msg:String, module:*):void{
			
			Logger.getInstance().error(msg, getQualifiedClassName(module));
		}
		
		public static function startSession(module:*):void{
			
			Logger.getInstance().start(getQualifiedClassName(module));
		}
		
		public static function endSession(module:*):void{
			
			Logger.getInstance().end(getQualifiedClassName(module));
		}
		
		
	}	
}