package com.utils
{
	public class ObjectUtils
	{
		public function ObjectUtils()
		{
		}
		
        public static function cleanArray(target:Array):void
		{
            for(var ii : int = 0; ii < target.length; ii++){
                if (null == target[ii]){
                    target.removeAt(ii);
                    if(ii > 0 && ii < target.length) ii--;
                }
            }
			//trace(target);
		}
		
		public static function merge(obj1:Object, obj2:Object):Object {
			var mergedObj:Object = {};
			for (var r:String in obj1) {
				mergedObj[r] = obj1[r];
			}

			for(var s:String in obj2) {
				mergedObj[s] = obj2[s];
			}
			return mergedObj;
		}
		
		public static function isItemExists(arr:Array, item:String):Boolean{
			
			for(var i:int=0; i<arr.length; i++){
				
				if(arr[i]==item){
					return true;
					break;
				}
				
			}
			return false;
		}
		
		public static function mergeArray(arr1:Array, arr2:Array):Array{
			
			if(arr1 && arr2){
				
				var newarr:Array=[];
				
				for(var i:int=0; i<arr2.length; i++){
					
					
					newarr[i]=arr2[i];
				}
				
				var l:int=arr1.length;
				
				for(var j:int=0; j<l; j++){
					
					if(!isItemExists(newarr, arr1[j])){
						
						newarr.push(arr1[j]);
					}
				}
				
				return newarr;
					
			}else if(arr1){
				
				return arr1;
			}else if(arr2){
				return arr2;
			}else{
				
				return [];
			}
			
		}

        public static function isEmpty(obj:Object):Boolean {
			for (var key:String in obj){
				return false;
			}
			return true;
        }

		public static function empty(obj:Object):void {
			for (var key:String in obj){
				delete obj[key];
			}
        }

        public static function addValue(obj:Object, prop:String, value:*):void{
            var props:Array = prop.split(".");
            var propName:String = null;
            var prevPropName:String = null;
            while (props.length){
                prevPropName = propName;
                propName = props.shift();
                if(propName.length){
                    if(!obj.hasOwnProperty(propName)){
                        obj[propName] = {};
                    }
                    if(props.length) {
                        obj = obj[propName];
                    }
                }else{
                    propName = prevPropName;
                }
            }
            obj[propName] = value;
        }

		public static function getProperty(obj:Object, prop:String):*{
			var props:Array = prop.split(".");
			var result:* = obj;
			while (props.length && result){
				if(result.hasOwnProperty(props[0])){
					result = result[props[0]];
					props.shift();
				}else{
					result = null;
					break;
				}
			}
			return result;
		}

		public static function hasProperty(obj:Object, prop:String):Boolean{
			var props:Array = prop.split(".");
			var result:* = obj;
			while (props.length && result){
				if(result.hasOwnProperty(props[0])){
					result = result[props[0]];
					props.shift();
				}else{
					return false;
				}
			}
			return true;
		}

		public static function mergeInto(obj:Object, targetObj:Object):void{
			for(var prop:String in obj){
				targetObj[prop] = obj[prop];
			}
		}

		public static function getLength(obj:Object):int{
			var result:int = 0;
			for(var prop:String in obj){
				result++;
			}
			return result;
		}


        public static function getKeys(object:*, sort:Boolean = true):Array {
			var result:Array = [];
			for(var key:String in object){
				result.push(key);
			}
			if(sort){
				result.sort(Array.NUMERIC);
            }
            return result;
        }

		public static function getFirstKey(object:*):String {
			for(var key:String in object){
				return key;
			}
            return null;
        }


        public static function createObject(...args):Object {
			var ln:int = int(args.length/2);
            var result:Object = {};
			for(var i:int = 0; i < ln; i++){
				result[args[2 * i]] = args[2 * i + 1];
			}
			return result;
        }

		public static function getValue(object:Object, propName:String, defaultValue:* = null, classType:Class = null):* {
			if(!object){
				return defaultValue;
			}
			var props:Array = propName.split(".");
			if(props && props.length > 1){
				var currObj:* = object;
				for(var i:int = 0; i < props.length; i++){
					if(!currObj.hasOwnProperty(props[i])){
						return defaultValue;
					}
					currObj = currObj[props[i]];
				}
				if(classType != null){
					return (currObj is classType)?currObj:defaultValue;
				}
				return currObj;
			}
			if(classType != null){
				return (object.hasOwnProperty(propName) && object[propName] is classType)?object[propName]:defaultValue;
			}
			return object.hasOwnProperty(propName)?object[propName]:defaultValue;
		}

		public static function clone(value:Object):Object{
			var result:Object = {};
			for(var key:String in value){
				result[key] = value[key];
			}
			return result;
		}
	}
}