package com.utils
{
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.system.Capabilities;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFormat;

public class SplashScreenLogo extends MovieClip
	{
		[Embed(source="/assets/textures/splash_logo.png")]
		public static var SPLASH_LOGO_CLASS : Class;
		
		[Embed(source="/assets/textures/splash_logo_ipad.png")]
		public static var SPLASH_LOGO_IPAD_CLASS : Class;
		
		[Embed(source="/assets/textures/spinner_splash.png")]
		public static var SPINNER_CLASS : Class;
		
		
		private var splash:Bitmap=null;
		
		private var spinner:Sprite=null;

		private var _width:Number;
		private var _height:Number;
		private var _loadingLabel:TextField;
		private var _loadBar:Sprite;

		public function SplashScreenLogo()
		{
			super();
			
			if(Capabilities.os.indexOf('iPad') > -1){   
				splash = new SPLASH_LOGO_IPAD_CLASS();
			}else{
				splash = new SPLASH_LOGO_CLASS();
			}
			addChild(splash);

			//
            _loadBar = new Sprite();
			
			spinner=new Sprite();
			spinner.visible=true;
			
			var spinnerBitmap:Bitmap=new SPINNER_CLASS();
			spinnerBitmap.x=-spinnerBitmap.width/2;
			spinnerBitmap.y=-spinnerBitmap.height/2;
			
			spinner.addChild(spinnerBitmap);

			_loadingLabel = new TextField();
            _loadingLabel.autoSize = TextFieldAutoSize.LEFT;
            _loadingLabel.selectable = false;

            _loadBar.addChild(spinner);
            _loadBar.addChild(_loadingLabel);

			addChild(_loadBar);

            _loadBar.x = (splash.width - _loadBar.width) / 2;
            _loadBar.y = splash.height - _loadBar.height-30;//((splash.height)/2)+200;
			
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		public function setSize(w:Number, h:Number):void{
			_width = w;
			_height = h;
			//
            spinner.height = 22 * _height / 524;
            spinner.scaleX = spinner.scaleY;
            _loadingLabel.defaultTextFormat = new TextFormat('Arial', int(12 * _height / 524)+1, 0xb5b5b5, true, true);
            _loadingLabel.text = 'Loading';
            _loadingLabel.x = spinner.getBounds(_loadBar).right + 2;
            _loadingLabel.y = -_loadingLabel.height / 2;
            //
            _loadBar.x = (_width - _loadBar.width) / 2;
            _loadBar.y = _height - _loadBar.height - 30;
			//
			var splashRatio:Number = splash.width / splash.height;
			var stageRatio:Number = _width / _height;
			//
			if(splashRatio > stageRatio){
                splash.height = _height;
				splash.width = splash.height * splashRatio;
			}else{
                splash.width = _width;
                splash.height = splash.width / splashRatio;
			}
            splash.x = (_width - splash.width) / 2;
            splash.y = (_height - splash.height) / 2;
		}
			
		public function dispose() : void{
            removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
            removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			while (numChildren){
				removeChildAt(0);
			}
		}
		
		public function showSpinner():void{
			spinner.visible=true;
		}
		
		private function onEnterFrame(event:Event):void{
			spinner.rotation+=5;    
		}
		
		private function onAddedToStage(event:Event):void{
		}
	}
}